/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(Y){for(var e=[],D=0,n=Y.length;D<n;D++)e[D]=te[Y[D]];return e};define(te[99],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,k){if(!n)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=D}),define(te[48],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(R,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(R,b,E){this.id=R,this.definition=b,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(T,R){const b=["codicon","codicon-"+T];return R&&b.push("codicon-modifier-"+R),b}e.getClassNamesArray=k;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function b(C){if(C instanceof n)return["codicon","codicon-"+C.id];const f=R.exec(C.id);if(!f)return b(n.error);let[,y,h]=f;const p=["codicon","codicon-"+y];return h&&p.push("codicon-modifier-"+h.substr(1)),p}T.asClassNameArray=b;function E(C){return b(C).join(" ")}T.asClassName=E;function P(C){return"."+b(C).join(".")}T.asCSSSelector=P})(A=e.CSSIcon||(e.CSSIcon={}))}),define(te[67],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(P){const C=[];for(let f in P)D.call(P,f)&&C.push(P[f]);return C}e.values=n;function k(P,C){for(let f in P)if(D.call(P,f)&&C({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=k;function A(P,C){const f=Object.create(null);for(const y of P){const h=C(y);let p=f[h];p||(p=f[h]=[]),p.push(y)}return f}e.groupBy=A;function T(P){const C=Object.create(null);return P&&P.forEach((f,y)=>{C[y]=f}),C}e.fromMap=T;function R(P,C){const f=[],y=[];for(let h of P)C.has(h)||f.push(h);for(let h of C)P.has(h)||y.push(h);return{removed:f,added:y}}e.diffSets=R;function b(P,C){const f=[],y=[];for(let[h,p]of P)C.has(h)||f.push(p);for(let[h,p]of C)P.has(h)||y.push(p);return{removed:f,added:y}}e.diffMaps=b;class E{constructor(){this.map=new Map}add(C,f){let y=this.map.get(C);y||(y=new Set,this.map.set(C,y)),y.add(f)}delete(C,f){const y=this.map.get(C);!y||(y.delete(f),y.size===0&&this.map.delete(C))}forEach(C,f){const y=this.map.get(C);!y||y.forEach(f)}}e.SetMap=E}),define(te[54],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(R,b,E)=>{let P=null,C=null;if(typeof E.value=="function"?(P="value",C=E.value):typeof E.get=="function"&&(P="get",C=E.get),!C)throw new Error("not supported");E[P]=T(C,b)}}e.createDecorator=D;function n(T,R,b){let E=null,P=null;if(typeof b.value=="function"?(E="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(E="get",P=b.get),!P)throw new Error("not supported");const C=`$memoize$${R}`;b[E]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[C]}}e.memoize=n;function k(T,R,b){return D((E,P)=>{const C=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...y){this[f]||(this[f]=b?b():void 0),clearTimeout(this[C]),R&&(this[f]=R(this[f],...y),y=[this[f]]),this[C]=setTimeout(()=>{E.apply(this,y),this[f]=b?b():void 0},T)}})}e.debounce=k;function A(T,R,b){return D((E,P)=>{const C=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,y=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...p){if(this[f]||(this[f]=b?b():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...p)),this[h])return;const d=this[y]+T;d<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0):(this[h]=!0,this[C]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0},d-Date.now()))}})}e.throttle=A}),define(te[9],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function k(l){b(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function A(l){b(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=A;function T(l){if(l instanceof Error){let{name:r,message:a}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:a,stack:i}}return l}e.transformErrorForSerialization=T;const R="Canceled";function b(l){return l instanceof E?!0:l instanceof Error&&l.name===R&&l.message===R}e.isCancellationError=b;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function P(){const l=new Error(R);return l.name=l.message,l}e.canceled=P;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function p(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=p;class d extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=d;class g extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=g;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function m(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=m;function S(l,r=Object.create(null)){const a=new Error(l);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=S}),define(te[16],ne([0,1,9]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(W,F=0){return W[W.length-(1+F)]}e.tail=n;function k(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=k;function A(W,F,V=(z,B)=>z===B){if(W===F)return!0;if(!W||!F||W.length!==F.length)return!1;for(let z=0,B=W.length;z<B;z++)if(!V(W[z],F[z]))return!1;return!0}e.equals=A;function T(W,F,V){let z=0,B=W.length-1;for(;z<=B;){const ie=(z+B)/2|0,se=V(W[ie],F);if(se<0)z=ie+1;else if(se>0)B=ie-1;else return ie}return-(z+1)}e.binarySearch=T;function R(W,F){let V=0,z=W.length;if(z===0)return 0;for(;V<z;){const B=Math.floor((V+z)/2);F(W[B])?z=B:V=B+1}return V}e.findFirstInSorted=R;function b(W,F,V){if(W=W|0,W>=F.length)throw new TypeError("invalid index");let z=F[Math.floor(F.length*Math.random())],B=[],ie=[],se=[];for(let ce of F){const he=V(ce,z);he<0?B.push(ce):he>0?ie.push(ce):se.push(ce)}return W<B.length?b(W,B,V):W<B.length+se.length?se[0]:b(W-(B.length+se.length),ie,V)}e.quickSelect=b;function E(W,F){const V=[];let z;for(const B of W.slice(0).sort(F))!z||F(z[0],B)!==0?(z=[B],V.push(z)):z.push(B);return V}e.groupBy=E;function P(W,F,V){const z=[];function B(ce,he,ge){if(he===0&&ge.length===0)return;const me=z[z.length-1];me&&me.start+me.deleteCount===ce?(me.deleteCount+=he,me.toInsert.push(...ge)):z.push({start:ce,deleteCount:he,toInsert:ge})}let ie=0,se=0;for(;;){if(ie===W.length){B(ie,0,F.slice(se));break}if(se===F.length){B(ie,W.length-ie,[]);break}const ce=W[ie],he=F[se],ge=V(ce,he);ge===0?(ie+=1,se+=1):ge<0?(B(ie,1,[]),ie+=1):ge>0&&(B(ie,0,[he]),se+=1)}return z}e.sortedDiff=P;function C(W,F,V){const z=P(W,F,V),B=[],ie=[];for(const se of z)B.push(...W.slice(se.start,se.start+se.deleteCount)),ie.push(...se.toInsert);return{removed:B,added:ie}}e.delta=C;function f(W,F,V){if(V===0)return[];const z=W.slice(0,V).sort(F);return h(W,F,z,V,W.length),z}e.top=f;function y(W,F,V,z,B){return V===0?Promise.resolve([]):new Promise((ie,se)=>{(async()=>{const ce=W.length,he=W.slice(0,V).sort(F);for(let ge=V,me=Math.min(V+z,ce);ge<ce;ge=me,me=Math.min(me+z,ce)){if(ge>V&&await new Promise(ye=>setTimeout(ye)),B&&B.isCancellationRequested)throw(0,D.canceled)();h(W,F,he,ge,me)}return he})().then(ie,se)})}e.topAsync=y;function h(W,F,V,z,B){for(const ie=V.length;z<B;z++){const se=W[z];if(F(se,V[ie-1])<0){V.pop();const ce=R(V,he=>F(se,he)<0);V.splice(ce,0,se)}}}function p(W){return W.filter(F=>!!F)}e.coalesce=p;function d(W){let F=0;for(let V=0;V<W.length;V++)W[V]&&(W[F]=W[V],F+=1);W.length=F}e.coalesceInPlace=d;function g(W,F,V){W.splice(V,0,W.splice(F,1)[0])}e.move=g;function w(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=w;function m(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=m;function S(W,F=V=>V){const V=new Set;return W.filter(z=>{const B=F(z);return V.has(B)?!1:(V.add(B),!0)})}e.distinct=S;function l(W){const F=new Set;return V=>{const z=W(V);return F.has(z)?!1:(F.add(z),!0)}}e.uniqueFilter=l;function r(W,F){const V=a(W,F);if(V!==-1)return W[V]}e.findLast=r;function a(W,F){for(let V=W.length-1;V>=0;V--){const z=W[V];if(F(z))return V}return-1}e.lastIndex=a;function i(W,F){return W.length>0?W[0]:F}e.firstOrDefault=i;function t(W,F,V=(z,B)=>z===B){let z=0;for(let B=0,ie=Math.min(W.length,F.length);B<ie&&V(W[B],F[B]);B++)z++;return z}e.commonPrefixLength=t;function s(W){return[].concat(...W)}e.flatten=s;function o(W,F){let V=typeof F=="number"?W:0;typeof F=="number"?V=W:(V=0,F=W);const z=[];if(V<=F)for(let B=V;B<F;B++)z.push(B);else for(let B=V;B>F;B--)z.push(B);return z}e.range=o;function c(W,F,V){return W.reduce((z,B)=>(z[F(B)]=V?V(B):B,z),Object.create(null))}e.index=c;function u(W,F){return W.push(F),()=>v(W,F)}e.insert=u;function v(W,F){const V=W.indexOf(F);if(V>-1)return W.splice(V,1),F}e.remove=v;function I(W,F,V){const z=W.slice(0,F),B=W.slice(F);return z.concat(V,B)}e.arrayInsert=I;function _(W,F){let V;if(typeof F=="number"){let z=F;V=()=>{const B=Math.sin(z++)*179426549;return B-Math.floor(B)}}else V=Math.random;for(let z=W.length-1;z>0;z-=1){const B=Math.floor(V()*(z+1)),ie=W[z];W[z]=W[B],W[B]=ie}}e.shuffle=_;function O(W,F){const V=W.indexOf(F);V>-1&&(W.splice(V,1),W.unshift(F))}e.pushToStart=O;function N(W,F){const V=W.indexOf(F);V>-1&&(W.splice(V,1),W.push(F))}e.pushToEnd=N;function $(W,F){return Array.isArray(W)?W.map(F):F(W)}e.mapArrayOrNot=$;function L(W){return Array.isArray(W)?W:[W]}e.asArray=L;function U(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=U;function j(W,F){for(const V of W){const z=F(V);if(z!==void 0)return z}}e.mapFind=j;function M(W,F,V){const z=K(W,F),B=W.length,ie=V.length;W.length=B+ie;for(let se=B-1;se>=z;se--)W[se+ie]=W[se];for(let se=0;se<ie;se++)W[se+z]=V[se]}e.insertInto=M;function G(W,F,V,z){const B=K(W,F),ie=W.splice(B,V);return M(W,B,z),ie}e.splice=G;function K(W,F){return F<0?Math.max(F+W.length,0):Math.min(F,W.length)}function x(W,F){return(V,z)=>F(W(V),W(z))}e.compareBy=x;const q=(W,F)=>W-F;e.numberComparator=q;function X(W,F){if(W.length===0)return;let V=W[0];for(let z=1;z<W.length;z++){const B=W[z];F(B,V)>0&&(V=B)}return V}e.findMaxBy=X;function H(W,F){if(W.length===0)return;let V=W[0];for(let z=1;z<W.length;z++){const B=W[z];F(B,V)>=0&&(V=B)}return V}e.findLastMaxBy=H;function Z(W,F){return X(W,(V,z)=>-F(V,z))}e.findMinBy=Z;class ee{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let V=this.firstIdx;for(;V<this.items.length&&F(this.items[V]);)V++;const z=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,z}takeFromEndWhile(F){let V=this.lastIdx;for(;V>=0&&F(this.items[V]);)V--;const z=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,z}peek(){return this.items[this.firstIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}takeCount(F){const V=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,V}}e.ArrayQueue=ee}),define(te[68],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const k=this;let A=!1,T;return function(){return A||(A=!0,T=n.apply(k,arguments)),T}}e.once=D}),define(te[55],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function k(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=k;const A=Object.freeze([]);function T(){return A}n.empty=T;function*R(l){yield l}n.single=R;function b(l){return l||A}n.from=b;function E(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=E;function P(l){return l[Symbol.iterator]().next().value}n.first=P;function C(l,r){for(const a of l)if(r(a))return!0;return!1}n.some=C;function f(l,r){for(const a of l)if(r(a))return a}n.find=f;function*y(l,r){for(const a of l)r(a)&&(yield a)}n.filter=y;function*h(l,r){let a=0;for(const i of l)yield r(i,a++)}n.map=h;function*p(...l){for(const r of l)for(const a of r)yield a}n.concat=p;function*d(l){for(const r of l)for(const a of r)yield a}n.concatNested=d;function g(l,r,a){let i=a;for(const t of l)i=r(i,t);return i}n.reduce=g;function*w(l,r,a=l.length){for(r<0&&(r+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);r<a;r++)yield l[r]}n.slice=w;function m(l,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,l];const i=l[Symbol.iterator]();for(let t=0;t<r;t++){const s=i.next();if(s.done)return[a,n.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return i}}]}n.consume=m;function S(l,r,a=(i,t)=>i===t){const i=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=i.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}n.equals=S})(D=e.Iterable||(e.Iterable={}))}),define(te[35],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(r){r.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(r,a=!1){let i=0,t=r.length,s="",o=0,c=16,u=0;function v(U){let j=0,M=0;for(;j<U;){const G=r.charCodeAt(i);if(G>=48&&G<=57)M=M*16+G-48;else if(G>=65&&G<=70)M=M*16+G-65+10;else if(G>=97&&G<=102)M=M*16+G-97+10;else break;i++,j++}return j<U&&(M=-1),M}function I(U){i=U,s="",o=0,c=16,u=0}function _(){const U=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&E(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&E(r.charCodeAt(i)))for(i++;i<r.length&&E(r.charCodeAt(i));)i++;else return u=3,r.substring(U,i);let j=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&E(r.charCodeAt(i))){for(i++;i<r.length&&E(r.charCodeAt(i));)i++;j=i}else u=3;return r.substring(U,j)}function O(){let U="",j=i;for(;;){if(i>=t){U+=r.substring(j,i),u=2;break}const M=r.charCodeAt(i);if(M===34){U+=r.substring(j,i),i++;break}if(M===92){if(U+=r.substring(j,i),i++,i>=t){u=2;break}switch(r.charCodeAt(i++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const K=v(4);K>=0?U+=String.fromCharCode(K):u=4;break}default:u=5}j=i;continue}if(M>=0&&M<=31)if(b(M)){U+=r.substring(j,i),u=2;break}else u=6;i++}return U}function N(){if(s="",u=0,o=i,i>=t)return o=t,c=17;let U=r.charCodeAt(i);if(R(U)){do i++,s+=String.fromCharCode(U),U=r.charCodeAt(i);while(R(U));return c=15}if(b(U))return i++,s+=String.fromCharCode(U),U===13&&r.charCodeAt(i)===10&&(i++,s+=`
`),c=14;switch(U){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,s=O(),c=10;case 47:{const j=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!b(r.charCodeAt(i));)i++;return s=r.substring(j,i),c=12}if(r.charCodeAt(i+1)===42){i+=2;const M=t-1;let G=!1;for(;i<M;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,u=1),s=r.substring(j,i),c=13}return s+=String.fromCharCode(U),i++,c=16}case 45:if(s+=String.fromCharCode(U),i++,i===t||!E(r.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=_(),c=11;default:for(;i<t&&$(U);)i++,U=r.charCodeAt(i);if(o!==i){switch(s=r.substring(o,i),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(U),i++,c=16}}function $(U){if(R(U)||b(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:I,getPosition:()=>i,scan:a?L:N,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>u}}e.createScanner=T;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function E(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function C(r,a){const i=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(v,I,_,O){o.value=v,o.offset=I,o.length=_,o.type=O,o.colonOffset=void 0,s=o}try{m(r,{onObjectBegin:(v,I)=>{if(a<=v)throw t;s=void 0,c=a>v,i.push("")},onObjectProperty:(v,I,_)=>{if(a<I||(u(v,I,_,"property"),i[i.length-1]=v,a<=I+_))throw t},onObjectEnd:(v,I)=>{if(a<=v)throw t;s=void 0,i.pop()},onArrayBegin:(v,I)=>{if(a<=v)throw t;s=void 0,i.push(0)},onArrayEnd:(v,I)=>{if(a<=v)throw t;s=void 0,i.pop()},onLiteralValue:(v,I,_)=>{if(a<I||(u(v,I,_,l(v)),a<=I+_))throw t},onSeparator:(v,I,_)=>{if(a<=I)throw t;if(v===":"&&s&&s.type==="property")s.colonOffset=I,c=!1,s=void 0;else if(v===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(c=!0,i[i.length-1]=""),s=void 0}}})}catch(v){if(v!==t)throw v}return{path:i,previousNode:s,isAtPropertyKey:c,matches:v=>{let I=0;for(let _=0;I<v.length&&_<i.length;_++)if(v[I]===i[_]||v[I]==="*")I++;else if(v[I]!=="**")return!1;return I===v.length}}}e.getLocation=C;function f(r,a=[],i=A.DEFAULT){let t=null,s=[];const o=[];function c(v){Array.isArray(s)?s.push(v):t!==null&&(s[t]=v)}return m(r,{onObjectBegin:()=>{const v={};c(v),o.push(s),s=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const v=[];c(v),o.push(s),s=v,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(v,I,_)=>{a.push({error:v,offset:I,length:_})}},i),s[0]}e.parse=f;function y(r,a=[],i=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){t.type==="property"&&(t.length=v-t.offset,t=t.parent)}function o(v){return t.children.push(v),v}m(r,{onObjectBegin:v=>{t=o({type:"object",offset:v,length:-1,parent:t,children:[]})},onObjectProperty:(v,I,_)=>{t=o({type:"property",offset:I,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:v,offset:I,length:_,parent:t})},onObjectEnd:(v,I)=>{t.length=v+I-t.offset,t=t.parent,s(v+I)},onArrayBegin:(v,I)=>{t=o({type:"array",offset:v,length:-1,parent:t,children:[]})},onArrayEnd:(v,I)=>{t.length=v+I-t.offset,t=t.parent,s(v+I)},onLiteralValue:(v,I,_)=>{o({type:l(v),offset:I,length:_,parent:t,value:v}),s(I+_)},onSeparator:(v,I,_)=>{t.type==="property"&&(v===":"?t.colonOffset=I:v===","&&s(I))},onError:(v,I,_)=>{a.push({error:v,offset:I,length:_})}},i);const u=t.children[0];return u&&delete u.parent,u}e.parseTree=y;function h(r,a){if(!r)return;let i=r;for(let t of a)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===t){i=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=h;function p(r){if(!r.parent||!r.parent.children)return[];const a=p(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;a.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&a.push(i)}return a}e.getNodePath=p;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const a=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(a[i.children[0].value]=d(t))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function g(r,a,i=!1){return a>=r.offset&&a<r.offset+r.length||i&&a===r.offset+r.length}e.contains=g;function w(r,a,i=!1){if(g(r,a,i)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=w(t[s],a,i);if(o)return o}return r}}e.findNodeAtOffset=w;function m(r,a,i=A.DEFAULT){const t=T(r,!1);function s(ee){return ee?()=>ee(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(ee){return ee?W=>ee(W,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=s(a.onObjectBegin),u=o(a.onObjectProperty),v=s(a.onObjectEnd),I=s(a.onArrayBegin),_=s(a.onArrayEnd),O=o(a.onLiteralValue),N=o(a.onSeparator),$=s(a.onComment),L=o(a.onError),U=i&&i.disallowComments,j=i&&i.allowTrailingComma;function M(){for(;;){const ee=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:U||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(ee){case 12:case 13:U?G(10):$();break;case 16:G(1);break;case 15:case 14:break;default:return ee}}}function G(ee,W=[],F=[]){if(L(ee),W.length+F.length>0){let V=t.getToken();for(;V!==17;){if(W.indexOf(V)!==-1){M();break}else if(F.indexOf(V)!==-1)break;V=M()}}}function K(ee){const W=t.getTokenValue();return ee?O(W):u(W),M(),!0}function x(){switch(t.getToken()){case 11:{let ee=0;try{ee=JSON.parse(t.getTokenValue()),typeof ee!="number"&&(G(2),ee=0)}catch{G(2)}O(ee);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function q(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(K(!1),t.getToken()===6?(N(":"),M(),Z()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function X(){c(),M();let ee=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),N(","),M(),t.getToken()===2&&j)break}else ee&&G(6,[],[]);q()||G(4,[],[2,5]),ee=!0}return v(),t.getToken()!==2?G(7,[2],[]):M(),!0}function H(){I(),M();let ee=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),N(","),M(),t.getToken()===4&&j)break}else ee&&G(6,[],[]);Z()||G(4,[],[4,5]),ee=!0}return _(),t.getToken()!==4?G(8,[4],[]):M(),!0}function Z(){switch(t.getToken()){case 3:return H();case 1:return X();case 10:return K(!0);default:return x()}}return M(),t.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):Z()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=m;function S(r,a){let i=T(r),t=[],s,o=0,c;do switch(c=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==c&&t.push(r.substring(o,c)),a!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(s!==17);return t.join("")}e.stripComments=S;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[49],ne([0,1,35]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,P,C){let f,y,h,p,d;if(P){for(p=P.offset,d=p+P.length,h=p;h>0&&!b(E,h-1);)h--;let c=d;for(;c<E.length&&!b(E,c);)c++;y=E.substring(h,c),f=T(y,C)}else y=E,f=0,h=0,p=0,d=E.length;const g=R(C,E);let w=!1,m=0,S;C.insertSpaces?S=A(" ",C.tabSize||4):S="	";const l=(0,D.createScanner)(y,!1);let r=!1;function a(){return g+A(S,f+m)}function i(){let c=l.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=l.scan();return r=c===16||l.getTokenError()!==0,c}const t=[];function s(c,u,v){!r&&u<d&&v>p&&E.substring(u,v)!==c&&t.push({offset:u,length:v-u,content:c})}let o=i();if(o!==17){const c=l.getTokenOffset()+h,u=A(S,f);s(u,h,c)}for(;o!==17;){let c=l.getTokenOffset()+l.getTokenLength()+h,u=i(),v="";for(;!w&&(u===12||u===13);){const _=l.getTokenOffset()+h;s(" ",c,_),c=l.getTokenOffset()+l.getTokenLength()+h,v=u===12?a():"",u=i()}if(u===2)o!==1&&(m--,v=a());else if(u===4)o!==3&&(m--,v=a());else{switch(o){case 3:case 1:m++,v=a();break;case 5:case 12:v=a();break;case 13:w?v=a():v=" ";break;case 6:v=" ";break;case 10:if(u===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?v=" ":u!==5&&u!==17&&(r=!0);break;case 16:r=!0;break}w&&(u===12||u===13)&&(v=a())}const I=l.getTokenOffset()+h;s(v,c,I),o=u}return t}e.format=n;function k(E,P){const C=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?C.replace(/\r\n|\r|\n/g,P.eol):C}e.toFormattedString=k;function A(E,P){let C="";for(let f=0;f<P;f++)C+=E;return C}function T(E,P){let C=0,f=0;const y=P.tabSize||4;for(;C<E.length;){const h=E.charAt(C);if(h===" ")f++;else if(h==="	")f+=y;else break;C++}return Math.floor(f/y)}function R(E,P){for(let C=0;C<P.length;C++){const f=P.charAt(C);if(f==="\r")return C+1<P.length&&P.charAt(C+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=R;function b(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}e.isEOL=b}),define(te[69],ne([0,1,35,49]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(E,P,C){return A(E,P,void 0,C)}e.removeProperty=k;function A(E,P,C,f,y){const h=P.slice(),p=[],d=(0,D.parseTree)(E,p);let g,w;for(;h.length>0&&(w=h.pop(),g=(0,D.findNodeAtLocation)(d,h),g===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const m=(0,D.findNodeAtLocation)(g,[w]);if(m!==void 0)if(C===void 0){if(!m.parent)throw new Error("Malformed AST");const S=g.children.indexOf(m.parent);let l,r=m.parent.offset+m.parent.length;if(S>0){const a=g.children[S-1];l=a.offset+a.length}else l=g.offset+1,g.children.length>1&&(r=g.children[1].offset);return T(E,{offset:l,length:r-l,content:""},f)}else return T(E,{offset:m.offset,length:m.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const S=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,l=y?y(g.children.map(a=>a.children[0].value)):g.children.length;let r;if(l>0){const a=g.children[l-1];r={offset:a.offset+a.length,length:0,content:","+S}}else g.children.length===0?r={offset:g.offset+1,length:0,content:S}:r={offset:g.offset+1,length:0,content:S+","};return T(E,r,f)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(C!==void 0){const m=`${JSON.stringify(C)}`;let S;if(g.children.length===0||w===0)S={offset:g.offset+1,length:0,content:g.children.length===0?m:m+","};else{const l=w===-1||w>g.children.length?g.children.length:w,r=g.children[l-1];S={offset:r.offset+r.length,length:0,content:","+m}}return T(E,S,f)}else{const m=w,S=g.children[m];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===m){const r=g.children[m-1],a=r.offset+r.length,i=g.offset+g.length;l={offset:a,length:i-2-a,content:""}}else l={offset:S.offset,length:g.children[m+1].offset-S.offset,content:""};return T(E,l,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return T(E,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(C)},f)}}e.setProperty=A;function T(E,P,C){let f=R(E,P),y=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;y>0&&!(0,n.isEOL)(f,y-1);)y--;for(;h<f.length&&!(0,n.isEOL)(f,h);)h++}const p=(0,n.format)(f,{offset:y,length:h-y},C);for(let g=p.length-1;g>=0;g--){const w=p[g];f=R(f,w),y=Math.min(y,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const d=E.length-(f.length-h)-y;return[{offset:y,length:d,content:f.substring(y,h)}]}e.withFormatting=T;function R(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}e.applyEdit=R;function b(E,P){let C=P.slice(0).sort((y,h)=>{const p=y.offset-h.offset;return p===0?y.length-h.length:p}),f=E.length;for(let y=C.length-1;y>=0;y--){let h=C[y];if(h.offset+h.length<=f)E=R(E,h);else throw new Error("Overlapping edit");f=h.offset}return E}e.applyEdits=b}),define(te[100],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new D(()=>k(this.getValue()))}}e.Lazy=D}),define(te[2],ne([0,1,68,55]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let A=null;function T(t){A=t}if(e.setDisposableTracker=T,k){const t="__is_disposable_tracked__";T(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function R(t){return A?.trackDisposable(t),t}function b(t){A?.markAsDisposed(t)}function E(t,s){A?.setParent(t,s)}function P(t,s){if(!!A)for(const o of t)A.setParent(o,s)}function C(t){return A?.markAsSingleton(t),t}e.markAsSingleton=C;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function y(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=y;function h(t){if(n.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function p(...t){const s=d(()=>h(t));return P(t,s),s}e.combinedDisposable=p;function d(t){const s=R({dispose:(0,D.once)(()=>{b(s),t()})});return s}e.toDisposable=d;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return E(s,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new g,R(this),E(this._store,this)}dispose(){b(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&E(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&E(s,null),s}}e.MutableDisposable=m;class S{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=S;class l{constructor(){this.references=new Map}acquire(s,...o){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,c));const{object:u}=c,v=(0,D.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:u,dispose:v}}}e.ReferenceCollection=l;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const c=this.referenceCollection.acquire(s,...o);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(u){throw c.dispose(),u}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function i(t){const s=new g;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=i}),define(te[101],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let A=this._first;for(;A!==D.Undefined;){const T=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const R=new D(A);if(this._first===D.Undefined)this._first=R,this._last=R;else if(T){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==D.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==D.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===D.Undefined&&A.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):A.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):A.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.LinkedList=n}),function(){function Y(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function T(b){A.push(b,Date.now())}function R(){const b=[];for(let E=0;E<A.length;E+=2)b.push({name:A[E],startTime:A[E+1]});return b}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(k+T.startTime)});return A}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(te[4],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let n=!1,k=!1,A=!1,T=!1,R=!1,b=!1,E=!1,P=!1,C,f=D,y,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const d=typeof p?.versions?.electron=="string",g=d&&p?.type==="renderer";if(e.isElectronSandboxed=g&&p?.sandboxed,typeof navigator=="object"&&!g)h=navigator.userAgent,n=h.indexOf("Windows")>=0,k=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,b=!0,C=navigator.language,f=C;else if(typeof p=="object"){n=p.platform==="win32",k=p.platform==="darwin",A=p.platform==="linux",T=A&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,E=d,C=D,f=D;const s=p.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),c=o.availableLanguages["*"];C=o.locale,f=c||D,y=o._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function m(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let S=0;k?S=1:n?S=3:A&&(S=2),e.isWindows=n,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=T,e.isNative=R,e.isElectron=E,e.isWeb=b,e.isIOS=P,e.platform=S,e.userAgent=h,e.language=f;var l;(function(s){function o(){return e.language}s.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function u(){return e.language==="en"}s.isDefault=u})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=y,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let u=0,v=s.length;u<v;u++){const I=s[u];if(I.id===c.data.vscodeScheduleAsyncWork){s.splice(u,1),I.callback();return}}});let o=0;return c=>{const u=++o;s.push({id:u,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||P?2:n?1:3;let a=!0,i=!1;function t(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(te[32],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const k=D.globals.vscode.process;n={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(te[10],ne([0,1,32]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,k=97,A=90,T=122,R=46,b=47,E=92,P=58,C=63;class f extends Error{constructor(S,l,r){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const i=S.indexOf(".")!==-1?"property":"argument";let t=`The "${S}" ${i} ${a} of type ${l}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function y(m,S){if(typeof m!="string")throw new f(S,"string",m)}function h(m){return m===b||m===E}function p(m){return m===b}function d(m){return m>=n&&m<=A||m>=k&&m<=T}function g(m,S,l,r){let a="",i=0,t=-1,s=0,o=0;for(let c=0;c<=m.length;++c){if(c<m.length)o=m.charCodeAt(c);else{if(r(o))break;o=b}if(r(o)){if(!(t===c-1||s===1))if(s===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const u=a.lastIndexOf(l);u===-1?(a="",i=0):(a=a.slice(0,u),i=a.length-1-a.lastIndexOf(l)),t=c,s=0;continue}else if(a.length!==0){a="",i=0,t=c,s=0;continue}}S&&(a+=a.length>0?`${l}..`:"..",i=2)}else a.length>0?a+=`${l}${m.slice(t+1,c)}`:a=m.slice(t+1,c),i=c-t-1;t=c,s=0}else o===R&&s!==-1?++s:s=-1}return a}function w(m,S){if(S===null||typeof S!="object")throw new f("pathObject","Object",S);const l=S.dir||S.root,r=S.base||`${S.name||""}${S.ext||""}`;return l?l===S.root?`${l}${r}`:`${l}${m}${r}`:r}e.win32={resolve(...m){let S="",l="",r=!1;for(let a=m.length-1;a>=-1;a--){let i;if(a>=0){if(i=m[a],y(i,"path"),i.length===0)continue}else S.length===0?i=D.cwd():(i=D.env[`=${S}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==S.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${S}\\`));const t=i.length;let s=0,o="",c=!1;const u=i.charCodeAt(0);if(t===1)h(u)&&(s=1,c=!0);else if(h(u))if(c=!0,h(i.charCodeAt(1))){let v=2,I=v;for(;v<t&&!h(i.charCodeAt(v));)v++;if(v<t&&v!==I){const _=i.slice(I,v);for(I=v;v<t&&h(i.charCodeAt(v));)v++;if(v<t&&v!==I){for(I=v;v<t&&!h(i.charCodeAt(v));)v++;(v===t||v!==I)&&(o=`\\\\${_}\\${i.slice(I,v)}`,s=v)}}}else s=1;else d(u)&&i.charCodeAt(1)===P&&(o=i.slice(0,2),s=2,t>2&&h(i.charCodeAt(2))&&(c=!0,s=3));if(o.length>0)if(S.length>0){if(o.toLowerCase()!==S.toLowerCase())continue}else S=o;if(r){if(S.length>0)break}else if(l=`${i.slice(s)}\\${l}`,r=c,c&&S.length>0)break}return l=g(l,!r,"\\",h),r?`${S}\\${l}`:`${S}${l}`||"."},normalize(m){y(m,"path");const S=m.length;if(S===0)return".";let l=0,r,a=!1;const i=m.charCodeAt(0);if(S===1)return p(i)?"\\":m;if(h(i))if(a=!0,h(m.charCodeAt(1))){let s=2,o=s;for(;s<S&&!h(m.charCodeAt(s));)s++;if(s<S&&s!==o){const c=m.slice(o,s);for(o=s;s<S&&h(m.charCodeAt(s));)s++;if(s<S&&s!==o){for(o=s;s<S&&!h(m.charCodeAt(s));)s++;if(s===S)return`\\\\${c}\\${m.slice(o)}\\`;s!==o&&(r=`\\\\${c}\\${m.slice(o,s)}`,l=s)}}}else l=1;else d(i)&&m.charCodeAt(1)===P&&(r=m.slice(0,2),l=2,S>2&&h(m.charCodeAt(2))&&(a=!0,l=3));let t=l<S?g(m.slice(l),!a,"\\",h):"";return t.length===0&&!a&&(t="."),t.length>0&&h(m.charCodeAt(S-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(m){y(m,"path");const S=m.length;if(S===0)return!1;const l=m.charCodeAt(0);return h(l)||S>2&&d(l)&&m.charCodeAt(1)===P&&h(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let S,l;for(let i=0;i<m.length;++i){const t=m[i];y(t,"path"),t.length>0&&(S===void 0?S=l=t:S+=`\\${t}`)}if(S===void 0)return".";let r=!0,a=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++a;const i=l.length;i>1&&h(l.charCodeAt(1))&&(++a,i>2&&(h(l.charCodeAt(2))?++a:r=!1))}if(r){for(;a<S.length&&h(S.charCodeAt(a));)a++;a>=2&&(S=`\\${S.slice(a)}`)}return e.win32.normalize(S)},relative(m,S){if(y(m,"from"),y(S,"to"),m===S)return"";const l=e.win32.resolve(m),r=e.win32.resolve(S);if(l===r||(m=l.toLowerCase(),S=r.toLowerCase(),m===S))return"";let a=0;for(;a<m.length&&m.charCodeAt(a)===E;)a++;let i=m.length;for(;i-1>a&&m.charCodeAt(i-1)===E;)i--;const t=i-a;let s=0;for(;s<S.length&&S.charCodeAt(s)===E;)s++;let o=S.length;for(;o-1>s&&S.charCodeAt(o-1)===E;)o--;const c=o-s,u=t<c?t:c;let v=-1,I=0;for(;I<u;I++){const O=m.charCodeAt(a+I);if(O!==S.charCodeAt(s+I))break;O===E&&(v=I)}if(I!==u){if(v===-1)return r}else{if(c>u){if(S.charCodeAt(s+I)===E)return r.slice(s+I+1);if(I===2)return r.slice(s+I)}t>u&&(m.charCodeAt(a+I)===E?v=I:I===2&&(v=3)),v===-1&&(v=0)}let _="";for(I=a+v+1;I<=i;++I)(I===i||m.charCodeAt(I)===E)&&(_+=_.length===0?"..":"\\..");return s+=v,_.length>0?`${_}${r.slice(s,o)}`:(r.charCodeAt(s)===E&&++s,r.slice(s,o))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const S=e.win32.resolve(m);if(S.length<=2)return m;if(S.charCodeAt(0)===E){if(S.charCodeAt(1)===E){const l=S.charCodeAt(2);if(l!==C&&l!==R)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(d(S.charCodeAt(0))&&S.charCodeAt(1)===P&&S.charCodeAt(2)===E)return`\\\\?\\${S}`;return m},dirname(m){y(m,"path");const S=m.length;if(S===0)return".";let l=-1,r=0;const a=m.charCodeAt(0);if(S===1)return h(a)?m:".";if(h(a)){if(l=r=1,h(m.charCodeAt(1))){let s=2,o=s;for(;s<S&&!h(m.charCodeAt(s));)s++;if(s<S&&s!==o){for(o=s;s<S&&h(m.charCodeAt(s));)s++;if(s<S&&s!==o){for(o=s;s<S&&!h(m.charCodeAt(s));)s++;if(s===S)return m;s!==o&&(l=r=s+1)}}}}else d(a)&&m.charCodeAt(1)===P&&(l=S>2&&h(m.charCodeAt(2))?3:2,r=l);let i=-1,t=!0;for(let s=S-1;s>=r;--s)if(h(m.charCodeAt(s))){if(!t){i=s;break}}else t=!1;if(i===-1){if(l===-1)return".";i=l}return m.slice(0,i)},basename(m,S){S!==void 0&&y(S,"ext"),y(m,"path");let l=0,r=-1,a=!0,i;if(m.length>=2&&d(m.charCodeAt(0))&&m.charCodeAt(1)===P&&(l=2),S!==void 0&&S.length>0&&S.length<=m.length){if(S===m)return"";let t=S.length-1,s=-1;for(i=m.length-1;i>=l;--i){const o=m.charCodeAt(i);if(h(o)){if(!a){l=i+1;break}}else s===-1&&(a=!1,s=i+1),t>=0&&(o===S.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=m.length),m.slice(l,r)}for(i=m.length-1;i>=l;--i)if(h(m.charCodeAt(i))){if(!a){l=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":m.slice(l,r)},extname(m){y(m,"path");let S=0,l=-1,r=0,a=-1,i=!0,t=0;m.length>=2&&m.charCodeAt(1)===P&&d(m.charCodeAt(0))&&(S=r=2);for(let s=m.length-1;s>=S;--s){const o=m.charCodeAt(s);if(h(o)){if(!i){r=s+1;break}continue}a===-1&&(i=!1,a=s+1),o===R?l===-1?l=s:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===r+1?"":m.slice(l,a)},format:w.bind(null,"\\"),parse(m){y(m,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return S;const l=m.length;let r=0,a=m.charCodeAt(0);if(l===1)return h(a)?(S.root=S.dir=m,S):(S.base=S.name=m,S);if(h(a)){if(r=1,h(m.charCodeAt(1))){let v=2,I=v;for(;v<l&&!h(m.charCodeAt(v));)v++;if(v<l&&v!==I){for(I=v;v<l&&h(m.charCodeAt(v));)v++;if(v<l&&v!==I){for(I=v;v<l&&!h(m.charCodeAt(v));)v++;v===l?r=v:v!==I&&(r=v+1)}}}}else if(d(a)&&m.charCodeAt(1)===P){if(l<=2)return S.root=S.dir=m,S;if(r=2,h(m.charCodeAt(2))){if(l===3)return S.root=S.dir=m,S;r=3}}r>0&&(S.root=m.slice(0,r));let i=-1,t=r,s=-1,o=!0,c=m.length-1,u=0;for(;c>=r;--c){if(a=m.charCodeAt(c),h(a)){if(!o){t=c+1;break}continue}s===-1&&(o=!1,s=c+1),a===R?i===-1?i=c:u!==1&&(u=1):i!==-1&&(u=-1)}return s!==-1&&(i===-1||u===0||u===1&&i===s-1&&i===t+1?S.base=S.name=m.slice(t,s):(S.name=m.slice(t,i),S.base=m.slice(t,s),S.ext=m.slice(i,s))),t>0&&t!==r?S.dir=m.slice(0,t-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let S="",l=!1;for(let r=m.length-1;r>=-1&&!l;r--){const a=r>=0?m[r]:D.cwd();y(a,"path"),a.length!==0&&(S=`${a}/${S}`,l=a.charCodeAt(0)===b)}return S=g(S,!l,"/",p),l?`/${S}`:S.length>0?S:"."},normalize(m){if(y(m,"path"),m.length===0)return".";const S=m.charCodeAt(0)===b,l=m.charCodeAt(m.length-1)===b;return m=g(m,!S,"/",p),m.length===0?S?"/":l?"./":".":(l&&(m+="/"),S?`/${m}`:m)},isAbsolute(m){return y(m,"path"),m.length>0&&m.charCodeAt(0)===b},join(...m){if(m.length===0)return".";let S;for(let l=0;l<m.length;++l){const r=m[l];y(r,"path"),r.length>0&&(S===void 0?S=r:S+=`/${r}`)}return S===void 0?".":e.posix.normalize(S)},relative(m,S){if(y(m,"from"),y(S,"to"),m===S||(m=e.posix.resolve(m),S=e.posix.resolve(S),m===S))return"";const l=1,r=m.length,a=r-l,i=1,t=S.length-i,s=a<t?a:t;let o=-1,c=0;for(;c<s;c++){const v=m.charCodeAt(l+c);if(v!==S.charCodeAt(i+c))break;v===b&&(o=c)}if(c===s)if(t>s){if(S.charCodeAt(i+c)===b)return S.slice(i+c+1);if(c===0)return S.slice(i+c)}else a>s&&(m.charCodeAt(l+c)===b?o=c:c===0&&(o=0));let u="";for(c=l+o+1;c<=r;++c)(c===r||m.charCodeAt(c)===b)&&(u+=u.length===0?"..":"/..");return`${u}${S.slice(i+o)}`},toNamespacedPath(m){return m},dirname(m){if(y(m,"path"),m.length===0)return".";const S=m.charCodeAt(0)===b;let l=-1,r=!0;for(let a=m.length-1;a>=1;--a)if(m.charCodeAt(a)===b){if(!r){l=a;break}}else r=!1;return l===-1?S?"/":".":S&&l===1?"//":m.slice(0,l)},basename(m,S){S!==void 0&&y(S,"ext"),y(m,"path");let l=0,r=-1,a=!0,i;if(S!==void 0&&S.length>0&&S.length<=m.length){if(S===m)return"";let t=S.length-1,s=-1;for(i=m.length-1;i>=0;--i){const o=m.charCodeAt(i);if(o===b){if(!a){l=i+1;break}}else s===-1&&(a=!1,s=i+1),t>=0&&(o===S.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=m.length),m.slice(l,r)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===b){if(!a){l=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":m.slice(l,r)},extname(m){y(m,"path");let S=-1,l=0,r=-1,a=!0,i=0;for(let t=m.length-1;t>=0;--t){const s=m.charCodeAt(t);if(s===b){if(!a){l=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===R?S===-1?S=t:i!==1&&(i=1):S!==-1&&(i=-1)}return S===-1||r===-1||i===0||i===1&&S===r-1&&S===l+1?"":m.slice(S,r)},format:w.bind(null,"/"),parse(m){y(m,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return S;const l=m.charCodeAt(0)===b;let r;l?(S.root="/",r=1):r=0;let a=-1,i=0,t=-1,s=!0,o=m.length-1,c=0;for(;o>=r;--o){const u=m.charCodeAt(o);if(u===b){if(!s){i=o+1;break}continue}t===-1&&(s=!1,t=o+1),u===R?a===-1?a=o:c!==1&&(c=1):a!==-1&&(c=-1)}if(t!==-1){const u=i===0&&l?1:i;a===-1||c===0||c===1&&a===t-1&&a===i+1?S.base=S.name=m.slice(u,t):(S.name=m.slice(u,a),S.base=m.slice(u,t),S.ext=m.slice(a,t))}return i>0?S.dir=m.slice(0,i-1):l&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1,10]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(C){const f=(0,D.extname)(C),y=k[f.toLowerCase()];return y!==void 0?y:R(C)}e.getMediaOrTextMime=T;function R(C){const f=(0,D.extname)(C);return A[f.toLowerCase()]}e.getMediaMime=R;function b(C){for(const f in A)if(A[f]===C)return f}e.getExtensionForMimeType=b;const E=/^(.+)\/(.+?)(;.+)?$/;function P(C,f){const y=E.exec(C);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:f?void 0:C}e.normalizeMimeType=P}),define(te[103],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var n;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(A,...T){const R=T.reduce((P,C)=>(P[C]=!0,P),{}),b=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(P=>!R[P]).forEach(P=>{for(let C=0;C<b.length;C++)if(P.search(b[C])!==-1){delete A[P];break}})}e.sanitizeProcessEnvironment=k}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:Y)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function D(n){if(e[n])return e[n].exports;var k=e[n]={i:n,l:!1,exports:{}};return Y[n].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=Y,D.c=e,D.d=function(n,k,A){D.o(n,k)||Object.defineProperty(n,k,{enumerable:!0,get:A})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,k){if(1&k&&(n=D(n)),8&k||4&k&&typeof n=="object"&&n&&n.__esModule)return n;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:n}),2&k&&typeof n!="string")for(var T in n)D.d(A,T,function(R){return n[R]}.bind(null,T));return A},D.n=function(n){var k=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(k,"a",k),k},D.o=function(n,k){return Object.prototype.hasOwnProperty.call(n,k)},D.p="",D(D.s=0)}([function(Y,e,D){(function(n){var k;e=Y.exports=F,k=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],E=0,P=E++;b[P]="0|[1-9]\\d*";var C=E++;b[C]="[0-9]+";var f=E++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;b[y]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var h=E++;b[h]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var p=E++;b[p]="(?:"+b[P]+"|"+b[f]+")";var d=E++;b[d]="(?:"+b[C]+"|"+b[f]+")";var g=E++;b[g]="(?:-("+b[p]+"(?:\\."+b[p]+")*))";var w=E++;b[w]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var m=E++;b[m]="[0-9A-Za-z-]+";var S=E++;b[S]="(?:\\+("+b[m]+"(?:\\."+b[m]+")*))";var l=E++,r="v?"+b[y]+b[g]+"?"+b[S]+"?";b[l]="^"+r+"$";var a="[v=\\s]*"+b[h]+b[w]+"?"+b[S]+"?",i=E++;b[i]="^"+a+"$";var t=E++;b[t]="((?:<|>)?=?)";var s=E++;b[s]=b[C]+"|x|X|\\*";var o=E++;b[o]=b[P]+"|x|X|\\*";var c=E++;b[c]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[g]+")?"+b[S]+"?)?)?";var u=E++;b[u]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[w]+")?"+b[S]+"?)?)?";var v=E++;b[v]="^"+b[t]+"\\s*"+b[c]+"$";var I=E++;b[I]="^"+b[t]+"\\s*"+b[u]+"$";var _=E++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;b[O]="(?:~>?)";var N=E++;b[N]="(\\s*)"+b[O]+"\\s+",R[N]=new RegExp(b[N],"g");var $=E++;b[$]="^"+b[O]+b[c]+"$";var L=E++;b[L]="^"+b[O]+b[u]+"$";var U=E++;b[U]="(?:\\^)";var j=E++;b[j]="(\\s*)"+b[U]+"\\s+",R[j]=new RegExp(b[j],"g");var M=E++;b[M]="^"+b[U]+b[c]+"$";var G=E++;b[G]="^"+b[U]+b[u]+"$";var K=E++;b[K]="^"+b[t]+"\\s*("+a+")$|^$";var x=E++;b[x]="^"+b[t]+"\\s*("+r+")$|^$";var q=E++;b[q]="(\\s*)"+b[t]+"\\s*("+a+"|"+b[c]+")",R[q]=new RegExp(b[q],"g");var X=E++;b[X]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var H=E++;b[H]="^\\s*("+b[u]+")\\s+-\\s+("+b[u]+")\\s*$";var Z=E++;b[Z]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)k(ee,b[ee]),R[ee]||(R[ee]=new RegExp(b[ee]));function W(re,ae){if(re instanceof F)return re;if(typeof re!="string"||re.length>A||!(ae?R[i]:R[l]).test(re))return null;try{return new F(re,ae)}catch{return null}}function F(re,ae){if(re instanceof F){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(re,ae);k("SemVer",re,ae),this.loose=ae;var ue=re.trim().match(ae?R[i]:R[l]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<T)return Ce}return be}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=W,e.valid=function(re,ae){var ue=W(re,ae);return ue?ue.version:null},e.clean=function(re,ae){var ue=W(re.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(re){return k("SemVer.compare",this.version,this.loose,re),re instanceof F||(re=new F(re,this.loose)),this.compareMain(re)||this.comparePre(re)},F.prototype.compareMain=function(re){return re instanceof F||(re=new F(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},F.prototype.comparePre=function(re){if(re instanceof F||(re=new F(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],be=re.prerelease[ae];if(k("prerelease compare",ae,ue,be),ue===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ue===void 0)return-1;if(ue!==be)return z(ue,be)}while(++ae)},F.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,ue,be){typeof ue=="string"&&(be=ue,ue=void 0);try{return new F(re,ue).inc(ae,be).version}catch{return null}},e.diff=function(re,ae){if(ce(re,ae))return null;var ue=W(re),be=W(ae);if(ue.prerelease.length||be.prerelease.length){for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return Ce},e.compareIdentifiers=z;var V=/^[0-9]+$/;function z(re,ae){var ue=V.test(re),be=V.test(ae);return ue&&be&&(re=+re,ae=+ae),ue&&!be?-1:be&&!ue?1:re<ae?-1:re>ae?1:0}function B(re,ae,ue){return new F(re,ue).compare(new F(ae,ue))}function ie(re,ae,ue){return B(re,ae,ue)>0}function se(re,ae,ue){return B(re,ae,ue)<0}function ce(re,ae,ue){return B(re,ae,ue)===0}function he(re,ae,ue){return B(re,ae,ue)!==0}function ge(re,ae,ue){return B(re,ae,ue)>=0}function me(re,ae,ue){return B(re,ae,ue)<=0}function ye(re,ae,ue,be){var Ce;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ce=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ce=re!==ue;break;case"":case"=":case"==":Ce=ce(re,ue,be);break;case"!=":Ce=he(re,ue,be);break;case">":Ce=ie(re,ue,be);break;case">=":Ce=ge(re,ue,be);break;case"<":Ce=se(re,ue,be);break;case"<=":Ce=me(re,ue,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function Se(re,ae){if(re instanceof Se){if(re.loose===ae)return re;re=re.value}if(!(this instanceof Se))return new Se(re,ae);k("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new F(re,ae).major},e.minor=function(re,ae){return new F(re,ae).minor},e.patch=function(re,ae){return new F(re,ae).patch},e.compare=B,e.compareLoose=function(re,ae){return B(re,ae,!0)},e.rcompare=function(re,ae,ue){return B(ae,re,ue)},e.sort=function(re,ae){return re.sort(function(ue,be){return e.compare(ue,be,ae)})},e.rsort=function(re,ae){return re.sort(function(ue,be){return e.rcompare(ue,be,ae)})},e.gt=ie,e.lt=se,e.eq=ce,e.neq=he,e.gte=ge,e.lte=me,e.cmp=ye,e.Comparator=Se;var Ie={};function Ee(re,ae){if(re instanceof Ee)return re.loose===ae?re:new Ee(re.raw,ae);if(re instanceof Se)return new Ee(re.value,ae);if(!(this instanceof Ee))return new Ee(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function De(re){return!re||re.toLowerCase()==="x"||re==="*"}function Fe(re,ae,ue,be,Ce,$e,Te,Oe,_e,Q,oe,le,fe){return((ae=De(ue)?"":De(be)?">="+ue+".0.0":De(Ce)?">="+ue+"."+be+".0":">="+ae)+" "+(Oe=De(_e)?"":De(Q)?"<"+(+_e+1)+".0.0":De(oe)?"<"+_e+"."+(+Q+1)+".0":le?"<="+_e+"."+Q+"."+oe+"-"+le:"<="+Oe)).trim()}function Ue(re,ae){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<re.length;ue++)if(k(re[ue].semver),re[ue].semver!==Ie&&re[ue].semver.prerelease.length>0){var be=re[ue].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function Ne(re,ae,ue){try{ae=new Ee(ae,ue)}catch{return!1}return ae.test(re)}function ze(re,ae,ue,be){var Ce,$e,Te,Oe,_e;switch(re=new F(re,be),ae=new Ee(ae,be),ue){case">":Ce=ie,$e=me,Te=se,Oe=">",_e=">=";break;case"<":Ce=se,$e=ge,Te=ie,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(re,ae,be))return!1;for(var Q=0;Q<ae.set.length;++Q){var oe=ae.set[Q],le=null,fe=null;if(oe.forEach(function(ve){ve.semver===Ie&&(ve=new Se(">=0.0.0")),le=le||ve,fe=fe||ve,Ce(ve.semver,le.semver,be)?le=ve:Te(ve.semver,fe.semver,be)&&(fe=ve)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&$e(re,fe.semver)||fe.operator===_e&&Te(re,fe.semver))return!1}return!0}Se.prototype.parse=function(re){var ae=this.loose?R[K]:R[x],ue=re.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new F(ue[2],this.loose):this.semver=Ie},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(re){return k("Comparator.test",re,this.loose),this.semver===Ie||(typeof re=="string"&&(re=new F(re,this.loose)),ye(re,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(re,ae){if(!(re instanceof Se))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ee(re.value,ae),Ne(this.value,ue,ae);if(re.operator==="")return ue=new Ee(this.value,ae),Ne(re.semver,ue,ae);var be=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),$e=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=ye(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=ye(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return be||Ce||$e&&Te||Oe||_e},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),k("range",re,ae);var ue=ae?R[H]:R[X];re=re.replace(ue,Fe),k("hyphen replace",re),re=re.replace(R[q],"$1$2$3"),k("comparator trim",re,R[q]),re=(re=(re=re.replace(R[N],"$1~")).replace(R[j],"$1^")).split(/\s+/).join(" ");var be=ae?R[K]:R[x],Ce=re.split(" ").map(function($e){return function(Te,Oe){return k("comp",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){k("caret",le,fe);var ve=fe?R[G]:R[M];return le.replace(ve,function(Le,we,Re,ke,Pe){var Ae;return k("caret",le,Le,we,Re,ke,Pe),De(we)?Ae="":De(Re)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?Ae=we==="0"?">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+".0 <"+(+we+1)+".0.0":Pe?(k("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=we==="0"?Re==="0"?">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+Re+"."+(+ke+1):">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+"."+ke+Pe+" <"+(+we+1)+".0.0"):(k("no pr"),Ae=we==="0"?Re==="0"?">="+we+"."+Re+"."+ke+" <"+we+"."+Re+"."+(+ke+1):">="+we+"."+Re+"."+ke+" <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+"."+ke+" <"+(+we+1)+".0.0"),k("caret return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),k("caret",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var ve=fe?R[L]:R[$];return le.replace(ve,function(Le,we,Re,ke,Pe){var Ae;return k("tilde",le,Le,we,Re,ke,Pe),De(we)?Ae="":De(Re)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?Ae=">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0":Pe?(k("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+(+Re+1)+".0"):Ae=">="+we+"."+Re+"."+ke+" <"+we+"."+(+Re+1)+".0",k("tilde return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),k("tildes",Te),Te=function(_e,Q){return k("replaceXRanges",_e,Q),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var ve=fe?R[I]:R[v];return le.replace(ve,function(Le,we,Re,ke,Pe,Ae){k("xRange",le,Le,we,Re,ke,Pe,Ae);var We=De(Re),xe=We||De(ke),Be=xe||De(Pe);return we==="="&&Be&&(we=""),We?Le=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(xe&&(ke=0),Be&&(Pe=0),we===">"?(we=">=",xe?(Re=+Re+1,ke=0,Pe=0):Be&&(ke=+ke+1,Pe=0)):we==="<="&&(we="<",xe?Re=+Re+1:ke=+ke+1),Le=we+Re+"."+ke+"."+Pe):xe?Le=">="+Re+".0.0 <"+(+Re+1)+".0.0":Be&&(Le=">="+Re+"."+ke+".0 <"+Re+"."+(+ke+1)+".0"),k("xRange return",Le),Le})}(oe,Q)}).join(" ")}(Te,Oe),k("xrange",Te),Te=function(_e,Q){return k("replaceStars",_e,Q),_e.trim().replace(R[Z],"")}(Te,Oe),k("stars",Te),Te}($e,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function($e){return!!$e.match(be)})),Ce=Ce.map(function($e){return new Se($e,ae)})},Ee.prototype.intersects=function(re,ae){if(!(re instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(be){return re.set.some(function(Ce){return Ce.every(function($e){return be.intersects($e,ae)})})})})},e.toComparators=function(re,ae){return new Ee(re,ae).set.map(function(ue){return ue.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new F(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ue(this.set[ae],re))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(re,ae,ue){var be=null,Ce=null;try{var $e=new Ee(ae,ue)}catch{return null}return re.forEach(function(Te){$e.test(Te)&&(be&&Ce.compare(Te)!==-1||(Ce=new F(be=Te,ue)))}),be},e.minSatisfying=function(re,ae,ue){var be=null,Ce=null;try{var $e=new Ee(ae,ue)}catch{return null}return re.forEach(function(Te){$e.test(Te)&&(be&&Ce.compare(Te)!==1||(Ce=new F(be=Te,ue)))}),be},e.validRange=function(re,ae){try{return new Ee(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,ue){return ze(re,ae,"<",ue)},e.gtr=function(re,ae,ue){return ze(re,ae,">",ue)},e.outside=ze,e.prerelease=function(re,ae){var ue=W(re,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ae,ue){return re=new Ee(re,ue),ae=new Ee(ae,ue),re.intersects(ae)},e.coerce=function(re){if(re instanceof F)return re;if(typeof re!="string")return null;var ae=re.match(R[_]);return ae==null?null:W((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(Y,e){var D,n,k=Y.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(d){if(D===setTimeout)return setTimeout(d,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var b,E=[],P=!1,C=-1;function f(){P&&b&&(P=!1,b.length?E=b.concat(E):C=-1,E.length&&y())}function y(){if(!P){var d=R(f);P=!0;for(var g=E.length;g;){for(b=E,E=[];++C<g;)b&&b[C].run();C=-1,g=E.length}b=null,P=!1,function(w){if(n===clearTimeout)return clearTimeout(w);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(w);try{n(w)}catch{try{return n.call(null,w)}catch{return n.call(this,w)}}}(d)}}function h(d,g){this.fun=d,this.array=g}function p(){}k.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)g[w-1]=arguments[w];E.push(new h(d,g)),E.length!==1||P||R(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=p,k.addListener=p,k.once=p,k.off=p,k.removeListener=p,k.removeAllListeners=p,k.emit=p,k.prependListener=p,k.prependOnceListener=p,k.listeners=function(d){return[]},k.binding=function(d){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(d){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[104],ne([0,1]),function(Y,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,b,E){this.level=R,this.key=b,this.value=E,this.forward=[]}}const k=void 0;class A{constructor(R,b=2**16){this.comparator=R,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new n(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,k,k)}has(R){return Boolean(A._search(this,R,this.comparator))}get(R){return A._search(this,R,this.comparator)?.value}set(R,b){return A._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=A._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let E=this._header.forward[0];for(;E;)R.call(b,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,E){let P=R._header;for(let C=R._level-1;C>=0;C--)for(;P.forward[C]&&E(P.forward[C].key,b)<0;)P=P.forward[C];if(P=P.forward[0],P&&E(P.key,b)===0)return P}static _insert(R,b,E,P){let C=[],f=R._header;for(let y=R._level-1;y>=0;y--){for(;f.forward[y]&&P(f.forward[y].key,b)<0;)f=f.forward[y];C[y]=f}if(f=f.forward[0],f&&P(f.key,b)===0)return f.value=E,!1;{let y=A._randomLevel(R);if(y>R._level){for(let h=R._level;h<y;h++)C[h]=R._header;R._level=y}f=new n(y,b,E);for(let h=0;h<y;h++)f.forward[h]=C[h].forward[h],C[h].forward[h]=f;return!0}}static _randomLevel(R,b=.5){let E=1;for(;Math.random()<b&&E<R._maxLevel;)E+=1;return E}static _delete(R,b,E){let P=[],C=R._header;for(let f=R._level-1;f>=0;f--){for(;C.forward[f]&&E(C.forward[f].key,b)<0;)C=C.forward[f];P[f]=C}if(C=C.forward[0],!C||E(C.key,b)!==0)return!1;for(let f=0;f<R._level&&P[f].forward[f]===C;f++)P[f].forward[f]=C.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===k;)R._level-=1;return!0}}e.SkipList=A}),define(te[105],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class k{constructor(T){this._highResolution=n&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=k}),define(te[3],ne([0,1,9,68,2,101,105]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(S){S.None=()=>k.Disposable.None;function l(K){return(x,q=null,X)=>{let H=!1,Z;return Z=K(ee=>{if(!H)return Z?Z.dispose():H=!0,x.call(q,ee)},null,X),H&&Z.dispose(),Z}}S.once=l;function r(K,x){return c((q,X=null,H)=>K(Z=>q.call(X,x(Z)),null,H))}S.map=r;function a(K,x){return c((q,X=null,H)=>K(Z=>{x(Z),q.call(X,Z)},null,H))}S.forEach=a;function i(K,x){return c((q,X=null,H)=>K(Z=>x(Z)&&q.call(X,Z),null,H))}S.filter=i;function t(K){return K}S.signal=t;function s(...K){return(x,q=null,X)=>(0,k.combinedDisposable)(...K.map(H=>H(Z=>x.call(q,Z),null,X)))}S.any=s;function o(K,x,q){let X=q;return r(K,H=>(X=x(X,H),X))}S.reduce=o;function c(K){let x;const q=new f({onFirstListenerAdd(){x=K(q.fire,q)},onLastListenerRemove(){x.dispose()}});return q.event}function u(K,x,q,X=100,H=!1){let Z,ee,W=0;return K(F=>{W++,Z=q(Z,F),H&&!ee&&(x(Z),Z=void 0),clearTimeout(ee),ee=setTimeout(()=>{const V=Z;Z=void 0,ee=void 0,(!H||W>1)&&x(V),W=0},X)})}S.debouncedListener=u;function v(K,x,q=100,X=!1,H){let Z,ee,W,F=0;const V=new f({leakWarningThreshold:H,onFirstListenerAdd(){Z=K(z=>{F++,ee=x(ee,z),X&&!W&&(V.fire(ee),ee=void 0),clearTimeout(W),W=setTimeout(()=>{const B=ee;ee=void 0,W=void 0,(!X||F>1)&&V.fire(B),F=0},q)})},onLastListenerRemove(){Z.dispose()}});return V.event}S.debounce=v;function I(K,x=(q,X)=>q===X){let q=!0,X;return i(K,H=>{const Z=q||!x(H,X);return q=!1,X=H,Z})}S.latch=I;function _(K,x){return[S.filter(K,x),S.filter(K,q=>!x(q))]}S.split=_;function O(K,x=!1,q=[]){let X=q.slice(),H=K(W=>{X?X.push(W):ee.fire(W)});const Z=()=>{X&&X.forEach(W=>ee.fire(W)),X=null},ee=new f({onFirstListenerAdd(){H||(H=K(W=>ee.fire(W)))},onFirstListenerDidAdd(){X&&(x?setTimeout(Z):Z())},onLastListenerRemove(){H&&H.dispose(),H=null}});return ee.event}S.buffer=O;class N{constructor(x){this.event=x}map(x){return new N(r(this.event,x))}forEach(x){return new N(a(this.event,x))}filter(x){return new N(i(this.event,x))}reduce(x,q){return new N(o(this.event,x,q))}latch(){return new N(I(this.event))}debounce(x,q=100,X=!1,H){return new N(v(this.event,x,q,X,H))}on(x,q,X){return this.event(x,q,X)}once(x,q,X){return l(this.event)(x,q,X)}}function $(K){return new N(K)}S.chain=$;function L(K,x,q=X=>X){const X=(...W)=>ee.fire(q(...W)),H=()=>K.on(x,X),Z=()=>K.removeListener(x,X),ee=new f({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}S.fromNodeEventEmitter=L;function U(K,x,q=X=>X){const X=(...W)=>ee.fire(q(...W)),H=()=>K.addEventListener(x,X),Z=()=>K.removeEventListener(x,X),ee=new f({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}S.fromDOMEventEmitter=U;function j(K){return new Promise(x=>l(K)(x))}S.toPromise=j;function M(K,x){return x(void 0),K(q=>x(q))}S.runAndSubscribe=M;function G(K,x){let q=null;function X(Z){q?.dispose(),q=new k.DisposableStore,x(Z,q)}X(void 0);const H=K(Z=>X(Z));return(0,k.toDisposable)(()=>{H.dispose(),q?.dispose()})}S.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class b{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${b._idPool++}`}start(l){this._stopWatch=new T.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let E=-1;function P(S){const l=E;return E=S,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=P;class C{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=E;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,c]of this._stacks)(!t||s<c)&&(t=o,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,a)=>{this._listeners||(this._listeners=new A.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof k.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(i){(0,D.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class y extends f{async fireAsync(l,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,token:r,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(c=a(c,typeof i=="function"?i:i[0])),s.push(c)}};try{typeof i=="function"?i.call(void 0,o):i[0].call(i[1],o)}catch(c){(0,D.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const u of c)u.status==="rejected"&&(0,D.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=y;class h extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class p extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=p;class d extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,k.toDisposable)((0,n.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,a,i)=>l(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,i)}bufferEvents(l){const r=[];this.buffers.push(r);const a=l();return this.buffers.pop(),r.forEach(i=>i()),a}}e.EventBufferer=w;class m{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=k.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=m}),define(te[25],ne([0,1,3]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,b){const E=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(E)}}});var k;(function(R){function b(E){return E===R.None||E===R.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(k=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=k.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(te[106],ne([0,1,25]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new D.CancellationTokenSource,R=this.task(T.token);return this.result={promise:R,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=n;class k{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const R=JSON.stringify(T);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=k}),define(te[40],ne([0,1,9,2]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(m){const S=m;return S?[S.on,S.pause,S.resume,S.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=k;function A(m){const S=m;return S?k(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=A;function T(m,S){return new R(m,S)}e.newWriteableStream=T;class R{constructor(S,l){this.reducer=S,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S!="undefined"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(l=>l(S))}emitError(S){this.listeners.error.length===0?(0,D.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(l=>l(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,l){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(S,l){if(this.state.destroyed)return;let r;switch(S){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(l);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(m,S){const l=[];let r;for(;(r=m.read())!==null;)l.push(r);return S(l)}e.consumeReadable=b;function E(m,S,l){const r=[];let a;for(;(a=m.read())!==null&&r.length<l;)r.push(a);return a===null&&r.length>0?S(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return m.read()}}}e.peekReadable=E;function P(m,S){return new Promise((l,r)=>{const a=[];C(m,{onData:i=>{S&&a.push(i)},onError:i=>{S?r(i):l(void 0)},onEnd:()=>{l(S?S(a):void 0)}})})}e.consumeStream=P;function C(m,S){let l=!1;return m.on("error",r=>{l||S.onError(r)}),m.on("end",()=>{l||S.onEnd()}),m.on("data",r=>{l||S.onData(r)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=C;function f(m,S){return new Promise((l,r)=>{const a=new n.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>S)return a.dispose(),m.pause(),l({stream:m,buffer:i,ended:!1})},s=c=>r(c),o=()=>l({stream:m,buffer:i,ended:!0});a.add((0,n.toDisposable)(()=>m.removeListener("error",s))),m.on("error",s),a.add((0,n.toDisposable)(()=>m.removeListener("end",o))),m.on("end",o),a.add((0,n.toDisposable)(()=>m.removeListener("data",t))),m.on("data",t)})}e.peekStream=f;function y(m,S){const l=T(S);return l.end(m),l}e.toStream=y;function h(){const m=T(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=h;function p(m){let S=!1;return{read:()=>S?null:(S=!0,m)}}e.toReadable=p;function d(m,S,l){const r=T(l);return C(m,{onData:a=>r.write(S.data(a)),onError:a=>r.error(S.error?S.error(a):a),onEnd:()=>r.end()}),r}e.transform=d;function g(m,S,l){let r=!1;return{read:()=>{const a=S.read();return r?a:(r=!0,a!==null?l([m,a]):m)}}}e.prefixedReadable=g;function w(m,S,l){let r=!1;const a=T(l);return C(S,{onData:i=>r?a.write(i):(r=!0,a.write(l([m,i]))),onError:i=>a.error(i),onEnd:()=>{r||(r=!0,a.write(m)),a.end()}}),a}e.prefixedStream=w}),define(te[17],ne([0,1,40]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let k,A;class T{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return n?new T(Buffer.allocUnsafe(u)):new T(new Uint8Array(u))}static wrap(u){return n&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new T(u)}static fromString(u,v){return!(v?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(u)):(k||(k=new TextEncoder),new T(k.encode(u)))}static fromByteArray(u){const v=T.alloc(u.length);for(let I=0,_=u.length;I<_;I++)v.buffer[I]=u[I];return v}static concat(u,v){if(typeof v=="undefined"){v=0;for(let O=0,N=u.length;O<N;O++)v+=u[O].byteLength}const I=T.alloc(v);let _=0;for(let O=0,N=u.length;O<N;O++){const $=u[O];I.set($,_),_+=$.byteLength}return I}clone(){const u=T.alloc(this.byteLength);return u.set(this),u}toString(){return n?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(u,v){return new T(this.buffer.subarray(u,v))}set(u,v){if(u instanceof T)this.buffer.set(u.buffer,v);else if(u instanceof Uint8Array)this.buffer.set(u,v);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),v);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),v);else throw new Error("Unkown argument 'array'")}readUInt32BE(u){return E(this.buffer,u)}writeUInt32BE(u,v){P(this.buffer,u,v)}readUInt32LE(u){return C(this.buffer,u)}writeUInt32LE(u,v){f(this.buffer,u,v)}readUInt8(u){return y(this.buffer,u)}writeUInt8(u,v){h(this.buffer,u,v)}}e.VSBuffer=T;function R(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=R;function b(c,u,v){c[v+0]=u&255,u=u>>>8,c[v+1]=u&255}e.writeUInt16LE=b;function E(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=E;function P(c,u,v){c[v+3]=u,u=u>>>8,c[v+2]=u,u=u>>>8,c[v+1]=u,u=u>>>8,c[v]=u}e.writeUInt32BE=P;function C(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=C;function f(c,u,v){c[v+0]=u&255,u=u>>>8,c[v+1]=u&255,u=u>>>8,c[v+2]=u&255,u=u>>>8,c[v+3]=u&255}e.writeUInt32LE=f;function y(c,u){return c[u]}e.readUInt8=y;function h(c,u,v){c[v]=u}e.writeUInt8=h;function p(c){return D.consumeReadable(c,u=>T.concat(u))}e.readableToBuffer=p;function d(c){return D.toReadable(c)}e.bufferToReadable=d;function g(c){return D.consumeStream(c,u=>T.concat(u))}e.streamToBuffer=g;async function w(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await g(c.stream)])}e.bufferedStreamToBuffer=w;function m(c){return D.toStream(c,u=>T.concat(u))}e.bufferToStream=m;function S(c){return D.transform(c,{data:u=>typeof u=="string"?T.fromString(u):T.wrap(u)},u=>T.concat(u))}e.streamToBufferReadableStream=S;function l(c){return D.newWriteableStream(u=>T.concat(u),c)}e.newWriteableBufferStream=l;function r(c,u){return D.prefixedReadable(c,u,v=>T.concat(v))}e.prefixedBufferReadable=r;function a(c,u){return D.prefixedStream(c,u,v=>T.concat(v))}e.prefixedBufferStream=a;function i(c){let u=0,v=0,I=0;const _=new Uint8Array(Math.floor(c.length/4*3)),O=$=>{switch(v){case 3:_[I++]=u|$,v=0;break;case 2:_[I++]=u|$>>>2,u=$<<6,v=3;break;case 1:_[I++]=u|$>>>4,u=$<<4,v=2;break;default:u=$<<2,v=1}};for(let $=0;$<c.length;$++){const L=c.charCodeAt($);if(L>=65&&L<=90)O(L-65);else if(L>=97&&L<=122)O(L-97+26);else if(L>=48&&L<=57)O(L-48+52);else if(L===43||L===45)O(62);else if(L===47||L===95)O(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${c[$]}`)}}const N=I;for(;v>0;)O(0);return T.wrap(_).slice(0,N)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},u=!0,v=!1){const I=v?s:t;let _="";const O=c.byteLength%3;let N=0;for(;N<c.byteLength-O;N+=3){const $=c[N+0],L=c[N+1],U=c[N+2];_+=I[$>>>2],_+=I[($<<4|L>>>4)&63],_+=I[(L<<2|U>>>6)&63],_+=I[U&63]}if(O===1){const $=c[N+0];_+=I[$>>>2],_+=I[$<<4&63],u&&(_+="==")}else if(O===2){const $=c[N+0],L=c[N+1];_+=I[$>>>2],_+=I[($<<4|L>>>4)&63],_+=I[L<<2&63],u&&(_+="=")}return _}e.encodeBase64=o}),define(te[26],ne([0,1,106,100]),function(Y,e,D,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function R(Q,...oe){return oe.length===0?Q:Q.replace(T,function(le,fe){const ve=parseInt(fe,10);return isNaN(ve)||ve<0||ve>=oe.length?le:oe[ve]})}e.format=R;const b=/{([^}]+)}/g;function E(Q,oe){return Q.replace(b,(le,fe)=>oe[fe]??le)}e.format2=E;function P(Q){return Q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function C(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function f(Q,oe){let le=0;const fe=oe.charCodeAt(0);for(let ve=Q.length-1;ve>=0;ve--)Q.charCodeAt(ve)===fe&&le++;return le}e.count=f;function y(Q,oe,le="\u2026"){return Q.length<=oe?Q:`${Q.substr(0,oe)}${le}`}e.truncate=y;function h(Q,oe=" "){const le=p(Q,oe);return d(le,oe)}e.trim=h;function p(Q,oe){if(!Q||!oe)return Q;const le=oe.length;if(le===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(oe,fe)===fe;)fe=fe+le;return Q.substring(fe)}e.ltrim=p;function d(Q,oe){if(!Q||!oe)return Q;const le=oe.length,fe=Q.length;if(le===0||fe===0)return Q;let ve=fe,Le=-1;for(;Le=Q.lastIndexOf(oe,ve-1),!(Le===-1||Le+le!==ve);){if(Le===0)return"";ve=Le}return Q.substring(0,ve)}e.rtrim=d;function g(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function w(Q){return Q.replace(/\*/g,"")}e.stripWildcards=w;function m(Q,oe,le={}){if(!Q)throw new Error("Cannot create regex from empty string");oe||(Q=C(Q)),le.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=m;function S(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function l(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=r;function a(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Q){for(let oe=0,le=Q.length;oe<le;oe++){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(Q,oe=0,le=Q.length){for(let fe=oe;fe<le;fe++){const ve=Q.charCodeAt(fe);if(ve!==32&&ve!==9)return Q.substring(oe,fe)}return Q.substring(oe,le)}e.getLeadingWhitespace=t;function s(Q,oe=Q.length-1){for(let le=oe;le>=0;le--){const fe=Q.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function o(Q,oe){return Q<oe?-1:Q>oe?1:0}e.compare=o;function c(Q,oe,le=0,fe=Q.length,ve=0,Le=oe.length){for(;le<fe&&ve<Le;le++,ve++){let ke=Q.charCodeAt(le),Pe=oe.charCodeAt(ve);if(ke<Pe)return-1;if(ke>Pe)return 1}const we=fe-le,Re=Le-ve;return we<Re?-1:we>Re?1:0}e.compareSubstring=c;function u(Q,oe){return v(Q,oe,0,Q.length,0,oe.length)}e.compareIgnoreCase=u;function v(Q,oe,le=0,fe=Q.length,ve=0,Le=oe.length){for(;le<fe&&ve<Le;le++,ve++){let ke=Q.charCodeAt(le),Pe=oe.charCodeAt(ve);if(ke===Pe)continue;if(ke>=128||Pe>=128)return c(Q.toLowerCase(),oe.toLowerCase(),le,fe,ve,Le);I(ke)&&(ke-=32),I(Pe)&&(Pe-=32);const Ae=ke-Pe;if(Ae!==0)return Ae}const we=fe-le,Re=Le-ve;return we<Re?-1:we>Re?1:0}e.compareSubstringIgnoreCase=v;function I(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=I;function _(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=_;function O(Q,oe){return Q.length===oe.length&&v(Q,oe)===0}e.equalsIgnoreCase=O;function N(Q,oe){const le=oe.length;return oe.length>Q.length?!1:v(Q,oe,0,le)===0}e.startsWithIgnoreCase=N;function $(Q,oe){let le,fe=Math.min(Q.length,oe.length);for(le=0;le<fe;le++)if(Q.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=$;function L(Q,oe){let le,fe=Math.min(Q.length,oe.length);const ve=Q.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(Q.charCodeAt(ve-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=L;function U(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=U;function j(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=j;function M(Q,oe){return(Q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=M;function G(Q,oe,le){const fe=Q.charCodeAt(le);if(U(fe)&&le+1<oe){const ve=Q.charCodeAt(le+1);if(j(ve))return M(fe,ve)}return fe}e.getNextCodePoint=G;function K(Q,oe){const le=Q.charCodeAt(oe-1);if(j(le)&&oe>1){const fe=Q.charCodeAt(oe-2);if(U(fe))return M(fe,le)}return le}class x{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=K(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class q{constructor(oe,le=0){this._iterator=new x(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ve=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,we=oe.getGraphemeBreakType(le.nextCodePoint());if(ze(ve,we)){le.setOffset(Le);break}ve=we}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ve=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,we=oe.getGraphemeBreakType(le.prevCodePoint());if(ze(we,ve)){le.setOffset(Le);break}ve=we}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function X(Q,oe){return new q(Q,oe).nextGraphemeLength()}e.nextCharLength=X;function H(Q,oe){return new q(Q,oe).prevGraphemeLength()}e.prevCharLength=H;function Z(Q,oe){oe>0&&j(Q.charCodeAt(oe))&&oe--;const le=oe+X(Q,oe);return[le-H(Q,le),le]}e.getCharContainingOffset=Z;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(Q){return ee.test(Q)}e.containsRTL=W;const F=/^[\t\n\r\x20-\x7E]*$/;function V(Q){return F.test(Q)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=z;function B(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=B;function ie(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=ie;function se(Q,oe){if(Q.length<oe)return Q;const le=/\b/g;let fe=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function me(Q){return Q&&(Q=Q.replace(ce,""),Q=Q.replace(he,""),Q=Q.replace(ge,"")),Q}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function Se(Q){return ye(Q)?Q.substr(1):Q}e.stripUTF8BOM=Se;function Ie(Q,oe){if(!Q||!oe||Q.length<oe.length)return!1;const le=oe.length,fe=Q.toLowerCase();let ve=0,Le=-1;for(;ve<le;){const we=fe.indexOf(oe[ve],Le+1);if(we<0)return!1;Le=we,ve++}return!0}e.fuzzyContains=Ie;function Ee(Q,oe=!1){return Q?(oe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Ee;function De(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=De;function Fe(Q,oe=1){if(oe===0)return"";let le=-1;do le=Q.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?Q:(Q[le-1]==="\r"&&le--,Q.substr(0,le))}e.getNLines=Fe;function Ue(Q){const oe=90-65+1;return Q=Q%(2*oe),Q<oe?String.fromCharCode(97+Q):String.fromCharCode(65+Q-oe)}e.singleLetterHash=Ue;function Ne(Q){return ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=Ne;function ze(Q,oe){return Q===0?oe!==5&&oe!==7:Q===2&&oe===3?!1:Q===4||Q===2||Q===3||oe===4||oe===2||oe===3?!0:!(Q===8&&(oe===8||oe===9||oe===11||oe===12)||(Q===11||Q===9)&&(oe===9||oe===10)||(Q===12||Q===10)&&oe===10||oe===5||oe===13||oe===7||Q===1||Q===13&&oe===14||Q===6&&oe===6)}var re;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let ve=1;for(;ve<=fe;)if(oe<le[3*ve])ve=2*ve;else if(oe>le[3*ve+1])ve=2*ve+1;else return le[3*ve+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(Q,oe){if(Q===0)return 0;const le=Ce(Q,oe);if(le!==void 0)return le;const fe=new x(oe,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=be;function Ce(Q,oe){const le=new x(oe,Q);let fe=le.prevCodePoint();for(;$e(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!ie(fe))return;let ve=le.offset;return ve>0&&le.prevCodePoint()===8205&&(ve=le.offset),ve}function $e(Q){return 127995<=Q&&Q<=127999}var Te;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,k=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new D.LRUCachedComputed(Q=>{function oe(Pe){const Ae=new Map;for(let We=0;We<Pe.length;We+=2)Ae.set(Pe[We],Pe[We+1]);return Ae}function le(Pe,Ae){const We=new Map(Pe);for(const[xe,Be]of Ae)We.set(xe,Be);return We}function fe(Pe,Ae){if(!Pe)return Ae;const We=new Map;for(const[xe,Be]of Pe)Ae.has(xe)&&We.set(xe,Be);return We}const ve=k.ambiguousCharacterData.getValue();let Le=Q.filter(Pe=>!Pe.startsWith("_")&&Pe in ve);Le.length===0&&(Le=["_default"]);let we;for(const Pe of Le){const Ae=oe(ve[Pe]);we=fe(we,Ae)}const Re=oe(ve._common),ke=le(Re,we);return new Oe(ke)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(te[70],ne([0,1,26]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(g){return k(g,0)}e.hash=n;function k(g,w){switch(typeof g){case"object":return g===null?A(349,w):Array.isArray(g)?b(g,w):E(g,w);case"string":return R(g,w);case"boolean":return T(g,w);case"number":return A(g,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=k;function A(g,w){return(w<<5)-w+g|0}e.numberHash=A;function T(g,w){return A(g?433:863,w)}function R(g,w){w=A(149417,w);for(let m=0,S=g.length;m<S;m++)w=A(g.charCodeAt(m),w);return w}e.stringHash=R;function b(g,w){return w=A(104579,w),g.reduce((m,S)=>k(S,m),w)}function E(g,w){return w=A(181387,w),Object.keys(g).sort().reduce((m,S)=>(m=R(S,m),k(g[S],m)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=k(w,this._value),this._value}}e.Hasher=P;var C;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(g,w,m=32){const S=m-w,l=~((1<<S)-1);return(g<<w|(l&g)>>>S)>>>0}function y(g,w=0,m=g.byteLength,S=0){for(let l=0;l<m;l++)g[w+l]=S}function h(g,w,m="0"){for(;g.length<w;)g=m+g;return g}function p(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(m=>m.toString(16).padStart(2,"0")).join(""):h((g>>>0).toString(16),w/4)}e.toHexString=p;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const m=w.length;if(m===0)return;const S=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,a,i;for(r!==0?(a=r,i=-1,r=0):(a=w.charCodeAt(0),i=0);;){let t=a;if(D.isHighSurrogate(a))if(i+1<m){const s=w.charCodeAt(i+1);D.isLowSurrogate(s)?(i++,t=D.computeCodePoint(a,s)):t=65533}else{r=a;break}else D.isLowSurrogate(a)&&(t=65533);if(l=this._push(S,l,t),i++,i<m)a=w.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,m,S){return S<128?w[m++]=S:S<2048?(w[m++]=192|(S&1984)>>>6,w[m++]=128|(S&63)>>>0):S<65536?(w[m++]=224|(S&61440)>>>12,w[m++]=128|(S&4032)>>>6,w[m++]=128|(S&63)>>>0):(w[m++]=240|(S&1835008)>>>18,w[m++]=128|(S&258048)>>>12,w[m++]=128|(S&4032)>>>6,w[m++]=128|(S&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=d._bigBlock32,m=this._buffDV;for(let c=0;c<64;c+=4)w.setUint32(c,m.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,f(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let S=this._h0,l=this._h1,r=this._h2,a=this._h3,i=this._h4,t,s,o;for(let c=0;c<80;c++)c<20?(t=l&r|~l&a,s=1518500249):c<40?(t=l^r^a,s=1859775393):c<60?(t=l&r|l&a|r&a,s=2400959708):(t=l^r^a,s=3395469782),o=f(S,5)+t+i+s+w.getUint32(c*4,!1)&4294967295,i=a,a=r,r=f(l,30),l=S,S=o;this._h0=this._h0+S&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(Y,e,D,n,k){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?k.call(Y,D):k?k.value=D:e.set(Y,D),D},Ke=this&&this.__classPrivateFieldGet||function(Y,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!n:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(Y):n?n.value:e.get(Y)};define(te[39],ne([0,1,16,26]),function(Y,e,D,n){"use strict";var k,A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,t,s){let o=i.get(t);return o===void 0&&(o=s,i.set(t,o)),o}e.getOrSet=R;function b(i){const t=[];return i.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=b;function E(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var y;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(y||(y={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(d||(d={}));class g{constructor(t){this._iter=t}static forUris(t=()=>!1){return new g(new h(t))}static forPaths(t=!1){return new g(new f(void 0,!t))}static forStrings(){return new g(new P)}static forConfigKeys(){return new g(new C)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,D.shuffle)(o);for(let c of o)this.set(c,t)}else{const o=t.slice(0);(0,D.shuffle)(o);for(let c of o)this.set(c[0],c[1])}}set(t,s){const o=this._iter.reset(t);let c;this._root||(this._root=new p,this._root.segment=o.value());const u=[];for(c=this._root;;){const I=o.cmp(c.segment);if(I>0)c.left||(c.left=new p,c.left.segment=o.value()),u.push([-1,c]),c=c.left;else if(I<0)c.right||(c.right=new p,c.right.segment=o.value()),u.push([1,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new p,c.mid.segment=o.value()),u.push([0,c]),c=c.mid;else break}const v=c.value;c.value=s,c.key=t;for(let I=u.length-1;I>=0;I--){const _=u[I][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const N=u[I][0],$=u[I+1][0];if(N===1&&$===1)u[I][1]=_.rotateLeft();else if(N===-1&&$===-1)u[I][1]=_.rotateRight();else if(N===1&&$===-1)_.right=u[I+1][1]=u[I+1][1].rotateRight(),u[I][1]=_.rotateLeft();else if(N===-1&&$===1)_.left=u[I+1][1]=u[I+1][1].rotateLeft(),u[I][1]=_.rotateRight();else throw new Error;if(I>0)switch(u[I-1][0]){case-1:u[I-1][1].left=u[I][1];break;case 1:u[I-1][1].right=u[I][1];break;case 0:u[I-1][1].mid=u[I][1];break}else this._root=u[0][1]}}return v}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),c=[];let u=this._root;for(;u;){const v=o.cmp(u.segment);if(v>0)c.push([-1,u]),u=u.left;else if(v<0)c.push([1,u]),u=u.right;else if(o.hasNext())o.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(s?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const v=this._min(u.right),{key:I,value:_,segment:O}=v;this._delete(v.key,!1),u.key=I,u.value=_,u.segment=O}else{const v=u.left??u.right;if(c.length>0){const[I,_]=c[c.length-1];switch(I){case-1:_.left=v;break;case 0:_.mid=v;break;case 1:_.right=v;break}}else this._root=v}for(let v=c.length-1;v>=0;v--){const I=c[v][1];I.updateHeight();const _=I.balanceFactor();if(_>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),c[v][1]=I.rotateLeft()):_<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),c[v][1]=I.rotateRight()),v>0)switch(c[v-1][0]){case-1:c[v-1][1].left=c[v][1];break;case 1:c[v-1][1].right=c[v][1];break;case 0:c[v-1][1].mid=c[v][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,c;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=g;class w{constructor(t,s){this.uri=t,this.value=s}}class m{constructor(t,s){this[k]="ResourceMap",t instanceof m?(this.map=new Map(t.map),this.toKey=s??m.defaultToKey):(this.map=new Map,this.toKey=t??m.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new w(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=m,m.defaultToKey=i=>i.toString();var S;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class l{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let c=this._map.get(t);if(c)c.value=s,o!==0&&this.touch(c,o);else{switch(c={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let c=this._head;for(;c;){if(s?t.bind(s)(c.value,c.key,this):t(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:o.key,done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return c}values(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:o.value,done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return c}entries(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:[o.key,o.value],done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,c=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=l;class r extends l{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){T.set(this,void 0),It(this,T,t,"f")}get size(){return Ke(this,T,"f").size}forEach(t,s){Ke(this,T,"f").forEach(t,s)}get(t){return Ke(this,T,"f").get(t)}has(t){return Ke(this,T,"f").has(t)}entries(){return Ke(this,T,"f").entries()}keys(){return Ke(this,T,"f").keys()}values(){return Ke(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Ke(this,T,"f").entries()}}e.ReadonlyMapView=a}),define(te[71],ne([0,1,39]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function k(E){return b(E,"NFC",n)}e.normalizeNFC=k;const A=new D.LRUCache(1e4);function T(E){return b(E,"NFD",A)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function b(E,P,C){if(!E)return E;const f=C.get(E);if(f)return f;let y;return R.test(E)?y=E.normalize(P):y=E,C.set(E,y),y}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return T(P).replace(E,"")}}()}),define(te[14],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(u){return Array.isArray(u)}e.isArray=D;function n(u){return typeof u=="string"}e.isString=n;function k(u){return Array.isArray(u)&&u.every(v=>n(v))}e.isStringArray=k;function A(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=A;function T(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=T;function R(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=R;function b(u){return u===!0||u===!1}e.isBoolean=b;function E(u){return typeof u=="undefined"}e.isUndefined=E;function P(u){return!C(u)}e.isDefined=P;function C(u){return E(u)||u===null}e.isUndefinedOrNull=C;function f(u,v){if(!u)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=f;function y(u){if(C(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=y;function h(...u){const v=[];for(let I=0;I<u.length;I++){const _=u[I];if(C(_))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);v.push(_)}return v}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function d(u){if(!A(u))return!1;for(let v in u)if(p.call(u,v))return!1;return!0}e.isEmptyObject=d;function g(u){return typeof u=="function"}e.isFunction=g;function w(...u){return u.length>0&&u.every(g)}e.areFunctions=w;function m(u,v){const I=Math.min(u.length,v.length);for(let _=0;_<I;_++)S(u[_],v[_])}e.validateConstraints=m;function S(u,v){if(n(v)){if(typeof u!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(g(v)){try{if(u instanceof v)return}catch{}if(!C(u)&&u.constructor===v||v.length===1&&v.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function l(u){let v=[],I=Object.getPrototypeOf(u);for(;Object.prototype!==I;)v=v.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return v}e.getAllPropertyNames=l;function r(u){const v=[];for(const I of l(u))typeof u[I]=="function"&&v.push(I);return v}e.getAllMethodNames=r;function a(u,v){const I=O=>function(){const N=Array.prototype.slice.call(arguments,0);return v(O,N)};let _={};for(const O of u)_[O]=I(O);return _}e.createProxyObject=a;function i(u){return u===null?void 0:u}e.withNullAsUndefined=i;function t(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=t;function s(u){return class{constructor(){return new Proxy({},{get(v,I){if(v[I])return v[I];throw new Error(`Not Implemented: ${u}->${String(I)}`)}})}}}e.NotImplementedProxy=s;function o(u,v="Unreachable"){throw new Error(v)}e.assertNever=o;function c(u){return!!u&&typeof u.then=="function"&&typeof u.catch=="function"}e.isPromise=c}),define(te[41],ne([0,1,10,4,26,14]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function R(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function b(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=b;function E(s,o=D.posix.sep){if(!s)return"";const c=s.length,u=s.charCodeAt(0);if(T(u)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let I=3;const _=I;for(;I<c&&!T(s.charCodeAt(I));I++);if(_!==I&&!T(s.charCodeAt(I+1))){for(I+=1;I<c;I++)if(T(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(g(u)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<c;v++)if(T(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=E;function P(s){if(!n.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let c=2;const u=c;for(;c<s.length&&(o=s.charCodeAt(c),o!==92);c++);return!(u===c||(o=s.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=P;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,o=n.isWindows){const c=o?C:f;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||o&&y.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function p(s,o,c){const u=s===o;return!c||u?u:!s||!o?!1:(0,k.equalsIgnoreCase)(s,o)}e.isEqual=p;function d(s,o,c,u=D.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(c){if(!(0,k.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let I=o.length;return o.charAt(o.length-1)===u&&I--,s.charAt(I)===u}return o.charAt(o.length-1)!==u&&(o+=u),s.indexOf(o)===0}e.isEqualOrParent=d;function g(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=g;function w(s,o){return n.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(o,s)),s=(0,D.normalize)(s),n.isWindows?(s=(0,k.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,k.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=w;function m(s){const o=(0,D.normalize)(s);return n.isWindows?s.length>3?!1:S(o)&&(s.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=m;function S(s,o){return(o!==void 0?o:n.isWindows)?g(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function l(s){return S(s)?s[0]:void 0}e.getDriveLetter=l;function r(s,o,c){return o.length>s.length?-1:s===o?0:(c&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=r;function a(s){const o=s.split(":");let c,u,v;for(const I of o){const _=Number(I);(0,A.isNumber)(_)?u===void 0?u=_:v===void 0&&(v=_):c=c?[c,I].join(":"):I}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:u!==void 0?u:void 0,column:v!==void 0?v:u!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,o,c=8){let u="";for(let I=0;I<c;I++)u+=i.charAt(Math.floor(Math.random()*i.length));let v;return o?v=`${o}-${u}`:v=u,s?(0,D.join)(s,v):v}e.randomPath=t}),define(te[28],ne([0,1,14]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const d=Array.isArray(p)?[]:{};return Object.keys(p).forEach(g=>{p[g]&&typeof p[g]=="object"?d[g]=n(p[g]):d[g]=p[g]}),d}e.deepClone=n;function k(p){if(!p||typeof p!="object")return p;const d=[p];for(;d.length>0;){const g=d.shift();Object.freeze(g);for(const w in g)if(A.call(g,w)){const m=g[w];typeof m=="object"&&!Object.isFrozen(m)&&d.push(m)}}return p}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function T(p,d){return R(p,d,new Set)}e.cloneAndChange=T;function R(p,d,g){if((0,D.isUndefinedOrNull)(p))return p;const w=d(p);if(typeof w!="undefined")return w;if((0,D.isArray)(p)){const m=[];for(const S of p)m.push(R(S,d,g));return m}if((0,D.isObject)(p)){if(g.has(p))throw new Error("Cannot clone recursive data-structure");g.add(p);const m={};for(let S in p)A.call(p,S)&&(m[S]=R(p[S],d,g));return g.delete(p),m}return p}function b(p,d,g=!0){return(0,D.isObject)(p)?((0,D.isObject)(d)&&Object.keys(d).forEach(w=>{w in p?g&&((0,D.isObject)(p[w])&&(0,D.isObject)(d[w])?b(p[w],d[w],g):p[w]=d[w]):p[w]=d[w]}),p):d}e.mixin=b;function E(p,d){if(p===d)return!0;if(p==null||d===null||d===void 0||typeof p!=typeof d||typeof p!="object"||Array.isArray(p)!==Array.isArray(d))return!1;let g,w;if(Array.isArray(p)){if(p.length!==d.length)return!1;for(g=0;g<p.length;g++)if(!E(p[g],d[g]))return!1}else{const m=[];for(w in p)m.push(w);m.sort();const S=[];for(w in d)S.push(w);if(S.sort(),!E(m,S))return!1;for(g=0;g<m.length;g++)if(!E(p[m[g]],d[m[g]]))return!1}return!0}e.equals=E;function P(p){const d=new Set;return JSON.stringify(p,(g,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=P;function C(p,d,g){const w=d(p);return typeof w=="undefined"?g:w}e.getOrDefault=C;function f(p,d){const g=Object.create(null);return!p||!d||Object.keys(d).forEach(m=>{const S=p[m],l=d[m];E(S,l)||(g[m]=l)}),g}e.distinct=f;function y(p,d){const g=d.toLowerCase(),w=Object.keys(p).find(m=>m.toLowerCase()===g);return w?p[w]:p[d]}e.getCaseInsensitive=y;function h(p,d){const g=Object.create(null);for(const[w,m]of Object.entries(p))d(w,m)&&(g[w]=m);return g}e.filter=h}),define(te[7],ne([0,1,10,4]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,t){return!i&&!t?"file":i}function E(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const P="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(t,s,o,c,u,v=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=b(t,v),this.authority=s||P,this.path=E(this.scheme,o||P),this.query=c||P,this.fragment=u||P,R(this,v))}static isUri(t){return t instanceof y?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:c,query:u,fragment:v}=t;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),c===void 0?c=this.path:c===null&&(c=P),u===void 0?u=this.query:u===null&&(u=P),v===void 0?v=this.fragment:v===null&&(v=P),s===this.scheme&&o===this.authority&&c===this.path&&u===this.query&&v===this.fragment?this:new p(s,o,c,u,v)}static parse(t,s=!1){const o=f.exec(t);return o?new p(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),s):new p(P,P,P,P,P)}static file(t){let s=P;if(n.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const o=t.indexOf(C,2);o===-1?(s=t.substring(2),t=C):(s=t.substring(2,o),t=t.substring(o)||C)}return new p("file",s,t,P,P)}static from(t){const s=new p(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&t.scheme==="file"?o=y.file(D.win32.join(m(t,!0),...s)).path:o=D.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return S(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof y)return t;{const s=new p(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=y;const h=n.isWindows?1:void 0;class p extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,t){let s,o=-1;for(let c=0;c<i.length;c++){const u=i.charCodeAt(c);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47)o!==-1&&(s+=encodeURIComponent(i.substring(o,c)),o=-1),s!==void 0&&(s+=i.charAt(c));else{s===void 0&&(s=i.substr(0,c));const v=d[u];v!==void 0?(o!==-1&&(s+=encodeURIComponent(i.substring(o,c)),o=-1),s+=v):o===-1&&(o=c)}}return o!==-1&&(s+=encodeURIComponent(i.substring(o))),s!==void 0?s:i}function w(i){let t;for(let s=0;s<i.length;s++){const o=i.charCodeAt(s);o===35||o===63?(t===void 0&&(t=i.substr(0,s)),t+=d[o]):t!==void 0&&(t+=i[s])}return t!==void 0?t:i}function m(i,t){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=m;function S(i,t){const s=t?w:g;let o="",{scheme:c,authority:u,path:v,query:I,fragment:_}=i;if(c&&(o+=c,o+=":"),(u||c==="file")&&(o+=C,o+=C),u){let O=u.indexOf("@");if(O!==-1){const N=u.substr(0,O);u=u.substr(O+1),O=N.indexOf(":"),O===-1?o+=s(N,!1):(o+=s(N.substr(0,O),!1),o+=":",o+=s(N.substr(O+1),!1)),o+="@"}u=u.toLowerCase(),O=u.indexOf(":"),O===-1?o+=s(u,!1):(o+=s(u.substr(0,O),!1),o+=u.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const O=v.charCodeAt(1);O>=65&&O<=90&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const O=v.charCodeAt(0);O>=65&&O<=90&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}o+=s(v,!0)}return I&&(o+="?",o+=s(I,!1)),_&&(o+="#",o+=t?_:g(_,!1)),o}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(r)?i.replace(r,t=>l(t)):i}}),define(te[107],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=n;function k(E){const P=[];let C;try{const f=JSON.parse(E.arguments),y=f[f.length-1];y&&y.__$stack&&(f.pop(),C=y.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:C}}e.parse=k;function A(E){if(typeof E!="string")return A(k(E).stack);const P=E;if(P){const C=T(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=A;function T(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function R(E,P){const{args:C,stack:f}=k(E),y=typeof C[0]=="string"&&C.length===1;let h=T(f);h&&(h=`(${h.trim()})`);let p=[];if(typeof C[0]=="string"?h&&y?p=[`%c[${P}] %c${C[0]} %c${h}`,b("blue"),b(""),b("grey")]:p=[`%c[${P}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:p=[`%c[${P}]%`,b("blue"),...C],h&&!y&&p.push(h),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,p)}e.log=R;function b(E){return`color: ${E}`}}),define(te[108],ne([0,1,17,26,7]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,b)}e.stringify=A;function T(P){let C=JSON.parse(P);return C=E(C),C}e.parse=T;var R;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext",P[P.Date=14]="Date"})(R=e.MarshalledId||(e.MarshalledId={}));function b(P,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function E(P,C=0){if(!P||C>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return k.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof D.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let f=0;f<P.length;++f)P[f]=E(P[f],C+1);else for(const f in P)Object.hasOwnProperty.call(P,f)&&(P[f]=E(P[f],C+1))}return P}e.revive=E}),define(te[18],ne([0,1,4,7]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(k=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,E,P){this._hosts[b]=E,this._ports[b]=P}setConnectionToken(b,E){this._connectionTokens[b]=E}rewrite(b){if(this._delegate)return this._delegate(b);const E=b.authority;let P=this._hosts[E];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const C=this._ports[E],f=this._connectionTokens[E];let y=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(y+=`&tkn=${encodeURIComponent(f)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${P}:${C}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new A;class T{asBrowserUri(b,E){const P=this.toUri(b,E);return P.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===k.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?P.with({scheme:k.vscodeFileResource,authority:P.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(b,E){const P=this.toUri(b,E);return P.scheme===k.vscodeFileResource?P.with({scheme:k.file,authority:P.authority!==T.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(b,E){return n.URI.isUri(b)?b:n.URI.parse(E.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(te[19],ne([0,1,41,18,10,4,26,7]),function(Y,e,D,n,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(y){return(0,R.uriToFsPath)(y,!0)}e.originalFSPath=b;class E{constructor(h){this._ignorePathCasing=h}compare(h,p,d=!1){return h===p?0:(0,T.compare)(this.getComparisonKey(h,d),this.getComparisonKey(p,d))}isEqual(h,p,d=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,d)===this.getComparisonKey(p,d)}getComparisonKey(h,p=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,p,d=!1){if(h.scheme===p.scheme){if(h.scheme===n.Schemas.file)return D.isEqualOrParent(b(h),b(p),this._ignorePathCasing(h))&&h.query===p.query&&(d||h.fragment===p.fragment);if((0,e.isEqualAuthority)(h.authority,p.authority))return D.isEqualOrParent(h.path,p.path,this._ignorePathCasing(h),"/")&&h.query===p.query&&(d||h.fragment===p.fragment)}return!1}joinPath(h,...p){return R.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===n.Schemas.file?p=R.URI.file(k.dirname(b(h))).path:(p=k.posix.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===n.Schemas.file?p=R.URI.file(k.normalize(b(h))).path:p=k.posix.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.isEqualAuthority)(h.authority,p.authority))return;if(h.scheme===n.Schemas.file){const w=k.relative(b(h),b(p));return A.isWindows?D.toSlashes(w):w}let d=h.path||"/",g=p.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const m=Math.min(d.length,g.length);w<m&&!(d.charCodeAt(w)!==g.charCodeAt(w)&&d.charAt(w).toLowerCase()!==g.charAt(w).toLowerCase());w++);d=g.substr(0,w)+d.substr(w)}return k.posix.relative(d,g)}resolvePath(h,p){if(h.scheme===n.Schemas.file){const d=R.URI.file(k.resolve(b(h),p));return h.with({authority:d.authority,path:d.path})}return p=D.toPosixPath(p),h.with({path:k.posix.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||h!==void 0&&p!==void 0&&(0,T.equalsIgnoreCase)(h,p)}hasTrailingPathSeparator(h,p=k.sep){if(h.scheme===n.Schemas.file){const d=b(h);return d.length>D.getRoot(d).length&&d[d.length-1]===p}else{const d=h.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=k.sep){return(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=k.sep){let d=!1;if(h.scheme===n.Schemas.file){const g=b(h);d=g!==void 0&&g.length===D.getRoot(g).length&&g[g.length-1]===p}else{p="/";const g=h.path;d=g.length===1&&g.charCodeAt(g.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path+"/"}):h}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(y=>y.scheme===n.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new E(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(y,h){const p=[];for(let d=0;d<y.length;d++){const g=h(y[d]);y.some((w,m)=>m===d?!1:(0,e.isEqualOrParent)(g,h(w)))||p.push(y[d])}return p}e.distinctParents=P;var C;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(p){const d=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(m=>{const[S,l]=m.split(":");S&&l&&d.set(S,l)});const w=p.path.substring(0,p.path.indexOf(";"));return w&&d.set(y.META_DATA_MIME,w),d}y.parseMetaData=h})(C=e.DataUri||(e.DataUri={}));function f(y,h,p){if(h){let d=y.path;return d&&d[0]!==k.posix.sep&&(d=k.posix.sep+d),y.with({scheme:p,authority:h,path:d})}return y.with({scheme:p})}e.toLocalResource=f}),define(te[5],ne([0,1,25,9,3,2,19,4]),function(Y,e,D,n,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(W){return!!W&&typeof W.then=="function"}e.isThenable=b;function E(W){const F=new D.CancellationTokenSource,V=W(F.token),z=new Promise((B,ie)=>{const se=F.token.onCancellationRequested(()=>{se.dispose(),F.dispose(),ie(new n.CancellationError)});Promise.resolve(V).then(ce=>{se.dispose(),F.dispose(),B(ce)},ce=>{se.dispose(),F.dispose(),ie(ce)})});return new class{cancel(){F.cancel()}then(B,ie){return z.then(B,ie)}catch(B){return this.then(void 0,B)}finally(B){return z.finally(B)}}}e.createCancelablePromise=E;function P(W,F,V){return new Promise((z,B)=>{const ie=F.onCancellationRequested(()=>{ie.dispose(),z(V)});W.then(z,B).finally(()=>ie.dispose())})}e.raceCancellation=P;function C(W,F){return new Promise((V,z)=>{const B=F.onCancellationRequested(()=>{B.dispose(),z(new n.CancellationError)});W.then(V,z).finally(()=>B.dispose())})}e.raceCancellationError=C;async function f(W){let F=-1;const V=W.map((B,ie)=>B.then(se=>(F=ie,se))),z=await Promise.race(V);return W.forEach((B,ie)=>{ie!==F&&B.cancel()}),z}e.raceCancellablePromises=f;function y(W,F,V){let z;const B=setTimeout(()=>{z?.(void 0),V?.()},F);return Promise.race([W.finally(()=>clearTimeout(B)),new Promise(ie=>z=ie)])}e.raceTimeout=y;function h(W){return new Promise((F,V)=>{const z=W();b(z)?z.then(F,V):F(z)})}e.asPromise=h;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(V,V).then(z)})}return new Promise((V,z)=>{this.queuedPromise.then(V,z)})}return this.activePromise=F(),new Promise((V,z)=>{this.activePromise.then(B=>{this.activePromise=null,V(B)},B=>{this.activePromise=null,z(B)})})}}e.Throttler=p;class d{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(F,V){const B=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(F)===B&&this.promiseMap.delete(F)});return this.promiseMap.set(F,B),B}}e.SequencerByKey=g;const w=(W,F)=>{let V=!0;const z=setTimeout(()=>{V=!1,F()},W);return{isTriggered:()=>V,dispose:()=>{clearTimeout(z),V=!1}}},m=W=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,W())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,V=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,ie)=>{this.doResolve=B,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=V===e.MicrotaskDelay?m(z):w(V,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=S;class l{constructor(F){this.delayer=new S(F),this.throttler=new p}trigger(F,V){return this.delayer.trigger(()=>this.throttler.queue(F),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise((F,V)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class a extends r{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function i(W,F){return F?new Promise((V,z)=>{const B=setTimeout(()=>{ie.dispose(),V()},W),ie=F.onCancellationRequested(()=>{clearTimeout(B),ie.dispose(),z(new n.CancellationError)})}):E(V=>i(W,V))}e.timeout=i;function t(W,F=0){const V=setTimeout(W,F);return(0,A.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=t;function s(W){const F=[];let V=0;const z=W.length;function B(){return V<z?W[V++]():null}function ie(se){se!=null&&F.push(se);const ce=B();return ce?ce.then(ie):Promise.resolve(F)}return Promise.resolve(null).then(ie)}e.sequence=s;function o(W,F=z=>!!z,V=null){let z=0;const B=W.length,ie=()=>{if(z>=B)return Promise.resolve(V);const se=W[z++];return Promise.resolve(se()).then(he=>F(he)?Promise.resolve(he):ie())};return ie()}e.first=o;function c(W,F=z=>!!z,V=null){if(W.length===0)return Promise.resolve(V);let z=W.length;const B=()=>{z=-1;for(const ie of W)ie.cancel?.()};return new Promise((ie,se)=>{for(const ce of W)ce.then(he=>{--z>=0&&F(he)?(B(),ie(he)):z===0&&ie(V)}).catch(he=>{--z>=0&&(B(),se(he))})})}e.firstParallel=c;class u{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((V,z)=>{this.outstandingPromises.push({factory:F,c:V,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const V=F.factory();V.then(F.c,F.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class v extends u{constructor(){super(1)}}e.Queue=v;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new x;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,V=T.extUri){const z=V.getComparisonKey(F);let B=this.queues.get(z);return B||(B=new v,k.Event.once(B.onFinished)(()=>{B?.dispose(),this.queues.delete(z),this.onDidQueueFinish()}),this.queues.set(z,B)),B}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class _{constructor(F,V){this._token=-1,typeof F=="function"&&typeof V=="number"&&this.setIfNotSet(F,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},V)}setIfNotSet(F,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},V))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,V){this.cancel(),this._token=setInterval(()=>{F()},V)}}e.IntervalTimer=O;class N{constructor(F,V){this.timeoutToken=-1,this.runner=F,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=N;class ${constructor(F,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=$;class L extends N{constructor(F,V){super(F,V);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class U extends A.Disposable{constructor(F,V){super();this.options=F,this.handler=V,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,R.setTimeout0)(()=>{if(F)return;const V=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(W,F)=>{const V=requestIdleCallback(W,typeof F=="number"?{timeout:F}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(V))}}}}();class j{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function M(W,F,V){let z;for(let B=0;B<V;B++)try{return await W()}catch(ie){z=ie,await i(F)}throw z}e.retry=M;class G{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,V,z){return this._pending={taskId:F,cancel:()=>z?.(),promise:V},V.then(()=>this.donePending(F),()=>this.donePending(F)),V}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let V,z;const B=new Promise((ie,se)=>{V=ie,z=se});this._next={run:F,promise:B,promiseResolve:V,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=G;class K{constructor(F,V=()=>Date.now()){this.interval=F,this.nowFn=V,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,V)=>{this.completeCallback=F,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(V=>{this.completeCallback(F),this.resolved=!0,V()})}error(F){return new Promise(V=>{this.errorCallback(F),this.rejected=!0,V()})}cancel(){new Promise(F=>{this.errorCallback(new n.CancellationError),this.rejected=!0,F()})}}e.DeferredPromise=x;var q;(function(W){async function F(z){let B;const ie=await Promise.all(z.map(se=>se.then(ce=>ce,ce=>{B||(B=ce)})));if(typeof B!="undefined")throw B;return ie}W.settled=F;function V(z){return new Promise(async(B,ie)=>{try{await z(B,ie)}catch(se){ie(se)}})}W.withAsyncBody=V})(q=e.Promises||(e.Promises={}));var X;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(X||(X={}));class H{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const V={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(F(V)),this.resolve()}catch(z){this.reject(z)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}static fromArray(F){return new H(V=>{V.emitMany(F)})}static fromPromise(F){return new H(async V=>{V.emitMany(await F)})}static fromPromises(F){return new H(async V=>{await Promise.all(F.map(async z=>V.emitOne(await z)))})}static merge(F){return new H(async V=>{await Promise.all(F.map(async z=>{for await(const B of z)V.emitOne(B)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,V){return new H(async z=>{for await(const B of F)z.emitOne(V(B))})}map(F){return H.map(this,F)}static filter(F,V){return new H(async z=>{for await(const B of F)V(B)&&z.emitOne(B)})}filter(F){return H.filter(this,F)}static coalesce(F){return H.filter(F,V=>!!V)}coalesce(){return H.coalesce(this)}static async toPromise(F){const V=[];for await(const z of F)V.push(z);return V}toPromise(){return H.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Z extends H{constructor(F,V){super(V);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function ee(W){const F=new D.CancellationTokenSource,V=W(F.token);return new Z(F,async z=>{const B=F.token.onCancellationRequested(()=>{B.dispose(),F.dispose(),z.reject(new n.CancellationError)});try{for await(const ie of V){if(F.token.isCancellationRequested)return;z.emitOne(ie)}B.dispose(),F.dispose()}catch(ie){B.dispose(),F.dispose(),z.reject(ie)}})}e.createCancelableAsyncIterable=ee}),define(te[109],ne([0,1,5,41,39,10,26]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",E="[^/\\\\]",P=/\//g;function C(K){switch(K){case 0:return"";case 1:return`${E}*?`;default:return`(?:${b}|${E}+${b}|${b}${E}+)*?`}}function f(K,x){if(!K)return[];const q=[];let X=!1,H=!1,Z="";for(const ee of K){switch(ee){case x:if(!X&&!H){q.push(Z),Z="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":H=!0;break;case"]":H=!1;break}Z+=ee}return Z&&q.push(Z),q}e.splitGlobAware=f;function y(K){if(!K)return"";let x="";const q=f(K,e.GLOB_SPLIT);if(q.every(X=>X===e.GLOBSTAR))x=".*";else{let X=!1;q.forEach((H,Z)=>{if(H===e.GLOBSTAR){X||(x+=C(2),X=!0);return}let ee=!1,W="",F=!1,V="";for(const z of H){if(z!=="}"&&ee){W+=z;continue}if(F&&(z!=="]"||!V)){let B;z==="-"?B=z:(z==="^"||z==="!")&&!V?B="^":z===e.GLOB_SPLIT?B="":B=T.escapeRegExpCharacters(z),V+=B;continue}switch(z){case"{":ee=!0;continue;case"[":F=!0;continue;case"}":{x+=`(?:${f(W,",").map(se=>y(se)).join("|")})`,ee=!1,W="";break}case"]":x+="["+V+"]",F=!1,V="";break;case"?":x+=E;continue;case"*":x+=C(1);continue;default:x+=T.escapeRegExpCharacters(z)}}Z<q.length-1&&(q[Z+1]!==e.GLOBSTAR||Z+2<q.length)&&(x+=b),X=!1})}return x}const h=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,S=new k.LRUCache(1e4),l=function(){return!1},r=function(){return null};function a(K,x){if(!K)return r;let q;typeof K!="string"?q=K.pattern:q=K,q=q.trim();const X=`${q}_${!!x.trimForExclusions}`;let H=S.get(X);if(H)return i(H,K);let Z;if(h.test(q)){const ee=q.substr(4);H=function(W,F){return typeof W=="string"&&W.endsWith(ee)?q:null}}else(Z=p.exec(t(q,x)))?H=s(Z[1],q):(x.trimForExclusions?g:d).test(q)?H=o(q,x):(Z=w.exec(t(q,x)))?H=c(Z[1].substr(1),q,!0):(Z=m.exec(t(q,x)))?H=c(Z[1],q,!1):H=u(q);return S.set(X,H),i(H,K)}function i(K,x){return typeof x=="string"?K:function(q,X){return n.isEqualOrParent(q,x.base)?K(A.relative(x.base,q),X):null}}function t(K,x){return x.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function s(K,x){const q=`/${K}`,X=`\\${K}`,H=function(ee,W){return typeof ee!="string"?null:W?W===K?x:null:ee===K||ee.endsWith(q)||ee.endsWith(X)?x:null},Z=[K];return H.basenames=Z,H.patterns=[x],H.allBasenames=Z,H}function o(K,x){const q=G(K.slice(1,-1).split(",").map(W=>a(W,x)).filter(W=>W!==r),K),X=q.length;if(!X)return r;if(X===1)return q[0];const H=function(W,F){for(let V=0,z=q.length;V<z;V++)if(q[V](W,F))return K;return null},Z=q.find(W=>!!W.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=q.reduce((W,F)=>F.allPaths?W.concat(F.allPaths):W,[]);return ee.length&&(H.allPaths=ee),H}function c(K,x,q){const X=A.sep===A.posix.sep,H=X?K:K.replace(P,A.sep),Z=A.sep+H,ee=A.posix.sep+K,W=q?function(F,V){return typeof F=="string"&&(F===H||F.endsWith(Z)||!X&&(F===K||F.endsWith(ee)))?x:null}:function(F,V){return typeof F=="string"&&(F===H||!X&&F===K)?x:null};return W.allPaths=[(q?"*/":"./")+K],W}function u(K){try{const x=new RegExp(`^${y(K)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?K:null}}catch{return r}}function v(K,x,q){return!K||typeof x!="string"?!1:I(K)(x,void 0,q)}e.match=v;function I(K,x={}){if(!K)return l;if(typeof K=="string"||$(K)){const q=a(K,x);if(q===r)return l;const X=function(H,Z){return!!q(H,Z)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return j(K,x)}e.parse=I;function _(K){if(!K)return;let x;return q=>(x||(x=(K()||Promise.resolve([])).then(X=>X?N(X):{})),x.then(X=>!!X[q]))}e.hasSiblingPromiseFn=_;function O(K){if(!K)return;let x;return q=>{if(!x){const X=K();x=X?N(X):{}}return!!x[q]}}e.hasSiblingFn=O;function N(K){const x={};for(const q of K)x[q]=!0;return x}function $(K){const x=K;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}e.isRelativePattern=$;function L(K){return K.allBasenames||[]}e.getBasenameTerms=L;function U(K){return K.allPaths||[]}e.getPathTerms=U;function j(K,x){const q=G(Object.getOwnPropertyNames(K).map(W=>M(W,K[W],x)).filter(W=>W!==r)),X=q.length;if(!X)return r;if(!q.some(W=>!!W.requiresSiblings)){if(X===1)return q[0];const W=function(z,B){for(let ie=0,se=q.length;ie<se;ie++){const ce=q[ie](z,B);if(ce)return ce}return null},F=q.find(z=>!!z.allBasenames);F&&(W.allBasenames=F.allBasenames);const V=q.reduce((z,B)=>B.allPaths?z.concat(B.allPaths):z,[]);return V.length&&(W.allPaths=V),W}const H=function(W,F,V){let z;for(let B=0,ie=q.length;B<ie;B++){const se=q[B];se.requiresSiblings&&V&&(F||(F=A.basename(W)),z||(z=F.substr(0,F.length-A.extname(W).length)));const ce=se(W,F,z,V);if(ce)return ce}return null},Z=q.find(W=>!!W.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=q.reduce((W,F)=>F.allPaths?W.concat(F.allPaths):W,[]);return ee.length&&(H.allPaths=ee),H}function M(K,x,q){if(x===!1)return r;const X=a(K,q);if(X===r)return r;if(typeof x=="boolean")return X;if(x){const H=x.when;if(typeof H=="string"){const Z=(ee,W,F,V)=>{if(!V||!X(ee,W))return null;const z=H.replace("$(basename)",F),B=V(z);return(0,D.isThenable)(B)?B.then(ie=>ie?K:null):B?K:null};return Z.requiresSiblings=!0,Z}}return X}function G(K,x){const q=K.filter(W=>!!W.basenames);if(q.length<2)return K;const X=q.reduce((W,F)=>{const V=F.basenames;return V?W.concat(V):W},[]);let H;if(x){H=[];for(let W=0,F=X.length;W<F;W++)H.push(x)}else H=q.reduce((W,F)=>{const V=F.patterns;return V?W.concat(V):W},[]);const Z=function(W,F){if(typeof W!="string")return null;if(!F){let z;for(z=W.length;z>0;z--){const B=W.charCodeAt(z-1);if(B===47||B===92)break}F=W.substr(z)}const V=X.indexOf(F);return V!==-1?H[V]:null};Z.basenames=X,Z.patterns=H,Z.allBasenames=X;const ee=K.filter(W=>!W.basenames);return ee.push(Z),ee}}),define(te[110],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(P){return P.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:n(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:n(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function A(P,C,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof D.URI)return C.transformOutgoing(P);for(let y in P)if(Object.hasOwnProperty.call(P,y)){const h=A(P[y],C,f+1);h!==null&&(P[y]=h)}}return null}function T(P,C){const f=A(P,C,0);return f===null?P:f}e.transformOutgoingURIs=T;function R(P,C,f,y){if(!P||y>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?D.URI.revive(C.transformIncoming(P)):C.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const p=R(P[h],C,f,y+1);p!==null&&(P[h]=p)}}return null}function b(P,C){const f=R(P,C,!1,0);return f===null?P:f}e.transformIncomingURIs=b;function E(P,C){const f=R(P,C,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=E}),define(te[29],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(b){return D.test(b)}e.isUUID=n;const k=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};function R(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let b=0,E="";return E+=A[k[b++]],E+=A[k[b++]],E+=A[k[b++]],E+=A[k[b++]],E+="-",E+=A[k[b++]],E+=A[k[b++]],E+="-",E+=A[k[b++]],E+=A[k[b++]],E+="-",E+=A[k[b++]],E+=A[k[b++]],E+="-",E+=A[k[b++]],E+=A[k[b++]],E+=A[k[b++]],E+=A[k[b++]],E+=A[k[b++]],E+=A[k[b++]],E}e.generateUuid=R}),define(te[111],ne([0,1,249]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(A="utf8"){this.stringDecoder=new D.StringDecoder(A),this.remaining=null}write(A){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(R.length<1)return T;let b=0,E,P=b;for(;P<R.length;)if(E=R.charCodeAt(P),E===13||E===10){if(T.push(R.substring(b,P)),P++,P<R.length){const C=E;E=R.charCodeAt(P),(C===13&&E===10||C===10&&E===13)&&P++}b=P}else P++;return this.remaining=b<R.length?R.substr(b):null,T}end(){return this.remaining}}e.LineDecoder=n}),define(te[112],ne([0,1,33]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const R=T.replace(/\-/g,":").toLowerCase();return!n.has(R)}function A(){const T=(0,D.networkInterfaces)();for(let R in T){const b=T[R];if(b){for(const{mac:E}of b)if(k(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(te[113],ne([0,1,33,9,39,29,112]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,C=0;const f=(0,D.networkInterfaces)();for(let y in f){const h=f[y];if(h)for(const{mac:p,internal:d}of h)d||(C+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(P+=1))}this._value=C>0?P/C:0}return this._value}};let R;async function b(){return R||(R=(async()=>await E()||A.generateUuid())()),R}e.getMachineId=b;async function E(){try{const P=await new Promise((f,y)=>{Y(["crypto"],f,y)}),C=(0,T.getMac)();return P.createHash("sha256").update(C,"utf8").digest("hex")}catch(P){n.onUnexpectedError(P);return}}}),define(te[22],ne([0,1,50,33,250,5,41,71,10,4,19,7]),function(Y,e,D,n,k,A,T,R,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function y(U,j=f.UNLINK){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return j===f.UNLINK?p(U):h(U)}async function h(U){try{const j=(0,T.randomPath)((0,n.tmpdir)());try{await D.promises.rename(U,j)}catch{return p(U)}p(j).catch(M=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function p(U){return(0,k.promisify)(D.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function d(U){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function g(U,j){return S(await(j?w(U):(0,k.promisify)(D.readdir)(U)))}async function w(U){try{return await(0,k.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const j=[],M=await g(U);for(const G of M){let K=!1,x=!1,q=!1;try{const X=await e.Promises.lstat((0,b.join)(U,G));K=X.isFile(),x=X.isDirectory(),q=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}j.push({name:G,isFile:()=>K,isDirectory:()=>x,isSymbolicLink:()=>q})}return j}function m(U){return S(D.readdirSync(U))}e.readdirSync=m;function S(U){return U.map(j=>typeof j=="string"?E.isMacintosh?(0,R.normalizeNFC)(j):j:(j.name=E.isMacintosh?(0,R.normalizeNFC)(j.name):j.name,j))}async function l(U){const j=await g(U),M=[];for(const G of j)await a.existsDirectory((0,b.join)(U,G))&&M.push(G);return M}function r(U,j=1e3){return new Promise(M=>{let G=!1;const K=setInterval(()=>{G||(G=!0,D.access(U,x=>{G=!1,x&&(clearInterval(K),M(void 0))}))},j)})}e.whenDeleted=r;var a;(function(U){async function j(K){let x;try{if(x=await e.Promises.lstat(K),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(E.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw X}throw q}}U.stat=j;async function M(K){try{const{stat:x,symbolicLink:q}=await U.stat(K);return x.isFile()&&q?.dangling!==!0}catch{}return!1}U.existsFile=M;async function G(K){try{const{stat:x,symbolicLink:q}=await U.stat(K);return x.isDirectory()&&q?.dangling!==!0}catch{}return!1}U.existsDirectory=G})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function t(U,j,M){return i.queueFor(C.URI.file(U),P.extUriBiasedIgnorePathCase).queue(()=>{const G=u(M);return new Promise((K,x)=>o(U,j,G,q=>q?x(q):K()))})}let s=!0;function o(U,j,M,G){if(!s)return D.writeFile(U,j,{mode:M.mode,flag:M.flag},G);D.open(U,M.flag,M.mode,(K,x)=>{if(K)return G(K);D.writeFile(x,j,q=>{if(q)return D.close(x,()=>G(q));D.fdatasync(x,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),s=!1),D.close(x,H=>G(H))))})})}function c(U,j,M){const G=u(M);if(!s)return D.writeFileSync(U,j,{mode:G.mode,flag:G.flag});const K=D.openSync(U,G.flag,G.mode);try{D.writeFileSync(K,j);try{D.fdatasyncSync(K)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),s=!1}}finally{D.closeSync(K)}}e.writeFileSync=c;function u(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function v(U,j){if(U===j)return;async function M(G){try{const K=await e.Promises.lstat(G);if(K.isDirectory()||K.isSymbolicLink())return;await e.Promises.utimes(G,K.atime,new Date)}catch{}}try{await e.Promises.rename(U,j),await M(j)}catch(G){if(U.toLowerCase()!==j.toLowerCase()&&G.code==="EXDEV"||U.endsWith("."))await I(U,j,{preserveSymlinks:!1}),await y(U,f.MOVE),await M(j);else throw G}}async function I(U,j,M){return O(U,j,{root:{source:U,target:j},options:M,handledSourcePaths:new Set})}const _=511;async function O(U,j,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:G,symbolicLink:K}=await a.stat(U);if(K){if(M.options.preserveSymlinks)try{return await L(U,j,M)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(K.dangling)return}return G.isDirectory()?N(U,j,G.mode&_,M):$(U,j,G.mode&_)}async function N(U,j,M,G){await e.Promises.mkdir(j,{recursive:!0,mode:M});const K=await g(U);for(const x of K)await O((0,b.join)(U,x),(0,b.join)(j,x),G)}async function $(U,j,M){await e.Promises.copyFile(U,j),await e.Promises.chmod(j,M)}async function L(U,j,M){let G=await e.Promises.readlink(U);(0,T.isEqualOrParent)(G,M.root.source,!E.isLinux)&&(G=(0,b.join)(M.root.target,G.substr(M.root.source.length+1))),await e.Promises.symlink(G,j)}e.Promises=new class{get access(){return(0,k.promisify)(D.access)}get stat(){return(0,k.promisify)(D.stat)}get lstat(){return(0,k.promisify)(D.lstat)}get utimes(){return(0,k.promisify)(D.utimes)}get read(){return(U,j,M,G,K)=>new Promise((x,q)=>{D.read(U,j,M,G,K,(X,H,Z)=>X?q(X):x({bytesRead:H,buffer:Z}))})}get readFile(){return(0,k.promisify)(D.readFile)}get write(){return(U,j,M,G,K)=>new Promise((x,q)=>{D.write(U,j,M,G,K,(X,H,Z)=>X?q(X):x({bytesWritten:H,buffer:Z}))})}get appendFile(){return(0,k.promisify)(D.appendFile)}get fdatasync(){return(0,k.promisify)(D.fdatasync)}get truncate(){return(0,k.promisify)(D.truncate)}get rename(){return(0,k.promisify)(D.rename)}get copyFile(){return(0,k.promisify)(D.copyFile)}get open(){return(0,k.promisify)(D.open)}get close(){return(0,k.promisify)(D.close)}get symlink(){return(0,k.promisify)(D.symlink)}get readlink(){return(0,k.promisify)(D.readlink)}get chmod(){return(0,k.promisify)(D.chmod)}get mkdir(){return(0,k.promisify)(D.mkdir)}get unlink(){return(0,k.promisify)(D.unlink)}get rmdir(){return(0,k.promisify)(D.rmdir)}get realpath(){return(0,k.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return y}get move(){return v}get copy(){return I}}}),define(te[114],ne([0,1,50,10,4,26,22]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(k.isLinux)return f;const y=(0,n.dirname)(f);if(f===y)return f;const h=((0,n.basename)(f)||f).toLowerCase();try{const d=(0,T.readdirSync)(y).filter(g=>g.toLowerCase()===h);if(d.length===1){const g=R(y);if(g)return(0,n.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(h);if(g>=0){const w=R(y);if(w)return(0,n.join)(w,d[g])}}}catch{}return null}e.realcaseSync=R;async function b(f){if(k.isLinux)return f;const y=(0,n.dirname)(f);if(f===y)return f;const h=((0,n.basename)(f)||f).toLowerCase();try{const d=(await T.Promises.readdir(y)).filter(g=>g.toLowerCase()===h);if(d.length===1){const g=await b(y);if(g)return(0,n.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(h);if(g>=0){const w=await b(y);if(w)return(0,n.join)(w,d[g])}}}catch{}return null}e.realcase=b;async function E(f){try{return await T.Promises.realpath(f)}catch{const h=C(f);return await T.Promises.access(h,D.constants.R_OK),h}}e.realpath=E;function P(f){try{return D.realpathSync(f)}catch{const h=C(f);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=P;function C(f){return(0,A.rtrim)((0,n.normalize)(f),n.sep)}}),define(te[115],ne([0,1,56]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,b,E,P=1){let C=!1;return new Promise(f=>{const y=setTimeout(()=>{if(!C)return C=!0,f(0)},E);k(R,b,P,h=>{if(!C)return C=!0,clearTimeout(y),f(h)})})}e.findFreePort=n;function k(R,b,E,P){if(b===0)return P(0);const C=new D.Socket;C.once("connect",()=>(T(C),k(R+E,b-1,E,P))),C.once("data",()=>{}),C.once("error",f=>(T(C),f.code!=="ECONNREFUSED"?k(R+E,b-1,E,P):P(R))),C.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,b,E){let P=!1,C,f=1;const y=D.createServer({pauseOnConnect:!0});function h(p,d){P||(P=!0,y.removeAllListeners(),y.close(),C&&clearTimeout(C),d(p))}return new Promise(p=>{C=setTimeout(()=>{h(0,p)},E),y.on("listening",()=>{h(R,p)}),y.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&f<b?(R++,f++,y.listen(R,"127.0.0.1")):h(0,p)}),y.on("close",()=>{h(0,p)}),y.listen(R,"127.0.0.1")})}e.findFreePortFaster=A;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(te[72],ne([0,1,33,10,22]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(b||(b={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class C{constructor(l,r,a){this.exePath=l,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:S=!1}={}){return S?E===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:S=!1,findPreview:l=!1}={}){const r=f({useAlternateBitness:S});if(!r)return null;const a=n.join(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let i=-1,t=null;for(const c of await k.Promises.readdir(a)){let u=-1;if(l){const I=c.indexOf("-");if(I<0)continue;const _=c.substring(0,I);if(!A.test(_)||c.substring(I+1)!=="preview")continue;u=parseInt(_,10)}else{if(!A.test(c))continue;u=parseInt(c,10)}if(u<=i)continue;const v=n.join(a,c,"pwsh.exe");!await k.SymlinkSupport.existsFile(v)||(t=v,i=u)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=l?" Preview":"";return new C(t,`PowerShell${o}${s}`,!0)}async function h({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=S?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(l))if(r.test(i)){const t=n.join(l,i,"pwsh.exe");return new C(t,a)}return null}function p(){const S=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(S,".NET Core PowerShell Global Tool")}function d(){const S=n.join(process.env.windir,E===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(S,"Windows PowerShell",!0)}async function*g(){let S=await y();S&&(yield S),S=await y({useAlternateBitness:!0}),S&&(yield S),S=await h(),S&&(yield S),S=p(),S&&(yield S),S=await y({findPreview:!0}),S&&(yield S),S=await h({findPreview:!0}),S&&(yield S),S=await y({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=d(),S&&(yield S)}async function*w(){for await(const S of g())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=w;async function m(){for await(const S of w())return S;return null}e.getFirstAvailablePowerShellInstallation=m}),define(te[116],ne([0,1,45,18]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(T){return new Promise((R,b)=>{let E;const P=new Map;function C(y,h,p,d,g){const w=P.get(h);if(y===T||w){const m={name:f(p),cmd:p,pid:y,ppid:h,load:d,mem:g};P.set(y,m),y===T&&(E=m),w&&(w.children||(w.children=[]),w.children.push(m),w.children.length>1&&(w.children=w.children.sort((S,l)=>S.pid-l.pid)))}}function f(y){const h=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,d=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,w=/--crashes-directory/,m=/\\pipe\\winpty-control/,S=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(y))return"electron-crash-reporter";if(m.exec(y))return"winpty-process";if(S.exec(y))return"console-window-host (Windows internal process)";let r=l.exec(y);if(r&&r.length===2)return r[1]==="renderer"?h.exec(y)?"shared-process":p.exec(y)?"issue-reporter":d.exec(y)?"process-explorer":"window":r[1]==="utility"&&g.exec(y)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let i="";do r=a.exec(y),r&&(i+=r+" ");while(r);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,p)=>{Y(["windows-process-tree"],h,p)}).then(h=>{h.getProcessList(T,p=>{h.getProcessCpuUsage(p,d=>{const g=new Map;d.forEach(w=>{const m=y(w.commandLine||"");g.set(w.pid,{name:f(m),cmd:m,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),E=g.get(T),E?(g.forEach(w=>{const m=g.get(w.ppid);m&&(m.children||(m.children=[]),m.children.push(w))}),g.forEach(w=>{w.children&&(w.children=w.children.sort((m,S)=>m.pid-S.pid))}),R(E)):b(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[E];const p=[];for(;h.length;){const g=h.shift();g&&(p.push(g.pid),g.children&&(h=h.concat(g.children)))}let d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);d+=" "+p.join(" "),(0,D.exec)(d,{},(g,w,m)=>{if(g||m)b(g||new Error(m.toString()));else{const S=w.toString().split(`
`);for(let l=0;l<p.length;l++){const r=P.get(p[l]);r.load=parseFloat(S[l])}if(!E){b(new Error(`Root process ${T} not found`));return}R(E)}})};(0,D.exec)("which ps",{},(h,p,d)=>{if(h||d)if(process.platform!=="linux")b(h||new Error(d.toString()));else{const g=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,D.exec)(g,{},(w,m,S)=>{w||S?b(w||new Error(S.toString())):(A(m,C),y())})}else{const g=p.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${g} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,S,l)=>{m||l&&!l.includes("screen size is bogus")?b(m||new Error(l.toString())):(A(S,C),process.platform==="linux"?y():E?R(E):b(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=k;function A(T,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=T.toString().split(`
`);for(const P of E){const C=b.exec(P.trim());C&&C.length===6&&R(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var de=this&&this.__decorate||function(Y,e,D,n){var k=arguments.length,A=k<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Y,e,D,n);else for(var R=Y.length-1;R>=0;R--)(T=Y[R])&&(A=(k<3?T(A):k>3?T(e,D,A):T(e,D))||A);return k>3&&A&&Object.defineProperty(e,D,A),A};define(te[36],ne([0,1,16,5,17,25,54,9,3,2,108,26,14]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function h(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function d(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(g||(g={}));class w{constructor(q){this.buffer=q,this.pos=0}read(q){const X=this.buffer.slice(this.pos,this.pos+q);return this.pos+=X.byteLength,X}}class m{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var S;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(S||(S={}));function l(x){const q=k.VSBuffer.alloc(4);return q.writeUInt32BE(x,0),q}function r(x){return x.read(4).readUInt32BE(0)}function a(x){const q=k.VSBuffer.alloc(1);return q.writeUInt8(x,0),q}const i={Undefined:a(S.Undefined),String:a(S.String),Buffer:a(S.Buffer),VSBuffer:a(S.VSBuffer),Array:a(S.Array),Object:a(S.Object)},t=typeof Buffer!="undefined";function s(x,q){if(typeof q=="undefined")x.write(i.Undefined);else if(typeof q=="string"){const X=k.VSBuffer.fromString(q);x.write(i.String),x.write(l(X.byteLength)),x.write(X)}else if(t&&Buffer.isBuffer(q)){const X=k.VSBuffer.wrap(q);x.write(i.Buffer),x.write(l(X.byteLength)),x.write(X)}else if(q instanceof k.VSBuffer)x.write(i.VSBuffer),x.write(l(q.byteLength)),x.write(q);else if(Array.isArray(q)){x.write(i.Array),x.write(l(q.length));for(const X of q)s(x,X)}else{const X=k.VSBuffer.fromString(JSON.stringify(q));x.write(i.Object),x.write(l(X.byteLength)),x.write(X)}}function o(x){switch(x.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return x.read(r(x)).toString();case S.Buffer:return x.read(r(x)).buffer;case S.VSBuffer:return x.read(r(x));case S.Array:{const X=r(x),H=[];for(let Z=0;Z<X;Z++)H.push(o(x));return H}case S.Object:return JSON.parse(x.read(r(x)).toString())}}class c{constructor(q,X,H=null,Z=1e3){this.protocol=q,this.ctx=X,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(q,X){this.channels.set(q,X),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const X=this.send([q.type]);this.logger&&this.logger.logOutgoing(X,0,1,d(q.type));return}case 201:case 202:case 204:case 203:{const X=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(X,q.id,1,d(q.type),q.data);return}}}send(q,X=void 0){const H=new m;return s(H,q),s(H,X),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const X=new w(q),H=o(X),Z=o(X),ee=H[0];switch(ee){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(ee)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(ee)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]})}}onPromise(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const H=new A.CancellationTokenSource;let Z;try{Z=X.call(this.ctx,q.name,q.arg,H.token)}catch(F){Z=Promise.reject(F)}const ee=q.id;Z.then(F=>{this.sendResponse({id:ee,data:F,type:201}),this.activeRequests.delete(q.id)},F=>{F instanceof Error?this.sendResponse({id:ee,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:ee,data:F,type:203}),this.activeRequests.delete(q.id)});const W=(0,E.toDisposable)(()=>H.cancel());this.activeRequests.set(q.id,W)}onEventListen(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const H=q.id,ee=X.listen(this.ctx,q.name,q.arg)(W=>this.sendResponse({id:H,data:W,type:204}));this.activeRequests.set(q.id,ee)}disposeActiveRequest(q){const X=this.activeRequests.get(q.id);X&&(X.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let X=this.pendingRequests.get(q.channelName);X||(X=[],this.pendingRequests.set(q.channelName,X));const H=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:q,timeoutTimer:H})}flushPendingRequests(q){const X=this.pendingRequests.get(q);if(X){for(const H of X)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var u;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(q,X=null){this.protocol=q,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=X}getChannel(q){const X=this;return{call(H,Z,ee){return X.isDisposed?Promise.reject(R.canceled()):X.requestPromise(q,H,Z,ee)},listen(H,Z){return X.isDisposed?Promise.reject(R.canceled()):X.requestEvent(q,H,Z)}}}requestPromise(q,X,H,Z=A.CancellationToken.None){const ee=this.lastRequestId++,F={id:ee,type:100,channelName:q,name:X,arg:H};if(Z.isCancellationRequested)return Promise.reject(R.canceled());let V;return new Promise((B,ie)=>{if(Z.isCancellationRequested)return ie(R.canceled());const se=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(ee),B(ye.data);break;case 202:{this.handlers.delete(ee);const Se=new Error(ye.data.message);Se.stack=ye.data.stack,Se.name=ye.data.name,ie(Se);break}case 203:this.handlers.delete(ee),ie(ye.data);break}};this.handlers.set(ee,me),this.sendRequest(F)};let ce=null;this.state===g.Idle?se():(ce=(0,n.createCancelablePromise)(me=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:ee,type:101}),ie(R.canceled())},ge=Z.onCancellationRequested(he);V=(0,E.combinedDisposable)((0,E.toDisposable)(he),ge),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(q,X,H){const Z=this.lastRequestId++,W={id:Z,type:102,channelName:q,name:X,arg:H};let F=null;const V=new b.Emitter({onFirstListenerAdd:()=>{F=(0,n.createCancelablePromise)(B=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(V),this.sendRequest(W)})},onLastListenerRemove:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(V),this.sendRequest({id:Z,type:103}))}}),z=B=>V.fire(B.data);return this.handlers.set(Z,z),V.event}sendRequest(q){switch(q.type){case 100:case 102:{const X=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(X,q.id,0,`${h(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const X=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(X,q.id,0,h(q.type));return}}}send(q,X=void 0){const H=new m;return s(H,q),s(H,X),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const X=new w(q),H=o(X),Z=o(X),ee=H[0];switch(ee){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,d(ee)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],0,d(ee),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(q){if(q.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(q.id);X&&X(q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}de([T.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class I{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:X,onDidClientDisconnect:H})=>{b.Event.once(X.onMessage)(ee=>{const W=new w(ee),F=o(W),V=new c(X,F),z=new v(X);this.channels.forEach((ie,se)=>V.registerChannel(se,ie));const B={channelServer:V,channelClient:z,ctx:F};this._connections.add(B),this._onDidAddConnection.fire(B),H(()=>{V.dispose(),z.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const q=[];return this._connections.forEach(X=>q.push(X)),q}getChannel(q,X){const H=this;return{call(Z,ee,W){let F;if((0,f.isFunction)(X)){let z=(0,D.getRandomElement)(H.connections.filter(X));F=z?Promise.resolve(z):b.Event.toPromise(b.Event.filter(H.onDidAddConnection,X))}else F=X.routeCall(H,Z,ee);const V=F.then(z=>z.channelClient.getChannel(q));return O(V).call(Z,ee,W)},listen(Z,ee){if((0,f.isFunction)(X))return H.getMulticastEvent(q,X,Z,ee);const W=X.routeEvent(H,Z,ee).then(F=>F.channelClient.getChannel(q));return O(W).listen(Z,ee)}}}getMulticastEvent(q,X,H,Z){const ee=this;let W=new E.DisposableStore;const F=new b.Emitter({onFirstListenerAdd:()=>{W=new E.DisposableStore;const V=new b.EventMultiplexer,z=new Map,B=se=>{const he=se.channelClient.getChannel(q).listen(H,Z),ge=V.add(he);z.set(se,ge)},ie=se=>{const ce=z.get(se);!ce||(ce.dispose(),z.delete(se))};ee.connections.filter(X).forEach(B),b.Event.filter(ee.onDidAddConnection,X)(B,void 0,W),ee.onDidRemoveConnection(ie,void 0,W),V.event(F.fire,F,W),W.add(V)},onLastListenerRemove:()=>{W.dispose()}});return F.event}registerChannel(q,X){this.channels.set(q,X),this._connections.forEach(H=>{H.channelServer.registerChannel(q,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class _{constructor(q,X,H=null){const Z=new m;s(Z,X),q.send(Z.buffer),this.channelClient=new v(q,H),this.channelServer=new c(q,X,H)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,X){this.channelServer.registerChannel(q,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(x){return{call(q,X,H){return x.then(Z=>Z.call(q,X,H))},listen(q,X){const H=new b.Relay;return x.then(Z=>H.input=Z.listen(q,X)),H.event}}}e.getDelayedChannel=O;function N(x){let q=!1;return{call(X,H,Z){return q?x.call(X,H,Z):(0,n.timeout)(0).then(()=>q=!0).then(()=>x.call(X,H,Z))},listen(X,H){if(q)return x.listen(X,H);const Z=new b.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>Z.input=x.listen(X,H)),Z.event}}}e.getNextTickChannel=N;class ${constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const X of q.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=$;var L;(function(x){function q(ee,W){const F=ee,V=W&&W.disableMarshalling,z=new Map;for(const B in F)H(B)&&z.set(B,b.Event.buffer(F[B],!0));return new class{listen(B,ie,se){const ce=z.get(ie);if(ce)return ce;if(Z(ie)){const he=F[ie];if(typeof he=="function")return he.call(F,se)}throw new Error(`Event not found: ${ie}`)}call(B,ie,se){const ce=F[ie];if(typeof ce=="function"){if(!V&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ce.apply(F,se)}throw new Error(`Method not found: ${ie}`)}}}x.fromService=q;function X(ee,W){const F=W&&W.disableMarshalling;return new Proxy({},{get(V,z){if(typeof z=="string")return W?.properties?.has(z)?W.properties.get(z):Z(z)?function(B){return ee.listen(z,B)}:H(z)?ee.listen(z):async function(...B){let ie;W&&!(0,f.isUndefinedOrNull)(W.context)?ie=[W.context,...B]:ie=B;const se=await ee.call(z,ie);return F?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}x.toService=X;function H(ee){return ee[0]==="o"&&ee[1]==="n"&&C.isUpperAsciiLetter(ee.charCodeAt(2))}function Z(ee){return/^onDynamic/.test(ee)&&C.isUpperAsciiLetter(ee.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let q=x.toString();if(q!=="[object Object]")return q}return x}function M(x){return Array.isArray(x)?x.map(j):j(x)}function G(x,q,X,H,Z,ee,W){W=M(W);const F=U[Z],V=F[H%F.length];let z=[`%c[${x}]%c[${String(q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(ee)?(z=z.concat(W),z.push(")")):z.push(W),console.log.apply(console,z)}e.logWithColors=G;class K{constructor(q,X){this._outgoingPrefix=q,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,X,H,Z,ee){this._totalOutgoing+=q,G(this._outgoingPrefix,this._totalOutgoing,q,X,H,Z,ee)}logIncoming(q,X,H,Z,ee){this._totalIncoming+=q,G(this._incomingPrefix,this._totalIncoming,q,X,H,Z,ee)}}e.IPCLogger=K}),define(te[117],ne([0,1,17,3,36]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(b){this.port=b,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class T extends k.IPCClient{constructor(b,E){const P=new A(b);super(P,E);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=T}),define(te[73],ne([0,1,17,3,2,36]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function c(v,I){if(!s.has(v)){const _=String(++o);s.set(v,_)}return s.get(v)}function u(v,I,_,O){if(!t.enableDiagnostics)return;const N=c(v,I);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const $=D.VSBuffer.alloc(O.byteLength);$.set(O),t.records.push({timestamp:Date.now(),id:N,label:I,type:_,buff:$})}else t.records.push({timestamp:Date.now(),id:N,label:I,type:_,data:O})}t.traceSocketEvent=u})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function P(){return E||(E=D.VSBuffer.alloc(0)),E}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),I}if(this._chunks[0].byteLength>s){const I=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),I}let c=D.VSBuffer.alloc(s),u=0,v=0;for(;s>0;){const I=this._chunks[v];if(I.byteLength>s){const _=I.slice(0,s);c.set(_,u),u+=s,o&&(this._chunks[v]=I.slice(s),this._totalLength-=s),s-=s}else c.set(I,u),u+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):v++,s-=I.byteLength}return c}}e.ChunkStream=C;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function y(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,o,c,u){this.type=s,this.id=o,this.ack=c,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends k.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,u=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new p(c,u,v,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const c=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,c}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class w extends k.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=w;class m extends A.IPCClient{constructor(s,o,c=null){super(s,o,c);this.protocol=s}static fromSocket(s,o){return new m(new w(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=m;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class l{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,c=this._first;for(;c;)s[o++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new l(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let u=0;u<a._HISTORY_LENGTH;u++)s-this.lastRuns[u]<=o&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class i{constructor(s,o=null,c=a.getInstance()){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new p(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new p(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let c=0,u=o.length;c<u;c++)this._socketWriter.write(o[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new p(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let c=0,u=o.length;c<u;c++)this._socketWriter.write(o[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new p(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const o=new p(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&c>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const v=Math.max(2e4-o,2e4-c,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(te[118],ne([0,1,74,3,36,117]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends k.IPCServer{static getOnDidClientConnect(){const b=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,P)=>P);return n.Event.map(b,E=>{const{port1:P,port2:C}=new MessageChannel,y={protocol:new A.Protocol(P),onDidClientDisconnect:n.Event.fromDOMEventEmitter(P,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[C]),y})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(te[119],ne([0,1,17,9]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(R,b){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((P,C)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),A(E,R),E.responseType="arraybuffer",E.onerror=f=>C(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{P({res:{statusCode:E.status,headers:T(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>C(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),b.onCancellationRequested(()=>{E.abort(),C((0,n.canceled)())})})}e.request=k;function A(R,b){if(b.headers){e:for(let E in b.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,b.headers[E])}}}function T(R){const b=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const P=E.indexOf(":");b[E.substr(0,P).trim().toLowerCase()]=E.substr(P+1).trim()}return b}}),define(te[75],ne([0,1,5,3,2,14]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function R(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(b||(b={}));class E extends k.Disposable{constructor(f,y=Object.create(null)){super();this.database=f,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((y,h)=>this.accept(h,y)),f.deleted?.forEach(y=>this.accept(y,void 0))}accept(f,y){if(this.state===b.Closed)return;let h=!1;(0,A.isUndefinedOrNull)(y)?h=this.cache.delete(f):this.cache.get(f)!==y&&(this.cache.set(f,y),h=!0),h&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,y){const h=this.cache.get(f);return(0,A.isUndefinedOrNull)(h)?y:h}getBoolean(f,y){const h=this.get(f);return(0,A.isUndefinedOrNull)(h)?y:h==="true"}getNumber(f,y){const h=this.get(f);return(0,A.isUndefinedOrNull)(h)?y:parseInt(h,10)}async set(f,y){if(this.state===b.Closed)return;if((0,A.isUndefinedOrNull)(y))return this.delete(f);const h=String(y);if(this.cache.get(f)!==h)return this.cache.set(f,h),this.pendingInserts.set(f,h),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((y,h)=>this.items.set(h,y)),f.delete&&f.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=P}),define(te[120],ne([11,12]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(te[57],ne([0,1,120]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,k=n*60,A=k*24,T=A*7,R=A*30,b=A*365;function E(C,f,y){typeof C!="number"&&(C=C.getTime());const h=Math.round((new Date().getTime()-C)/1e3);if(h<-30)return(0,D.localize)(0,null,E(new Date().getTime()+h*1e3,!1));if(h<30)return(0,D.localize)(1,null);let p;return h<n?(p=h,f?p===1?y?(0,D.localize)(2,null,p):(0,D.localize)(3,null,p):y?(0,D.localize)(4,null,p):(0,D.localize)(5,null,p):p===1?y?(0,D.localize)(6,null,p):(0,D.localize)(7,null,p):y?(0,D.localize)(8,null,p):(0,D.localize)(9,null,p)):h<k?(p=Math.floor(h/n),f?p===1?y?(0,D.localize)(10,null,p):(0,D.localize)(11,null,p):y?(0,D.localize)(12,null,p):(0,D.localize)(13,null,p):p===1?y?(0,D.localize)(14,null,p):(0,D.localize)(15,null,p):y?(0,D.localize)(16,null,p):(0,D.localize)(17,null,p)):h<A?(p=Math.floor(h/k),f?p===1?y?(0,D.localize)(18,null,p):(0,D.localize)(19,null,p):y?(0,D.localize)(20,null,p):(0,D.localize)(21,null,p):p===1?y?(0,D.localize)(22,null,p):(0,D.localize)(23,null,p):y?(0,D.localize)(24,null,p):(0,D.localize)(25,null,p)):h<T?(p=Math.floor(h/A),f?p===1?(0,D.localize)(26,null,p):(0,D.localize)(27,null,p):p===1?(0,D.localize)(28,null,p):(0,D.localize)(29,null,p)):h<R?(p=Math.floor(h/T),f?p===1?y?(0,D.localize)(30,null,p):(0,D.localize)(31,null,p):y?(0,D.localize)(32,null,p):(0,D.localize)(33,null,p):p===1?y?(0,D.localize)(34,null,p):(0,D.localize)(35,null,p):y?(0,D.localize)(36,null,p):(0,D.localize)(37,null,p)):h<b?(p=Math.floor(h/R),f?p===1?y?(0,D.localize)(38,null,p):(0,D.localize)(39,null,p):y?(0,D.localize)(40,null,p):(0,D.localize)(41,null,p):p===1?y?(0,D.localize)(42,null,p):(0,D.localize)(43,null,p):y?(0,D.localize)(44,null,p):(0,D.localize)(45,null,p)):(p=Math.floor(h/b),f?p===1?y?(0,D.localize)(46,null,p):(0,D.localize)(47,null,p):y?(0,D.localize)(48,null,p):(0,D.localize)(49,null,p):p===1?y?(0,D.localize)(50,null,p):(0,D.localize)(51,null,p):y?(0,D.localize)(52,null,p):(0,D.localize)(53,null,p))}e.fromNow=E;function P(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(te[121],ne([11,12]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,16,14,121]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(E,P){return P&&(E.stack||E.stacktrace)?k.localize(0,null,R(E),T(E.stack)||T(E.stacktrace)):R(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?k.localize(1,null,E.message):E.message||k.localize(2,null)}function b(E=null,P=!1){if(!E)return k.localize(3,null);if(Array.isArray(E)){const C=D.coalesce(E),f=b(C[0],P);return C.length>1?k.localize(4,null,f,C.length):f}if(n.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return A(C.error,P);if(C.exception)return A(C.exception,P)}return E.stack?A(E,P):E.message?E.message:k.localize(5,null)}e.toErrorMessage=b}),define(te[122],ne([11,12]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(te[76],ne([0,1,45,41,18,28,10,4,32,103,14,111,22,122]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(r,a){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};a&&(i.cwd=a);const t=D.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,c)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?h(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{D.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,c)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function d(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=d;function g(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=g;class w{constructor(a,i,t,s){if(i!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=i,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(b.env).forEach(c=>{o[c]=b.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const i=a.lastIndexOf(T.sep);return i!==-1&&(a=a.substring(i+1)),w.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(i=>{let t,s;const o=new Promise((c,u)=>{t=c,s=u});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(u,v,I)=>{this.childProcess=null;const _=u;_&&_.killed?s({killed:this.terminateRequested,stdout:v.toString(),stderr:I.toString()}):this.handleExec(t,a,u,v,I)})}else{let c=null;const u=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,t,a,s);const I={terminated:this.terminateRequested};P.isNumber(v)&&(I.cmdCode=v),t(I)};if(this.shell&&R.isWindows){const v=A.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let I=!1,_=!1;const O=[];let N=this.ensureQuotes(this.cmd);O.push(N.value),I=N.quoted,this.args&&this.args.forEach(L=>{N=this.ensureQuotes(L),O.push(N.value),_=_&&N.quoted});const $=["/s","/c"];I?_?$.push('"'+O.join(" ")+'"'):O.length>1?$.push('"'+O[0]+'" '+O.slice(1).join(" ")):$.push('"'+O[0]+'"'):$.push(O.join(" ")),c=D.spawn(g(),$,v)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",v=>{this.childProcess=null,s({terminated:this.terminateRequested,error:v})}),c.pid&&(this.childProcess.on("close",u),this.handleSpawn(c,t,a,s,!0)))}return o})}handleClose(a,i,t,s){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,p(a,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const i=D.spawn(g(),["/s","/c"]);i.on("error",t=>a(!0)),i.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class m extends w{constructor(a,i,t,s){super(a,i,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,i,t,s,o){[s,o].forEach((c,u)=>{const v=new C.LineDecoder;v.write(c).forEach(O=>{i({line:O,source:u===0?0:1})});const _=v.end();_&&i({line:_,source:u===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,i,t,s,o){const c=new C.LineDecoder,u=new C.LineDecoder;a.stdout.on("data",v=>{c.write(v).forEach(_=>t({line:_,source:0}))}),a.stderr.on("data",v=>{u.write(v).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=u}handleClose(a,i,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=m;function S(r){let a=[],i=!1;const t=function(s){if(i){a.push(s);return}(!r.send(s,c=>{if(c&&console.error(c),i=!1,a.length>0){const u=a.slice(0);a=[],u.forEach(v=>t(v))}})||R.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=S;var l;(function(r){async function a(i,t,s){if(T.isAbsolute(i))return i;if(t===void 0&&(t=b.cwd()),T.dirname(i)!=="."||(s===void 0&&P.isString(b.env.PATH)&&(s=b.env.PATH.split(T.delimiter)),s===void 0||s.length===0))return T.join(t,i);async function c(u){if(await f.Promises.exists(u)){let v;try{v=await f.Promises.stat(u)}catch(I){I.message.startsWith("EACCES")&&(v=await f.Promises.lstat(u))}return v?!v.isDirectory():!1}return!1}for(let u of s){let v;if(T.isAbsolute(u)?v=T.join(u,i):v=T.join(t,u,i),await c(v))return v;let I=v+".com";if(await c(I)||(I=v+".exe",await c(I)))return I}return T.join(t,i)}r.findExecutable=a})(l=e.win32||(e.win32={}))}),define(te[123],ne([0,1,33,4,72,76]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(y,h){return y===1?n.isWindows?C():A.getWindowsShell(h):E(y,h)}e.getSystemShell=T;function R(y,h){return y===1?n.isWindows?f(h):A.getWindowsShell(h):E(y,h)}e.getSystemShellSync=R;let b=null;function E(y,h){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!b){let p;if(n.isWindows)p="/bin/bash";else{if(p=h.SHELL,!p)try{p=(0,D.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}b=p}return b}let P=null;async function C(){return P||(P=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(y){if(P)return P;const h=n.isWindows&&parseFloat((0,D.release)())>=10,p=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${y.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?d:A.getWindowsShell(y)}}),define(te[58],ne([0,1,45,5,17,25,107,9,3,2,28,76,36]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends f.ChannelServer{constructor(d){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=y;class h{constructor(d,g){this.modulePath=d,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(d){const g=this;return{call(w,m,S){return g.requestPromise(d,w,m,S)},listen(w,m){return g.requestEvent(d,w,m)}}}requestPromise(d,g,w,m=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(d),l=(0,n.createCancelablePromise)(i=>S.call(g,w,i)),r=m.onCancellationRequested(()=>l.cancel()),a=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(d,g,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let m;const S=new b.Emitter({onFirstListenerAdd:()=>{m=this.getCachedChannel(d).listen(g,w)(S.fire,S),this.activeRequests.add(m)},onLastListenerRemove:()=>{this.activeRequests.delete(m),m.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(g.env),this.child=(0,D.fork)(this.modulePath,d,g);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,T.isRemoteConsoleLog)(t)){(0,T.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(t,"base64")))});const S=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&S.send(t.buffer.toString("base64")),r=w.event,a={send:l,onMessage:r};this._client=new f.ChannelClient(a);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",i),this.activeRequests.forEach(o=>(0,E.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(d){let g=this.channels.get(d);return g||(g=this.client.getChannel(d),this.channels.set(d,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[124],ne([11,12]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(te[125],ne([11,12]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[126],ne([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(te[127],ne([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(te[128],ne([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/shellEnv",e)}),define(te[129],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([11,12]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([11,12]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([11,12]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(te[138],ne([11,12]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(te[139],ne([11,12]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([11,12]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(te[141],ne([11,12]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([11,12]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[144],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[145],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[146],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[147],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[148],ne([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[149],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(T){T.Team="team",T.Internal="internal",T.Insiders="insider",T.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var k;(function(T){T.Market="X-MSEdge-Market",T.CorpNet="X-FD-Corpnet",T.ApplicationVersion="X-VSCode-AppVersion",T.Build="X-VSCode-Build",T.ClientId="X-MSEdge-ClientId",T.ExtensionName="X-VSCode-ExtensionName",T.Language="X-VSCode-Language",T.TargetPopulation="X-VSCode-TargetPopulation"})(k=e.Filters||(e.Filters={}));class A{constructor(R,b,E,P){this.version=R,this.appName=b,this.machineId=E,this.targetPopulation=P}getFilterValue(R){switch(R){case k.ApplicationVersion:return this.version;case k.Build:return this.appName;case k.ClientId:return this.machineId;case k.Language:return D.language;case k.ExtensionName:return"vscode-core";case k.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(k);for(let E of b)R.set(E,this.getFilterValue(E));return R}}e.AssignmentFilterProvider=A}),define(te[77],ne([0,1,57,54,18,10,32,19,7]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(p,d,g){this._args=p,this.paths=d,this.productService=g}get appRoot(){return(0,A.dirname)(k.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=T.env.VSCODE_PORTABLE;return p?b.URI.file((0,A.join)(p,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,A.resolve)(p):(0,A.normalize)((0,A.join)(k.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,A.resolve)(p):(0,A.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,A.resolve)(p);const d=T.env.VSCODE_EXTENSIONS;if(d)return d;const g=T.env.VSCODE_PORTABLE;return g?(0,A.join)(g,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,A.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?b.URI.parse(p):b.URI.file((0,A.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],E.prototype,"appRoot",null),de([n.memoize],E.prototype,"userHome",null),de([n.memoize],E.prototype,"userDataPath",null),de([n.memoize],E.prototype,"appSettingsHome",null),de([n.memoize],E.prototype,"tmpDir",null),de([n.memoize],E.prototype,"cacheHome",null),de([n.memoize],E.prototype,"userRoamingDataHome",null),de([n.memoize],E.prototype,"settingsResource",null),de([n.memoize],E.prototype,"userDataSyncHome",null),de([n.memoize],E.prototype,"userDataSyncLogResource",null),de([n.memoize],E.prototype,"sync",null),de([n.memoize],E.prototype,"machineSettingsResource",null),de([n.memoize],E.prototype,"globalStorageHome",null),de([n.memoize],E.prototype,"workspaceStorageHome",null),de([n.memoize],E.prototype,"keybindingsResource",null),de([n.memoize],E.prototype,"keyboardLayoutResource",null),de([n.memoize],E.prototype,"argvResource",null),de([n.memoize],E.prototype,"snippetsHome",null),de([n.memoize],E.prototype,"isExtensionDevelopment",null),de([n.memoize],E.prototype,"untitledWorkspacesHome",null),de([n.memoize],E.prototype,"installSourcePath",null),de([n.memoize],E.prototype,"builtinExtensionsPath",null),de([n.memoize],E.prototype,"extensionsPath",null),de([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],E.prototype,"extensionDevelopmentKind",null),de([n.memoize],E.prototype,"extensionTestsLocationURI",null),de([n.memoize],E.prototype,"debugExtensionHost",null),de([n.memoize],E.prototype,"serviceMachineIdResource",null),de([n.memoize],E.prototype,"telemetryLogResource",null),de([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function P(h,p){return y(h["inspect-extensions"],h["inspect-brk-extensions"],5870,p,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=P;function C(h,p){return y(h["inspect-search"],h["inspect-brk-search"],5876,p,h.extensionEnvironment)}e.parseSearchPort=C;function f(h,p){return y(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,p,h.extensionEnvironment)}e.parsePtyHostPort=f;function y(h,p,d,g,w,m){const l=Number(p||h)||(g?null:d),r=l?Boolean(!!p):!1;let a;if(m)try{a=JSON.parse(m)}catch{}return{port:l,break:r,debugId:w,env:a}}}),define(te[150],ne([0,1,251,4,126]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,p,d=T){const g={},w=[],m=[];for(let a in p){const i=p[a];i.alias&&(g[a]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(a),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(m.push(a),i.deprecates&&m.push(...i.deprecates))}const S=D(h,{string:w,boolean:m,alias:g}),l={},r=S;l._=S._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in p){const i=p[a];i.alias&&delete r[i.alias];let t=r[a];if(i.deprecates)for(const s of i.deprecates)r.hasOwnProperty(s)&&(t||(t=r[s],t&&d.onDeprecatedOption(s,i.deprecationMessage||(0,k.localize)(33,null))),delete r[s]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),d.onMultipleValues(a,t)),l[a]=t,i.deprecationMessage&&d.onDeprecatedOption(a,i.deprecationMessage)),delete r[a]}for(let a in r)d.onUnknownOption(a);return l}e.parseArgs=R;function b(h,p){let d="";return p.args&&(Array.isArray(p.args)?d=` <${p.args.join("> <")}>`:d=` <${p.args}>`),p.alias?`-${p.alias} --${h}${d}`:`--${h}${d}`}function E(h,p){let d=0,g=[];for(const l in h){const r=h[l],a=b(l,r);d=Math.max(d,a.length),g.push([a,r.description])}let w=d+2+1;if(p-w<25)return g.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let m=p-w-1,S=[];for(const l of g){let r=l[0],a=C(l[1],m),i=P(w-r.length-2);S.push("  "+r+i+a[0]);for(let t=1;t<a.length;t++)S.push(P(w)+a[t])}return S}e.formatOptions=E;function P(h){return" ".repeat(h)}function C(h,p){let d=[];for(;h.length;){let g=h.length<p?h.length:h.lastIndexOf(" ",p),w=h.slice(0,g).trim();h=h.slice(g),d.push(w)}return d}function f(h,p,d,g,w){const m=process.stdout.isTTY&&process.stdout.columns||80,S=w?.noInputFiles!==!0?`[${(0,k.localize)(34,null)}...]`:"",l=[`${h} ${d}`];l.push(""),l.push(`${(0,k.localize)(35,null)}: ${p} [${(0,k.localize)(36,null)}]${S}`),l.push(""),w?.noPipe!==!0&&(n.isWindows?l.push((0,k.localize)(37,null,p)):l.push((0,k.localize)(38,null,p)),l.push(""));const r={};for(const a in g){const i=g[a];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[a]=i}}for(let a in r){const i=a;let t=r[i];t&&(l.push(A[i]),l.push(...E(t,m)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function y(h,p){return`${h||(0,k.localize)(39,null)}
${p||(0,k.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),function(){"use strict";function Y(e,D,n,k){function A(R){const b=T(R),E=[b];return e.isAbsolute(b)||E.unshift(k),e.resolve(...E)}function T(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(C,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:A}}if(typeof define=="function")define(te[151],ne([0,252,33,18,19,32]),function(e,D,n,k,A,T){const R=A.dirname(k.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(A.joinPath(R,"package.json").fsPath);return Y(D,n,b.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=Y(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[152],ne([0,1,33,77,151]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends n.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=A}),define(te[153],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(d){const g=d.match(T);return g?g[1]:null}function P(d){if(d.indexOf("://")===-1){const g=d.match(n);return g?E(g[2]):null}try{const g=D.URI.parse(d);if(g.authority)return E(g.authority)}catch{}return null}function C(d,g){const w=new Set;let m;for(;m=R.exec(d);){const l=P(m[1]);l&&w.add(l)}const S=new Set(g);return Array.from(w).map(l=>S.has(l)?l:l.replace(b,"a"))}e.getDomainsOfRemotes=C;function f(d){const g=d.match(A);return g?g[2]:null}function y(d,g,w){return d&&g?(w&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${d}${g}`:`${d}/${g}`):null}function h(d,g){if(d.indexOf("://")===-1){const w=d.match(k);if(w)return y(w[2],w[3],g)}try{const w=D.URI.parse(d);if(w.authority)return y(f(w.authority),w.path,g)}catch{}return null}function p(d,g=!1){const w=[];let m;for(;m=R.exec(d);){const S=h(m[1],g);S&&w.push(S)}return w}e.getRemotes=p}),define(te[154],ne([0,1,28]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function k(A,T){const R=b=>{if(typeof b!="string")return;const E=n.exec(b);if(!E)return;const P=T[E[1]]??b;return typeof P=="string"?P:typeof P.message=="string"?P.message:b};return(0,D.cloneAndChange)(A,R)}e.localizeManifest=k}),define(te[155],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,T,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[A,T,R,b])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(A){this.service=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(te[78],ne([0,1,135]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function A(f){return f=f.trim(),f==="*"||n.test(f)}e.isValidVersionStr=A;function T(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=f.match(n);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=T;function R(f){if(!f)return null;let y=f.majorBase,h=f.majorMustEqual,p=f.minorBase,d=f.minorMustEqual,g=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(y===0||(d=!1),w=!1);let m=0;if(f.preRelease){const S=k.exec(f.preRelease);if(S){const[,l,r,a]=S;m=Date.UTC(Number(l),Number(r)-1,Number(a))}}return{majorBase:y,majorMustEqual:h,minorBase:p,minorMustEqual:d,patchBase:g,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:m}}e.normalizeVersion=R;function b(f,y,h){let p;typeof f=="string"?p=R(T(f)):p=f;let d;y instanceof Date?d=y.getTime():typeof y=="string"&&(d=new Date(y).getTime());let g;if(typeof h=="string"?g=R(T(h)):g=h,!p||!g)return!1;let w=p.majorBase,m=p.minorBase,S=p.patchBase,l=g.majorBase,r=g.minorBase,a=g.patchBase,i=g.notBefore,t=g.majorMustEqual,s=g.minorMustEqual,o=g.patchMustEqual;return g.isMinimum?w>l?!0:w<l?!1:m>r?!0:m<r||d&&d<i?!1:S>=a:(w===1&&l===0&&(!t||!s||!o)&&(l=1,r=0,a=0,t=!0,s=!1,o=!1),w<l?!1:w>l?!t:m<r?!1:m>r?!s:S<a?!1:S>a?!o:!(d&&d<i))}e.isValidVersion=b;function E(f,y,h,p){return h.isBuiltin||typeof h.main=="undefined"?!0:C(f,y,h.engines.vscode,p)}e.isValidExtensionVersion=E;function P(f,y,h){return f==="*"||C(y,h,f)}e.isEngineValid=P;function C(f,y,h,p=[]){let d=R(T(h));if(!d)return p.push(D.localize(0,null,h)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return p.push(D.localize(1,null,h)),!1}else if(!d.majorMustEqual)return p.push(D.localize(2,null,h)),!1;return b(f,y,d)?!0:(p.push(D.localize(3,null,f,h)),!1)}}),define(te[51],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(k,A=[],T=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(te[79],ne([0,1,51]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function k(T,R,b){R instanceof D.SyncDescriptor||(R=new D.SyncDescriptor(R,[],b)),n.push([T,R])}e.registerSingleton=k;function A(){return n}e.getSingletonServiceDescriptors=A}),define(te[156],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=D;class n{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const R=this.lookupOrInsertNode(A),b=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),b),b.incoming.set(this._hashFn(A),R)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let R=this._nodes.get(T);return R||(R=new D(A),this._nodes.set(T,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[T,R]of this._nodes)A.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,T]of this._nodes){const R=new Set([A]),b=this._findCycle(T,R);if(b)return b}}_findCycle(A,T){for(let[R,b]of A.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const E=this._findCycle(b,T);if(E)return E;T.delete(R)}}}e.Graph=n}),define(te[6],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(D=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function n(T,R,b,E){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:T,index:b,optional:E}):(R[D.DI_DEPENDENCIES]=[{id:T,index:b,optional:E}],R[D.DI_TARGET]=R)}function k(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const R=function(b,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,b,P,!1)};return R.toString=()=>T,D.serviceIds.set(T,R),R}e.createDecorator=k;function A(T){return T}e.refineServiceDecorator=A}),define(te[157],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[20],ne([0,1,14,7,6]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=A;function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||D.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function E(d,g){const w=Object.create(null);for(let m in d)P(w,m,d[m],g);return w}e.toValuesTree=E;function P(d,g,w,m){const S=g.split("."),l=S.pop();let r=d;for(let a=0;a<S.length;a++){let i=S[a],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${g} as ${S.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{m(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(r)}`)}else m(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function C(d,g){const w=g.split(".");f(d,w)}e.removeFromValueTree=C;function f(d,g){const w=g.shift();if(g.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const m=d[w];typeof m=="object"&&!Array.isArray(m)&&(f(m,g),Object.keys(m).length===0&&delete d[w])}}function y(d,g,w){function m(r,a){let i=r;for(const t of a){if(typeof i!="object"||i===null)return;i=i[t]}return i}const S=g.split("."),l=m(d,S);return typeof l=="undefined"?w:l}e.getConfigurationValue=y;function h(d,g,w){Object.keys(g).forEach(m=>{m!=="__proto__"&&(m in d?D.isObject(d[m])&&D.isObject(g[m])?h(d[m],g[m],w):w&&(d[m]=g[m]):d[m]=g[m])})}e.merge=h;function p(d,g,w){const m=d.inspect(g),S=d.inspect(w);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:m.defaultValue}e.getMigratedSettingValue=p}),define(te[158],ne([0,1,4,26,6]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=D.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",A.indexOf("Edg/")>=0),T.set("isFirefox",A.indexOf("Firefox")>=0),T.set("isChrome",A.indexOf("Chrome")>=0),T.set("isSafari",A.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var b;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return f.INSTANCE}static true(){return y.INSTANCE}static has(L){return h.create(L)}static equals(L,U){return p.create(L,U)}static notEquals(L,U){return w.create(L,U)}static regex(L,U){return t.create(L,U)}static in(L,U){return d.create(L,U)}static not(L){return m.create(L)}static and(...L){return c.create(L,null)}static or(...L){return u.create(L,null,!0)}static greater(L,U){return l.create(L,U)}static greaterEquals(L,U){return r.create(L,U)}static smaller(L,U){return a.create(L,U)}static smallerEquals(L,U){return i.create(L,U)}static deserialize(L,U=!1){if(!!L)return this._deserializeOrExpression(L,U)}static _deserializeOrExpression(L,U){let j=L.split("||");return u.create(j.map(M=>this._deserializeAndExpression(M,U)),null,!0)}static _deserializeAndExpression(L,U){let j=L.split("&&");return c.create(j.map(M=>this._deserializeOne(M,U)),null)}static _deserializeOne(L,U){if(L=L.trim(),L.indexOf("!=")>=0){let j=L.split("!=");return w.create(j[0].trim(),this._deserializeValue(j[1],U))}if(L.indexOf("==")>=0){let j=L.split("==");return p.create(j[0].trim(),this._deserializeValue(j[1],U))}if(L.indexOf("=~")>=0){let j=L.split("=~");return t.create(j[0].trim(),this._deserializeRegexValue(j[1],U))}if(L.indexOf(" in ")>=0){let j=L.split(" in ");return d.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const j=L.split(">=");return r.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const j=L.split(">");return l.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const j=L.split("<=");return i.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const j=L.split("<");return a.create(j[0].trim(),j[1].trim())}return/^\!\s*/.test(L)?m.create(L.substr(1).trim()):h.create(L)}static _deserializeValue(L,U){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let j=/^'([^']*)'$/.exec(L);return j?j[1].trim():L}static _deserializeRegexValue(L,U){if((0,n.isFalsyOrWhitespace)(L)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let j=L.indexOf("/"),M=L.lastIndexOf("/");if(j===M||j<0){if(U)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let G=L.slice(j+1,M),K=L[M+1]==="i"?"i":"";try{return new RegExp(G,K)}catch(x){if(U)throw new Error(`bad regexp-value '${L}', parse error: ${x}`);return console.warn(`bad regexp-value '${L}', parse error: ${x}`),null}}}e.ContextKeyExpr=E;function P($,L){const U=$?$.substituteConstants():void 0,j=L?L.substituteConstants():void 0;return!U&&!j?!0:!U||!j?!1:U.equals(j)}e.expressionsAreEqualWithConstantSubstitution=P;function C($,L){return $.cmp(L)}class f{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class y{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class h{constructor(L,U){this.key=L,this.negated=U,this.type=2}static create(L,U=null){const j=T.get(L);return typeof j=="boolean"?j?y.INSTANCE:f.INSTANCE:new h(L,U)}cmp(L){return L.type!==this.type?this.type-L.type:I(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?y.INSTANCE:f.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class p{constructor(L,U,j){this.key=L,this.value=U,this.negated=j,this.type=4}static create(L,U,j=null){if(typeof U=="boolean")return U?h.create(L,j):m.create(L,j);const M=T.get(L);return typeof M=="boolean"?U===(M?"true":"false")?y.INSTANCE:f.INSTANCE:new p(L,U,j)}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const U=L?"true":"false";return this.value===U?y.INSTANCE:f.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class d{constructor(L,U){this.key=L,this.valueKey=U,this.type=10,this.negated=null}static create(L,U){return new d(L,U)}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const U=L.getValue(this.valueKey),j=L.getValue(this.key);return Array.isArray(U)?U.indexOf(j)>=0:typeof j=="string"&&typeof U=="object"&&U!==null?R.call(U,j):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=d;class g{constructor(L){this._actual=L,this.type=11}static create(L){return new g(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new g(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class w{constructor(L,U,j){this.key=L,this.value=U,this.negated=j,this.type=5}static create(L,U,j=null){if(typeof U=="boolean")return U?m.create(L,j):h.create(L,j);const M=T.get(L);return typeof M=="boolean"?U===(M?"true":"false")?f.INSTANCE:y.INSTANCE:new w(L,U,j)}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const U=L?"true":"false";return this.value===U?f.INSTANCE:y.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class m{constructor(L,U){this.key=L,this.negated=U,this.type=3}static create(L,U=null){const j=T.get(L);return typeof j=="boolean"?j?f.INSTANCE:y.INSTANCE:new m(L,U)}cmp(L){return L.type!==this.type?this.type-L.type:I(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?f.INSTANCE:y.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function S($,L){if(typeof $=="string"){const U=parseFloat($);isNaN(U)||($=U)}return typeof $=="string"||typeof $=="number"?L($):f.INSTANCE}class l{constructor(L,U,j){this.key=L,this.value=U,this.negated=j,this.type=12}static create(L,U,j=null){return S(U,M=>new l(L,M,j))}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(L,U,j){this.key=L,this.value=U,this.negated=j,this.type=13}static create(L,U,j=null){return S(U,M=>new r(L,M,j))}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(L,U,j){this.key=L,this.value=U,this.negated=j,this.type=14}static create(L,U,j=null){return S(U,M=>new a(L,M,j))}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class i{constructor(L,U,j){this.key=L,this.value=U,this.negated=j,this.type=15}static create(L,U,j=null){return S(U,M=>new i(L,M,j))}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(L,U){this.key=L,this.regexp=U,this.type=7,this.negated=null}static create(L,U){return new t(L,U)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const U=this.regexp?this.regexp.source:"",j=L.regexp?L.regexp.source:"";return U<j?-1:U>j?1:0}equals(L){if(L.type===this.type){const U=this.regexp?this.regexp.source:"",j=L.regexp?L.regexp.source:"";return this.key===L.key&&U===j}return!1}substituteConstants(){return this}evaluate(L){let U=L.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(L){this._actual=L,this.type=8}static create(L){return new s(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new s(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o($){let L=null;for(let U=0,j=$.length;U<j;U++){const M=$[U].substituteConstants();if($[U]!==M&&L===null){L=[];for(let G=0;G<U;G++)L[G]=$[G]}L!==null&&(L[U]=M)}return L===null?$:L}class c{constructor(L,U){this.expr=L,this.negated=U,this.type=6}static create(L,U){return c._normalizeArr(L,U)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let U=0,j=this.expr.length;U<j;U++){const M=C(this.expr[U],L.expr[U]);if(M!==0)return M}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].equals(L.expr[U]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:c.create(L,this.negated)}evaluate(L){for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].evaluate(L))return!1;return!0}static _normalizeArr(L,U){const j=[];let M=!1;for(const G of L)if(!!G){if(G.type===1){M=!0;continue}if(G.type===0)return f.INSTANCE;if(G.type===6){j.push(...G.expr);continue}j.push(G)}if(j.length===0&&M)return y.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(C);for(let G=1;G<j.length;G++)j[G-1].equals(j[G])&&(j.splice(G,1),G--);if(j.length===1)return j[0];for(;j.length>1;){const G=j[j.length-1];if(G.type!==9)break;j.pop();const K=j.pop(),x=j.length===0,q=u.create(G.expr.map(X=>c.create([X,K],null)),null,x);q&&(j.push(q),j.sort(C))}return j.length===1?j[0]:new c(j,U)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let U of this.expr)L.push(...U.keys());return L}map(L){return new c(this.expr.map(U=>U.map(L)),null)}negate(){if(!this.negated){const L=[];for(let U of this.expr)L.push(U.negate());this.negated=u.create(L,this,!0)}return this.negated}}class u{constructor(L,U){this.expr=L,this.negated=U,this.type=9}static create(L,U,j){return u._normalizeArr(L,U,j)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let U=0,j=this.expr.length;U<j;U++){const M=C(this.expr[U],L.expr[U]);if(M!==0)return M}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].equals(L.expr[U]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:u.create(L,this.negated,!1)}evaluate(L){for(let U=0,j=this.expr.length;U<j;U++)if(this.expr[U].evaluate(L))return!0;return!1}static _normalizeArr(L,U,j){let M=[],G=!1;if(L){for(let K=0,x=L.length;K<x;K++){const q=L[K];if(!!q){if(q.type===0){G=!0;continue}if(q.type===1)return y.INSTANCE;if(q.type===9){M=M.concat(q.expr);continue}M.push(q)}}if(M.length===0&&G)return f.INSTANCE;M.sort(C)}if(M.length!==0){if(M.length===1)return M[0];for(let K=1;K<M.length;K++)M[K-1].equals(M[K])&&(M.splice(K,1),K--);if(M.length===1)return M[0];if(j){for(let K=0;K<M.length;K++)for(let x=K+1;x<M.length;x++)O(M[K],M[x])&&(M.splice(x,1),x--);if(M.length===1)return M[0]}return new u(M,U)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let U of this.expr)L.push(...U.keys());return L}map(L){return new u(this.expr.map(U=>U.map(L)),null)}negate(){if(!this.negated){let L=[];for(let U of this.expr)L.push(U.negate());for(;L.length>1;){const U=L.shift(),j=L.shift(),M=[];for(const K of N(U))for(const x of N(j))M.push(c.create([K,x],null));const G=L.length===0;L.unshift(u.create(M,null,G))}this.negated=L[0]}return this.negated}}class v extends h{constructor(L,U,j){super(L,null);this._defaultValue=U,typeof j=="object"?v._info.push({...j,key:L}):j!==!0&&v._info.push({key:L,description:j,type:U!=null?typeof U:void 0})}static all(){return v._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return p.create(this.key,L)}notEqualsTo(L){return w.create(this.key,L)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I($,L){return $<L?-1:$>L?1:0}function _($,L,U,j){return $<U?-1:$>U?1:L<j?-1:L>j?1:0}function O($,L){if(L.type===6&&$.type!==9&&$.type!==6){for(const M of L.expr)if($.equals(M))return!0}const U=$.negate(),j=N(U).concat(N(L));j.sort(C);for(let M=0;M<j.length;M++){const K=j[M].negate();for(let x=M+1;x<j.length;x++){const q=j[x];if(K.equals(q))return!0}}return!1}e.implies=O;function N($){return $.type===9?$.expr:[$]}}),define(te[80],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=n}),define(te[81],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[15],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,18,130,6]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var A;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));function T(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function R(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function b(m,S){switch(m){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=b;function E(m,S){return S==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function P(m,S,l){return E(S,l)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===l?!0:C(l).includes(m)}e.isTargetPlatformCompatible=P;function C(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function f(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=f;var y;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var h;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var p;(function(m){m.Install="install",m.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var d;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var g;(function(m){m.Unsupported="Unsupported",m.UnsupportedPreRelease="UnsupportedPreRelease",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(S,l){super(S);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(te[159],ne([0,1,3,2,28,7,110,30]),function(Y,e,D,n,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(p,d){return A.URI.revive(d?d.transformIncoming(p):p)}function E(p,d){return d?d.transformOutgoingURI(p):p}function P(p,d){d=d||T.DefaultURITransformer;const g=p.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...p,manifest:void 0},d),manifest:g}}function C(p,d){return d?(0,k.cloneAndChange)(p,g=>g instanceof A.URI?d.transformOutgoingURI(g):void 0):p}class f{constructor(d,g){this.service=d,this.getUriTransformer=g,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,g){const w=this.getUriTransformer(d);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,m=>m.map(S=>({...S,local:S.local?C(S.local,w):S.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,g,w){const m=this.getUriTransformer(d);switch(g){case"zip":return this.service.zip(P(w[0],m)).then(S=>E(S,m));case"unzip":return this.service.unzip(b(w[0],m));case"install":return this.service.install(b(w[0],m),w[1]);case"getManifest":return this.service.getManifest(b(w[0],m));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],m),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],m));case"getInstalled":return this.service.getInstalled(w[0]).then(S=>S.map(l=>C(l,m)));case"updateMetadata":return this.service.updateMetadata(P(w[0],m),w[1]).then(S=>C(S,m));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],m),w[1]).then(S=>C(S,m));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class y extends n.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?A.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire(g))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire(g)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const g=await this.getTargetPlatform();return d.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,d.allTargetPlatforms,g))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(g=>A.URI.revive(g)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,g){return Promise.resolve(this.channel.call("install",[d,g])).then(w=>P(w,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,g){return Promise.resolve(this.channel.call("installFromGallery",[d,g])).then(w=>P(w,null))}uninstall(d,g){return Promise.resolve(this.channel.call("uninstall",[d,g]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(g=>g.map(w=>P(w,null)))}updateMetadata(d,g){return Promise.resolve(this.channel.call("updateMetadata",[d,g])).then(w=>P(w,null))}updateExtensionScope(d,g){return Promise.resolve(this.channel.call("updateExtensionScope",[d,g])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class h{constructor(d){this.service=d}listen(d,g){throw new Error("Invalid listen")}call(d,g,w){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[82],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function k(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[13],ne([0,1,39,10,26,14,7,137,6]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function E(M){return M.create===!0}e.isFileOpenForWriteOptions=E;var P;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var C;(function(M){M[M.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function d(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=d;function g(M){return y(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var w;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(G,K){super(G);this.code=K}}e.FileSystemProviderError=m;function S(M,G){const K=new m(M.toString(),G);return r(K,G),K}e.createFileSystemProviderError=S;function l(M){return M||S((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function r(M,G){return M.name=G?`${G} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=r;function a(M){if(!M)return w.Unknown;if(M instanceof m)return M.code;const G=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!G)return w.Unknown;switch(G[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=a;function i(M){if(M instanceof v)return M.fileOperationResult;switch(a(M)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor(G,K,x){this.resource=G,this.operation=K,this.target=x}isOperation(G){return this.operation===G}}e.FileOperationEvent=s;var o;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class c{constructor(G,K){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const x=new Map;for(const q of G){const X=x.get(q.type);switch(X?X.push([q.resource,q]):x.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,X]of x)switch(q){case 1:this.added=D.TernarySearchTree.forUris(()=>K),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>K),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>K),this.deleted.fill(X);break}}contains(G,...K){return this.doContains(G,{includeChildren:!1},...K)}affects(G,...K){return this.doContains(G,{includeChildren:!0},...K)}doContains(G,K,...x){if(!G)return!1;const q=x.length>0;return!!((!q||x.includes(1))&&(this.added?.get(G)||K.includeChildren&&this.added?.findSuperstr(G))||(!q||x.includes(0))&&(this.updated?.get(G)||K.includeChildren&&this.updated?.findSuperstr(G))||(!q||x.includes(2))&&(this.deleted?.findSubstr(G)||K.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function u(M,G,K){return!M||!G||M===G||G.length>M.length?!1:(G.charAt(G.length-1)!==n.sep&&(G+=n.sep),K?(0,k.startsWithIgnoreCase)(M,G):M.indexOf(G)===0)}e.isParent=u;class v extends Error{constructor(G,K,x){super(G);this.fileOperationResult=K,this.options=x}}e.FileOperationError=v;class I extends v{constructor(G,K,x){super(G,2,x);this.stat=K}}e.NotModifiedSinceFileOperationError=I;var _;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=N;async function $(M,G){if(!G.hasProvider(T.URI.from({scheme:M.scheme})))return new Promise(K=>{const x=G.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===M.scheme&&q.added&&(x.dispose(),K())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(G){return(0,A.isNumber)(G)||(G=0),G<L.KB?(0,R.localize)(1,null,G.toFixed(0)):G<L.MB?(0,R.localize)(2,null,(G/L.KB).toFixed(2)):G<L.GB?(0,R.localize)(3,null,(G/L.MB).toFixed(2)):G<L.TB?(0,R.localize)(4,null,(G/L.GB).toFixed(2)):(0,R.localize)(5,null,(G/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var U;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function j(M){return{maxFileSize:M===0?300*L.MB:16*L.GB,maxHeapSize:M===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=j});var J=this&&this.__param||function(Y,e){return function(D,n){e(D,n,Y)}};define(te[160],ne([0,1,83,40,13]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((E,P)=>{const C=(0,D.createHash)("md5");(0,n.listenStream)(b,{onData:f=>C.update(f.buffer),onError:f=>P(f),onEnd:()=>E(C.digest("base64").replace(/=+$/,""))})})}};A=de([J(0,k.IFileService)],A),e.ChecksumService=A}),define(te[161],ne([0,1,253,127,150,13]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function T(f,y){const h={onUnknownOption:d=>{console.warn((0,n.localize)(0,null,d))},onMultipleValues:(d,g)=>{console.warn((0,n.localize)(1,null,d,g))},onDeprecatedOption:(d,g)=>{console.warn((0,n.localize)(2,null,d,g))}},p=(0,k.parseArgs)(f,k.OPTIONS,y?h:void 0);return p.goto&&p._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,n.localize)(3,null))),p["max-memory"]&&D(parseInt(p["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),p}function R(f){const y=f.findIndex(h=>!/^-/.test(h));if(y>-1)return[...f.slice(0,y),...f.slice(y+1)]}function b(f){let[,...y]=f;process.env.VSCODE_DEV&&(y=R(y)||[]);const h=!C(process.env);return T(y,h)}e.parseMainProcessArgv=b;function E(f){const[,,...y]=f;return T(y,!0)}e.parseCLIProcessArgv=E;function P(f,...y){const h=f.indexOf("--");return h===-1?f.push(...y):f.splice(h,0,...y),f}e.addArg=P;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(te[162],ne([0,1,45,10,128,25,37,9,4,29,123,161,5]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let h;async function p(g,w,m){return w["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(m)&&!w["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(m)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(S,l)=>{const r=new A.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),l(new Error((0,k.localize)(0,null)))},y);try{S(await d(g,r.token))}catch(i){!(0,R.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(i)))):S({})}finally{clearTimeout(a),r.dispose()}})),h)}e.getResolvedShellEnv=p;async function d(g,w){const m=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",m);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",S);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",a);const i=await(0,P.getSystemShell)(b.OS,a);return g.trace("getUnixShellEnvironment#shell",i),new Promise((t,s)=>{if(w.isCancellationRequested)return s((0,R.canceled)());const o=(0,n.basename)(i);let c,u;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${v} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,u=["-Login","-Command"]):(c=`'${process.execPath}' ${v} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?u=["-ic"]:u=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),c);const I=(0,D.spawn)(i,[...u,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(I.kill(),s((0,R.canceled)()))),I.on("error",N=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(N)),s(N)});const _=[];I.stdout.on("data",N=>_.push(N));const O=[];I.stderr.on("data",N=>O.push(N)),I.on("close",(N,$)=>{const L=Buffer.concat(_).toString("utf8");g.trace("getUnixShellEnvironment#raw",L);const U=Buffer.concat(O).toString("utf8");if(U.trim()&&g.trace("getUnixShellEnvironment#stderr",U),N||$)return s(new Error((0,k.localize)(2,null,N,$)));const j=r.exec(L),M=j?j[1]:"{}";try{const G=JSON.parse(M);m?G.ELECTRON_RUN_AS_NODE=m:delete G.ELECTRON_RUN_AS_NODE,S?G.ELECTRON_NO_ATTACH_CONSOLE=S:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){g.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(G)),s(G)}})})}}),define(te[163],ne([0,1,17,37,9,3,2,40,7,29,13]),function(Y,e,D,n,k,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends T.Disposable{constructor(y,h){super();this.channel=y,this.extraCapabilities=h,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,h){const{buffer:p}=await this.channel.call("readFile",[y,h]);return p}readFileStream(y,h,p){const d=(0,R.newWriteableStream)(w=>D.VSBuffer.concat(w.map(m=>D.VSBuffer.wrap(m))).buffer),g=this.channel.listen("readFileStream",[y,h])(w=>{if(w instanceof D.VSBuffer)d.write(w.buffer);else{if(w==="end")d.end();else{let m=w;m instanceof Error||(m=(0,P.createFileSystemProviderError)((0,n.toErrorMessage)(m),P.FileSystemProviderErrorCode.Unknown)),d.error(m),d.end()}g.dispose()}});return p.onCancellationRequested(()=>{d.error((0,k.canceled)()),d.end(),g.dispose()}),d}writeFile(y,h,p){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(h),p])}open(y,h){return this.channel.call("open",[y,h])}close(y){return this.channel.call("close",[y])}async read(y,h,p,d,g){const[w,m]=await this.channel.call("read",[y,h,g]);return p.set(w.buffer.slice(0,m),d),m}write(y,h,p,d,g){return this.channel.call("write",[y,h,D.VSBuffer.wrap(p),d,g])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,h){return this.channel.call("delete",[y,h])}rename(y,h,p){return this.channel.call("rename",[y,h,p])}copy(y,h,p){return this.channel.call("copy",[y,h,p])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const h=y;this._onDidChange.fire(h.map(p=>({resource:b.URI.revive(p.resource),type:p.type})))}else{const h=y;this._onDidWatchError.fire(h)}}))}watch(y,h){const p=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,p,y,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=C}),define(te[84],ne([0,1,17,9,138,13]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,C,f,y,h,p){let d;try{await R(P,C,f,y,h,p)}catch(g){d=g}finally{d&&h.errorTransformer&&(d=h.errorTransformer(d)),typeof d!="undefined"&&f.error(d),f.end()}}e.readFileIntoStream=T;async function R(P,C,f,y,h,p){b(p);const d=await P.open(C,{create:!1});try{b(p);let g=0,w=0,m=h&&typeof h.length=="number"?h.length:void 0,S=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof m=="number"?m:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,r=0;do w=await P.read(d,l,S.buffer,r,S.byteLength-r),l+=w,r+=w,g+=w,typeof m=="number"&&(m-=w),r===S.byteLength&&(await f.write(y(S)),S=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof m=="number"?m:h.bufferSize)),r=0);while(w>0&&(typeof m!="number"||m>0)&&b(p)&&E(g,h));if(r>0){let a=r;typeof m=="number"&&(a=Math.min(r,m)),f.write(y(S.slice(0,a)))}}catch(g){throw(0,A.ensureFileSystemProviderError)(g)}finally{await P.close(d)}}function b(P){if(P.isCancellationRequested)throw(0,n.canceled)();return!0}function E(P,C){if(C?.limits){if(typeof C.limits.memory=="number"&&P>C.limits.memory)throw(0,A.createFileSystemProviderError)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&P>C.limits.size)throw(0,A.createFileSystemProviderError)((0,k.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[52],ne([0,1,2,4,7,13]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function T(y){return y.recursive===!0}e.isRecursiveWatchRequest=T;class R extends D.Disposable{constructor(h,p,d,g){super();this.onFileChanges=h,this.onLogMessage=p,this.verboseLogging=d,this.options=g,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new D.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(p=>this.onFileChanges(p))),h.add(this.watcher.onDidLogMessage(p=>this.onLogMessage(p))),h.add(this.watcher.onDidError(p=>this.onError(p)))}onError(h){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class b extends R{constructor(h,p,d){super(h,p,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class E extends R{constructor(h,p,d){super(h,p,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function P(y){return y.map(h=>({type:h.type,resource:k.URI.file(h.path)}))}e.toFileChanges=P;function C(y){const h=new f;for(const p of y)h.processEvent(p);return h.coalesce()}e.coalesceEvents=C;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return n.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const p=this.mapPathToChange.get(this.toKey(h));let d=!1;if(p){const g=p.type,w=h.type;p.path!==h.path&&(h.type===2||h.type===1)?d=!0:g===1&&w===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(p)):g===2&&w===1?p.type=0:g===1&&w===0||(p.type=w)}else d=!0;d&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],p=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(h.push(d),!1):!0).sort((d,g)=>d.path.length-g.path.length).filter(d=>p.some(g=>(0,A.isParent)(d.path,g,!n.isLinux))?!1:(p.push(d.path),!0)).concat(h)}}}),define(te[164],ne([0,1,50,5,25,41,109,2,71,10,4,114,22,52]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends R.Disposable{constructor(g,w,m,S){super();this.request=g,this.onDidFilesChange=w,this.onLogMessage=m,this.verboseLogging=S,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,T.parse)(l)),this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(g);this._register(await this.doWatch(g,w.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(g)}}async normalizePath(g){let w=g.path;try{w=await f.Promises.realpath(g.path),g.path===w&&(w=await(0,C.realcase)(g.path)??g.path),g.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${w})`)}catch{}return w}async doWatch(g,w){if(P.isMacintosh&&(0,A.isEqualOrParent)(g,"/Volumes/"))return this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const m=new k.CancellationTokenSource(this.cts.token);let S=new R.DisposableStore;try{const l=(0,E.basename)(g),r=(0,D.watch)(g);S.add((0,R.toDisposable)(()=>{r.removeAllListeners(),r.close()})),this.trace(`Started watching: '${g}'`);const a=new Set;if(w)try{for(const t of await f.Promises.readdir(g))a.add(t)}catch(t){this.error(t)}const i=new Map;S.add((0,R.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,s)=>{this.error(`Failed to watch ${g} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),r.on("change",(t,s)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${s}`);let o="";if(s&&(o=s.toString(),P.isMacintosh&&(o=(0,b.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(w)if(t==="rename"){i.get(o)?.dispose();const c=setTimeout(async()=>{if(i.delete(o),o===l&&!await f.Promises.exists(g)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,E.join)(g,o));if(m.token.isCancellationRequested)return;let v;u?a.has(o)?v=0:(v=1,a.add(o)):(a.delete(o),v=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:v})},h.FILE_DELETE_HANDLER_DELAY);i.set(o,(0,R.toDisposable)(()=>clearTimeout(c)))}else{let c;a.has(o)?c=0:(c=1,a.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:c})}else if(t==="rename"||o!==l){const c=setTimeout(async()=>{const u=await f.Promises.exists(g);m.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),S.add(await this.doWatch(g,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);S.clear(),S.add((0,R.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await f.Promises.exists(g)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${g} for changes using fs.watch() (${l.toString()})`)}return(0,R.toDisposable)(()=>{m.dispose(!0),S.dispose()})}async onFileChange(g,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!w&&this.excludes.some(m=>m(g.path))?this.verboseLogging&&this.trace(` >> ignored ${g.path}`):this.fileChangesBuffer.push(g);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,y.coalesceEvents)(m);if(S.length>0){if(this.verboseLogging)for(const r of S)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(S)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${S.length}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(g){if(P.isLinux)return f.Promises.exists(g);try{const w=(0,E.basename)(g);return(await f.Promises.readdir((0,E.dirname)(g))).some(S=>S===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=50;async function p(d,g,w,m,S=512){const l=await f.Promises.open(d,"r"),r=Buffer.allocUnsafe(S),a=new k.CancellationTokenSource(m);let i,t=!1;const s={path:d,excludes:[],recursive:!1},o=new h(s,c=>{(async()=>{for(const{type:u}of c)if(u===0){if(t)return;t=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:v}=await f.Promises.read(l,r,0,S,null);if(!v||a.token.isCancellationRequested)break;g(r.slice(0,v))}}catch(v){i=new Error(v),a.dispose(!0)}finally{t=!1}}})()});return await o.ready,w(),new Promise((c,u)=>{a.token.onCancellationRequested(async()=>{o.dispose();try{await f.Promises.close(l)}catch(v){i=new Error(v)}i?u(i):c()})})}e.watchFileContents=p}),define(te[165],ne([0,1,16,3,2,4,164]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const P=this.normalizeRequests(E),C=P.filter(y=>{const h=this.watchers.get(y.path);return h?!(0,D.equals)(h.request.excludes,y.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:y})=>!P.find(h=>h.path===y.path&&(0,D.equals)(h.excludes,y.excludes))).map(({request:y})=>y.path);C.length&&this.trace(`Request to start watching: ${C.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const y of f)this.stopWatching(y);for(const y of C)this.startWatching(y)}startWatching(E){const P=new T.NodeJSFileWatcherLibrary(E,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),C={request:E,instance:P};this.watchers.set(E.path,C)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const P=this.watchers.get(E);P&&(this.watchers.delete(E),P.instance.dispose())}normalizeRequests(E){const P=new Map;for(const C of E){const f=A.isLinux?C.path:C.path.toLowerCase();P.set(f,C)}return Array.from(P.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,P]of this.watchers)P.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,P){return P?`[File Watcher (node.js)] ${E} (path: ${P.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=R}),define(te[166],ne([0,1,52,165]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends D.AbstractNonRecursiveWatcherClient{constructor(T,R,b){super(T,R,b);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(te[167],ne([0,1,18,36,58,52]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(b,E,P){super(b,E,P);this.init()}createWatcher(b){const E=b.add(new k.Client(D.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(E.onDidProcessExit(({code:P,signal:C})=>this.onError(`terminated by itself with code ${P}, signal: ${C}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(te[85],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...k){this._entries=new Map;for(let[A,T]of k)this.set(A,T)}set(k,A){const T=this._entries.get(k);return this._entries.set(k,A),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=D}),define(te[168],ne([0,1,5,9,51,156,6,85]),function(Y,e,D,n,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new R.ServiceCollection,p=!1,d){this._activeInstantiations=new Set,this._services=h,this._strict=p,this._parent=d,this._services.set(T.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...p){let d=f.traceInvocation(h),g=!1;try{return h({get:m=>{if(g)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(m,d);if(!S)throw new Error(`[invokeFunction] unknown service '${m}'`);return S}},...p)}finally{g=!0,d.stop()}}createInstance(h,...p){let d,g;return h instanceof k.SyncDescriptor?(d=f.traceCreation(h.ctor),g=this._createInstance(h.ctor,h.staticArguments.concat(p),d)):(d=f.traceCreation(h),g=this._createInstance(h,p,d)),d.stop(),g}_createInstance(h,p=[],d){let g=T._util.getServiceDependencies(h).sort((S,l)=>S.index-l.index),w=[];for(const S of g){let l=this._getOrCreateServiceInstance(S.id,d);if(!l&&this._strict&&!S.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${S.id}.`);w.push(l)}let m=g.length>0?g[0].index:p.length;if(p.length!==m){console.warn(`[createInstance] First service dependency of ${h.name} at position ${m+1} conflicts with ${p.length} static arguments`);let S=m-p.length;S>0?p=p.concat(new Array(S)):p=p.slice(0,m)}return new h(...[...p,...w])}_setServiceInstance(h,p){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,p);else if(this._parent)this._parent._setServiceInstance(h,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let p=this._services.get(h);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):p}_getOrCreateServiceInstance(h,p){let d=this._getServiceInstanceOrDescriptor(h);return d instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,d,p.branch(h,!0)):(p.branch(h,!1),d)}_safeCreateAndCacheServiceInstance(h,p,d){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,p,d)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,p,d){const g=new A.Graph(S=>S.id.toString());let w=0;const m=[{id:h,desc:p,_trace:d}];for(;m.length;){const S=m.pop();if(g.lookupOrInsertNode(S),w++>1e3)throw new E(g);for(let l of T._util.getServiceDependencies(S.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),r instanceof k.SyncDescriptor){const a={id:l.id,desc:r,_trace:S._trace.branch(l.id,!0)};g.insertEdge(S,a),m.push(a)}}}for(;;){const S=g.roots();if(S.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:l}of S){if(this._getServiceInstanceOrDescriptor(l.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}g.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,p,d=[],g,w){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(p,d,g,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,p,d,g,w);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(h,p=[],d,g){if(d){const w=new D.IdleValue(()=>this._createInstance(h,p,g));return new Proxy(Object.create(null),{get(m,S){if(S in m)return m[S];let l=w.value,r=l[S];return typeof r!="function"||(r=r.bind(l),m[S]=r),r},set(m,S,l){return w.value[S]=l,!0}})}else return this._createInstance(h,p,g)}}e.InstantiationService=P;var C;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(C||(C={}));class f{constructor(h,p){this.type=h,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return b?new f(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(h){return b?new f(0,h.name):f._None}branch(h,p){let d=new f(2,h.toString());return this._dep.push([h,p,d]),d}stop(){let h=Date.now()-this._start;f._totals+=h;let p=!1;function d(w,m){let S=[],l=new Array(w+1).join("	");for(const[r,a,i]of m._dep)if(a&&i){p=!0,S.push(`${l}CREATES -> ${r}`);let t=d(w+1,i);t&&S.push(t)}else S.push(`${l}uses -> ${r}`);return S.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||p)&&console.log(g.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[169],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(k,A){this.server=k,this.router=A}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,A){this.server.registerChannel(k,A)}}e.MessagePortMainProcessService=D}),define(te[170],ne([0,1,36,51,79,6]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(y,h,p){const d=p.getChannel(y);return R(h)?new h.channelClientCtor(d):D.ProxyChannel.toService(d,h?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let b=class extends T{constructor(y,h,p){super(y,h,p)}};b=de([J(2,e.IMainProcessService)],b);function E(f,y,h){(0,k.registerSingleton)(f,new n.SyncDescriptor(b,[y,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let P=class extends T{constructor(y,h,p){super(y,h,p)}};P=de([J(2,e.ISharedProcessService)],P);function C(f,y,h){(0,k.registerSingleton)(f,new n.SyncDescriptor(P,[y,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(te[59],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function n(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const A of k.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=n}),define(te[171],ne([0,1,2,59]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends D.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=de([J(0,n.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(te[8],ne([0,1,37,3,2,4,6]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function E(a,i,t){switch(i){case b.Trace:a.trace(t);break;case b.Debug:a.debug(t);break;case b.Info:a.info(t);break;case b.Warning:a.warn(t);break;case b.Error:a.error(t);break;case b.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=E;function P(a){let i="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(t>0?" ":"")+s}return i}e.format=P;class C extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class f extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,P([i,...t]))}debug(i,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,P([i,...t]))}info(i,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,P([i,...t]))}warn(i,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,P([i,...t]))}error(i,...t){if(this.checkLogLevel(b.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(b.Error,P(s))}else this.log(b.Error,P([i,...t]))}critical(i,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,P([i,...t]))}flush(){}}e.AbstractMessageLogger=f;class y extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}debug(i,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}info(i,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}warn(i,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...t):console.warn(`[main ${R()}]`,i,...t))}error(i,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}critical(i,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class h extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class p extends C{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class d extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const s of this.logServices)s.trace(i,...t)}debug(i,...t){for(const s of this.logServices)s.debug(i,...t)}info(i,...t){for(const s of this.logServices)s.info(i,...t)}warn(i,...t){for(const s of this.logServices)s.warn(i,...t)}error(i,...t){for(const s of this.logServices)s.error(i,...t)}critical(i,...t){for(const s of this.logServices)s.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=g;class w extends k.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,t?.always?b.Trace:this.logLevel,t),this.loggers.set(i.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class m{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=m;function S(a){if(a.verbose)return b.Trace;if(typeof a.logLevel=="string"){const i=l(a.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function l(a){switch(a){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=l;function r(a){switch(a){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(te[172],ne([0,1,5,9,2,10,22,15,8]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends k.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,A.basename)(this.environmentService.logsPath),f=(0,A.dirname)(this.environmentService.logsPath),p=(await T.Promises.readdir(f)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==C),d=p.slice(0,Math.max(0,p.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(g=>T.Promises.rm((0,A.join)(f,g)))))}catch(C){(0,n.onUnexpectedError)(C)}}};E=de([J(0,R.IEnvironmentService),J(1,b.ILogService)],E),e.LogsDataCleaner=E}),define(te[173],ne([0,1,5,9,2,10,22,15,8]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class gt extends k.Disposable{constructor(C,f,y){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await T.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(C).emptyWorkspaceInfos.map(p=>p.backupFolder),h=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async p=>{p.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||p===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(p)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${p}.`),await T.Promises.rm((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,p)))}))}catch(C){(0,n.onUnexpectedError)(C)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=de([J(1,R.INativeEnvironmentService),J(2,b.ILogService)],E),e.StorageDataCleaner=E}),define(te[174],ne([0,1,45,5,37,3,2,18,10,22,15,8]),function(Y,e,D,n,k,A,T,R,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends T.Disposable{constructor(h,p){super();this.environmentService=h,this.logService=p,this.processesLimiter=new n.Limiter(5)}async postUninstall(h){const p=this.parseScript(h,"uninstall");return p&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${d}`)))),E.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(h,p){const d=`vscode:${p}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[d]=="string"){const g=h.manifest.scripts[d].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${d} should be a node script`),null):{script:(0,b.join)(h.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(h,p,d,g,w){return new Promise((m,S)=>{const l=this.start(h,p,d,w);let r;const a=i=>{r&&(clearTimeout(r),r=null),i?S(i):m(void 0)};l.on("error",i=>{a((0,k.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,t)=>{a(i?`post-${p} process exited with code ${i}`:void 0)}),g&&(r=setTimeout(()=>{r=null,l.kill(),S("timed out")},5e3))})}start(h,p,d,g){const w={silent:!0,execArgv:void 0},m=(0,D.fork)(h,[`--type=extension-post-${p}`,...d],w);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const S=A.Event.fromNodeEventEmitter(m.stdout,"data"),l=A.Event.fromNodeEventEmitter(m.stderr,"data");S(i=>this.logService.info(g.identifier.id,g.manifest.version,`post-${p}`,i)),l(i=>this.logService.error(g.identifier.id,g.manifest.version,`post-${p}`,i));const r=A.Event.any(A.Event.map(S,i=>({data:`%c${i}`,format:[""]})),A.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(g.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),m}getExtensionStoragePath(h){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};f=de([J(0,P.IEnvironmentService),J(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(te[175],ne([0,1,16,5,9,3,2,10,52,8]),function(Y,e,D,n,k,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(f,y){super();this.logService=f,this.options=y,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(f,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,y):this.watchNonRecursive(f,y)}watchUniversal(f,y){const h={path:this.toFilePath(f),excludes:y.excludes,recursive:y.recursive},p=(0,D.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,k.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,b.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const y of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const y of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(y)&&f.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,y){const h={path:this.toFilePath(f),excludes:y.excludes,recursive:!1},p=(0,D.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,k.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(te[176],ne([0,1,16,5,17,25,3,70,55,2,39,18,177,19,40,136,13,84,8]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${l}`);const a=new E.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),a.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new d.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&a.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),a.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,E.dispose)(a)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(a){r.push(a)}}),!this.provider.has(l)&&await n.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const a=this.provider.get(l.scheme);return!!(a&&a.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,y.isAbsolutePath)(l))throw new d.FileOperationError((0,p.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const a=new Error;throw a.name="ENOPRO",a.message=(0,p.localize)(1,null,l.toString()),a}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)||(0,d.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(a){throw(0,d.toFileSystemProviderErrorCode)(a)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,p.localize)(2,null,this.resourceForError(l)),1):(0,d.ensureFileSystemProviderError)(a)}}async doResolveFile(l,r){const a=await this.withProvider(l),i=this.isPathCaseSensitive(a),t=r?.resolveTo,s=r?.resolveSingleChildDescendants,o=r?.resolveMetadata,c=await a.stat(l);let u;return this.toFileStat(a,l,c,void 0,!!o,(v,I)=>(u||(u=P.TernarySearchTree.forUris(()=>!i),u.set(l,!0),t&&u.fill(!0,t)),u.get(v.resource)||u.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&s?I===1:!1))}async toFileStat(l,r,a,i,t,s){const{providerExtUri:o}=this.getExtUri(l),c={resource:r,name:o.basename(r),isFile:(a.type&d.FileType.File)!=0,isDirectory:(a.type&d.FileType.Directory)!=0,isSymbolicLink:(a.type&d.FileType.SymbolicLink)!=0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&d.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,d.etag)({mtime:a.mtime,size:a.size})};if(c.isDirectory&&s(c,i)){try{const u=await l.readdir(r),v=await n.Promises.settled(u.map(async([I,_])=>{try{const O=o.joinPath(r,I),N=t?await l.stat(O):{type:_};return await this.toFileStat(l,O,N,u.length,t,s)}catch(O){return this.logService.trace(O),null}}));c.children=(0,D.coalesce)(v)}catch(u){this.logService.trace(u),c.children=[]}return c}return c}async resolveAll(l){return n.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(a){return a}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new d.FileOperationError((0,p.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=k.VSBuffer.fromString(""),a){await this.doValidateCreateFile(l,a);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,i)),i}async writeFile(l,r,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,l,a)||await this.mkdirp(i,t.dirname(l));let o;if((0,d.hasReadWriteCapability)(i)&&!(r instanceof k.VSBuffer))if((0,h.isReadableStream)(r)){const c=await(0,h.peekStream)(r,3);c.ended?o=k.VSBuffer.concat(c.buffer):o=c}else o=(0,h.peekReadable)(r,c=>k.VSBuffer.concat(c),3);else o=r;!(0,d.hasOpenReadWriteCloseCapability)(i)||(0,d.hasReadWriteCapability)(i)&&o instanceof k.VSBuffer?await this.doWriteUnbuffered(i,l,a,o):await this.doWriteBuffered(i,l,a,o instanceof k.VSBuffer?(0,k.bufferToReadable)(o):o)}catch(s){throw new d.FileOperationError((0,p.localize)(4,null,this.resourceForError(l),(0,d.ensureFileSystemProviderError)(s).toString()),(0,d.toFileOperationResult)(s),a)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,a){if(!!a?.unlock&&!(l.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(r)));let t;try{t=await l.stat(r)}catch{return}if((t.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,p.localize)(6,null,this.resourceForError(r)),0,a);if(this.throwIfFileIsReadonly(r,t),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==d.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&a.mtime<t.mtime&&a.etag!==(0,d.etag)({mtime:a.mtime,size:t.size}))throw new d.FileOperationError((0,p.localize)(7,null),3,a);return t}async readFile(l,r,a){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,a):this.doReadFile(i,l,r,a)}async doReadFileAtomic(l,r,a,i){return new Promise((t,s)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(l,r,a,i);t(o)}catch(o){s(o)}})})}async doReadFile(l,r,a,i){const t=await this.doReadFileStream(l,r,{...a,preferUnbuffered:!0},i);return{...t,value:await(0,k.streamToBuffer)(t.value)}}async readFileStream(l,r,a){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,a)}async doReadFileStream(l,r,a,i){const t=new A.CancellationTokenSource(i),s=this.validateReadFile(r,a).then(c=>c,c=>{throw t.cancel(),c});let o;try{return typeof a?.etag=="string"&&a.etag!==d.ETAG_DISABLED&&await s,a?.atomic&&(0,d.hasFileAtomicReadCapability)(l)||!((0,d.hasOpenReadWriteCloseCapability)(l)||(0,d.hasFileReadStreamCapability)(l))||(0,d.hasReadWriteCapability)(l)&&a?.preferUnbuffered?o=this.readFileUnbuffered(l,r,a):(0,d.hasFileReadStreamCapability)(l)?o=this.readFileStreamed(l,r,t.token,a):o=this.readFileBuffered(l,r,t.token,a),{...await s,value:o}}catch(c){o&&await(0,h.consumeStream)(o);const u=(0,p.localize)(8,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(c).toString());throw c instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(u,c.stat,a):new d.FileOperationError(u,(0,d.toFileOperationResult)(c),a)}}readFileStreamed(l,r,a,i=Object.create(null)){const t=l.readFileStream(r,i,a);return(0,h.transform)(t,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new d.FileOperationError((0,p.localize)(9,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(s).toString()),(0,d.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}readFileBuffered(l,r,a,i=Object.create(null)){const t=(0,k.newWriteableBufferStream)();return(0,g.readFileIntoStream)(l,r,t,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new d.FileOperationError((0,p.localize)(10,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(s).toString()),(0,d.toFileOperationResult)(s),i)},a),t}readFileUnbuffered(l,r,a){const i=(0,h.newWriteableStream)(t=>k.VSBuffer.concat(t));return(async()=>{try{let t;a?.atomic&&(0,d.hasFileAtomicReadCapability)(l)?t=await l.readFile(r,{atomic:!0}):t=await l.readFile(r),typeof a?.position=="number"&&(t=t.slice(a.position)),typeof a?.length=="number"&&(t=t.slice(0,a.length)),this.validateReadFileLimits(r,t.byteLength,a),i.end(k.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(l,r){const a=await this.resolve(l,{resolveMetadata:!0});if(a.isDirectory)throw new d.FileOperationError((0,p.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==d.ETAG_DISABLED&&r.etag===a.etag)throw new d.NotModifiedSinceFileOperationError((0,p.localize)(12,null),a,r);return this.validateReadFileLimits(l,a.size,r),a}validateReadFileLimits(l,r,a){if(a?.limits){let i;if(typeof a.limits.memory=="number"&&r>a.limits.memory&&(i=9),typeof a.limits.size=="number"&&r>a.limits.size&&(i=7),typeof i=="number")throw new d.FileOperationError((0,p.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,a){return this.doCanMoveCopy(l,r,"move",a)}async canCopy(l,r,a){return this.doCanMoveCopy(l,r,"copy",a)}async doCanMoveCopy(l,r,a,i){if(l.toString()!==r.toString())try{const t=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(t,l,s,r,a,i)}catch(t){return t}return!0}async move(l,r,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,l,t,r,"move",!!a),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,s==="move"?2:3,o)),o}async copy(l,r,a){const i=await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,l,t,r,"copy",!!a),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,s==="copy"?3:2,o)),o}async doMoveCopy(l,r,a,i,t,s){if(r.toString()===i.toString())return t;const{exists:o,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,r,a,i,t,s);if(o&&!c&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(i)),t==="copy"){if(l===a&&(0,d.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:s});else{const u=await this.resolve(r);u.isDirectory?await this.doCopyFolder(l,u,a,i):await this.doCopyFile(l,r,a,i)}return t}else return l===a?(await l.rename(r,i,{overwrite:s}),t):(await this.doMoveCopy(l,r,a,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,a,i){if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(l,r,a,i);if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(l,r,a,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(l,r,a,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasReadWriteCapability)(a))return this.doPipeUnbuffered(l,r,a,i)}async doCopyFolder(l,r,a,i){await a.mkdir(i),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async t=>{const s=this.getExtUri(a).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(l,await this.resolve(t.resource),a,s):this.doCopyFile(l,t.resource,a,s)}))}async doValidateMoveCopy(l,r,a,i,t,s){let o=!1;if(l===a){const{providerExtUri:u,isPathCaseSensitive:v}=this.getExtUri(l);if(v||(o=u.isEqual(r,i)),o&&t==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!o&&u.isEqualOrParent(i,r))throw new Error((0,p.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!o){if(!s)throw new d.FileOperationError((0,p.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===a){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(r,i))throw new Error((0,p.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:o}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,a)),a}async mkdirp(l,r){const a=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&d.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(r)));break}catch(t){if((0,d.toFileSystemProviderErrorCode)(t)!==d.FileSystemProviderErrorCode.FileNotFound)throw t;a.push(i.basename(r)),r=i.dirname(r)}for(let t=a.length-1;t>=0;t--){r=i.joinPath(r,a[t]);try{await l.mkdir(r)}catch(s){if((0,d.toFileSystemProviderErrorCode)(s)!==d.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(a){return a}return!0}async doValidateDelete(l,r){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(a.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(l)));let t;try{t=await a.stat(l)}catch{}if(t)this.throwIfFileIsReadonly(l,t);else throw new d.FileOperationError((0,p.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const o=await this.resolve(l);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(l)))}return a}async del(l,r){const a=await this.doValidateDelete(l,r),i=!!r?.useTrash,t=!!r?.recursive;await a.delete(l,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new d.FileOperationEvent(l,1))}watch(l,r={recursive:!1,excludes:[]}){const a=new E.DisposableStore;let i=!1,t=()=>{i=!0};return a.add((0,E.toDisposable)(()=>t())),(async()=>{try{const s=await this.doWatch(l,r);i?(0,E.dispose)(s):t=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),a}async doWatch(l,r){const a=await this.withProvider(l),i=(0,R.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(l),r]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:a.watch(l,r)},this.activeWatchers.set(i,t)),t.count+=1,(0,E.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,E.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,a,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const t=await l.open(r,{create:!0,unlock:a?.unlock??!1});try{(0,h.isReadableStream)(i)||(0,h.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,t,i):await this.doWriteReadableBufferedQueued(l,t,i)}catch(s){throw(0,d.ensureFileSystemProviderError)(s)}finally{await l.close(t)}})}async doWriteStreamBufferedQueued(l,r,a){let i=0,t;if((0,h.isReadableBufferedStream)(a)){if(a.buffer.length>0){const s=k.VSBuffer.concat(a.buffer);await this.doWriteBuffer(l,r,s,s.byteLength,i,0),i+=s.byteLength}if(a.ended)return;t=a.stream}else t=a;return new Promise((s,o)=>{(0,h.listenStream)(t,{onData:async c=>{t.pause();try{await this.doWriteBuffer(l,r,c,c.byteLength,i,0)}catch(u){return o(u)}i+=c.byteLength,setTimeout(()=>t.resume())},onError:c=>o(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,r,a){let i=0,t;for(;(t=a.read())!==null;)await this.doWriteBuffer(l,r,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(l,r,a,i,t,s){let o=0;for(;o<i;)o+=await l.write(r,t+o,a.buffer,s+o,i-o)}async doWriteUnbuffered(l,r,a,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,a,i))}async doWriteUnbufferedQueued(l,r,a,i){let t;i instanceof k.VSBuffer?t=i:(0,h.isReadableStream)(i)?t=await(0,k.streamToBuffer)(i):(0,h.isReadableBufferedStream)(i)?t=await(0,k.bufferedStreamToBuffer)(i):t=(0,k.readableToBuffer)(i),await l.writeFile(r,t.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,a,i))}async doPipeBufferedQueued(l,r,a,i){let t,s;try{t=await l.open(r,{create:!1}),s=await a.open(i,{create:!0,unlock:!1});const o=k.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,u=0,v=0;do v=await l.read(t,c,o.buffer,u,o.byteLength-u),await this.doWriteBuffer(a,s,o,v,c,u),c+=v,u+=v,u===o.byteLength&&(u=0);while(v>0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await n.Promises.settled([typeof t=="number"?l.close(t):Promise.resolve(),typeof s=="number"?a.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,a,i))}async doPipeUnbufferedQueued(l,r,a,i){return a.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,a,i))}async doPipeUnbufferedToBufferedQueued(l,r,a,i){const t=await a.open(i,{create:!0,unlock:!1});try{const s=await l.readFile(r);await this.doWriteBuffer(a,t,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,d.ensureFileSystemProviderError)(s)}finally{await a.close(t)}}async doPipeBufferedToUnbuffered(l,r,a,i){const t=await(0,k.streamToBuffer)(this.readFileBuffered(l,r,A.CancellationToken.None));await this.doWriteUnbuffered(a,i,void 0,t)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new d.FileOperationError((0,p.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,p.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};m=de([J(0,w.ILogService)],m),e.FileService=m}),define(te[178],ne([0,1,50,254,5,39,17,3,41,2,10,4,19,40,22,139,13,84,175,37,167,166]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(a)}`)}})();class r extends w.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new A.ResourceMap(s=>f.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await h.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,f.joinPath)(i,o.name))).type:c=this.toType(o),s.push([o.name,c])}catch(c){this.logService.trace(c)}})),s}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let s;return t?.dangling?s=d.FileType.Unknown:i.isFile()?s=d.FileType.File:i.isDirectory()?s=d.FileType.Directory:s=d.FileType.Unknown,t&&(s|=d.FileType.SymbolicLink),s}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let t;for(;t=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await t.wait();const s=new k.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),s.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const o=this.toFilePath(i);return await h.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(i,t,s){const o=(0,y.newWriteableStream)(c=>T.VSBuffer.concat(c.map(u=>T.VSBuffer.wrap(u))).buffer);return(0,g.readFileIntoStream)(this,i,o,c=>c.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(i,t,s){let o;try{const c=this.toFilePath(i);if(!s.create||!s.overwrite){if(await h.Promises.exists(c)){if(!s.overwrite)throw(0,d.createFileSystemProviderError)((0,p.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,d.createFileSystemProviderError)((0,p.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof o=="number"&&await this.close(o)}}async open(i,t){let s;(0,d.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(i));let o;try{const c=this.toFilePath(i);if((0,d.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:v}=await h.SymlinkSupport.stat(c);v.mode&128||await h.Promises.chmod(c,v.mode|128)}catch(v){this.logService.trace(v)}let u;if((0,d.isFileOpenForWriteOptions)(t)){if(C.isWindows)try{await h.Promises.truncate(c,0),u="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}u||(u="w")}else u="r";o=await h.Promises.open(c,u)}catch(c){throw s?.dispose(),(0,d.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}return this.mapHandleToPos.set(o,0),(0,d.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(o,i),s&&this.mapHandleToLock.set(o,s),o}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await h.Promises.fdatasync(i)}catch(t){this.canFlush=!1,this.logService.error(t)}return await h.Promises.close(i)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(i);t&&(this.mapHandleToLock.delete(i),t.dispose())}}async read(i,t,s,o,c){const u=this.normalizePos(i,t);let v=null;try{const{bytesRead:I}=await h.Promises.read(i,s,o,c,u);return I}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(i,u,v)}}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,s){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,o+s):this.mapHandleToPos.delete(i)))}async write(i,t,s,o,c){return(0,k.retry)(()=>this.doWrite(i,t,s,o,c),100,3)}async doWrite(i,t,s,o,c){const u=this.normalizePos(i,t);let v=null;try{const{bytesWritten:I}=await h.Promises.write(i,s,o,c,u);return I}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),I)}finally{this.updatePos(i,u,v)}}async mkdir(i){try{await h.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const s=this.toFilePath(i);t.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateTargetDeleted(i,t,"move",s.overwrite),await h.Promises.move(o,c)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateTargetDeleted(i,t,"copy",s.overwrite),await h.Promises.copy(o,c,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(i,t,s,o){const c=this.toFilePath(i),u=this.toFilePath(t);let v=!1;if(!!(this.capabilities&1024)||(v=(0,b.isEqual)(c,u,!0)),v&&s==="copy")throw(0,d.createFileSystemProviderError)((0,p.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!v&&await h.Promises.exists(u)){if(!o)throw(0,d.createFileSystemProviderError)((0,p.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,t,s){return new S.UniversalWatcherClient(o=>i(o),o=>t(o),s)}createNonRecursiveWatcher(i,t,s){return new l.NodeJSWatcherClient(o=>i(o),o=>t(o),s)}toFileSystemProviderError(i){if(i instanceof d.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let s=this.toFileSystemProviderError(t);if(i&&s.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await h.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(s=(0,d.createFileSystemProviderError)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=r}),define(te[86],ne([0,1,3,7,8]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(f,y,h){switch(y){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=A;class T{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){T.setLevel(this.channel,f)}static setLevel(f,y){return f.call("setLevel",y)}}e.LogLevelChannelClient=T;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,y){throw new Error(`Event not found: ${y}`)}async call(f,y,h){switch(y){case"createLogger":this.createLogger(n.URI.revive(h[0]),h[1]);return;case"log":return this.log(n.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${y}`)}createLogger(f,y){this.loggers.set(f.toString(),this.loggerService.createLogger(f,y))}consoleLog(f,y){let h=console.log;switch(f){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...y)}log(f,y){const h=this.loggers.get(f.toString());if(!h)throw new Error("Create the logger before logging");for(const[p,d]of y)(0,k.log)(h,p,d)}}e.LoggerChannel=R;class b extends k.AbstractLoggerService{constructor(f,y,h){super(f,y);this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(f,y)=>{this.channel.call("consoleLog",[f,y])}})}doCreateLogger(f,y,h){return new E(this.channel,f,y,h)}}e.LoggerChannelClient=b;class E extends k.AbstractMessageLogger{constructor(f,y,h,p){super(p?.always);this.channel=f,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[y,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,y){const h=[[f,y]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends k.LogService{constructor(f,y){super(y);this.parent=f,this._register(f.onDidChangeLogLevel(h=>y.setLevel(h)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(te[60],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[87],ne([0,1,18,4,32,19]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const R=n.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const R=(0,A.dirname)(D.FileAccess.asFileUri("",Y));T=Y.__$__nodeRequire((0,A.joinPath)(R,"product.json").fsPath);const b=Y.__$__nodeRequire((0,A.joinPath)(R,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:b.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(te[27],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[179],ne([0,1,5,9,2,10,22,8,27]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends k.Disposable{constructor(C,f,y){super();this.productService=f,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),y=(0,A.dirname)(C),h=(0,A.basename)(C),p=await T.Promises.readdir(y);await Promise.all(p.map(async d=>{if(d===h)return;const g=(0,A.join)(y,d),w=await T.Promises.stat(g);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),T.Promises.rm(g)}))}catch(f){(0,n.onUnexpectedError)(f)}}};E=de([J(1,b.IProductService),J(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(te[180],ne([0,1,5,9,2,10,22,15,8,27]),function(Y,e,D,n,k,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends k.Disposable{constructor(f,y,h){super();this.environmentService=f,this.logService=y,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),y=JSON.parse(await T.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(y)){const m=y[w];f[`${m.hash}.${w}`]=!0}const h=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const d=await T.Promises.readdir(h);for(const w of d){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await T.Promises.rm((0,A.join)(h,w))}const g=Date.now();for(const w of Object.keys(f)){const m=(0,A.join)(h,w),S=await T.Promises.readdir(m);for(const l of S){if(l==="tcf.json")continue;const r=(0,A.join)(m,l),a=await T.Promises.stat(r);a.isDirectory()&&g-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(w,l)}`),await T.Promises.rm(r))}}}catch(f){(0,n.onUnexpectedError)(f)}}};P=de([J(0,R.INativeEnvironmentService),J(1,b.ILogService),J(2,E.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(te[181],ne([0,1,10,6]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var k;(function(A){function T(R,b="noAbsolutePaths"){for(const E of R.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(b,(0,D.basename)(E.callFrame.url)));return R}A.rewriteAbsolutePaths=T})(k=e.Utils||(e.Utils={}))}),define(te[182],ne([0,1,29]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(A){const R=await(await new Promise((E,P)=>{Y(["v8-inspect-profiler"],E,P)})).startProfiling({port:A.port,checkForPaused:!0}),b=(0,D.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(A){const T=this._sessions.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const R=await T.stop();return this._sessions.delete(A),R.profile}}e.InspectProfilingService=n}),define(te[38],ne([0,1,99,14]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,R){D.ok(n.isString(T)),D.ok(n.isObject(R)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(te[88],ne([0,1,3,38]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,E){this.schemasById[k(b)]=E,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;n.Registry.add(e.Extensions.JSONContribution,T)}),define(te[42],ne([0,1,16,3,14,125,88,38]),function(Y,e,D,n,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(T.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const a=this.doRegisterConfigurations(l,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(l,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(a)})}registerDefaultConfigurations(l){const r=[],a=[];for(const{overrides:i,source:t}of l)for(const s in i)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...i[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const c={type:"object",default:o,description:A.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:k.isString(t)?void 0:t};a.push(...h(s)),this.configurationProperties[s]=c,this.defaultLanguageConfigurationOverridesNode.properties[s]=c}else{this.configurationDefaultsOverrides.set(s,{value:i[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:a,source:i}of l)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=k.isString(i)?i:i?.id,c=k.isString(s?.source)?s?.source:s?.source?.id;if(o===c)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const u=this.configurationProperties[t];u&&(this.updatePropertyDefaultValue(t,u),this.updateSchema(t,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const a=[];return l.forEach(i=>{a.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),a}doDeregisterConfigurations(l){const r=[],a=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>a(t))};for(const i of l){a(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,a,i,t=3){t=k.isUndefinedOrNull(l.scope)?t:l.scope;let s=[],o=l.properties;if(o)for(let u in o){if(r&&w(u)){delete o[u];continue}const v=o[u];if(v.source=a,v.defaultDefaultValue=o[u].default,this.updatePropertyDefaultValue(u,v),e.OVERRIDE_PROPERTY_REGEX.test(u)?v.scope=void 0:(v.scope=k.isUndefinedOrNull(v.scope)?t:v.scope,v.restricted=k.isUndefinedOrNull(v.restricted)?!!i?.includes(u):v.restricted),o[u].hasOwnProperty("included")&&!o[u].included){this.excludedConfigurationProperties[u]=o[u],delete o[u];continue}else this.configurationProperties[u]=o[u];!o[u].deprecationMessage&&o[u].markdownDeprecationMessage&&(o[u].deprecationMessage=o[u].markdownDeprecationMessage),s.push(u)}let c=l.allOf;if(c)for(let u of c)s.push(...this.validateAndRegisterProperties(u,r,a,i,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=a=>{let i=a.properties;if(i)for(const s in i)this.updateSchema(s,i[s]);let t=a.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,a={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const a=this.configurationDefaultsOverrides.get(l);let i=a?.value,t=a?.source;k.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),k.isUndefined(i)&&(i=d(r.type)),r.default=i,r.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(S){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let r=y.exec(S);for(;r?.length;){const a=r[1].trim();a&&l.push(a),r=y.exec(S)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=h;function p(S){return S.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=p;function d(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new C;R.Registry.add(e.Extensions.Configuration,g);function w(S){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?A.localize(7,null,S):g.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):null:A.localize(6,null)}e.validateProperty=w;function m(){const S=[],l=g.getConfigurationProperties();for(const r of Object.keys(l))S.push([r,l[r].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=m}),define(te[89],ne([0,1,16,3,35,2,39,28,14,7,20,42,38]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},t=[],s=[]){this._contents=i,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const s=this.getContentsForOverrideIdentifer(t);return s?i?(0,P.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return D.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const c of i){this.mergeContents(t,c.contents);for(const u of c.overrides){const[v]=s.filter(I=>D.equals(I.identifiers,u.identifiers));v?(this.mergeContents(v.contents,u.contents),v.keys.push(...u.keys),v.keys=D.distinct(v.keys)):s.push(R.deepClone(u))}for(const u of c.keys)o.indexOf(u)===-1&&o.push(u)}return new y(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o],u=t[o];u&&(typeof c=="object"&&typeof u=="object"?(c=R.deepClone(c),this.mergeContents(c,u)):c=u),s[o]=c}return new y(s,this.keys,this.overrides)}mergeContents(i,t){for(const s of Object.keys(t)){if(s in i&&b.isObject(i[s])&&b.isObject(t[s])){this.mergeContents(i[s],t[s]);continue}i[s]=R.deepClone(t[s])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,s=null;const o=c=>{c&&(s?this.mergeContents(s,c):s=R.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[i])?t=c.contents:c.identifiers.includes(i)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,P.addToValueTree)(this.contents,i,t,s=>{throw new Error(s)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let s=0;s<t;s++)i.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class h extends y{constructor(i={}){const t=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),c=[];for(const u in t){const v=i[u],I=v!==void 0?v:t[u].default;(0,P.addToValueTree)(o,u,I,_=>console.error(`Conflict in default settings: ${_}`))}for(const u of Object.keys(o))C.OVERRIDE_PROPERTY_REGEX.test(u)&&c.push({identifiers:(0,C.overrideIdentifiersFromKey)(u),keys:Object.keys(o[u]),contents:(0,P.toValuesTree)(o[u],v=>console.error(`Conflict in default settings file: ${v}`))});super(o,s,c)}}e.DefaultConfigurationModel=h;class p{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!b.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:s,keys:o,overrides:c,restricted:u}=this.doParseRaw(i,t);this._configurationModel=new y(s,o,c),this._restrictedConfigurations=u||[]}doParseContent(i){let t={},s=null,o=[],c=[],u=[];function v(_){Array.isArray(o)?o.push(_):s!==null&&(o[s]=_)}let I={onObjectBegin:()=>{let _={};v(_),c.push(o),o=_,s=null},onObjectProperty:_=>{s=_},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let _=[];v(_),c.push(o),o=_,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:v,onError:(_,O,N)=>{u.push({error:_,offset:O,length:N})}};if(i)try{k.visit(i,I),t=o[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(i,t){const s=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,s,!0,t);i=o.raw;const c=(0,P.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),u=Object.keys(i),v=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:c,keys:u,overrides:v,restricted:o.restricted}}filter(i,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const c={},u=[];for(let v in i)if(C.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const I=this.filter(i[v],t,!1,o);c[v]=I.raw,u.push(...I.restricted)}else{const I=t[v],_=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&u.push(v),(_===void 0||o.scopes===void 0||o.scopes.includes(_))&&(o.skipRestricted&&I?.restricted||(c[v]=i[v]))}return{raw:c,restricted:u}}toOverrides(i,t){const s=[];for(const o of Object.keys(i))if(C.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const u in i[o])c[u]=i[o][u];s.push({identifiers:(0,C.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=p;class d extends A.Disposable{constructor(i,t,s,o){super();this.userSettingsResource=i,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class g{constructor(i,t,s=new y,o=new y,c=new T.ResourceMap,u=new y,v=new T.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=u,this._memoryConfigurationByResource=v,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(i)}updateValue(i,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new y,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(i):o.setValue(i,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,s){const o=this.getConsolidateConfigurationModel(t,s),c=this.getFolderConfigurationModelForResource(t.resource,s),u=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,v=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,$=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,L=t.overrideIdentifier?u.override(t.overrideIdentifier).getValue(i):u.getValue(i),U=o.getValue(i),j=D.distinct(D.flatten(o.overrides.map(M=>M.identifiers))).filter(M=>o.getOverrideValue(i,M)!==void 0);return{defaultValue:v,userValue:I,userLocalValue:_,userRemoteValue:O,workspaceValue:N,workspaceFolderValue:$,memoryValue:L,value:U,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:c?.freeze().getValue(i),override:t.overrideIdentifier?c?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:u.getValue(i),override:t.overrideIdentifier?u.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:o,updated:c,removed:u}=l(this._defaultConfiguration,i);t=[...o,...c,...u]}for(const o of t)for(const c of(0,C.overrideIdentifiersFromKey)(o)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(c),v=i.getKeysForOverrideIdentifier(c),I=[...v.filter(_=>u.indexOf(_)===-1),...u.filter(_=>v.indexOf(_)===-1),...u.filter(_=>!R.equals(this._defaultConfiguration.override(c).getValue(_),i.override(c).getValue(_)))];s.push([c,I])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=l(this.localUserConfiguration,i),u=[...t,...s,...o];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=l(this.remoteUserConfiguration,i);let u=[...t,...s,...o];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=l(this.workspaceConfiguration,i);let u=[...t,...s,...o];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(i,t){const s=this.folderConfigurations.get(i),{added:o,updated:c,removed:u,overrides:v}=l(s,t);let I=[...o,...c,...u];return(I.length||!s)&&this.updateFolderConfiguration(i,t),{keys:I,overrides:v}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:c,overrides:u}=l(t,void 0);return{keys:[...s,...o,...c],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let s=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?s.override(i.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:i},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const o=t.getFolder(i);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const c=this._memoryConfigurationByResource.get(i);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=s}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:s,overrides:o,keys:c}=this._folderConfigurations.get(t);return i.push([t,{contents:s,overrides:o,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>i.add(s))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((u,v)=>(u.set(E.URI.revive(v[0]),this.parseConfigurationModel(v[1])),u),new T.ResourceMap);return new g(t,s,new y,o,c,new y,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=g;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,t=new Map;for(const o of a)o.keys.forEach(c=>i.add(c)),o.overrides.forEach(([c,u])=>{const v=(0,T.getOrSet)(t,c,new Set);u.forEach(I=>v.add(I))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=w;class m{constructor(i,t,s,o){this.change=i,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(v=>c.add(v)),i.overrides.forEach(([,v])=>v.forEach(I=>c.add(I))),this.affectedKeys=[...c.values()];const u=new y;this.affectedKeys.forEach(v=>u.setValue(v,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let s=(0,P.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(i=i[o],!i)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=m;class S extends m{constructor(i,t,s,o){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=S;function l(a,i){const{added:t,removed:s,updated:o}=r(i,a),c=[],u=a?.getAllOverrideIdentifiers()||[],v=i?.getAllOverrideIdentifiers()||[];if(i){const I=v.filter(_=>!u.includes(_));for(const _ of I)c.push([_,i.getKeysForOverrideIdentifier(_)])}if(a){const I=u.filter(_=>!v.includes(_));for(const _ of I)c.push([_,a.getKeysForOverrideIdentifier(_)])}if(i&&a){for(const I of u)if(v.includes(I)){const _=r({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});c.push([I,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function r(a,i){const t=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],s=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],o=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const u=(0,P.getConfigurationValue)(i.contents,c),v=(0,P.getConfigurationValue)(a.contents,c);R.equals(u,v)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(te[183],ne([0,1,5,3,2,19,20,89,42,38]),function(Y,e,D,n,k,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends k.Disposable{constructor(f,y){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,y)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,y){const h=typeof f=="string"?f:void 0,p=(0,T.isConfigurationOverrides)(f)?f:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(h,p,void 0)}updateValue(f,y,h,p){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(h,y,1)}onDidDefaultConfigurationChange(f){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(h,y,6)}trigger(f,y,h){const p=new R.ConfigurationChangeEvent(f,{data:y},this.configuration);p.source=h,p.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(te[184],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var n;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,R=n.Unknown,b){super(T);this._message=T,this._code=R,this._detail=b,this.isHandled=R===n.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===n.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===n.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(te[185],ne([0,1,5,17,25,9,3,2,29,73,184]),function(Y,e,D,n,k,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function y(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(H){const Z=new k.CancellationTokenSource;return setTimeout(()=>Z.cancel(),H),Z.token}function p(H,Z){if(H.isCancellationRequested||Z.isCancellationRequested)return k.CancellationToken.Cancelled;const ee=new k.CancellationTokenSource;return H.onCancellationRequested(()=>ee.cancel()),Z.onCancellationRequested(()=>ee.cancel()),ee.token}class d{constructor(Z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((ee,W)=>{this._resolvePromise=ee,this._rejectPromise=W}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function g(H,Z){const ee=new d(Z);return ee.registerDisposable(H.onControlMessage(W=>{const F=JSON.parse(W.toString()),V=G(F);V?ee.reject(V):ee.resolve(F)})),ee.promise}function w(H,Z,ee,W,F,V,z){const B=new d(z);return Z.connect(ee,W,F,V,(ie,se)=>{B.didTimeout?(ie&&H.error(ie),se?.dispose()):ie||!se?B.reject(ie):B.resolve(se)}),B.promise}function m(H,Z){const ee=new d(Z);return H.then(W=>{ee.didTimeout||ee.resolve(W)},W=>{ee.didTimeout||ee.reject(W)}),ee.promise}async function S(H,Z,ee,W){const F=q(H,Z);H.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let V;try{V=await w(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${y(Z)}-${H.reconnectionToken}`,W)}catch(ce){throw H.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let z,B;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(V,null),z=H.reconnectionProtocol,B=!1):(z=new E.PersistentProtocol(V,null),B=!0),H.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const ie=await m(H.signService.createNewMessage((0,b.generateUuid)()),W),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:ie.data};z.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await g(z,p(W,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(H.logService.trace(`${F} 4/6. received SignRequest control message.`),!await m(H.signService.validate(ie,ce.signedData),W)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const ge=await m(H.signService.sign(ce.data),W),me={type:"connectionType",commit:H.commit,signedData:ge,desiredConnectionType:Z};return ee&&(me.args=ee),H.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(n.VSBuffer.fromString(JSON.stringify(me))),{protocol:z,ownsProtocol:B}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${F} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${F} received error control message when negotiating connection. Error:`),H.logService.error(ce)),B&&M(z),ce}}async function l(H,Z,ee,W){const F=Date.now(),V=q(H,Z),{protocol:z,ownsProtocol:B}=await S(H,Z,ee,W),ie=new d(W);return ie.registerDisposable(z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=G(ce);he?(H.logService.error(`${V} received error control message when negotiating connection. Error:`),H.logService.error(he),B&&M(z),ie.reject(he)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${X(F)}!`),ie.resolve({protocol:z,firstMessage:ce}))})),ie.promise}async function r(H,Z){const{protocol:ee}=await l(H,1,void 0,Z);return{protocol:ee}}async function a(H,Z,ee){const{protocol:W,firstMessage:F}=await l(H,2,Z,ee),V=F&&F.debugPort;return{protocol:W,debugPort:V}}async function i(H,Z,ee){const W=Date.now(),F=q(H,3),{protocol:V}=await S(H,3,Z,ee);return H.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${X(W)}!`),V}async function t(H,Z,ee){const{host:W,port:F,connectionToken:V}=await H.addressProvider.getAddress();return{commit:H.commit,host:W,port:F,connectionToken:V,reconnectionToken:Z,reconnectionProtocol:ee,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function s(H,Z,ee){try{const W=(0,b.generateUuid)(),F=await t(H,W,null),{protocol:V}=await r(F,k.CancellationToken.None);return new U(H,Z,ee,W,V)}catch(W){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(W),L.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=s;async function o(H,Z){try{const ee=(0,b.generateUuid)(),W=await t(H,ee,null),{protocol:F,debugPort:V}=await a(W,Z,k.CancellationToken.None);return new j(H,Z,ee,F,V)}catch(ee){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(ee),L.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(ee)),ee}}e.connectRemoteAgentExtensionHost=o;async function c(H,Z,ee){const W=await t(H,(0,b.generateUuid)(),null);return await i(W,{host:Z,port:ee},k.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function u(H){return(0,D.createCancelablePromise)(Z=>new Promise((ee,W)=>{const F=setTimeout(ee,H*1e3);Z.onCancellationRequested(()=>{clearTimeout(F),ee()})}))}var v;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(v=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(Z,ee){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.type=0}}e.ConnectionLostEvent=I;class _{constructor(Z,ee,W,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.durationSeconds=W,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Z,ee,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=O;class N{constructor(Z,ee,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(Z,ee,W,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class L extends R.Disposable{constructor(Z,ee,W,F){super();this._connectionType=Z,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=ee,this.reconnectionToken=W,this.protocol=F,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(F.onSocketClose(V=>{const z=x(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(()=>{const V=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} received socket timeout event.`),this._beginReconnecting()})),L._instances.push(this),L._permanentFailure&&this._gotoPermanentFailure(L._permanentFailureMillisSinceLastIncomingData,L._permanentFailureAttempt,L._permanentFailureHandled)}static triggerPermanentFailure(Z,ee,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=ee,this._permanentFailureHandled=W,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(L._permanentFailure)return;const Z=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const F=W<ee.length?ee[W]:ee[ee.length-1];try{if(F>0){const z=u(F);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,z)),this._options.logService.info(`${Z} waiting for ${F} seconds before reconnecting...`);try{await z}catch{}}if(L._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${Z} resolving connection...`);const V=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,h(C)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,A.isCancellationError)(V)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,P.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!L._permanentFailure)}_gotoPermanentFailure(Z,ee,W){this._onDidStateChange.fire(new $(this.reconnectionToken,Z,ee,W)),M(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=L,L._permanentFailure=!1,L._permanentFailureMillisSinceLastIncomingData=0,L._permanentFailureAttempt=0,L._permanentFailureHandled=!1,L._instances=[];class U extends L{constructor(Z,ee,W,F,V){super(1,Z,F,V);this.client=this._register(new E.Client(V,{remoteAuthority:ee,clientId:W},Z.ipcLogger))}async _reconnect(Z,ee){await r(Z,ee)}}e.ManagementPersistentConnection=U;class j extends L{constructor(Z,ee,W,F,V){super(2,Z,W,F);this._startArguments=ee,this.debugPort=V}async _reconnect(Z,ee){await a(Z,this._startArguments,ee)}}e.ExtensionHostPersistentConnection=j;function M(H){try{H.acceptDisconnect();const Z=H.getSocket();H.dispose(),Z.dispose()}catch(Z){(0,A.onUnexpectedError)(Z)}}function G(H){if(H&&H.type==="error"){const Z=new Error(`Connection error: ${H.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function K(H,Z){for(;H.length<Z;)H+=" ";return H}function x(H,Z,ee){return`[remote-connection][${K(y(H),13)}][${Z.substr(0,5)}\u2026][${ee?"reconnect":"initial"}]`}function q(H,Z){return`${x(Z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function X(H){return`${Date.now()-H} ms`}}),define(te[186],ne([0,1,18]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=n;function k(E){if(!E)return;const P=E.indexOf("+");return P<0?E:E.substr(0,P)}e.getRemoteName=k;function A(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=A;function T(E){if(E.folders.length)return E.folders.every(P=>A(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&A(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=T;function R(E){return T(E)?.scheme}e.getVirtualWorkspaceScheme=R;function b(E){return T(E)!==void 0}e.isVirtualWorkspace=b}),define(te[90],ne([0,1,26,6,186]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=A;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,h){if(typeof y=="undefined"||y===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof y=="string"||typeof h=="string"){let p=typeof y=="string"?y:y.value,d=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(p,d)}return y._lower===h._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=b;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function C(f,y){if(y){const h=`onResolveRemoteAuthority:${(0,k.getRemoteName)(y)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,26,90]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,p){return h.uuid&&p.uuid?h.uuid===p.uuid:h.id===p.id?!0:(0,D.compareIgnoreCase)(h.id,p.id)===0}e.areSameExtensions=k;class A{constructor(p,d){this.version=d,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof A?k(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=A;function T(h,p){return`${h}.${p}`}e.getExtensionId=T;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(h,p){return R(T(h,p))}e.getGalleryExtensionId=b;function E(h,p){const d=[],g=w=>{for(const m of d)if(m.some(S=>k(p(S),p(w))))return m;return null};for(const w of h){const m=g(w);m?m.push(w):d.push([w])}return d}e.groupByExtension=E;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function C(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function f(h){const p=new Set;if(h.malicious)for(const d of h.malicious)p.add(d.id);return p}e.getMaliciousExtensionsSet=f;function y(h,p){const d=[],g=p.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const w=g.shift();if(w&&d.every(m=>!k(m.identifier,{id:w}))){const m=h.filter(S=>k(S.identifier,{id:w}));m.length===1&&(d.push(m[0]),g.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=y}),define(te[187],ne([0,1,31]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function n(k,A,T,R,b){try{const E=await k.getExtensionsControlManifest();if(!E.unsupportedPreReleaseExtensions)return;const P=await k.getInstalled(1);for(const[C,{id:f,migrateStorage:y}]of Object.entries(E.unsupportedPreReleaseExtensions)){const h=P.find(d=>(0,D.areSameExtensions)(d.identifier,{id:C}));if(!h)continue;const p=await A.getCompatibleExtension({id:f},!0,await k.getTargetPlatform());if(!p){b.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{b.info(`Migrating '${h.identifier.id}' extension to '${f}' extension...`);const d=!R.getDisabledExtensions().some(w=>(0,D.areSameExtensions)(w,h.identifier));await k.uninstall(h),b.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let g=P.find(w=>(0,D.areSameExtensions)(w.identifier,{id:f}));(!g||!g.isPreReleaseVersion&&d)&&(g=await k.installFromGallery(p,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${g.identifier.id}'`),d||(await R.disableExtension(g.identifier),b.info(`Disabled the pre-release extension '${g.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),y&&(T.addToMigrationList((0,D.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,D.getExtensionId)(g.manifest.publisher,g.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${h.identifier.id}' extension to '${f}' extension.`)}catch(d){b.error(d)}}}catch(E){b.error(E)}}e.migrateUnsupportedExtensions=n}),define(te[188],ne([0,1,5,9,2,4,19,61,7,29,22,15,30,31,13,8]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends k.Disposable{constructor(m,S,l,r){super();this.fileService=S,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=b.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,S){await this.cleanUpPromise;const l=this.getName(m),r=(0,T.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const a=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(m,a,S);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(a)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,a.path),i}}return r}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,S,l){try{await P.Promises.rename(m.fsPath,S.fsPath)}catch(r){if(A.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${m} to ${S} with 'EPERM' error. Trying again...`),this.rename(m,S,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const S=[],l=[];for(const i of m.children){const t=this.parse(i.name);t&&l.push([t,i])}const r=(0,y.groupByExtension)(l,([i])=>i),a=[];for(const i of r)i.sort((t,s)=>R.rcompare(t[0].version,s[0].version)),S.push(...i.slice(1).map(t=>t[1].resource)),a.push(i[0][1]);a.sort((i,t)=>i.mtime-t.mtime),S.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(i=>i.resource)),await D.Promises.settled(S.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?`${new y.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase()}${m.properties.targetPlatform!=="undefined"?`-${m.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(m){const S=d.exec(m);return S&&S[1]&&S[2]?new y.ExtensionIdentifierWithVersion({id:S[1]},S[2]):null}};g=de([J(0,C.INativeEnvironmentService),J(1,h.IFileService),J(2,f.IExtensionGalleryService),J(3,p.ILogService)],g),e.ExtensionsDownloader=g}),define(te[189],ne([0,1,2,10,22,90]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(b,E){super();this.environmentService=b,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(E.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(b){b.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(te[190],ne([0,1,83,16,5,2,18,10,22,15,30,31,59,8]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends A.Disposable{constructor(g,w,m){super();this.extensionManagementService=g,this.logService=m,this.cache=this._register(new p(w,m)),this.extensionManagementService.registerParticipant({postInstall:async S=>this.postInstallExtension(S),postUninstall:async S=>this.postUninstallExtension(S)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),w=["en",...Object.keys(g)];return(0,n.distinct)(w)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const w=await this.cache.getLanguagePacks();Object.keys(w).some(m=>w[m]&&w[m].extensions.some(S=>(0,C.areSameExtensions)(S.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),m=await this.cache.update(w);return!(0,n.equals)(Object.keys(g),Object.keys(m))}};h=de([J(0,P.IExtensionManagementService),J(1,E.INativeEnvironmentService),J(2,y.ILogService)],h),e.LocalizationsService=h;let p=class extends A.Disposable{constructor(g,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(w=>{Object.keys(w).forEach(m=>delete w[m]),this.createLanguagePacksFromExtensions(w,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...w){for(const m of w)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,m);Object.keys(g).forEach(m=>this.updateHash(g[m]))}createLanguagePacksFromExtension(g,w){const m=w.identifier,S=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of S)if(w.location.scheme===T.Schemas.file&&(0,f.isValidLocalization)(l)){let r=g[l.languageId];r||(r={hash:"",extensions:[],translations:{}},g[l.languageId]=r);let a=r.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,m))[0];a?a.version=w.manifest.version:r.extensions.push({extensionIdentifier:m,version:w.manifest.version});for(const i of l.translations)r.translations[i.id]=(0,R.join)(w.location.fsPath,i.path)}}updateHash(g){if(g){const w=(0,D.createHash)("md5");for(const m of g.extensions)w.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);g.hash=w.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(w=g(m),m)).then(m=>{for(const l of Object.keys(m))m[l]||delete m[l];this.languagePacks=m,this.initializedCache=!0;const S=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",S),b.Promises.writeFile(this.languagePacksFilePath,S)}).then(()=>w,m=>this.logService.error(m))})}};p=de([J(0,E.INativeEnvironmentService),J(1,y.ILogService)],p)}),define(te[191],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,8]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(h){h.Http="http",h.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=C;function f(h,p){return p?p!==1&&h<1024:!n.isWindows&&h<1024}e.isPortPrivileged=f;let y=class{constructor(p){this.logService=p,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],d=Array.from(this._tunnels.values());for(let g of d){const w=Array.from(g.values());for(let m of w){const S=await m.value;S&&p.push(S)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:d}of p.values())await d.then(g=>g?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,d,g,w,m=!1,S=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${w}.`),!p)return;d||(d="localhost");const r=this.retainOrCreateTunnel(p,d,g,w,m,S,l);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const d=this._tunnels.get(p.tunnelRemoteHost);if(d){const g=d.get(p.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,g))}}}}async tryDisposeTunnel(p,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${d}.`);const w=g.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(d),w}}async closeTunnel(p,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${d} `);const g=this._tunnels.get(p);if(g&&g.has(d)){const w=g.get(d);w.refcount=0,await this.tryDisposeTunnel(p,d,w)}}addTunnelToMap(p,d,g){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(p,d){const g=this._tunnels.get(p);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,d){let g=[p];P(p)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):C(p)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const w=g.map(m=>this._tunnels.get(m));for(const m of w){const S=m?.get(d);if(S)return S}}canTunnel(p){return!!E(p)}createWithProvider(p,d,g,w,m,S,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${w}.`);const a={elevationRequired:m?f(w===void 0?g:w):!1},i={remoteAddress:{host:d,port:g},localAddressPort:w,privacy:S,public:S!==R.Private,protocol:l},t=p.forwardPort(i,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,g,t),t}};y=de([J(0,A.ILogService)],y),e.AbstractTunnelService=y}),define(te[192],ne([0,1,8,62,2,9,5]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let b=class Ct extends k.Disposable{constructor(P,C){super();this._tunnelService=P,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,C,f,y,h,p){const d=new R,g=await Promise.resolve(this._tunnelService.openTunnel(P,d,f,y,h,p));if(!g)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${y} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),d.dispose(),await g.dispose(),(0,A.canceled)();return d.setTunnel(g),this._tunnels.set(C,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${g.localAddress} (local) to ${f}:${y} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(P,C){const f=this._tunnels.get(P);!f||f.setAddress(C)}async destroyTunnel(P){const C=this._tunnels.get(P);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await C.dispose();return}this._disposedTunnels.add(P)}};b._lastId=0,b=de([J(0,n.ISharedTunnelsService),J(1,D.ILogService)],b),e.SharedProcessTunnelService=b}),define(te[193],ne([0,1,119,20,8]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(R,b)}async resolveProxy(R){}};A=de([J(0,n.IConfigurationService),J(1,k.ILogService)],A),e.RequestService=A}),define(te[43],ne([0,1,17,140,42,6,38]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function b(h){return h.res.statusCode===204}async function E(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return b(h)?null:(await(0,D.streamToBuffer)(h.stream)).toString()}e.asText=E;async function P(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(b(h))return null;const d=(await(0,D.streamToBuffer)(h.stream)).toString();try{return JSON.parse(d)}catch(g){throw g.message+=`:
`+d,g}}e.asJson=P;function C(h){y(h)}e.updateProxyConfigurationsScope=C;let f;function y(h){const p=T.Registry.as(k.Extensions.Configuration),d=f;f={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[f],remove:d?[d]:[]})}y(2)}),define(te[194],ne([0,1,25,18,13,43]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(b,E){this.requestService=b,this.fileService=E}async download(b,E,P=D.CancellationToken.None){if(b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(b,E);return}const C={type:"GET",url:b.toString()},f=await this.requestService.request(C,P);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const y=await(0,A.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${y}`)}}};T=de([J(0,A.IRequestService),J(1,k.IFileService)],T),e.DownloadService=T}),define(te[195],ne([0,1,16,25,67,2,19,153,13,8,27,43]),function(Y,e,D,n,k,A,T,R,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends A.Disposable{constructor(h,p,d,g){super();this.fileService=h,this.productService=p,this.requestService=d,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const p=[];for(const[d,g]of this.allConfigBasedTips)if(!(g.configScheme&&g.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,T.joinPath)(h,d)),m=new Map;(0,k.forEach)(g.recommendations,({key:l,value:r})=>{if((0,D.isNonEmptyArray)(r.remotes))for(const a of r.remotes)m.set(a,{extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else p.push({extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const S=(0,R.getDomainsOfRemotes)(w.value.toString(),[...m.keys()]);for(const l of S){const r=m.get(l);r&&p.push(r)}}catch{}return p}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(h.res.statusCode!==200)return[];const p=await(0,C.asJson)(h);return p?p.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};f=de([J(0,b.IFileService),J(1,P.IProductService),J(2,C.IRequestService),J(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(te[46],ne([0,1,17,29]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(A,T,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const P=(await T.readFile(A.serviceMachineIdResource)).value.toString();b=(0,n.isUUID)(P)?P:null}catch{b=null}if(!b){b=(0,n.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,D.VSBuffer.fromString(b))}catch{}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=k}),define(te[91],ne([0,1,70,6]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(A){return(0,D.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[196],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[197],ne([0,1,74,5,25,3,2,18,29,8,91,196]),function(Y,e,D,n,k,A,T,R,b,E,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let f=class{constructor(p){this.logService=p,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(p){const d=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${d})`);const g=(0,P.hash)(p);this.processeDisposables.has(g)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${d})`),this.doDisposeWorker(p));const w=new k.CancellationTokenSource;let m,S,l;this.processeDisposables.set(g,t=>{w.dispose(!0),m?.terminate(p,k.CancellationToken.None),S?.close(),l?.close(),this.processeDisposables.delete(g);const s=this.processResolvers.get(g);s&&(this.processResolvers.delete(g),s({reason:t}))}),m=await this.getOrCreateWebWorker(p);const r=new Promise(t=>{this.processResolvers.set(g,t)});if(w.token.isCancellationRequested)return r;const{port1:a,port2:i}=new MessageChannel;return S=a,l=i,await m.spawn(p,l,w.token),w.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${d})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",p,[S])),r}getOrCreateWebWorker(p){let d=this.workers.get(p.process.moduleId);if(!d){this.logService.trace(`SharedProcess: creating new web worker (${p.process.moduleId})`);const g=new y(p.process.type,this.logService);d=g.init(),g.onDidProcessSelfTerminate(({configuration:w,reason:m})=>{this.doDisposeWorker(w,m)}),this.workers.set(p.process.moduleId,d)}return d}async disposeWorker(p){return this.doDisposeWorker(p)}doDisposeWorker(p,d){const g=this.processeDisposables.get((0,P.hash)(p));g&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),g(d))}};f=de([J(0,E.ILogService)],f),e.SharedProcessWorkerService=f;class y extends T.Disposable{constructor(p,d){super();this.type=p,this.logService=d,this._onDidProcessSelfTerminate=this._register(new A.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const p=new n.DeferredPromise,d=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return d.onerror=g=>{this.logService.error(`SharedProcess: worker error (${this.type})`,g.message)},d.onmessageerror=g=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,g)},d.onmessage=g=>{const{id:w,message:m,configuration:S,nonce:l}=g.data;switch(w){case C.SharedProcessWorkerMessages.Ready:p.complete(d);break;case C.SharedProcessWorkerMessages.Ack:if(l){const r=this.mapMessageNonceToPendingMessageResolve.get(l);r&&(this.mapMessageNonceToPendingMessageResolve.delete(l),r())}break;case C.SharedProcessWorkerMessages.SelfTerminated:S&&m&&this._onDidProcessSelfTerminate.fire({configuration:S,reason:JSON.parse(m)});break;case C.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,m);break;case C.SharedProcessWorkerMessages.Info:m&&this.logService.info(m);break;case C.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,m);break;case C.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,m);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,g)}},d.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),p.p}async send(p,d,g){const w=await this.workerReady;if(!d.isCancellationRequested)return new Promise(m=>{const S=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(S,m);const l={...p,nonce:S};g?w.postMessage(l,[g]):w.postMessage(l),d.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(S)&&m()})})}spawn(p,d,g){const w={id:C.SharedProcessWorkerMessages.Spawn,configuration:p,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",Y).fsPath}};return this.send(w,g,d)}terminate(p,d){const g={id:C.SharedProcessWorkerMessages.Terminate,configuration:p};return this.send(g,d)}}}),define(te[198],ne([0,1,54,18,152]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}de([D.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(te[92],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[199],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((k,A)=>Y(["vsda"],k,A))}async createNewMessage(k){try{const A=await this.vsda(),T=new A.validator;if(T){const R=String(D._nextId++);return this.validators.set(R,T),{id:R,data:T.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const T=this.validators.get(k.id);if(!T)return!1;this.validators.delete(k.id);try{return T.validate(A)==="ok"}catch{return!1}}async sign(k){try{const A=await this.vsda(),T=new A.signer;if(T)return T.sign(k)}catch{}return k}}e.SignService=D,D._nextId=1}),define(te[23],ne([0,1,5,3,2,177,14,75,6]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var P;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var f;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class y extends k.Disposable{constructor(g={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,w){w===E?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:w,target:this.getKeyTargets(g)[w]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,w,m){return this.getStorage(w)?.get(g,m)}getBoolean(g,w,m){return this.getStorage(w)?.getBoolean(g,m)}getNumber(g,w,m){return this.getStorage(w)?.getNumber(g,m)}store(g,w,m,S){if((0,T.isUndefinedOrNull)(w)){this.remove(g,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,m,S),this.getStorage(m)?.set(g,w)})}remove(g,w){this.withPausedEmitters(()=>{this.updateKeyTarget(g,w,void 0),this.getStorage(w)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,w){const m=[],S=this.getKeyTargets(g);for(const l of Object.keys(S))S[l]===w&&m.push(l);return m}updateKeyTarget(g,w,m){const S=this.getKeyTargets(w);typeof m=="number"?S[g]!==m&&(S[g]=m,this.getStorage(w)?.set(E,JSON.stringify(S))):typeof S[g]=="number"&&(delete S[g],this.getStorage(w)?.set(E,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const w=this.get(E,g);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this._onWillSaveState.fire({reason:g});const w=this.getStorage(0),m=this.getStorage(1);switch(g){case P.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return p(g,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends y{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=h;async function p(d,g,w,m){const S=o=>{try{return JSON.parse(o)}catch{return o}},l=new Map,r=new Map;d.forEach((o,c)=>{l.set(c,o),r.set(c,S(o))});const a=new Map,i=new Map;g.forEach((o,c)=>{a.set(c,o),i.set(c,S(o))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((o,c)=>{t.push({key:c,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${m})`);let s=[];a.forEach((o,c)=>{s.push({key:c,value:o})}),console.table(s),console.groupEnd(),console.log(i)}e.logStorage=p}),define(te[200],ne([0,1,3,2,14,30,31,23]),function(Y,e,D,n,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends n.Disposable{constructor(C,f){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(C)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(f.onDidInstallExtensions(y=>y.forEach(({local:h,operation:p})=>{h&&p===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(y=>!(0,T.areSameExtensions)(y,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let y=0;y<f.length;y++){const h=f[y];if((0,T.areSameExtensions)(h,C))return f.splice(y,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};b=de([J(0,R.IStorageService),J(1,A.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class E extends n.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let y;return f===0?((0,k.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),y=this.storage[C]):y=this._get(C,f),JSON.parse(y)}set(C,f,y){let h=JSON.stringify(f.map(({id:d,uuid:g})=>({id:d,uuid:g})));this._get(C,y)!==h&&(y===0&&(f.length?this.storage[C]=h:delete this.storage[C]),this._set(C,f.length?h:void 0,y))}onDidStorageChange(C){if(C.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const y=this.get(C.key,C.scope);delete this.storage[C.key];const h=this.get(C.key,C.scope),p=y.filter(g=>!h.some(w=>(0,T.areSameExtensions)(g,w))),d=h.filter(g=>!y.some(w=>(0,T.areSameExtensions)(w,g)));(p.length||d.length)&&this._onDidChange.fire([...p,...d])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,y){f?this.storageService.store(C,f,y,1):this.storageService.remove(C,y)}}e.StorageManager=E}),define(te[63],ne([0,1,6,3,2,23,31,27,16,8,14]),function(Y,e,D,n,k,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class nt extends k.Disposable{constructor(h,p,d){super();this.storageService=h,this.productService=p,this.logService=d,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(g=>this.onDidChangeStorageValue(g)))}static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const p=C.exec(h);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const h=this.storageService.keys(0,1);for(const p of h){const d=nt.fromKey(p);d&&this.extensionsWithKeysForSync.add(d.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const p=nt.fromKey(h.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(h){if((0,P.isString)(h))return h;const p=h.manifest?h.manifest.publisher:h.publisher,d=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(p,d)}getExtensionState(h,p){const d=this.getExtensionId(h),g=this.storageService.get(d,p?0:1);if(g)try{return JSON.parse(g)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${p}): ${w}`)}}setExtensionState(h,p,d){const g=this.getExtensionId(h);p===void 0?this.storageService.remove(g,d?0:1):this.storageService.store(g,JSON.stringify(p),d?0:1,1)}setKeysForSync(h,p){this.storageService.store(nt.toKey(h),JSON.stringify(p),0,1)}getKeysForSync(h){const p=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],d=this.storageService.get(nt.toKey(h),0),g=d?JSON.parse(d):void 0;return g&&p?(0,b.distinct)([...g,...p]):g||p}addToMigrationList(h,p){if(h!==p){const d=this.migrationList.filter(g=>!g.includes(h)&&!g.includes(p));d.push([h,p]),this.migrationList=d}}getSourceExtensionToMigrate(h){const p=this.migrationList.find(([,d])=>h===d);return p?p[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const p=JSON.parse(h);if((0,P.isArray)(p))return p}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=de([J(0,A.IStorageService),J(1,R.IProductService),J(2,E.ILogService)],f),e.ExtensionStorageService=f}),define(te[201],ne([0,1,2,30,63,187,8]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(E,P,C,f,y){super();E.removeDeprecatedExtensions(),(0,A.migrateUnsupportedExtensions)(E,P,C,f,y)}};R=de([J(0,n.IExtensionManagementService),J(1,n.IExtensionGalleryService),J(2,k.IExtensionStorageService),J(3,n.IGlobalExtensionEnablementService),J(4,T.ILogService)],R),e.ExtensionsCleaner=R}),define(te[202],ne([0,1,3,2]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P}async getItems(){const E={workspace:this.workspace},P=await this.channel.call("getItems",E);return new Map(P)}updateItems(E){const P={workspace:this.workspace};return E.insert&&(P.insert=Array.from(E.insert.entries())),E.delete&&(P.delete=Array.from(E.delete.values())),this.channel.call("updateItems",P)}}class A extends k{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class T extends k{constructor(E,P){super(E,P);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[203],ne([0,1,5,2,19,75,23,202]),function(Y,e,D,n,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends T.AbstractStorageService{constructor(P,C,f){super();this.mainProcessService=C,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new A.Storage(P.globalStorage);return this._register(C.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),C}createWorkspaceStorage(P){const C=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(C.workspaceStorage){const f=new A.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const C=this.workspaceStorage,f=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[y,h]of f)this.workspaceStorage.set(y,h)}}e.NativeStorageService=b}),define(te[204],ne([0,1,4,32,7,29]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,P,C,f,y,h,p,d,g,w){const m=Object.create(null);m["common.machineId"]=p,m.sessionID=(0,A.generateUuid)()+Date.now(),m.commitHash=y,m.version=h,m["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,D.PlatformToString)(D.platform),m["common.nodePlatform"]=n.platform,m["common.nodeArch"]=f,m["common.product"]=w||"desktop";const S=b(d||[]);S&&(m["common.msftInternal"]=S);let l=0;const r=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(m["common.snap"]="true");const a=T(C);a&&(m["common.platformDetail"]=a);try{const i=await E.readFile(k.URI.file(g));m["common.source"]=i.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=R;function b(E){const P=n.env.USERDNSDOMAIN;if(!P)return!1;const C=P.toLowerCase();return E.some(f=>C===f)}e.verifyMicrosoftInternalDomain=b}),define(te[21],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[205],ne([0,1,33,55,5,35,18,10,4,7,113,22,116,80,13,27,21]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(r,a){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=D.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:O=>/^[a-z]:\\(my drive|shared drives)\\/.test(O)||O.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:O=>O.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"\\onedrive")},{tag:"box",matcher:O=>O.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:O=>O.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:O=>O.startsWith("/volumes/googledrive/")||O.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:O=>O.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"/onedrive")||O.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:O=>O.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:O=>O.startsWith(s+"/box/")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:O=>O.startsWith(s+"/owncloud/")}];break}const o=new Map,c=new Map,u=2e4;function v(O,N,$,L){for(const j of t){const M=O.toLowerCase();j.matcher(M)&&c.set(j.tag,1)}const U=N.substring(O.length+1);return k.Promises.withAsyncBody(async j=>{let M;try{M=await C.Promises.readdir(N,{withFileTypes:!0})}catch{j();return}if(L.count>=u){L.count+=M.length,L.maxReached=!0,j();return}let G=M.length;if(G===0){j();return}let K=M;L.count+M.length>u&&(L.maxReached=!0,G=u-L.count,K=M.slice(0,G)),L.count+=M.length;for(const x of K)if(x.isDirectory()){if($.includes(x.name)||await v(O,(0,R.join)(N,x.name),$,L),--G==0){j();return}}else{const q=x.name.lastIndexOf(".");if(q>=0){const X=x.name.substring(q+1);X&&o.set(X,(o.get(X)??0)+1)}for(const X of i)X.relativePathPattern?.test(U)!==!1&&X.filePattern.test(x.name)&&c.set(X.tag,(c.get(X.tag)??0)+1);if(--G==0){j();return}}})}const I={count:0,maxReached:!1};await v(r,r,a,I);const _=await S(r);return{configFiles:w(c),fileTypes:w(o),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:_}}e.collectWorkspaceStats=g;function w(r){return[...n.Iterable.map(r.entries(),([a,i])=>({name:a,count:i}))].sort((a,i)=>i.count-a.count)}function m(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=m;async function S(r){try{const a=new Map,i=(0,R.join)(r,".vscode","launch.json"),t=await C.Promises.readFile(i),s=[],o=(0,A.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,A.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const u=c.type;u&&(a.has(u)?a.set(u,a.get(u)+1):a.set(u,1))}return w(a)}catch{return[]}}e.collectLaunchConfigs=S;let l=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||i.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,f.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,c=this.formatProcessList(a,s);return i.forEach(u=>{if((0,y.isRemoteDiagnosticError)(u))c+=`
${u.errorMessage}`,o+=`
${u.errorMessage}`;else if(c+=`

Remote: ${u.hostName}`,u.processes&&(c+=`
${this.formatProcessList(a,u.processes)}`),u.workspaceMetadata){o+=`
|  Remote: ${u.hostName}`;for(const v of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[v];let _=`${I.fileCount} files`;I.maxFilesReached&&(_=`more than ${_}`),o+=`|    Folder (${v}): ${_}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:t,vmHint:s,os:o,cpus:c}=m(),u={os:o,memory:t,cpus:c,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return b.isWindows||(u.load=`${D.loadavg().map(v=>Math.round(v)).join(", ")}`),b.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(a,i){const t=[];return(0,f.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),i.forEach(o=>{if((0,y.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const u=o.workspaceMetadata[c];let v=`${u.fileCount} files`;u.maxFilesReached&&(v=`more than ${v}`),t.push(`Folder (${c}): ${v}`),t.push(this.formatWorkspaceStats(u))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const i=[],t=60;let s=0;const o=(I,_)=>{const O=` ${I}(${_})`;s+O.length>t?(i.push(c),c="|                 ",s=c.length):s+=O.length,c+=O};let c="|      File types:";const u=10;let v=a.fileTypes.length>u?u:a.fileTypes.length;for(let I=0;I<v;I++){const _=a.fileTypes[I];o(_.name,_.count)}if(i.push(c),a.configFiles.length>=0&&(c="|      Conf files:",s=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),i.push(c)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(_=>{I+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),i.push(I)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=E.URI.revive(o);if(c.scheme===T.Schemas.file){const u=c.fsPath;t.push(g(u,["node_modules",".git"]).then(v=>{let I=`${v.fileCount} files`;v.maxFilesReached&&(I=`more than ${I}`),i.push(`|    Folder (${(0,R.basename)(u)}): ${I}`),i.push(this.formatWorkspaceStats(v))}).catch(v=>{i.push(`|      Error: Unable to collect workspace stats for folder ${u} (${v.toString()})`)}))}else i.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,i){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,t,s,i,0),s.join(`
`)}formatProcessItem(a,i,t,s,o){const c=o===0;let u;c?u=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(u=`${u} (${i.get(s.pid)})`));const v=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(v/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(s.children)&&s.children.forEach(I=>this.formatProcessItem(a,i,t,I,o+1))}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const t=E.URI.revive(i);if(t.scheme!==T.Schemas.file)continue;const s=t.fsPath;try{const o=await g(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};l=de([J(0,d.ITelemetryService),J(1,p.IProductService)],l),e.DiagnosticsService=l}),define(te[206],ne([0,1,16,5,25,9,3,2,4,14,7,129,30,31,8,27,21]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends R.Disposable{constructor(a,i,t,s){super();this.galleryService=a,this.telemetryService=i,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const i=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,a.allTargetPlatforms,i))}async installFromGallery(a,i={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(C.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw S(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),m(t)}}async uninstall(a,i={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,i)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const i=await this.findGalleryExtension(a);if(!i)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,i,t){if(!P.URI.isUri(i)){let v=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(v)return this.logService.info("Extensions is already requested to install",i.identifier.id),v.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],c=this.createInstallExtensionTask(a,i,t);P.URI.isUri(i)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:i}),this.logService.info("Installing extension:",c.identifier.id),s.push({task:c,manifest:a});let u=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:_,manifest:O}of I)if(u=u||!!O.extensionDependencies?.some(N=>(0,y.areSameExtensions)({id:N},c.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const N=this.createInstallExtensionTask(O,_,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(N.identifier,O.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:_}),this.logService.info("Installing extension:",N.identifier.id),s.push({task:N,manifest:O})}}catch(I){if(P.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,I.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),I}const v=s.reduce((I,{task:_,manifest:O})=>(I.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),I),new Map);for(;v.size;){let I;const _=[...v.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(N=>v.has(N.toLowerCase())));_.length?I=v.size===1?_:_.filter(({task:O})=>!(O===c&&!u)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),I=[...v.values()]),await this.joinAllSettled(I.map(async({task:O})=>{const N=new Date().getTime(),$=(0,E.isUndefined)(t.operation)?O.operation:t.operation;try{const L=await O.run();if(await this.joinAllSettled(this.participants.map(U=>U.postInstall(L,O.source,t,k.CancellationToken.None))),!P.URI.isUri(O.source)&&(S(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,void 0),b.isWeb&&$!==3))try{await this.galleryService.reportStatistic(L.manifest.publisher,L.manifest.name,L.manifest.version,"install")}catch{}o.push({local:L,identifier:O.identifier,operation:$,source:O.source})}catch(L){throw P.URI.isUri(O.source)||S(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,L),this.logService.error("Error while installing the extension:",O.identifier.id),L}finally{v.delete(O.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,y.areSameExtensions)(I,c.identifier))[0].local}catch(v){if(s.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<I.length;_++){const O=I[_],{identifier:N}=o[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,A.getErrorMessage)(O.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(I),o.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),v}finally{for(const{task:v,manifest:I}of s)if(!P.URI.isUri(v.source)){const _=new y.ExtensionIdentifierWithVersion(v.identifier,I.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(a){const i=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?i.push(o.value):t.push(o.reason);if(t.length)throw w(t);return i}async getAllDepsAndPackExtensionsToInstall(a,i,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const c=[a,...o.map(I=>I.identifier)],u=[],v=async(I,_)=>{const O=_.extensionDependencies||[],N=[...O];if(_.extensionPack){const $=t?o.find(L=>(0,y.areSameExtensions)(L.identifier,I)):void 0;for(const L of _.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(U=>(0,y.areSameExtensions)({id:U},{id:L}))||N.every(U=>!(0,y.areSameExtensions)({id:U},{id:L}))&&N.push(L)}if(N.length){const $=[...c,...u.map(U=>U.gallery.identifier)],L=N.filter(U=>$.every(j=>!(0,y.areSameExtensions)(j,{id:U})));if(L.length){const U=await this.galleryService.query({names:L,pageSize:N.length},k.CancellationToken.None);for(const j of U.firstPage){if($.find(K=>(0,y.areSameExtensions)(K,j.identifier)))continue;const M=O.some(K=>(0,y.areSameExtensions)({id:K},j.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(j,!0,s)}catch(K){if(K instanceof f.ExtensionManagementError&&K.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!M){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw K}u.push({gallery:G.extension,manifest:G.manifest}),await v(G.extension.identifier,_)}}}};return await v(a,i),o=await this.getInstalled(),u.filter(I=>!o.some(_=>(0,y.areSameExtensions)(_.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,i,t){const s=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new f.ExtensionManagementError(C.localize(3,null,a.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new f.ExtensionManagementError(C.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const u=await this.getTargetPlatform();throw new f.ExtensionManagementError(C.localize(5,null,a.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(u)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,i,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(C.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new f.ExtensionManagementError(C.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const c=await this.galleryService.getManifest(o,k.CancellationToken.None);if(c===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new f.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(a,i,t){const s=await this.getTargetPlatform();let o=null;return i&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&i&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,i){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(v,I)=>{const _=this.createUninstallExtensionTask(v,I);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",v.identifier.id),this._onUninstallExtension.fire(v.identifier),_},o=(v,I)=>{I?this.logService.error("Failed to uninstall extension:",v.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",v.identifier.id),S(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(v),void 0,I),this._onDidUninstallExtension.fire({identifier:v.identifier,error:I?.code})},c=[],u=[];try{c.push(s(a,{}));const v=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,v);for(const _ of I)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):c.push(s(_,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(I=>I.extension),v,a),await this.joinAllSettled(c.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(I.extension,i,k.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(_){const O=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,A.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw o(I.extension,O),O}finally{u.push(I)}}))}catch(v){const I=v instanceof f.ExtensionManagementError?v:new f.ExtensionManagementError((0,A.getErrorMessage)(v),f.ExtensionManagementErrorCode.Internal);for(const _ of c){try{_.cancel()}catch{}u.includes(_)||o(_.extension,I)}throw I}finally{for(const v of c)this.uninstallingExtensions.delete(v.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",v.extension.identifier.id)}}checkForDependents(a,i,t){for(const s of a){const o=this.getDependents(s,i);if(o.length){const c=o.filter(u=>!a.some(v=>(0,y.areSameExtensions)(v.identifier,u.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(s,c,t))}}}getDependentsErrorMessage(a,i,t){return t===a?i.length===1?C.localize(8,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?C.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(a,i,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=i.filter(u=>!u.isBuiltin&&s.some(v=>(0,y.areSameExtensions)({id:v},u.identifier))),c=[];for(const u of o)c.push(...this.getAllPackExtensionsToUninstall(u,i,t));return[...o,...c]}return[]}getDependents(a,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,y.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const i=await this.findGalleryExtensionById(a.identifier.uuid);return i||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},k.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},k.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};g=de([J(0,f.IExtensionGalleryService),J(1,d.ITelemetryService),J(2,h.ILogService),J(3,p.IProductService)],g),e.AbstractExtensionManagementService=g;function w(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function m(r){if(r instanceof f.ExtensionManagementError)return r;const a=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function S(r,a,i,t,s){const o=s?s instanceof f.ExtensionManagementError?s.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...i,success:!s,duration:t,errorcode:o})}e.reportTelemetry=S;class l{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>new Promise((i,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,A.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(te[207],ne([0,1,16,5,67,3,10,4,32,7,131,15,30,195,82,13,8,60,27,43,23,21]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let i=class extends y.ExtensionTipsService{constructor(s,o,c,u,v,I,_,O,N,$){super(_,O,N,$);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=c,this.storageService=u,this.nativeHostService=v,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,k.forEach)(O.exeBasedExtensionTips,({key:L,value:U})=>{const j=[],M=[],G=[];(0,k.forEach)(U.recommendations,({key:K,value:x})=>{x.important?U.important?j.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):M.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):G.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),j.length&&this.highImportanceExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:j}),M.length&&this.mediumImportanceExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:M}),G.length&&this.allOtherExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:G})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,c)}groupImportantTipsByExe(s,o){const c=new Map;s.forEach(O=>c.set(O.extensionId.toLowerCase(),O));const{installed:u,uninstalled:v}=this.groupByInstalled([...c.keys()],o);for(const O of u){const N=c.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of v){const N=c.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const I=this.getPromptedExecutableTips(),_=new Map;for(const O of v){const N=c.get(O);if(N&&(!I[N.exeName]||!I[N.exeName].includes(N.extensionId))){let $=_.get(N.exeName);$||($=[],_.set(N.exeName,$)),$.push(N)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const u=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(u(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const u=this._register((0,n.disposableTimeout)(()=>{u.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,c=7*24*60*60*1e3;if(o<c){const I=this._register((0,n.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},c-o));return}const[u,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(I=>{switch(I){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(u),this.addToRecommendedExecutables(v[0].exeName,v);const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(u),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(s){const o=s.map(({extensionId:u})=>u.toLowerCase()),c=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,c,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const c=this.getPromptedExecutableTips();c[s]=o.map(({extensionId:u})=>u.toLowerCase()),this.storageService.store(r,JSON.stringify(c),0,0)}groupByInstalled(s,o){const c=[],u=[],v=o.reduce((I,_)=>(I.add(_.identifier.id.toLowerCase()),I),new Set);return s.forEach(I=>{v.has(I.toLowerCase())?c.push(I):u.push(I)}),{installed:c,uninstalled:u}}async getValidExecutableBasedExtensionTips(s){const o=[],c=new Map;for(const u of s.keys()){const v=s.get(u);if(!v||!(0,D.isNonEmptyArray)(v.recommendations))continue;const I=[];R.isWindows?v.windowsPath&&I.push(v.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(I.push((0,T.join)("/usr/local/bin",u)),I.push((0,T.join)("/usr/bin",u)),I.push((0,T.join)(this.environmentService.userHome.fsPath,u)));for(const _ of I){let O=c.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),c.set(_,O)),O)for(const{extensionId:N,extensionName:$,isExtensionPack:L}of v.recommendations)o.push({extensionId:N,extensionName:$,isExtensionPack:L,exeName:u,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return o}};i=de([J(0,C.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,f.IExtensionManagementService),J(3,S.IStorageService),J(4,g.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,p.IFileService),J(7,w.IProductService),J(8,m.IRequestService),J(9,d.ILogService)],i),e.ExtensionTipsService=i}),define(te[93],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(A){this.appenders=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:R,data:b}){return this.appenders.forEach(E=>E.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(A){this.channel=A}log(A,T){return this.channel.call("log",{eventName:A,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(te[44],ne([0,1,28,14,20,21]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,w){return Promise.resolve(void 0)}publicLog2(g,w){return this.publicLog(g,w)}publicLogError(g,w){return Promise.resolve(void 0)}publicLogError2(g,w){return this.publicLogError(g,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class R{async publicLog(g,w,m){}async publicLogError(g,w,m){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(d,g){return g.onDidChangeConfiguration(w=>{w.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=b;function E(d,g){return!(g.disableTelemetry||!d.enableTelemetry||g.extensionTestsLocationURI)}e.supportsTelemetry=E;function P(d){const g=d.getValue(A.TELEMETRY_SETTING_ID),w=d.getValue("telemetry.enableCrashReporter");if(d.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function C(d){const g=Object.create(null),w=Object.create(null),m=Object.create(null);y(d,m);for(let S in m){S=S.length>150?S.substr(S.length-149):S;const l=m[S];typeof l=="number"?w[S]=l:typeof l=="boolean"?w[S]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${l.length}`),g[S]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(g[S]=l)}return{properties:g,measurements:w}}e.validateTelemetryData=C;function f(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(m=>{d.indexOf(`${m}+`)===0&&(g=m)}),g}e.cleanRemoteAuthority=f;function y(d,g,w=0,m){if(!!d)for(let S of Object.getOwnPropertyNames(d)){const l=d[S],r=m?m+S:S;Array.isArray(l)?g[r]=(0,D.safeStringify)(l):l instanceof Date?g[r]=l.toISOString():(0,n.isObject)(l)?w<2?y(l,g,w+1,r+"."):g[r]=(0,D.safeStringify)(l):g[r]=l}}function h(d){if(!d)return[];const g=[];return p(g,"",d),g}function p(d,g,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(m=>p(d,g?`${g}.${m}`:m,w[m])):d.push(g)}}),define(te[208],ne([0,1,44,149]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class k{constructor(){}setSharedProperty(b,E){}postEvent(b,E){}}class A{constructor(b,E,P,C,f){this.getMachineId=b,this.configurationService=E,this.productService=P,this.telemetry=C,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const y=this.configurationService.getValue("experiments.overrideDelay"),h=typeof y=="number"?y:0;this.overrideInitDelay=new Promise(p=>setTimeout(p,h))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+b);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let P;const C=await this.tasClient;return this.networkInitialized?P=C.getTreatmentVariable("vscode",b):P=await C.getTreatmentVariableAsync("vscode",b,!0),P=C.getTreatmentVariable("vscode",b),P}async setupTASClient(){const b=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,E=await this.getMachineId(),P=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,b),C=this.productService.tasConfig,f=new(await new Promise((y,h)=>{Y(["tas-client-umd"],y,h)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=A;class T extends A{constructor(b,E,P){super(()=>Promise.resolve(b),E,P,new k)}}e.AssignmentService=T}),define(te[209],ne([0,1,16,25,9,28,4,32,14,7,20,15,30,31,78,13,8,27,43,46,23,21,44]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=T.isWeb?"web":(0,f.getTargetPlatform)(T.platform,R.arch);var i;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished"})(i||(i={}));function t(...z){return String(z.reduce((B,ie)=>B|ie,0))}var s;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},v={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class I{constructor(B=v){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,ie=this.state.pageSize){return new I({...this.state,pageNumber:B,pageSize:ie})}withFilter(B,...ie){const se=[...this.state.criteria,...ie.length?ie.map(ce=>({filterType:B,value:ce})):[{filterType:B}]];return new I({...this.state,criteria:se})}withSortBy(B){return new I({...this.state,sortBy:B})}withSortOrder(B){return new I({...this.state,sortOrder:B})}withFlags(...B){return new I({...this.state,flags:B.reduce((ie,se)=>ie|se,0)})}withAssetTypes(...B){return new I({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:ie,pageSize:se,sortBy:ce,sortOrder:he,flags:ge,assetTypes:me}=this.state;return{filters:[{criteria:B,pageNumber:ie,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:me,flags:ge}}get searchText(){const B=this.state.criteria.filter(ie=>ie.filterType===s.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function _(z,B){const ie=(z||[]).filter(se=>se.statisticName===B)[0];return ie?ie.value:0}function O(z){const B="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(se=>se.assetType.indexOf(B)===0).reduce((se,ce)=>{const he=U(z,ce.assetType);return he&&se.push([ce.assetType.substring(B.length),he]),se},[])}function N(z){if(z.properties){const B=z.properties.filter(ce=>ce.key===o.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=B.filter(ce=>ie.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return U(z,o.Repository)}function $(z){return{uri:`${z.fallbackAssetUri}/${o.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${o.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function L(z){const B=U(z,o.Icon);if(B)return B;const ie=f.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function U(z,B){return z.files.filter(se=>se.assetType===B)[0]?{uri:`${z.assetUri}/${B}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${B}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function j(z,B){const ie=z.properties?z.properties.filter(ce=>ce.key===B):[],se=ie.length>0&&ie[0].value;return se?se.split(",").map(ce=>(0,y.adoptToGalleryExtensionId)(ce)):[]}function M(z){const B=z.properties?z.properties.filter(ie=>ie.key===c.Engine):[];return B.length>0&&B[0].value||""}function G(z){const B=z.properties?z.properties.filter(ie=>ie.key===c.PreRelease):[];return B.length>0&&B[0].value==="true"}function K(z){const B=z.properties?z.properties.filter(se=>se.key===c.LocalizedLanguages):[],ie=B.length>0&&B[0].value||"";return ie?ie.split(","):[]}function x(z){return z.indexOf("preview")!==-1}function q(z){return z.targetPlatform?(0,f.toTargetPlatform)(z.targetPlatform):"undefined"}function X(z){const B=(0,D.distinct)(z.versions.map(q)),ie=!!z.tags?.includes(f.WEB_EXTENSION_TAG),se=B.indexOf("web");return ie?se===-1&&B.push("web"):se!==-1&&B.splice(se,1),B}function H(z,B){const ie=(0,f.getFallbackTargetPlarforms)(B);for(let se=0;se<z.length;se++){const ce=z[se];if(ce.version===z[se-1]?.version){let he=se;const ge=q(ce);if(ge===B)for(;he>0&&z[he-1].version===ce.version;)he--;else if(ie.includes(ge))for(;he>0&&z[he-1].version===ce.version&&q(z[he-1])!==B;)he--;he!==se&&(z.splice(se,1),z.splice(he,0,ce))}}return z}e.sortExtensionVersions=H;function Z(z,B,ie,se,ce){const he=z.versions[0],ge={manifest:U(B,o.Manifest),readme:U(B,o.Details),changelog:U(B,o.Changelog),license:U(B,o.License),repository:N(B),download:$(B),icon:L(B),coreTranslations:O(B)};return{identifier:{id:(0,y.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:B.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:_(z.statistics,"install"),rating:_(z.statistics,"averagerating"),ratingCount:_(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:ie,assets:ge,properties:{dependencies:j(B,c.Dependency),extensionPack:j(B,c.ExtensionPack),engine:M(B),localizedLanguages:K(B),targetPlatform:q(B),isPreReleaseVersion:G(B)},hasPreReleaseVersion:G(he),hasReleaseVersion:se,preview:x(z.flags),telemetryData:ce}}let ee=class{constructor(B,ie,se,ce,he,ge,me,ye){this.requestService=ie,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=ge,this.productService=me,this.configurationService=ye;const Se=me.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=V(me.version,me,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,ie,se){const ce=(0,b.isBoolean)(ie)?ie:!1,he=(0,b.isBoolean)(ie)?se:ie;let ge=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,B.length).withFilter(s.ExtensionName,...B.map(({id:Se})=>Se.toLowerCase()));B.every(Se=>!Se.version)&&(ge=ge.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:me}=await this.queryGallery(ge,a,n.CancellationToken.None),ye=me.map(Se=>{const Ie=(0,y.getGalleryExtensionId)(Se.publisher.publisherName,Se.extensionName);return{rawGalleryExtension:Se,version:B.find(Ee=>(0,y.areSameExtensions)(Ee,{id:Ie}))?.version,preRelease:ce}});return this.converToGalleryExtensions(ye,ge,a,()=>{},he)}async getExtensions2(B){const ie=[],se=[];for(const me of B)me.uuid?se.push(me.uuid):ie.push(me.id.toLowerCase());let ce=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly).withPage(1,B.length);se.length&&(ce=ce.withFilter(s.ExtensionId,...se)),ie.length&&(ce=ce.withFilter(s.ExtensionId,...ie));const{galleryExtensions:he}=await this.queryGallery(ce,a,n.CancellationToken.None),ge=he.map(me=>{const ye=(0,y.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName),Se=B.find(Ie=>(0,y.areSameExtensions)(Ie,{id:ye,uuid:me.extensionId}));return{rawGalleryExtension:me,preRelease:!!Se?.preRelease}});return this.converToGalleryExtensions(ge,ce,a,()=>{},n.CancellationToken.None)}async getCompatibleExtension(B,ie,se){const ce=(0,f.isIExtensionIdentifier)(B)?null:B;if(ce){if((0,f.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(ce,ie,se))return ce}const{id:he,uuid:ge}=ce?ce.identifier:B;let me=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);ge?me=me.withFilter(s.ExtensionId,ge):me=me.withFilter(s.ExtensionName,he);const{galleryExtensions:ye}=await this.queryGallery(me,se,n.CancellationToken.None),[Se]=ye;if(!Se||!Se.versions.length)return null;const Ie=X(Se);if((0,f.isNotWebExtensionInWebTargetPlatform)(Ie,se))return null;for(let Ee of Se.versions){if(!M(Ee)){const De=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:c.Engine,value:De}]}}if(await this.isRawExtensionVersionCompatible(Ee,ie,Ie,se)){const De=Se.versions.some(Fe=>!G(Fe));return Z(Se,Ee,Ie,De)}}return null}async isExtensionCompatible(B,ie,se){if(!(0,f.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,se)||!ie&&B.properties.isPreReleaseVersion)return!1;let ce=B.properties.engine;if(!ce){const he=await this.getManifest(B,n.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,h.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(B,ie,se,ce){if(!(0,f.isTargetPlatformCompatible)(q(B),se,ce)||!ie&&G(B))return!1;const he=await this.getEngine(B);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(B,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=B.text||"";const ce=(0,A.getOrDefault)(B,Ee=>Ee.pageSize,50);let he=new I().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ce);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,Fe)=>(he=he.withFilter(s.Category,Fe||De),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,Fe)=>(he=he.withFilter(s.Tag,Fe||De),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(s.SearchText,se)),he=he.withSortBy(0)):B.ids?he=he.withFilter(s.ExtensionId,...B.ids):B.names?he=he.withFilter(s.ExtensionName,...B.names):he=he.withSortBy(4),typeof B.sortBy=="number"&&(he=he.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(he=he.withSortOrder(B.sortOrder));const{galleryExtensions:ge,total:me}=await this.queryGallery(he,a,ie),ye=Ee=>({index:(he.pageNumber-1)*he.pageSize+Ee,querySource:B.source}),Se=await this.converToGalleryExtensions(ge.map(Ee=>({rawGalleryExtension:Ee,preRelease:!!B.includePreRelease})),he,a,ye,ie),Ie=async(Ee,De)=>{if(De.isCancellationRequested)throw(0,k.canceled)();const Fe=he.withPage(Ee+1),{galleryExtensions:Ue}=await this.queryGallery(Fe,a,De);return await this.converToGalleryExtensions(Ue.map(Ne=>({rawGalleryExtension:Ne,preRelease:!!B.includePreRelease})),Fe,a,ye,ie)};return{firstPage:Se,total:me,pageSize:he.pageSize,getPage:Ie}}async converToGalleryExtensions(B,ie,se,ce,he){const ge=(Se,Ie,Ee,De,Fe)=>{const Ue=!(Ee.flags&i.IncludeLatestVersionOnly),Ne=X(Se);let ze=Se.versions[0];return ze=Se.versions.find(re=>re.version===ze.version&&(0,f.isTargetPlatformCompatible)(q(re),Ne,se))||ze,Ue&&G(ze)&&!Fe&&(ze=Se.versions.find(re=>re.version!==ze.version&&!G(re))||ze),Z(Se,ze,Ne,De,ce(Ie))},me=[],ye=new Map;for(let Se=0;Se<B.length;Se++){const{rawGalleryExtension:Ie,version:Ee,preRelease:De}=B[Se],Fe=Ie.versions.some(Ue=>!G(Ue));if(Ee){const Ue=Ie.versions.find(Ne=>Ne.version===Ee);Ue&&me.push([Se,Z(Ie,Ue,X(Ie),Fe)])}else{const Ue=ge(Ie,Se,ie,Fe,De);Ue.properties.isPreReleaseVersion?ye.set(Ue.identifier.uuid,{index:Se,preRelease:De}):me.push([Se,Ue])}}if(ye.size){const Se=new Date().getTime(),Ie=new I().withFlags(i.IncludeVersions,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ye.size).withFilter(s.ExtensionId,...ye.keys()),{galleryExtensions:Ee}=await this.queryGallery(Ie,se,he);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-Se,count:ye.size}),Ee.length!==ye.size)throw new Error("Not all extensions with latest versions are returned");for(const De of Ee){const Fe=De.versions.some(re=>!G(re)),{index:Ue,preRelease:Ne}=ye.get(De.extensionId),ze=ge(De,Ue,Ie,Fe,Ne);me.push([Ue,ze])}}return me.sort((Se,Ie)=>Se[0]-Ie[0]).map(([,Se])=>Se)}async queryGallery(B,ie,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,t(i.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(B.raw),ge={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},me=new Date().getTime();let ye,Se,Ie=0;try{if(ye=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:ge},se),ye.res.statusCode&&ye.res.statusCode>=400&&ye.res.statusCode<500)return{galleryExtensions:[],total:Ie};const Ee=await(0,w.asJson)(ye);if(Ee){const De=Ee.results[0],Fe=De.extensions;Fe.forEach(Ne=>H(Ne.versions,ie));const Ue=De.resultMetadata&&De.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ie=Ue&&Ue.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Fe,total:Ie}}return{galleryExtensions:[],total:Ie}}catch(Ee){throw Se=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-me,success:!!ye&&(0,w.isSuccess)(ye),responseBodySize:ye?.res.headers["Content-Length"],statusCode:ye?String(ye.res.statusCode):void 0,errorCode:Se?(0,k.isCancellationError)(Se)?"canceled":(0,k.getErrorMessage)(Se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ie)})}}async reportStatistic(B,ie,se,ce){if(!this.isEnabled())return;const he=T.isWeb?this.api(`/itemName/${B}.${ie}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${ie}/${se}/stats?statType=${ce}`),ge=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ye={...await this.commonHeadersPromise,Accept:ge};try{await this.requestService.request({type:"POST",url:he,headers:ye},n.CancellationToken.None)}catch{}}async download(B,ie,se){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ce=(0,y.getGalleryExtensionTelemetryData)(B),he=new Date().getTime(),ge=Ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ie}),me=se===2?"install":se===3?"update":"",ye=me?{uri:`${B.assets.download.uri}${E.URI.parse(B.assets.download.uri).query?"&":"?"}${me}=true`,fallbackUri:`${B.assets.download.fallbackUri}${E.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${me}=true`}:B.assets.download,Se=await this.getAsset(ye);await this.fileService.writeFile(ie,Se.stream),ge(new Date().getTime()-he)}async getReadme(B,ie){if(B.assets.readme){const se=await this.getAsset(B.assets.readme,{},ie);return await(0,w.asText)(se)||""}return""}async getManifest(B,ie){if(B.assets.manifest){const se=await this.getAsset(B.assets.manifest,{},ie),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(B,ie){const se=U(B,o.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(B,ie){const se=B.assets.coreTranslations.filter(ce=>ce[0]===ie.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(B,ie){if(B.assets.changelog){const se=await this.getAsset(B.assets.changelog,{},ie);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(B,ie,se){let ce=new I().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?ce=ce.withFilter(s.ExtensionId,B.identifier.uuid):ce=ce.withFilter(s.ExtensionName,B.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,se,n.CancellationToken.None);if(!he.length)return[];const ge=X(he[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(ge,se))return[];const me=[];for(const ye of he[0].versions)try{me[me.length-1]?.version!==ye.version&&await this.isRawExtensionVersionCompatible(ye,ie,ge,se)&&me.push({version:ye.version,date:ye.lastUpdated,isPreReleaseVersion:G(ye)})}catch{}return me}async getAsset(B,ie={},se=n.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},ge={...ce,...ie.headers||{}};ie={...ie,...he,headers:ge};const me=B.uri,ye=B.fallbackUri,Se={...ie,url:me};try{const Ie=await this.requestService.request(Se,se);if(Ie.res.statusCode===200)return Ie;const Ee=await(0,w.asText)(Ie);throw new Error(`Expected 200, got back ${Ie.res.statusCode} instead.

${Ee}`)}catch(Ie){if((0,k.isCancellationError)(Ie))throw Ie;const Ee=(0,k.getErrorMessage)(Ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:me,message:Ee});const De={...ie,url:ye};return this.requestService.request(De,se)}}async getEngine(B){let ie=M(B);if(!ie){const se=await this.getManifestFromRawExtensionVersion(B,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");ie=se.engines.vscode}return ie}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,w.asJson)(B),se=[],ce={};if(ie){for(const he of ie.malicious)se.push({id:he});if(ie.unsupported)for(const he of Object.keys(ie.unsupported)){const ge=ie.unsupported[he];(0,b.isBoolean)(ge)||(ce[he.toLowerCase()]=ge.preReleaseExtension)}if(ie.migrateToPreRelease)for(const[he,ge]of Object.entries(ie.migrateToPreRelease))(!ge.engine||(0,h.isEngineValid)(ge.engine,this.productService.version,this.productService.date))&&(ce[he.toLowerCase()]=ge)}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};ee=de([J(1,w.IRequestService),J(2,d.ILogService),J(3,C.IEnvironmentService),J(4,l.ITelemetryService),J(5,p.IFileService),J(6,g.IProductService),J(7,P.IConfigurationService)],ee);let W=class extends ee{constructor(B,ie,se,ce,he,ge,me,ye){super(B,ie,se,ce,he,ge,me,ye)}};W=de([J(0,S.IStorageService),J(1,w.IRequestService),J(2,d.ILogService),J(3,C.IEnvironmentService),J(4,l.ITelemetryService),J(5,p.IFileService),J(6,g.IProductService),J(7,P.IConfigurationService)],W),e.ExtensionGalleryService=W;let F=class extends ee{constructor(B,ie,se,ce,he,ge,me){super(void 0,B,ie,se,ce,he,ge,me)}};F=de([J(0,w.IRequestService),J(1,d.ILogService),J(2,C.IEnvironmentService),J(3,l.ITelemetryService),J(4,p.IFileService),J(5,g.IProductService),J(6,P.IConfigurationService)],F),e.ExtensionGalleryServiceWithNoStorageService=F;async function V(z,B,ie,se,ce,he){const ge={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z} (${B.nameShort})`},me=await(0,m.getServiceMachineId)(ie,ce,he);return(0,r.supportsTelemetry)(B,ie)&&(0,r.getTelemetryLevel)(se)===3&&(ge["X-Market-User-Id"]=me),ge}e.resolveMarketplaceHeaders=V}),define(te[94],ne([0,1,2,15,8,44]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(b,E,P=""){super();this.prefix=P;const C=b.getLogger(E.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(b.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,E){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,A.validateTelemetryData)(E))}};T=de([J(0,k.ILoggerService),J(1,n.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(te[95],ne([0,1,2,28,4,26,141,20,42,87,38,21,44]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const m=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!m})})}setExperimentProperty(d,g){this._experimentProperties[d]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,w=d["common.machineId"],m=d["common.firstSessionDate"],S=d["common.msftInternal"];return{sessionId:g,machineId:w,firstSessionDate:m,msftInternal:S}}dispose(){this._disposables.dispose()}_log(d,g,w,m){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(S=>{w=(0,n.mixin)(w,S),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,m)}),this._appenders.forEach(l=>l.log(d,w))},S=>{console.error(S)})}publicLog(d,g,w){return this._log(d,3,g,w)}publicLog2(d,g,w){return this.publicLog(d,g,w)}publicLogError(d,g){return this.sendErrorTelemetry?this._log(d,2,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_anonymizeFilePaths(d){let g=d;const w=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(d);if(!a)break;w.push([a.index,r.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(g="";;){const r=S.exec(d);if(!r)break;!m.test(r[0])&&w.every(([a,i])=>r.index<a||r.index>=i)&&(g+=d.substring(l,r.index)+"<REDACTED: user-file-path>",l=S.lastIndex)}return l<d.length&&(g+=d.substr(l)),g}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const g=d.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,m=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,S=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return m.test(g)?"<REDACTED: secret>":w.test(g)?"<REDACTED: email>":S.test(g)?"<REDACTED: token>":d}_cleanupInfo(d,g){let w=d;g&&(w=this._anonymizeFilePaths(w));for(let m of this._cleanupPatterns)w=w.replace(m,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=de([J(1,R.IConfigurationService)],y),e.TelemetryService=y;function h(){const p=(0,T.localize)(0,null,E.default.nameLong),d=E.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=k.isWeb?"":(0,T.localize)(3,null),w=(0,T.localize)(4,null),m=(0,T.localize)(5,null),S=(0,T.localize)(6,null),l=(0,T.localize)(7,null),r=`
|       | ${w} | ${m} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,T.localize)(8,null);return`
${p} ${d} ${g}

&nbsp;

${l}
${r}

&nbsp;

${a}
`}P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,T.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,T.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[210],ne([0,1,9,28,44]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(R,b){const E=await new Promise((C,f)=>{Y(["applicationinsights"],C,f)});let P;return E.defaultClient?(P=new E.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(E.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=E.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class T{constructor(b,E,P,C,f){this._eventPrefix=b,this._defaultData=E,this.testCollector=C,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{b(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(b,E){!this._aiClient||(E=(0,n.mixin)(E,this._defaultData),E=(0,k.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+b,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(te[211],ne([0,1,18,58,20,15,8,21,93,94,95]),function(Y,e,D,n,k,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(y,h,p,d){this.configurationService=y,this.telemetryService=h,this.loggerService=p,this.environmentService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(y){if(!this.customTelemetryServices.has(y.id)){const{machineId:h,sessionId:p}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=h,d["common.vscodesessionid"]=p;const g=[y.id,JSON.stringify(d),y.aiKey],m=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),S=[new b.TelemetryAppenderClient(m),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${y.id}] `)];this.customTelemetryServices.set(y.id,new P.TelemetryService({appenders:S,sendErrorTelemetry:y.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(y.id)}async publicLog(y,h,p){await(await this.getCustomTelemetryService(y)).publicLog(h,p)}async publicLogError(y,h,p){await(await this.getCustomTelemetryService(y)).publicLogError(h,p)}};C=de([J(0,k.IConfigurationService),J(1,R.ITelemetryService),J(2,T.ILoggerService),J(3,A.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(te[212],ne([0,1,5,25,3,2,8]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(E,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((P,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...E});const y=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,A.toDisposable)(()=>y.cancel())])})}acceptReply(E,P){const C=this._pendingRequests.get(E);C?(this._pendingRequests.delete(E),(0,A.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),C(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=de([J(1,T.ILogService)],R),e.RequestStore=R}),define(te[96],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var T;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(T=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(d){d.TerminalView="view",d.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(d){d[d.CwdDetection=0]="CwdDetection",d[d.NaiveCwdDetection=1]="NaiveCwdDetection",d[d.CommandDetection=2]="CommandDetection",d[d.PartialCommandDetection=3]="PartialCommandDetection"})(f=e.TerminalCapability||(e.TerminalCapability={}));var y;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}))}),define(te[213],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[214],ne([0,1,33,28,10,4,32,14,22]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=E;async function P(C,f,y,h=T.env,p=b.Promises.exists){if(k.isAbsolute(C))return await p(C)?C:void 0;if(f===void 0&&(f=T.cwd()),k.dirname(C)!=="."){const m=k.join(f,C);return await p(m)?m:void 0}const g=(0,n.getCaseInsensitive)(h,"PATH");if(y===void 0&&(0,R.isString)(g)&&(y=g.split(k.delimiter)),y===void 0||y.length===0){const m=k.join(f,C);return await p(m)?m:void 0}for(let m of y){let S;if(k.isAbsolute(m)?S=k.join(m,C):S=k.join(f,m,C),await p(S))return S;if(A.isWindows){let l=S+".com";if(await p(l)||(l=S+".exe",await p(l)))return l}}const w=k.join(f,C);return await p(w)?w:void 0}e.findExecutable=P}),define(te[215],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[97],ne([0,1,48,3,2,6,38,215]),function(Y,e,D,n,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var b;(function(d){function g(w){return w&&typeof w=="object"&&typeof w.id=="string"}d.isThemeColor=g})(b=e.ThemeColor||(e.ThemeColor={}));function E(d){return{id:d}}e.themeColorFromId=E;var P;(function(d){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||b.isThemeColor(t.color))}d.isThemeIcon=g;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function m(t){const s=w.exec(t);if(!s)return;let[,o]=s;return{id:o}}d.fromString=m;function S(t){return{id:t}}d.fromId=S;function l(t,s){let o=t.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),s&&(o=`${o}~${s}`),{id:o}}d.modify=l;function r(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}d.getModifier=r;function a(t,s){return t.id===s.id&&t.color?.id===s.color?.id}d.isEqual=a;function i(t,s){return{id:t.id,color:s?E(s):void 0}}d.asThemeIcon=i,d.asClassNameArray=D.CSSIcon.asClassNameArray,d.asClassName=D.CSSIcon.asClassName,d.asCSSSelector=D.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(d){switch(d){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,k.toDisposable)(()=>{const w=this.themingParticipants.indexOf(g);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new f;T.Registry.add(e.Extensions.ThemingContribution,y);function h(d){return y.onColorThemeChange(d)}e.registerThemingParticipant=h;class p extends k.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,w){let m=this.theme.getColor(g);return m&&w&&(m=w(m,this.theme)),m?m.toString():null}}e.Themable=p}),define(te[216],ne([0,1,48,7,97]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(C,f){const y=C.map(h=>({name:h.profileName,description:T(h)}));return f&&y.push(...f.map(h=>({name:h.title,description:R(h)}))),{values:y.map(h=>h.name),markdownDescriptions:y.map(h=>h.description)}}e.createProfileSchemaEnums=A;function T(C){let f=`$(${k.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?f+=`
- args: "${C.args}"`:f+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(f+=`
- overrideName: ${C.overrideName}`),C.color&&(f+=`
- color: ${C.color}`),C.env&&(f+=`
- env: ${JSON.stringify(C.env)}`),f}function R(C){return`$(${k.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function b(C,f){if(!C&&!f)return!0;if(typeof C=="string"&&typeof f=="string")return C===f;if(Array.isArray(C)&&Array.isArray(f)){if(C.length!==f.length)return!1;for(let y=0;y<C.length;y++)if(C[y]!==f[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function E(C,f){if(!C&&!f)return!0;if(!C||!f)return!1;if(k.ThemeIcon.isThemeIcon(C)&&k.ThemeIcon.isThemeIcon(f))return C.id===f.id&&C.color===f.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const y=C,h=f;if((n.URI.isUri(y.light)||P(y.light))&&(n.URI.isUri(y.dark)||P(y.dark))&&(n.URI.isUri(h.light)||P(h.light))&&(n.URI.isUri(h.dark)||P(h.dark)))return y.light.path===h.light.path&&y.dark.path===h.dark.path}if(n.URI.isUri(C)&&n.URI.isUri(f)||P(C)||P(f)){const y=C,h=f;return y.path===h.path&&y.scheme===h.scheme}return!1}e.terminalIconsEqual=E;function P(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=P}),define(te[217],ne([0,1,48,142,42,38,216]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),S=>S.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),S=>`$(${S.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),d={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){A.Registry.as(k.Extensions.Configuration).registerConfiguration(d),m()}e.registerTerminalPlatformConfiguration=g;let w;function m(S,l){const r=A.Registry.as(k.Extensions.Configuration);let a;S&&(a=(0,T.createProfileSchemaEnums)(S?.profiles,l));const i=w;w={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?a?.values:void 0,markdownEnumDescriptions:S?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?a?.values:void 0,markdownEnumDescriptions:S?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?a?.values:void 0,markdownEnumDescriptions:S?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=m}),define(te[218],ne([0,1,45,48,10,4,22,72,214,97]),function(Y,e,D,n,k,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,C=!0;function f(a,i,t,s,o=process.env,c,u,v,I){return c=c||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},A.isWindows?y(t,c,o,u,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:s.getValue("terminal.integrated.defaultProfile.windows"),I,v):S(c,u,t,a&&typeof a=="object"?{...a}:s.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:s.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,v,o)}e.detectAvailableProfiles=f;async function y(a,i,t,s,o,c,u,v,I){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let N=!1;(0,b.getWindowsBuildNumber)()>=16299&&(N=!0),await d(v);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),l(c,$);const L=await h($.entries(),u,i,t,s,I);if(a||!a&&o)try{const U=await w(`${O}\\${N?"wsl":"bash"}.exe`,u);for(const j of U)(!c||!(j.profileName in c))&&L.push(j)}catch{C&&(s?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return L}async function h(a,i,t,s=process.env,o,c){const u=[];for(const[v,I]of a){if(I===null)continue;let _,O,N;if("source"in I){const U=P?.get(I.source);if(!U)continue;_=U.paths,O=I.args||U.args,I.icon?N=p(I.icon):U.icon&&(N=U.icon)}else _=Array.isArray(I.path)?I.path:[I.path],O=A.isWindows||Array.isArray(I.args)?I.args:void 0,N=p(I.icon);const $=await c?.(_)||_.slice(),L=await r(v,i,$,t,s,O,I.env,I.overrideName,I.isAutoDetected,o);L?(L.isAutoDetected=I.isAutoDetected,L.icon=N,L.color=I.color,u.push(L)):o?.trace("profile not validated",v,_)}return u}function p(a){return typeof a=="string"?{id:a}:a}async function d(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await g(),icon:E.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function g(){const a=[];for await(const i of(0,R.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function w(a,i){const t=[],s=await new Promise((u,v)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,_)=>{if(I)return v("Problem occurred when getting wsl distros");u(_)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),c=s.split(o).filter(u=>u.trim().length>0&&u!=="");for(const u of c){if(u===""||u.startsWith("docker-desktop"))continue;const v=`${u} (WSL)`,I={profileName:v,path:a,args:["-d",`${u}`],isDefault:v===i,icon:m(u),isAutoDetected:!1};t.push(I)}return t}function m(a){return a.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):a.includes("Debian")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function S(a,i,t,s,o,c,u,v){const I=new Map;if(t){const _=(await a.readFile("/etc/shells")).toString(),O=c||_.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),N=new Map;for(const $ of O){let L=(0,k.basename)($),U=N.get(L)||0;U++,U>1&&(L=`${L} (${U})`),N.set(L,U),I.set(L,{path:$,isAutoDetected:!0})}}return l(s,I),await h(I.entries(),o,a,v,i,u)}function l(a,i){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?i.delete(t):(s.icon=s.icon||i.get(t)?.icon,i.set(t,s))}async function r(a,i,t,s,o,c,u,v,I,_){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(a,i,t,s,o,c,u,v,I);const N={profileName:a,path:O,args:c,env:u,overrideName:v,isAutoDetected:I,isDefault:a===i};if((0,k.basename)(O)===O){const L=o.PATH?o.PATH.split(k.delimiter):void 0,U=await(0,b.findExecutable)(O,void 0,L,void 0,s.existsFile);return U?(N.path=U,N.isFromPath=!0,N):r(a,i,t,s,o,c)}return await s.existsFile((0,k.normalize)(O))?N:r(a,i,t,s,o,c,u,v,I)}}),define(te[219],ne([0,1,3,2,18,4,36,58,20,15,77,162,8,86,21,212,96,217,218]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let S=0,l=class extends n.Disposable{constructor(a,i,t,s,o){super();this._reconnectConstants=a,this._configurationService=i,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new p.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(A.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:S,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?a.debugBrk=i.port:!i.break&&i.port&&(a.debug=i.port));const t=new R.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,a);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(u=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const o=t.getChannel(d.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(u=>this._onProcessData.fire(u))),this._register(c.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(c.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(c.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(c.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(c.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(c.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,i,t,s,o,c,u,v,I,_,O){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,i,t,s,o,c,u,v,I,_,O);return clearTimeout(N),S=Math.max(S,$),$}updateTitle(a,i,t){return this._proxy.updateTitle(a,i,t)}updateIcon(a,i,t){return this._proxy.updateIcon(a,i,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,i){return this._proxy.shutdown(a,i)}input(a,i){return this._proxy.input(a,i)}processBinary(a,i){return this._proxy.processBinary(a,i)}resize(a,i,t){return this._proxy.resize(a,i,t)}acknowledgeDataEvent(a,i){return this._proxy.acknowledgeDataEvent(a,i)}setUnicodeVersion(a,i){return this._proxy.setUnicodeVersion(a,i)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,i){return this._proxy.installAutoReply(a,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,i,t,s=!1){const o=await this._shellEnv;return(0,w.detectAvailableProfiles)(i,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,i){return this._proxy.requestDetachInstance(a,i)}async acceptDetachInstanceReply(a,i){return this._proxy.acceptDetachInstanceReply(a,i)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,i){return this._proxy.reviveTerminalProcesses(a,i)}async refreshProperty(a,i){return this._proxy.refreshProperty(a,i)}async updateProperty(a,i,t){return this._proxy.updateProperty(a,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:i})}async acceptPtyHostResolvedVariables(a,i){this._resolveVariablesRequestStore.acceptReply(a,i)}};l=de([J(1,b.IConfigurationService),J(2,E.IEnvironmentService),J(3,f.ILogService),J(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[34],ne([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(te[220],ne([0,1,3,2,7,15,31,13,8,34]),function(Y,e,D,n,k,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends n.Disposable{constructor(f,y,h,p,d){super();this.extensionsManagementService=f,this.logService=p,this.uriIdentityService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const g=k.URI.file(h.extensionsPath);this._register(y.watch(g)),this._register(D.Event.filter(y.onDidFilesChange,w=>w.rawChanges.some(m=>this.doesChangeAffects(m,g)))(()=>this.onDidChange()))}doesChangeAffects(f,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),y)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const y of f)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),y=f.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,T.areSameExtensions)(d,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),h=this.installedExtensions.filter(p=>this.installingExtensions.some(d=>(0,T.areSameExtensions)(d,p))?!1:f.every(d=>!(0,T.areSameExtensions)(d.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=f.map(p=>p.identifier),(y.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:h})}}};P=de([J(1,R.IFileService),J(2,A.INativeEnvironmentService),J(3,b.ILogService),J(4,E.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(te[221],ne([0,1,34,79,13,19,104,3,2]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(f){this.uri=f,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const y=new Map,h=p=>{let d=y.get(p.scheme);return d===void 0&&(d=f.hasProvider(p)&&!this._fileService.hasCapability(p,1024),y.set(p.scheme,d)),d};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(p=>{y.delete(p.scheme)})),this.extUri=new A.ExtUri(h),this._canonicalUris=new T.SkipList((p,d)=>this.extUri.compare(p,d,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,A.normalizePath)(f));let y=this._canonicalUris.get(f);return y?y.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new E(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,p)=>h[1].touch<p[1].touch?1:h[1].touch>p[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let h=0;h<y;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};P=de([J(0,k.IFileService)],P),e.UriIdentityService=P,(0,n.registerSingleton)(D.IUriIdentityService,P,!0)}),define(te[222],ne([0,1,3,2,40,39,17]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends n.Disposable{constructor(E,P,C,f,y){super();this.fileSystemScheme=E,this.fileSystemProvider=P,this.userDataScheme=C,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(f.onDidFilesChange(h=>this.handleFileChanges(h)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,P){this.watchResources.set(E,E);const C=this.fileSystemProvider.watch(this.toFileSystemResource(E),P);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),C.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,P,C){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(P),C)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,P,C){const f=(0,k.newWriteableStream)(y=>T.VSBuffer.concat(y.map(h=>T.VSBuffer.wrap(h))).buffer);return(async()=>{try{const y=await this.readFile(E);f.end(y)}catch(y){f.error(y),f.end()}})(),f}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,P,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),P,C)}delete(E,P){return this.fileSystemProvider.delete(this.toFileSystemResource(E),P)}handleFileChanges(E){const P=[];for(const C of E.rawChanges){if(C.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(C.resource);this.watchResources.findSubstr(f)&&P.push({resource:f,type:C.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(te[53],ne([0,1,69]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(T,R,b,E){const P=(0,D.setProperty)(T,R,b,E)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=n;function k(T,R,b){let E=b;for(;E>=0;){if(T.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&T.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=k;function A(T,R,b){let E=b;for(;E>=0;)if(T.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&T.charAt(E)===R.charAt(1)))return E;return T.length-1}e.getLineEndOffset=A}),define(te[223],ne([0,1,28,61,14]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(f,y,h,p,d){const g=[],w=[],m=[];if(!y){const O=f.filter(({identifier:N})=>d.every($=>$.toLowerCase()!==N.id.toLowerCase()));return{local:{added:g,removed:w,updated:m},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(P),y=y.map(P),h=h?h.map(P):null;const S=new Map,l=O=>{O.uuid&&S.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>l(O)),y.forEach(({identifier:O})=>l(O)),h&&h.forEach(({identifier:O})=>l(O));const r=O=>{const N=O.identifier.uuid||S.get(O.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${O.identifier.id.toLowerCase()}`},a=(O,N)=>(O.set(r(N),N),O),i=f.reduce(a,new Map),t=y.reduce(a,new Map),s=y.reduce((O,N)=>{const $=r(N);N=(0,D.deepClone)(N);const L=i.get($);return L&&(L.installed&&(N.installed=!0),N.version||(N.version=L.version)),a(O,N)},new Map),o=h?h.reduce(a,new Map):null,c=p.reduce(a,new Map),u=d.reduce((O,N)=>{const $=S.get(N.toLowerCase());return O.add($?`uuid:${$}`:`id:${N.toLowerCase()}`)},new Set),v=T(i,t,u);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const O=T(o,i,u),N=T(o,t,u),$=(L,U)=>{const j=i.get(L);if(j){const M=t.get(L),G=U?M:j;return{...G,version:(M.version&&n.gt(M.version,j.version),j.version),state:R(j,M,o?.get(L)),preRelease:(0,k.isUndefined)(G.preRelease)?j.preRelease:G.preRelease}}};for(const L of N.removed.values()){const U=i.get(L);U&&w.push(U.identifier)}for(const L of N.added.values())if(O.added.has(L)){if(v.updated.has(L)){const U=$(L,!0);U&&(m.push(C(U,L)),s.set(L,U))}}else{const U=t.get(L);U.installed&&g.push(C(U,L))}for(const L of N.updated.values()){const U=$(L,!0);U&&(m.push(C(U,L)),s.set(L,U))}for(const L of O.added.values())N.added.has(L)||s.set(L,i.get(L));for(const L of O.updated.values())if(!N.removed.has(L)&&!N.updated.has(L)){const U=$(L,!1);U&&(s.get(L)?.installed&&(U.installed=!0),s.set(L,U))}for(const L of O.removed.values())!c.has(L)&&!N.updated.has(L)&&o?.get(L)?.installed&&s.delete(L)}const I=[],_=T(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&s.forEach((O,N)=>I.push(C(O,N))),{local:{added:g,removed:w,updated:m},remote:I.length?{added:[..._.added].map(O=>s.get(O)),updated:[..._.updated].map(O=>s.get(O)),removed:[..._.removed].map(O=>t.get(O)),all:I}:null}}e.merge=A;function T(f,y,h,{checkInstalledProperty:p,checkVersionProperty:d}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=f?[...f.keys()].filter(r=>!h.has(r)):[],w=[...y.keys()].filter(r=>!h.has(r)),m=w.filter(r=>g.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),S=g.filter(r=>w.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=new Set;for(const r of g){if(S.has(r))continue;const a=f.get(r),i=y.get(r);(!i||a.disabled!==i.disabled||a.preRelease!==i.preRelease||!E(a.state,i.state)||d&&a.version!==i.version||p&&a.installed!==i.installed)&&l.add(r)}return{added:m,removed:S,updated:l}}function R(f,y,h){const p=f.state,d=y.state,g=h?.state;if(!y.version||p&&n.gt(f.version,y.version))return p;if(d&&n.gt(y.version,f.version)||!p)return d;if(!d)return p;const w=(0,D.deepClone)(p),m=g?b(g,d):{added:Object.keys(d).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},S=g?b(g,p):{added:Object.keys(p).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...m.added.values(),...m.updated.values()])w[l]=d[l];for(const l of m.removed.values())S.updated.has(l)||delete w[l];return w}function b(f,y){const h=Object.keys(f),p=Object.keys(y),d=p.filter(m=>h.indexOf(m)===-1).reduce((m,S)=>(m.add(S),m),new Set),g=h.filter(m=>p.indexOf(m)===-1).reduce((m,S)=>(m.add(S),m),new Set),w=new Set;for(const m of h){if(g.has(m))continue;const S=f[m],l=y[m];(0,D.equals)(S,l)||w.add(m)}return{added:d,removed:g,updated:w}}function E(f={},y={}){const{added:h,removed:p,updated:d}=b(f,y);return h.size===0&&p.size===0&&d.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function C(f,y){const h={identifier:{id:f.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(h.version=f.version),f.disabled&&(h.disabled=!0),f.installed&&(h.installed=!0),f.state&&(h.state=f.state),h}}),define(te[98],ne([0,1,16,20,6]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),b&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),b&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const b=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],C=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?C.push(f.substring(1)):P.push(f);return(0,D.distinct)([...b,...P].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};A=de([J(0,n.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(te[224],ne([0,1,16,35,28,158,53]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(S){return(0,n.parse)(S)||[]}e.parseKeybindings=R;async function b(S,l,r,a,i){const t=R(S),s=R(l),o=r?R(r):null,c=[...t,...s,...o||[]].map(M=>M.key),u=await i.resolveUserBindings(c);let v=P(t,s,o,u);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const I=f(t),_=f(s),O=o?f(o):null,N=h(I,_,u),$=O?h(O,I,u):{added:[...I.keys()].reduce((M,G)=>(M.add(G),M),new Set),removed:new Set,updated:new Set},L=O?h(O,_,u):{added:[..._.keys()].reduce((M,G)=>(M.add(G),M),new Set),removed:new Set,updated:new Set},U=E(N,$,L);let j=S;for(const M of U.removed.values())U.conflicts.has(M)||(j=w(j,M,a));for(const M of U.added.values()){if(U.conflicts.has(M))continue;const G=_.get(M);if(G.some(K=>K.command!==`-${M}`&&v.conflicts.has(u[K.key]))){U.conflicts.add(M);continue}j=g(j,G,a)}for(const M of U.updated.values()){if(U.conflicts.has(M))continue;const G=_.get(M);if(G.some(K=>K.command!==`-${M}`&&v.conflicts.has(u[K.key]))){U.conflicts.add(M);continue}j=m(j,M,G,a)}return{mergeContent:j,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=b;function E(S,l,r){const a=new Set,i=new Set,t=new Set,s=new Set;for(const o of l.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(l.updated.has(o)?s.add(o):i.add(o));for(const o of l.added.values())s.has(o)||r.added.has(o)&&S.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(l.added.has(o)?S.updated.has(o)&&s.add(o):a.add(o));for(const o of l.updated.values())s.has(o)||r.updated.has(o)&&S.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(l.updated.has(o)?S.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:i,updated:t,conflicts:s}}function P(S,l,r,a){const i=new Set,t=C(S,a),s=C(l,a),o=r?C(r,a):null,c=y(t,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const u=o?y(o,t):{added:[...t.keys()].reduce(($,L)=>($.add(L),$),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const v=o?y(o,s):{added:[...s.keys()].reduce(($,L)=>($.add(L),$),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:I,removed:_,updated:O,conflicts:N}=E(c,u,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:_,updated:O,conflicts:N}}function C(S,l){const r=new Map;for(const a of S){const i=l[a.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(a)}return r}function f(S){const l=new Map;for(const r of S){const a=r.command[0]==="-"?r.command.substring(1):r.command;let i=l.get(a);i||(i=[],l.set(a,i)),i.push(r)}return l}function y(S,l){const r=[...S.keys()],a=[...l.keys()],i=a.filter(o=>r.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const c=S.get(o).map(v=>({...v,key:o})),u=l.get(o).map(v=>({...v,key:o}));(0,D.equals)(c,u,(v,I)=>d(v,I))||s.add(o)}return{added:i,removed:t,updated:s}}function h(S,l,r){const a=[...S.keys()],i=[...l.keys()],t=i.filter(c=>a.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),s=a.filter(c=>i.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),o=new Set;for(const c of a){if(s.has(c))continue;const u=S.get(c).map(I=>({...I,key:r[I.key]})),v=l.get(c).map(I=>({...I,key:r[I.key]}));p(u,v)||o.add(c)}return{added:t,removed:s,updated:o}}function p(S,l){return!(!(0,D.equals)(S.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,a)=>d(r,a))||!(0,D.equals)(S.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,a)=>d(r,a)))}function d(S,l){if(S.command!==l.command||S.key!==l.key)return!1;const r=A.ContextKeyExpr.deserialize(S.when),a=A.ContextKeyExpr.deserialize(l.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!k.equals(S.args,l.args))}function g(S,l,r){for(const a of l)S=T.edit(S,[-1],a,r);return S}function w(S,l,r){const a=R(S);for(let i=a.length-1;i>=0;i--)(a[i].command===l||a[i].command===`-${l}`)&&(S=T.edit(S,[i],void 0,r));return S}function m(S,l,r,a){const i=R(S),t=i.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=i.length-1;s>=0;s--)(i[s].command===l||i[s].command===`-${l}`)&&(S=T.edit(S,[s],void 0,a));for(let s=r.length-1;s>=0;s--)S=T.edit(S,[t],r[s],a);return S}}),define(te[225],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(A,T,R){const b={},E={},P=new Set;if(!T)return{local:{added:b,updated:E,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const C=n(A,T);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:b,updated:E,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=n(R,A),y=n(R,T),h={},p={},d=new Set,g=new Set;for(const w of f.removed.values())y.updated.has(w)?b[w]=T[w]:d.add(w);for(const w of y.removed.values())g.has(w)||(f.updated.has(w)?g.add(w):P.add(w));for(const w of f.updated.values())g.has(w)||(y.updated.has(w)?C.updated.has(w)&&g.add(w):p[w]=A[w]);for(const w of y.updated.values())g.has(w)||(f.updated.has(w)?C.updated.has(w)&&g.add(w):A[w]!==void 0&&(E[w]=T[w]));for(const w of f.added.values())g.has(w)||(y.added.has(w)?C.updated.has(w)&&g.add(w):h[w]=A[w]);for(const w of y.added.values())g.has(w)||(f.added.has(w)?C.updated.has(w)&&g.add(w):b[w]=T[w]);return{local:{added:b,removed:[...P.values()],updated:E},remote:{added:h,removed:[...d.values()],updated:p},conflicts:[...g.values()]}}e.merge=D;function n(A,T){const R=A?Object.keys(A):[],b=T?Object.keys(T):[],E=b.filter(f=>R.indexOf(f)===-1).reduce((f,y)=>(f.add(y),f),new Set),P=R.filter(f=>b.indexOf(f)===-1).reduce((f,y)=>(f.add(y),f),new Set),C=new Set;for(const f of R){if(P.has(f))continue;const y=A[f],h=T[f];y!==h&&C.add(f)}return{added:E,removed:P,updated:C}}function k(A,T){const{added:R,removed:b,updated:E}=n(A,T);return R.size===0&&b.size===0&&E.size===0}e.areSame=k}),define(te[24],ne([0,1,16,19,14,147,42,30,6,88,38]),function(Y,e,D,n,k,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const o=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(c=>!!o[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const o=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(o).filter(I=>!!o[I].ignoreSync),u=Object.keys(o).filter(I=>o[I].scope===2||o[I].scope===6),v=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...u,...v])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const o="vscode://schemas/ignoredSettings",c=P.Registry.as(T.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=P.Registry.as(E.Extensions.JSONContribution),v=()=>{const I=C(),_=f().filter(L=>L!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(T.allSettings.properties).filter(L=>_.indexOf(L)===-1),N=_.filter(L=>I.indexOf(L)===-1),$={items:{type:"string",enum:[...O,...N.map(L=>`-${L}`)]}};u.registerSchema(o,$)};return c.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=y;function h(o){return o&&(0,k.isObject)(o)&&(0,k.isString)(o.id)&&(0,k.isArray)(o.scopes)}e.isAuthenticationProvider=h;var p;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function d(o,c,u){return u.joinPath(c.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(o){const c={};return c[e.HEADER_EXECUTION_ID]=o,c}e.createSyncHeaders=g;var w;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class m extends Error{constructor(c,u,v,I){super(c);this.code=u,this.resource=v,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=m;class S extends m{constructor(c,u,v,I,_){super(c,v,void 0,_);this.url=u,this.serverCode=I}}e.UserDataSyncStoreError=S;class l extends m{constructor(c,u){super(c,u)}}e.UserDataAutoSyncError=l,function(o){function c(u){if(u instanceof o)return u;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(v&&v[1]){const I=v[2]==="unknown"?void 0:v[2],_=v[3]==="unknown"?void 0:v[3];return new o(u.message,v[1],I,_)}return new o(u.message,"Unknown")}o.toUserDataSyncError=c}(m=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,c){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,n.isEqualOrParent)(o,(0,n.joinPath)(c.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(te[47],ne([0,1,16,5,17,25,3,35,2,26,14,7,143,20,15,13,8,46,23,21,34,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends b.Disposable{constructor(c,u,v,I,_,O,N,$,L,U,j){super();this.resource=c,this.fileService=u,this.environmentService=v,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=N,this.telemetryService=$,this.logService=L,this.configurationService=U,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(v.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(c,v,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(v,u,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const u=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,u={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),u)}async preview(c,u,v={}){return this._sync(c,!1,u,v)}async apply(c,u={}){try{this.syncHeaders={...u};const v=await this.doApply(c);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,u,v,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(c,O);return _=await this.performSync(N,O,u,v),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(c){const u=await this.resolveContent(c);if(!u)return!1;const v=this.parseSyncData(u);if(!v)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,I),O=await this.isRemoteDataFromCurrentMachine(_),N=await this.generateSyncPreview({ref:_.ref,syncData:v},I,O,this.getUserDataSyncConfiguration(),A.CancellationToken.None),$=[];for(const L of N){const U=await this.getAcceptResult(L,L.remoteResource,void 0,A.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(L,L.previewResource,L.remoteContent,A.CancellationToken.None);$.push([L,{...U,remoteChange:j!==0?j:2}])}await this.applyResult(_,I,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const u=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===u}async getLatestRemoteUserData(c,u){if(u){const v=c&&c.latest?c.latest[this.resource]:void 0;if(u.ref===v||v===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(c,u,v,I){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,u,v,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,u,v,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(c,u,v,I)}throw _}}async doSync(c,u,v,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(c,u,v,I,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(c){return await this.updateSyncResourcePreview(c,async u=>{const v=await this.getMergeResult(u,A.CancellationToken.None);await this.fileService.writeFile(u.previewResource,k.VSBuffer.fromString(v?.content||""));const I=v&&!v.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,A.CancellationToken.None):void 0;return u.acceptResult=I,u.mergeState=v.hasConflicts?"conflict":I?"accepted":"preview",u.localChange=I?I.localChange:v.localChange,u.remoteChange=I?I.remoteChange:v.remoteChange,u}),this.syncPreviewPromise}async accept(c,u){return await this.updateSyncResourcePreview(c,async v=>{const I=await this.getAcceptResult(v,c,u,A.CancellationToken.None);return v.acceptResult=I,v.mergeState="accepted",v.localChange=I.localChange,v.remoteChange=I.remoteChange,v}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async u=>{const v=await this.getMergeResult(u,A.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,k.VSBuffer.fromString(v.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=v.localChange,u.remoteChange=v.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(c,u){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const I=v.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:N})=>this.extUri.isEqual(_,c)||this.extUri.isEqual(O,c)||this.extUri.isEqual(N,c));I!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const O=[...v.resourcePreviews];return O[I]=await u(O[I]),{...v,resourcePreviews:O}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(v=>[v,v.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(c){const u=c.filter(({mergeState:v})=>v==="conflict");(0,D.equals)(this._conflicts,u,(v,I)=>this.extUri.isEqual(v.previewResource,I.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:v})=>({created:u,uri:this.toRemoteBackupResource(v)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:v})=>({created:u,uri:this.toLocalBackupResource(v)}))}toRemoteBackupResource(c){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const u=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(u))){const{content:v}=await this.getUserData(u);if(v)return this.parseSyncData(v)?.machineId}}async resolveContent(c){const u=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(u))){const{content:v}=await this.getUserData(u);return v}return this.extUri.isEqual(c,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(c){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const v of u.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,c))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,c))return v.remoteContent;if(this.extUri.isEqual(v.localResource,c))return v.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(c,u,v,I,_){const O=await this.isRemoteDataFromCurrentMachine(c),N=await this.generateSyncPreview(c,u,O,I,_),$=[];for(const L of N){const U=L.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(L.localChange===0&&L.remoteChange===0)$.push({...L,acceptedResource:U,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const j=v?await this.getMergeResult(L,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(L.previewResource,k.VSBuffer.fromString(j?.content||""));const M=j&&!j.hasConflicts?await this.getAcceptResult(L,L.previewResource,void 0,_):void 0;$.push({...L,acceptResult:M,mergeState:j?.hasConflicts?"conflict":M?"accepted":"preview",localChange:M?M.localChange:j?j.localChange:L.localChange,remoteChange:M?M.remoteChange:j?j.remoteChange:L.remoteChange})}}return{remoteUserData:c,lastSyncUserData:u,resourcePreviews:$,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(c.value.toString()),v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&v&&u.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;const I=u;if(I.content===null)return{ref:u.ref,syncData:null};const _=JSON.parse(I.content);if(r(_))return{...u,syncData:_,content:void 0}}catch(c){c instanceof p.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:v,...u};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(c){const{ref:u,content:v}=await this.getUserData(c);let I=null;return v!==null&&(I=this.parseSyncData(v)),{ref:u,syncData:I}}parseSyncData(c){try{const u=JSON.parse(c);if(r(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,P.isString)(c)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:u}}else{const u=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(c,u){const v=await this.currentMachineIdPromise,I={version:this.version,machineId:v,content:c};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),u,this.syncHeaders),{ref:u,syncData:I}}async backupLocal(c){const u={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([J(1,p.IFileService),J(2,h.IEnvironmentService),J(3,w.IStorageService),J(4,l.IUserDataSyncStoreService),J(5,l.IUserDataSyncBackupStoreService),J(6,l.IUserDataSyncEnablementService),J(7,m.ITelemetryService),J(8,l.IUserDataSyncLogService),J(9,y.IConfigurationService),J(10,S.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(c,u,v,I,_,O,N,$,L,U,j,M){super(u,v,I,_,O,N,$,L,U,j,M);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(c,u,v){try{u?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(c),v?void 0:u):await this.fileService.createFile(this.file,k.VSBuffer.fromString(c),{overwrite:v})}catch(I){throw I instanceof p.FileOperationError&&I.fileOperationResult===1||I instanceof p.FileOperationError&&I.fileOperationResult===3?new l.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};i=de([J(2,p.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,m.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,y.IConfigurationService),J(11,S.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(c,u,v,I,_,O,N,$,L,U,j,M,G){super(c,u,v,I,_,O,N,$,L,U,M,G);this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(c){const u=[];return(0,R.parse)(c,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([J(2,p.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,m.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,l.IUserDataSyncUtilService),J(11,y.IConfigurationService),J(12,S.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(c,u,v,I,_){this.resource=c,this.environmentService=u,this.logService=v,this.fileService=I,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:c,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(u);if(!!v)try{await this.doInitialize({ref:c,syncData:v})}catch(I){this.logService.error(I)}}parseSyncData(c){try{const u=JSON.parse(c);if(r(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,u={}){const v={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(v)))}};s=de([J(1,h.IEnvironmentService),J(2,d.ILogService),J(3,p.IFileService),J(4,S.IUriIdentityService)],s),e.AbstractInitializer=s}),define(te[226],ne([0,1,5,25,9,3,49,26,7,20,15,30,31,63,13,8,23,21,34,47,223,98,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function a(s,o){const c=JSON.parse(s.content);if(s.version===1||s.version===2){const u=(await o.getInstalled(0)).filter(v=>v.isBuiltin);for(const v of c)s.version===1&&(v.enabled===!1&&(v.disabled=!0),delete v.enabled),s.version===2&&u.every(I=>!(0,f.areSameExtensions)(I.identifier,v.identifier))&&(v.installed=!0)}return c}let i=class mt extends m.AbstractSynchroniser{constructor(o,c,u,v,I,_,O,N,$,L,U,j,M,G,K){super("extensions",c,o,u,v,I,j,M,$,U,K);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=N,this.extensionGalleryService=L,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.debounce(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:q})=>!!q)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(o,c){const u=o.syncData?await a(o.syncData,this.extensionManagementService):null,v=c?.skippedExtensions||[],I=c?.syncData?await a(c.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);u?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:L}=(0,S.merge)(O,u,I,v,N),U={local:$,remote:L,content:this.getPreviewContent(O,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:L!==null?2:0};return[{skippedExtensions:v,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:u?this.stringify(u,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const c=o.syncData?await a(o.syncData,this.extensionManagementService):null,u=await this.extensionManagementService.getInstalled(void 0,!0),v=this.getLocalExtensions(u),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),{remote:_}=(0,S.merge)(v,c,c,o.skippedExtensions||[],I);return _!==null}getPreviewContent(o,c,u,v){const I=[...c,...u],_=new Set,O=N=>{_.add(N.id.toLowerCase()),N.uuid&&_.add(N.uuid)};I.forEach(({identifier:N})=>O(N)),v.forEach(O);for(const N of o)_.has(N.identifier.id.toLowerCase())||N.identifier.uuid&&_.has(N.identifier.uuid)||I.push(N);return this.stringify(I,!1)}async getMergeResult(o,c){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,c,u,v){if(this.extUri.isEqual(c,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(c,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(c,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${c.toString()}`)}async acceptLocal(o){const c=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),v=(0,S.merge)(o.localExtensions,null,null,o.skippedExtensions,u),{local:I,remote:_}=v;return{content:o.localContent,local:I,remote:_,localChange:I.added.length>0||I.removed.length>0||I.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(o){const c=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),v=o.remoteContent?JSON.parse(o.remoteContent):null;if(v!==null){const I=(0,S.merge)(o.localExtensions,v,o.localExtensions,[],u),{local:_,remote:O}=I;return{content:o.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,c,u,v){let{skippedExtensions:I,localExtensions:_}=u[0][0],{local:O,remote:N,localChange:$,remoteChange:L}=u[0][1];if($===0&&L===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(_)),I=await this.updateLocalExtensions(O.added,O.removed,O.updated,I)),N){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(N.all);o=await this.updateRemoteUserData(U,v?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${N.added.length?` Added: ${JSON.stringify(N.added.map(j=>j.identifier.id))}.`:""}${N.updated.length?` Updated: ${JSON.stringify(N.updated.map(j=>j.identifier.id))}.`:""}${N.removed.length?` Removed: ${JSON.stringify(N.removed.map(j=>j.identifier.id))}.`:""}`)}c?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:I}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${I.length?` Skipped: ${JSON.stringify(I.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,mt.EXTENSIONS_DATA_URI)){const u=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),I=this.getLocalExtensions(u).filter(_=>!v.some(O=>(0,f.areSameExtensions)({id:O},_.identifier)));return this.stringify(I,!0)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)){const u=await this.resolvePreviewContent(o);return u&&this.stringify(JSON.parse(u),!0)}let c=await super.resolveContent(o);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(o)),c){const u=this.parseSyncData(c);if(u)switch(this.extUri.basename(o)){case"extensions.json":return this.stringify(this.parseExtensions(u),!0)}}return null}stringify(o,c){return o.sort((u,v)=>!u.identifier.uuid&&v.identifier.uuid?-1:u.identifier.uuid&&!v.identifier.uuid?1:(0,R.compare)(u.identifier.id,v.identifier.id)),c?(0,T.toFormattedString)(o,{}):JSON.stringify(o)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(u=>u.installed||u.disabled))return!0}catch{}return!1}async updateLocalExtensions(o,c,u,v){const I=[],_=[],O=await this.extensionManagementService.getInstalled();if(c.length){const $=O.filter(({identifier:L,isBuiltin:U})=>!U&&c.some(j=>(0,f.areSameExtensions)(L,j)));await D.Promises.settled($.map(async L=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,L.identifier.id),await this.extensionManagementService.uninstall(L,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,L.identifier.id),I.push(L.identifier)}))}(o.length||u.length)&&await D.Promises.settled([...o,...u].map(async $=>{const L=O.find(j=>(0,f.areSameExtensions)(j.identifier,$.identifier));if(L&&L.isBuiltin){$.state&&L.manifest.version===$.version&&this.updateExtensionState($.state,L,L.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(M=>(0,f.areSameExtensions)(M,$.identifier))!==!!$.disabled&&($.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id))),I.push($.identifier);return}const U=(await this.extensionGalleryService.getExtensions([$.identifier],!!$.preRelease,n.CancellationToken.None))[0];if($.state&&(L?L.manifest.version===$.version:!!U)&&this.updateExtensionState($.state,L||U,L?.manifest.version),U)try{this.extensionEnablementService.getDisabledExtensions().some(M=>(0,f.areSameExtensions)(M,$.identifier))!==!!$.disabled&&($.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,U.version))),(!L||L.preRelease!==$.preRelease)&&(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:$.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,U.version),I.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),_.push($)))}catch(j){_.push($),j instanceof C.ExtensionManagementError&&[C.ExtensionManagementErrorCode.Incompatible,C.ExtensionManagementErrorCode.IncompatiblePreRelease,C.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else _.push($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}));const N=[];for(const $ of v)I.some(L=>(0,f.areSameExtensions)(L,$.identifier))||N.push($);for(const $ of _)N.some(L=>(0,f.areSameExtensions)(L.identifier,$.identifier))||N.push($);return N}updateExtensionState(o,c,u){const v=this.extensionStorageService.getExtensionState(c,!0)||{},I=u?this.extensionStorageService.getKeysForSync({id:c.identifier.id,version:u}):void 0;I?I.forEach(_=>{v[_]=o[_]}):Object.keys(o).forEach(_=>v[_]=o[_]),this.extensionStorageService.setExtensionState(c,v,!0)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const c=this.extensionEnablementService.getDisabledExtensions();return o.map(u=>{const{identifier:v,isBuiltin:I,manifest:_,preRelease:O}=u,N={identifier:v,preRelease:O,version:_.version};c.some($=>(0,f.areSameExtensions)($,v))&&(N.disabled=!0),I||(N.installed=!0);try{const $=this.extensionStorageService.getKeysForSync({id:v.id,version:_.version});if($){const L=this.extensionStorageService.getExtensionState(u,!0)||{};N.state=Object.keys(L).reduce((U,j)=>($.includes(j)&&(U[j]=L[j]),U),{})}}catch($){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)($))}return N})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([J(0,P.IEnvironmentService),J(1,h.IFileService),J(2,d.IStorageService),J(3,r.IUserDataSyncStoreService),J(4,r.IUserDataSyncBackupStoreService),J(5,C.IExtensionManagementService),J(6,C.IGlobalExtensionEnablementService),J(7,l.IIgnoredExtensionsManagementService),J(8,r.IUserDataSyncLogService),J(9,C.IExtensionGalleryService),J(10,E.IConfigurationService),J(11,r.IUserDataSyncEnablementService),J(12,g.ITelemetryService),J(13,y.IExtensionStorageService),J(14,w.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let t=class extends m.AbstractInitializer{constructor(o,c,u,v,I,_){super("extensions",v,I,u,_);this.extensionManagementService=o,this.ignoredExtensionsManagementService=c}async parseExtensions(o){return o.syncData?await a(o.syncData,this.extensionManagementService):null}generatePreview(o,c){const u=[],v=[],I=[];for(const _ of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=c.find(N=>(0,f.areSameExtensions)(N.identifier,_.identifier));O?(u.push(O),_.disabled&&I.push(_.identifier)):_.installed&&(v.push(_.identifier),_.disabled&&I.push(_.identifier))}return{installedExtensions:u,newExtensions:v,disabledExtensions:I,remoteExtensions:o}}};t=de([J(0,C.IExtensionManagementService),J(1,l.IIgnoredExtensionsManagementService),J(2,h.IFileService),J(3,P.IEnvironmentService),J(4,p.ILogService),J(5,w.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(te[227],ne([0,1,28,24]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(R,b,E,P,C){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=A(R,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=E?A(E,b):{added:Object.keys(b).reduce((w,m)=>(w.add(m),w),new Set),removed:new Set,updated:new Set},h=E?A(E,R):{added:Object.keys(R).reduce((w,m)=>(w.add(m),w),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},d=D.deepClone(b),g=!E;for(const w of h.added.values())w!==n.SYNC_SERVICE_URL_TYPE&&g&&y.added.has(w)||(d[w]=R[w]);for(const w of h.updated.values())d[w]=R[w];for(const w of h.removed.values())P.unregistered.includes(w)||delete d[w];for(const w of y.added.values()){const m=b[w];if(P.machine.includes(w)){C.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(E&&h.added.has(w))continue;const S=R[w];S&&S.value===m.value||w===n.SYNC_SERVICE_URL_TYPE&&g&&h.added.has(w)||(S?p.updated[w]=m:p.added[w]=m)}for(const w of y.updated.values()){const m=b[w];if(P.machine.includes(w)){C.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const S=R[w];S&&S.value===m.value||(p.updated[w]=m)}for(const w of y.removed.values()){if(P.machine.includes(w)){C.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||p.removed.push(w)}return{local:p,remote:T(d,b)?null:d}}e.merge=k;function A(R,b){const E=Object.keys(R),P=Object.keys(b),C=P.filter(h=>E.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),f=E.filter(h=>P.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),y=new Set;for(const h of E){if(f.has(h))continue;const p=R[h],d=b[h];D.equals(p,d)||y.add(h)}return{added:C,removed:f,updated:y}}function T(R,b){const{added:E,removed:P,updated:C}=A(R,b);return E.size===0&&P.size===0&&C.size===0}}),define(te[228],ne([0,1,17,9,3,35,49,4,7,29,20,15,13,8,46,23,21,34,47,53,227,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function i(u,v){const I=u.storage?Object.keys(u.storage).sort():[],_={};return I.forEach(O=>_[O]=u.storage[O]),u.storage=_,v?(0,T.toFormattedString)(u,{}):JSON.stringify(u)}const t=1;let s=class vt extends w.AbstractSynchroniser{constructor(v,I,_,O,N,$,L,U,j,M){super("globalState",v,N,j,I,_,$,L,O,U,M);this.storageService=j,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(v.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),k.Event.filter(j.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:j.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(v,I,_){const O=v.syncData?JSON.parse(v.syncData.content):null;I=I===null&&_?v:I;const N=I&&I.syncData?JSON.parse(I.syncData.content):null,$=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const L=this.getStorageKeys(N),{local:U,remote:j}=(0,S.merge)($.storage,O?O.storage:null,N?N.storage:null,L,this.logService),M={content:null,local:U,remote:j,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:i($,!1),localUserData:$,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource,storageKeys:L}]}async hasRemoteChanged(v){const I=v.syncData?JSON.parse(v.syncData.content):null;if(I===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(I),{remote:N}=(0,S.merge)(_.storage,I.storage,I.storage,O,this.logService);return N!==null}async getMergeResult(v,I){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,I,_,O){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(I,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:v.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(v){if(v.remoteContent!==null){const I=JSON.parse(v.remoteContent),{local:_,remote:O}=(0,S.merge)(v.localUserData.storage,I.storage,null,v.storageKeys,this.logService);return{content:v.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(v,I,_,O){let{localUserData:N}=_[0][0],{local:$,remote:L,localChange:U,remoteChange:j}=_[0][1];if(U===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),U!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:L});v=await this.updateRemoteUserData(M,O?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v)){const _=await this.resolvePreviewContent(v);return _&&i(JSON.parse(_),!0)}let I=await super.resolveContent(v);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(v)),I){const _=this.parseSyncData(I);if(_)switch(this.extUri.basename(v)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:v}=await this.getLocalGlobalState();if(Object.keys(v).length>1||v[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const v={},I=await this.getLocalArgvContent(),_=(0,A.parse)(I);for(const O of a)_[O]!==void 0&&(v[`${r}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const N=this.storageService.get(O,0);N&&(v[O]={version:1,value:N})}return{storage:v}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const v=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),v.value.toString()}catch(v){this.logService.debug((0,n.getErrorMessage)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:I,updated:_}){const O={},N={},$=(U,j)=>{for(const M of U){if(M.startsWith(r)){O[M.substring(r.length)]=j?j[M].value:void 0;continue}if(j){const G=j[M];G.value!==String(this.storageService.get(M,0))&&(N[M]=G.value)}else this.storageService.get(M,0)!==void 0&&(N[M]=void 0)}};if($(Object.keys(v),v),$(Object.keys(_),_),$(I),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const U of Object.keys(N))this.storageService.store(U,N[U],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(v){const I=await this.getLocalArgvContent();let _=I;for(const O of Object.keys(v))_=(0,m.edit)(_,[O],v[O],{});I!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(v){const I=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...I,..._],N=v?.storage?Object.keys(v.storage).filter($=>!$.startsWith(r)&&!O.includes($)&&this.storageService.get($,0)!==void 0):[];if(!R.isWeb){const $=[...l.ALL_SYNC_RESOURCES.map(L=>(0,l.getEnablementKey)(L)),l.SYNC_SERVICE_URL_TYPE];N.push(...$),_.push(...$)}return{user:I,machine:_,unregistered:N}}};s.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([J(0,f.IFileService),J(1,l.IUserDataSyncStoreService),J(2,l.IUserDataSyncBackupStoreService),J(3,l.IUserDataSyncLogService),J(4,C.IEnvironmentService),J(5,l.IUserDataSyncEnablementService),J(6,d.ITelemetryService),J(7,P.IConfigurationService),J(8,p.IStorageService),J(9,g.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends w.AbstractInitializer{constructor(v,I,_,O,N){super("globalState",_,O,I,N);this.storageService=v}async doInitialize(v){const I=v.syncData?JSON.parse(v.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const N of Object.keys(I.storage))N.startsWith(r)?_[N.substring(r.length)]=I.storage[N].value:this.storageService.get(N,0)===void 0&&(O[N]=I.storage[N].value);if(Object.keys(_).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(_))N=(0,m.edit)(N,[$],_[$],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N))}if(Object.keys(O).length)for(const N of Object.keys(O))this.storageService.store(N,O[N],0,0)}};o=de([J(0,p.IStorageService),J(1,f.IFileService),J(2,C.IEnvironmentService),J(3,l.IUserDataSyncLogService),J(4,g.IUriIdentityService)],o),e.GlobalStateInitializer=o;let c=class{constructor(v,I,_,O,N){this.userDataSyncStoreClient=v,this.storageService=I,this.environmentService=_,this.fileService=O,this.logService=N}getSyncStoreType(v){return this.parseGlobalState(v)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(v){const I=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(v,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(v,I)}throw _}}async doSync(v,I){const _=await this.userDataSyncStoreClient.read("globalState",null,I),O=this.parseGlobalState(_)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:v,version:t};const N=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:t,machineId:N,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),_.ref,I)}parseGlobalState({content:v}){if(!v)return null;const I=JSON.parse(v);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};c=de([J(1,p.IStorageService),J(2,C.IEnvironmentService),J(3,f.IFileService),J(4,y.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(te[229],ne([0,1,16,17,3,35,4,14,144,20,15,13,23,21,34,47,224,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,a){try{const i=JSON.parse(l);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return a.error(i),null}}e.getKeybindingsContentFromSyncContent=w;let m=class extends p.AbstractJsonFileSynchroniser{constructor(r,a,i,t,s,o,c,u,v,I,_){super(c.keybindingsResource,"keybindings",o,c,u,r,a,s,I,i,v,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,i,t){const s=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&i?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,c=await this.getLocalFileContent(),u=await this.getFormattingOptions();let v=null,I=!1,_=!1,O=!1;if(s){let $=c?c.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new g.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const L=await(0,d.merge)($,s,o,u,this.userDataSyncUtilService);L.hasChanges&&(v=L.mergeContent,O=L.hasConflicts,I=O||L.mergeContent!==$,_=O||L.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=c.value.toString(),_=!0);const N={content:v,localChange:I?c?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",s=await this.getFormattingOptions(),o=await(0,d.merge)(t||"[]",a,a,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,i,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:c,remoteChange:u}=i[0][1];if(c===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new g.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const v=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(v,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,A.parse)(r.value.toString());if((0,D.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return w(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let i={};try{i=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,T.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};m=de([J(0,g.IUserDataSyncStoreService),J(1,g.IUserDataSyncBackupStoreService),J(2,g.IUserDataSyncLogService),J(3,E.IConfigurationService),J(4,g.IUserDataSyncEnablementService),J(5,C.IFileService),J(6,P.IEnvironmentService),J(7,f.IStorageService),J(8,g.IUserDataSyncUtilService),J(9,y.ITelemetryService),J(10,h.IUriIdentityService)],m),e.KeybindingsSynchroniser=m;let S=class extends p.AbstractInitializer{constructor(r,a,i,t){super("keybindings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,A.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};S=de([J(0,C.IFileService),J(1,P.IEnvironmentService),J(2,g.IUserDataSyncLogService),J(3,h.IUriIdentityService)],S),e.KeybindingsInitializer=S}),define(te[230],ne([0,1,16,35,69,49,28,53,24]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(o,c,u){let v=[];u?v=C(u):v=P(c);const I=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const O of v)O.startsWith("-")?_.push(O.substring(1)):I.push(O);return(0,D.distinct)([...o,...I].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function P(o){let c=o.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=o.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:o.getValue("settingsSync.ignoredSettings")||[]}function C(o){const c=(0,n.parse)(o);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function f(o,c,u,v){if(u.length){const I=s(c),_=(0,n.parse)(c),O=(0,n.parse)(o),N=[];for(const $ of u){const L=_[$],U=O[$];L===void 0?o=R.edit(o,[$],void 0,v):U!==void 0?o=R.edit(o,[$],L,v):N.push(l($,I))}N.sort(($,L)=>$.startOffset-L.startOffset),N.forEach($=>o=g($.setting.key,c,o,v))}return o}e.updateIgnoredSettings=f;function y(o,c,u,v,I,_){const O=f(o,c,v,_),N=u!==O,$=u!==c;if(!N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if($&&!N)return{conflictsSettings:[],localContent:f(c,o,v,_),remoteContent:null,hasConflicts:!1};if(u===null&&p(o)){const z=h(o,c,v)?null:f(c,o,v,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let L=o,U=c;const j=(0,n.parse)(o),M=(0,n.parse)(c),G=u?(0,n.parse)(u):null,K=v.reduce((z,B)=>(z.add(B),z),new Set),x=d(j,M,K),q=d(G,j,K),X=d(G,M,K),H=new Map,Z=new Set,ee=z=>{Z.add(z);const B=I.filter(({key:ie})=>ie===z)[0];B?(L=R.edit(L,[z],B.value,_),U=R.edit(U,[z],B.value,_)):H.set(z,{key:z,localValue:j[z],remoteValue:M[z]})};for(const z of q.removed.values())X.updated.has(z)?ee(z):U=R.edit(U,[z],void 0,_);for(const z of X.removed.values())Z.has(z)||(q.updated.has(z)?ee(z):L=R.edit(L,[z],void 0,_));for(const z of q.updated.values())Z.has(z)||(X.updated.has(z)?x.updated.has(z)&&ee(z):U=R.edit(U,[z],j[z],_));for(const z of X.updated.values())Z.has(z)||(q.updated.has(z)?x.updated.has(z)&&ee(z):L=R.edit(L,[z],M[z],_));for(const z of q.added.values())Z.has(z)||(X.added.has(z)?x.updated.has(z)&&ee(z):U=g(z,L,U,_));for(const z of X.added.values())Z.has(z)||(q.added.has(z)?x.updated.has(z)&&ee(z):L=g(z,U,L,_));const W=H.size>0||!h(L,U,v),F=W||!h(L,o,[]),V=W||!h(U,c,[]);return{localContent:F?L:null,remoteContent:V?U:null,conflictsSettings:[...H.values()],hasConflicts:W}}e.merge=y;function h(o,c,u){if(o===c)return!0;const v=(0,n.parse)(o),I=(0,n.parse)(c),_=u.reduce(($,L)=>($.add(L),$),new Set),O=s(o).filter($=>!($.setting&&_.has($.setting.key))),N=s(c).filter($=>!($.setting&&_.has($.setting.key)));if(O.length!==N.length)return!1;for(let $=0;$<O.length;$++){const L=O[$],U=N[$];if(L.setting&&U.setting){if(L.setting.key!==U.setting.key||!T.equals(v[L.setting.key],I[L.setting.key]))return!1}else if(!L.setting&&!U.setting){if(L.value!==U.value)return!1}else return!1}return!0}e.areSame=h;function p(o){return o?s(o).length===0:!0}e.isEmpty=p;function d(o,c,u){const v=o?Object.keys(o).filter($=>!u.has($)):[],I=Object.keys(c).filter($=>!u.has($)),_=I.filter($=>v.indexOf($)===-1).reduce(($,L)=>($.add(L),$),new Set),O=v.filter($=>I.indexOf($)===-1).reduce(($,L)=>($.add(L),$),new Set),N=new Set;if(o)for(const $ of v){if(O.has($))continue;const L=o[$],U=c[$];T.equals(L,U)||N.add($)}return{added:_,removed:O,updated:N}}function g(o,c,u,v){const I=(0,n.parse)(c),_=s(c),O=s(u),N=w(o,_,O);return m(u,o,I[o],N,O,v)}e.addSetting=g;function w(o,c,u){const v=c.findIndex(_=>_.setting?.key===o),I=c[v-1];if(I){if(I.setting){const O=l(I.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!0}}else{const O=r(v,c);if(O){const N=l(O.setting.key,u);if(N){const $=a(u.indexOf(N),u),L=i(c,O,c[v]);if($){const U=i(u,N,$),j=t(L,U);return j?{index:u.indexOf(j),insertAfter:!0}:{index:u.indexOf($),insertAfter:!1}}else{const U=i(u,N,u[u.length-1]),j=t(L,U);return j?{index:u.indexOf(j),insertAfter:!0}:{index:u.length-1,insertAfter:!0}}}}}const _=c[v+1];if(_)if(_.setting){const O=l(_.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!1}}else{const O=a(v,c);if(O){const N=l(O.setting.key,u);if(N){const $=r(u.indexOf(N),u),L=i(c,c[v],O);if($){const U=i(u,$,N),j=t(L.reverse(),U.reverse());return j?{index:u.indexOf(j),insertAfter:!1}:{index:u.indexOf($),insertAfter:!0}}else{const U=i(u,u[0],N),j=t(L.reverse(),U.reverse());return j?{index:u.indexOf(j),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:u.length-1,insertAfter:!0}}function m(o,c,u,v,I,_){let O;return v.index===-1?O=(0,k.setProperty)(o,[c],u,_):O=S(o,c,u,v,I,_).map(N=>(0,k.withFormatting)(o,N,_)[0]),(0,k.applyEdits)(o,O)}function S(o,c,u,v,I,_){const O=`${JSON.stringify(c)}: ${JSON.stringify(u)}`,N=(0,A.getEOL)(_,o),$=I[v.index];if(v.insertAfter){const L=[];if($.setting)L.push({offset:$.endOffset,length:0,content:","+O});else{const U=a(v.index,I),j=r(v.index,I),M=j?.setting?.commaOffset;j&&M===void 0&&L.push({offset:j.endOffset,length:0,content:","});const G=M!==void 0&&M>$.endOffset;L.push({offset:G?M+1:$.endOffset,length:0,content:U?N+O+",":N+O})}return L}else{if($.setting)return[{offset:$.startOffset,length:0,content:O+","}];const L=(I[v.index-1]&&!I[v.index-1].setting?N:"")+O+(a(v.index,I)?",":"")+N;return[{offset:$.startOffset,length:0,content:L}]}}function l(o,c){return c.filter(u=>u.setting?.key===o)[0]}function r(o,c){for(let u=o-1;u>=0;u--)if(c[u].setting)return c[u]}function a(o,c){for(let u=o+1;u<c.length;u++)if(c[u].setting)return c[u]}function i(o,c,u){const v=o.indexOf(c),I=o.indexOf(u);return o.filter((_,O)=>v<O&&O<I)}function t(o,c){if(o.length&&c.length){let u=0;for(;u<c.length&&u<o.length;u++)if(o[u].value!==c[u].value)return c[u-1];return c[u-1]}}function s(o){const c=[];let u=-1,v,I;const _={onObjectBegin:O=>{u++},onObjectProperty:(O,N,$)=>{u===0&&(v=N,I=O)},onObjectEnd:(O,N)=>{u--,u===0&&c.push({startOffset:v,endOffset:O+N,value:o.substring(v,O+N),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(O,N)=>{u++},onArrayEnd:(O,N)=>{u--,u===0&&c.push({startOffset:v,endOffset:O+N,value:o.substring(v,O+N),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(O,N,$)=>{u===0&&c.push({startOffset:v,endOffset:N+$,value:o.substring(v,N+$),setting:{key:I,commaOffset:void 0}})},onSeparator:(O,N,$)=>{if(u===0&&O===","){let L=c.length-1;for(;L>=0&&!c[L].setting;L--);const U=c[L];U&&c.splice(L,1,{startOffset:U.startOffset,endOffset:U.endOffset,value:U.value,setting:{key:U.setting.key,commaOffset:N}})}},onComment:(O,N)=>{u===0&&c.push({startOffset:O,endOffset:O+N,value:o.substring(O,O+N)})}};return(0,n.visit)(o,_),c}}),define(te[231],ne([0,1,17,3,145,20,89,15,30,13,23,21,34,47,53,230,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const r=JSON.parse(l);return g(r)?r:{settings:l}}e.parseSettingsSyncContent=w;let m=class extends y.AbstractJsonFileSynchroniser{constructor(r,a,i,t,s,o,c,u,v,I,_,O){super(a.settingsResource,"settings",r,a,i,t,s,v,I,o,c,u,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const a=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,a),t=this.getSettingsSyncContent(i),s=new T.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&s.parse(t.settings),s.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,a,i){const t=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(r);a=a===null&&i?r:a;const c=a?this.getSettingsSyncContent(a):null,u=await this.getIgnoredSettings();let v=null,I=!1,_=!1,O=!1;if(o){let $=t?t.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const L=(0,p.merge)($,o.settings,c?c.settings:null,u,[],s);v=L.localContent||L.remoteContent,I=L.localContent!==null,_=L.remoteContent!==null,O=L.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),v=t.value.toString(),_=!0);const N={content:v,localChange:I?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getSettingsSyncContent(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,p.merge)(t||"{}",a.settings,a.settings,s,[],o).remoteContent!==null}async getMergeResult(r,a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,p.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,a,i,t){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?(0,p.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent!==null?(0,p.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,p.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:c,remoteChange:u}=i[0][1];if(c===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),u!==0){const v=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(o);o=(0,p.updateIgnoredSettings)(o,I?I.settings:"{}",_,v),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=await this.getFormattingOptions(),i=(0,h.edit)(r.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,p.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let a=await super.resolvePreviewContent(r);if(a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,p.updateIgnoredSettings)(a,"{}",t,i)}return a}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:s})=>!!s)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(a,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new d.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};m=de([J(0,E.IFileService),J(1,R.IEnvironmentService),J(2,P.IStorageService),J(3,d.IUserDataSyncStoreService),J(4,d.IUserDataSyncBackupStoreService),J(5,d.IUserDataSyncLogService),J(6,d.IUserDataSyncUtilService),J(7,A.IConfigurationService),J(8,d.IUserDataSyncEnablementService),J(9,C.ITelemetryService),J(10,b.IExtensionManagementService),J(11,f.IUriIdentityService)],m),e.SettingsSynchroniser=m;let S=class extends y.AbstractInitializer{constructor(r,a,i,t){super("settings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}};S=de([J(0,E.IFileService),J(1,R.IEnvironmentService),J(2,d.IUserDataSyncLogService),J(3,f.IUriIdentityService)],S),e.SettingsInitializer=S}),define(te[232],ne([0,1,17,3,28,20,15,13,23,21,34,47,225,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends C.AbstractSynchroniser{constructor(g,w,m,S,l,r,a,i,t,s){super("snippets",w,g,m,S,l,i,t,r,a,s);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,w,m){const S=await this.getSnippetsFileContents(),l=this.toSnippetsContents(S),r=g.syncData?this.parseSnippets(g.syncData):null;w=w===null&&m?g:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,f.merge)(l,r,a);return this.getResourcePreviews(i,S,r||{})}async hasRemoteChanged(g){const w=g.syncData?this.parseSnippets(g.syncData):null;if(w===null)return!0;const m=await this.getSnippetsFileContents(),S=this.toSnippetsContents(m),l=(0,f.merge)(S,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(g,w){return g.previewResult}async getAcceptResult(g,w,m,S){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return m===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:m,localChange:m===null?g.fileContent!==null?3:0:2,remoteChange:m===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(g,w,m,S){const l=m.map(([r,a])=>({...r,acceptResult:a}));l.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,S)),l.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(l,g,S)),w?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(g,w,m){const S=new Map;for(const l of Object.keys(g.local.added)){const r={content:g.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};S.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.local.updated)){const r={content:g.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.added)){const r={content:g.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.updated)){const r={content:g.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:m[l]?2:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!S.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:g}){let w=await super.resolveContent(g);if(w){const m=this.parseSyncData(w);if(m){const S=this.parseSnippets(m),l=[];for(const r of Object.keys(S)){const a=this.extUri.joinPath(g,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);l.push({resource:a,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let w=await super.resolveContent(g);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(g)),w){const m=this.parseSyncData(w);if(m)return this.parseSnippets(m)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const w={};for(const m of g)m.fileContent&&(w[this.extUri.basename(m.localResource)]=m.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(g,w){for(const{fileContent:m,acceptResult:S,localResource:l,remoteResource:r,localChange:a}of g)if(a!==0){const i=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,i);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(S.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(S.content),w?void 0:m),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(g,w,m){const S=w.syncData?this.parseSnippets(w.syncData):{},l=(0,k.deepClone)(S);for(const{acceptResult:r,localResource:a,remoteResource:i,remoteChange:t}of g)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(i);t===3?delete l[s]:l[s]=r.content}return(0,f.areSame)(S,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),m?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const w={};for(const m of Object.keys(g))w[m]=g[m].value.toString();return w}async getSnippetsFileContents(){const g={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(m){if(m instanceof R.FileOperationError&&m.fileOperationResult===1)return g;throw m}for(const m of w.children||[]){const S=m.resource,l=this.extUri.extname(S);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,S),a=await this.fileService.readFile(S);g[r]=a}}return g}};h=de([J(0,T.IEnvironmentService),J(1,R.IFileService),J(2,b.IStorageService),J(3,y.IUserDataSyncStoreService),J(4,y.IUserDataSyncBackupStoreService),J(5,y.IUserDataSyncLogService),J(6,A.IConfigurationService),J(7,y.IUserDataSyncEnablementService),J(8,E.ITelemetryService),J(9,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let p=class extends C.AbstractInitializer{constructor(g,w,m,S){super("snippets",w,m,g,S)}async doInitialize(g){const w=g.syncData?JSON.parse(g.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(w)){const l=w[S];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(r,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};p=de([J(0,R.IFileService),J(1,T.IEnvironmentService),J(2,y.IUserDataSyncLogService),J(3,P.IUriIdentityService)],p),e.SnippetsInitializer=p}),define(te[64],ne([0,1,3,2,6,24]),function(Y,e,D,n,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let T=class extends n.Disposable{constructor(b,E){super();this.userDataSyncStoreService=b,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};T=de([J(0,A.IUserDataSyncStoreService),J(1,A.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(te[233],ne([0,1,5,17,57,2,19,20,15,13,24]),function(Y,e,D,n,k,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends A.Disposable{constructor(y,h,p,d){super();this.environmentService=y,this.fileService=h,this.configurationService=p,this.logService=d,P.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(y){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,y),p=await this.fileService.resolve(h);return p.children?p.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(y,h){if(!h){const p=await this.getAllRefs(y);p.length&&(h=p[p.length-1].ref)}if(h){const p=(0,T.joinPath)(this.environmentService.userDataSyncHome,y,h);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(y,h){const p=(0,T.joinPath)(this.environmentService.userDataSyncHome,y),d=(0,T.joinPath)(p,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,n.VSBuffer.fromString(h))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(h))return}catch{return}const p=await this.fileService.resolve(h);if(p.children){const d=p.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=d.filter(S=>Date.now()-this.getCreationTime(S)>g);const m=d.length-w.length;m<10&&(w=w.slice(10-m)),await D.Promises.settled(w.map(async S=>{this.logService.info("Deleting from backup",S.resource.path),await this.fileService.del(S.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};C=de([J(0,b.IEnvironmentService),J(1,E.IFileService),J(2,R.IConfigurationService),J(3,P.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(te[234],ne([0,1,3,2,4,15,23,21,24]),function(Y,e,D,n,k,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let P=class extends n.Disposable{constructor(f,y,h,p){super();this.storageService=f,this.telemetryService=y,this.environmentService=h,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:f}),this.storageService.store(E,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,y){if(this.isResourceEnabled(f)!==y){const h=(0,b.getEnablementKey)(f);this.telemetryService.publicLog2(h,{enabled:y}),this.storeResourceEnablement(h,y)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,y){this.storageService.store(f,y,0,k.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(E===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=b.ALL_SYNC_RESOURCES.filter(h=>(0,b.getEnablementKey)(h)===f.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};P=de([J(0,T.IStorageService),J(1,R.ITelemetryService),J(2,A.IEnvironmentService),J(3,b.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(te[235],ne([0,1,2,7]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(f){this.service=f}listen(f,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(f,y,h){switch(y){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class A{constructor(f){this.service=f}listen(f,y){throw new Error(`Event not found: ${y}`)}call(f,y,h){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class T{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(f,y,h){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(f,y,h){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class E{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(f,y,h){switch(y){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class P extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:n.URI.revive(f.url),type:f.type,defaultUrl:n.URI.revive(f.defaultUrl),insidersUrl:n.URI.revive(f.insidersUrl),stableUrl:n.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(te[236],ne([0,1,15,8]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends n.AbstractLogger{constructor(T,R){super();this.logger=this._register(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.logger.trace(T,...R)}debug(T,...R){this.logger.debug(T,...R)}info(T,...R){this.logger.info(T,...R)}warn(T,...R){this.logger.warn(T,...R)}error(T,...R){this.logger.error(T,...R)}critical(T,...R){this.logger.critical(T,...R)}flush(){this.logger.flush()}};k=de([J(0,n.ILoggerService),J(1,D.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(te[65],ne([0,1,3,2,4,26,148,15,13,6,27,46,23,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let p=class Ze extends n.Disposable{constructor(g,w,m,S,l,r){super();this.storageService=m,this.userDataSyncStoreService=S,this.logService=l,this.productService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(g,w,m)}async getMachines(g){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(g)).machines.map(S=>({...S,isCurrent:S.id===w}))}async addCurrentMachine(g){const w=await this.currentMachineIdPromise,m=await this.readMachinesData(g);m.machines.some(({id:S})=>S===w)||(m.machines.push({id:w,name:this.computeCurrentMachineName(m.machines)}),await this.writeMachinesData(m))}async removeCurrentMachine(g){const w=await this.currentMachineIdPromise,m=await this.readMachinesData(g),S=m.machines.filter(({id:l})=>l!==w);S.length!==m.machines.length&&(m.machines=S,await this.writeMachinesData(m))}async renameMachine(g,w,m){const S=await this.currentMachineIdPromise,l=await this.readMachinesData(m),r=l.machines.find(({id:a})=>a===g);r&&(r.name=w,await this.writeMachinesData(l),l.machines.some(({id:a})=>a===S)&&this.storageService.store(h,w,0,1))}async setEnablement(g,w){const m=await this.readMachinesData(),S=m.machines.find(({id:l})=>l===g);S&&(S.disabled=w?void 0:!0,await this.writeMachinesData(m))}computeCurrentMachineName(g){const w=this.storageService.get(h,0);if(w)return w;const m=`${this.productService.nameLong} (${(0,k.PlatformToString)(k.isWeb?0:k.platform)})`,S=new RegExp(`${(0,A.escapeRegExpCharacters)(m)}\\s#(\\d+)`);let l=0;for(const r of g){const a=S.exec(r.name),i=a?parseInt(a[1]):0;l=i>l?i:l}return`${m} #${l+1}`}async readMachinesData(g){this.userData=await this.readUserData(g);const w=this.parse(this.userData);if(w.version!==Ze.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(g){const w=JSON.stringify(g),m=await this.userDataSyncStoreService.write(Ze.RESOURCE,w,this.userData?.ref||null);this.userData={ref:m,content:w},this._onDidChange.fire()}async readUserData(g){if(this.userData){const w=g&&g.latest?g.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(g){if(g.content!==null)try{return JSON.parse(g.content)}catch(w){this.logService.error(w)}return{version:Ze.VERSION,machines:[]}}};p.VERSION=1,p.RESOURCE="machines",p=de([J(0,R.IEnvironmentService),J(1,b.IFileService),J(2,f.IStorageService),J(3,y.IUserDataSyncStoreService),J(4,y.IUserDataSyncLogService),J(5,P.IProductService)],p),e.UserDataSyncMachinesService=p}),define(te[237],ne([0,1,5,57,37,9,3,2,4,19,7,146,27,23,21,24,64,65]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",m="sync.sessionId",S="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(t,s,o,c,u,v,I,_,O,N){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=c,this.userDataSyncService=u,this.logService=v,this.userDataSyncAccountService=I,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(T.Event.debounce(u.onDidChangeLocal,($,L)=>$?[...$,L]:[L],1e3)($=>this.triggerSync($,!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(S,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(S,t.toString(),0,1):this.storageService.remove(S,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(m,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(s)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=p.UserDataSyncError.toUserDataSyncError(t);s instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?b.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([J(0,f.IProductService),J(1,p.IUserDataSyncStoreManagementService),J(2,p.IUserDataSyncStoreService),J(3,p.IUserDataSyncEnablementService),J(4,p.IUserDataSyncService),J(5,p.IUserDataSyncLogService),J(6,d.IUserDataSyncAccountService),J(7,h.ITelemetryService),J(8,g.IUserDataSyncMachinesService),J(9,y.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,s,o,c,u,v,I,_){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncService=u,this.userDataSyncMachinesService=v,this.logService=I,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,D.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,A.isCancellationError)(u))return}return this.doSync(t,s,c)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,E.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const u=this.storageService.get(m,0);if(u&&this.manifest&&u!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const I=v.find(_=>_.isCurrent);if(I?.disabled)throw new p.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new p.UserDataAutoSyncError((0,k.toErrorMessage)(_),_ instanceof p.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==u&&this.storageService.store(m,this.manifest.session,0,1),o.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(u){this.logService.error(u),c=u}this._onDidFinishSync.fire(c)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(te[238],ne([0,1,16,5,37,3,2,19,14,29,20,30,6,23,21,226,228,229,231,232,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let r=class extends T.Disposable{constructor(o,c,u,v,I,_,O,N){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=c,this.instantiationService=u,this.configurationService=v,this.logService=I,this.telemetryService=_,this.storageService=O,this.userDataSyncEnablementService=N,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new T.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,c){this.checkEnablement();const u=(0,E.generateUuid)();try{const N=(0,S.createSyncHeaders)(u);c&&(N["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,N)}catch(N){const $=S.UserDataSyncError.toUserDataSyncError(N);throw this.reportUserDataSyncError($,u),$}let v=!1;const I=this,_=this.getEnabledSynchronizers();let O;return{manifest:o,async run(){if(v)throw new Error("Can run a task only once");return O=(0,n.createCancelablePromise)(N=>I.sync(_,o,u,N)),O.finally(()=>O=void 0)},async stop(){if(O&&O.cancel(),I.status!=="idle")return I.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new S.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,E.generateUuid)(),c=(0,S.createSyncHeaders)(o);let u;try{u=await this.userDataSyncStoreService.manifest(null,c)}catch(I){const _=S.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(_,o),_}await this.resetLocal();const v=this.getEnabledSynchronizers();return new a(o,u,c,v,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(o,c,u,v){if(v.isCancellationRequested||!o.length)return;const I=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,S.createSyncHeaders)(u);for(const O of o){if(v.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(c,_)}catch(N){let $=!1;if(N instanceof S.UserDataSyncError)switch(N.code){case"TooLarge":N=new S.UserDataSyncError(N.message,N.code,O.resource),$=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":$=!0;break}const L=S.UserDataSyncError.toUserDataSyncError(N);if(this.reportUserDataSyncError(L,u),$)throw L;this.logService.error(N),this.logService.error(`${O.resource}: ${(0,k.toErrorMessage)(N)}`),this._syncErrors.push([O.resource,L])}}this.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),this.updateLastSyncTime()}catch(_){const O=S.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(O,u),O}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const c of o)try{c.status!=="idle"&&await c.stop()}catch(u){this.logService.error(u)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(o))return!0})}async accept(o,c,u,v){this.checkEnablement(),await this.performSynchronizerAction(async I=>{if(I.resource===o)return await I.accept(c,u),v&&await I.apply(!1,(0,S.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async c=>{const u=await c.resolveContent(o);if(u)return u})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async u=>{if(u.resource===o)return u.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async u=>{if(u.resource===o)return u.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,c){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return v.getAssociatedResources(c)})||[]}async getMachineId(o,c){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return await v.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(c){this.logService.error(`${o.resource}: ${(0,k.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const c=new T.DisposableStore;try{const u=this.synchronizers.value||c.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),v=[...u.enabled,...u.disabled.map(I=>c.add(u.createSynchronizer(I)))];for(const I of v){const _=await o(I);if(!(0,b.isUndefined)(_))return _}return null}finally{c.dispose()}}setStatus(o){const c=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const c=this.computeStatus(o);this.setStatus(c)}updateConflicts(o){const c=this.computeConflicts(o);(0,D.equals)(this._conflicts,c,([u,v],[I,_])=>u===u&&(0,D.equals)(v,_,(O,N)=>(0,R.isEqual)(O.previewResource,N.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(c))}computeConflicts(o){return o.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(t)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(c=>c.status==="hasConflicts")?"hasConflicts":o.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,c){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof S.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof S.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([J(0,S.IUserDataSyncStoreService),J(1,S.IUserDataSyncStoreManagementService),J(2,f.IInstantiationService),J(3,P.IConfigurationService),J(4,S.IUserDataSyncLogService),J(5,h.ITelemetryService),J(6,y.IStorageService),J(7,S.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends T.Disposable{constructor(o,c,u,v,I,_,O){super();this.id=o,this.manifest=c,this.syncHeaders=u,this.synchronisers=v,this.onStop=I,this.configurationService=_,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,c){try{return await this.performAction(o,u=>u.accept(o,c))}catch(u){throw this.logService.error(u),u}}async merge(o){try{return o?await this.performAction(o,c=>c.merge(o)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(o){try{return await this.performAction(o,c=>c.discard(o))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,c]of this.previews)for(const u of c.resourcePreviews)u.mergeState==="conflict"&&o.push(u.previewResource);for(const c of o)await this.discard(c);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[c,u]of this.previews){this.synchronizingResources.push([c,u.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(_=>_.resource===c);for(const _ of u.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await v.merge(_.previewResource);const I=await v.apply(!1,this.syncHeaders);I&&o.push(this.toSyncResourcePreview(v.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(v=>v.resource===o);for(const v of c.resourcePreviews)await u.accept(v.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(v=>v.resource===o);for(const v of c.resourcePreviews)await u.accept(v.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,U])=>U.resourcePreviews.some(({localResource:j,previewResource:M,remoteResource:G})=>(0,R.isEqual)(o,j)||(0,R.isEqual)(o,M)||(0,R.isEqual)(o,G)));if(u===-1)return this.previews;const[v,I]=this.previews[u],_=I.resourcePreviews.find(({localResource:U,remoteResource:j,previewResource:M})=>(0,R.isEqual)(U,o)||(0,R.isEqual)(j,o)||(0,R.isEqual)(M,o));if(!_)return this.previews;let O=this.synchronizingResources.find(U=>U[0]===v);O||(O=[v,[]],this.synchronizingResources.push(O)),O[1].some(U=>(0,R.isEqual)(U,_.localResource))||(O[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const N=this.synchronisers.find(U=>U.resource===this.previews[u][0]),$=await c(N);$?this.previews.splice(u,1,this.toSyncResourcePreview(N.resource,$)):this.previews.splice(u,1);const L=this.synchronizingResources.findIndex(U=>U[0]===v);return this.synchronizingResources[L][1].splice(O[1].findIndex(U=>(0,R.isEqual)(U,_.localResource)),1),O[1].length||(this.synchronizingResources.splice(L,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[c,u]of this.previews){this.synchronizingResources.push([c,u.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(_=>_.resource===c);let I=u;for(const _ of u.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(I=await v.merge(_.previewResource));I&&o.push(this.toSyncResourcePreview(v.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const c=[],u=await this.getUserDataSyncConfiguration();for(const v of this.synchronisers){if(o.isCancellationRequested)return[];const I=await v.preview(this.manifest,u,this.syncHeaders);I&&c.push(this.toSyncResourcePreview(v.resource,I))}return c}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(S.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=await this.synchronisers.find(u=>u instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...c}}toSyncResourcePreview(o,c){return[o,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends T.Disposable{constructor(o,c,u,v,I,_,O){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=c,this.onDidChangeLocal=u,this.userDataSyncEnablementService=v,this.instantiationService=I,this.extensionGalleryService=_,this.logService=O,this._enabled=[],this._register(v.onDidChangeResourceEnablement(([N,$])=>this.onDidChangeResourceEnablement(N,$))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,N])=>N.dispose())));for(const N of S.ALL_SYNC_RESOURCES)v.isResourceEnabled(N)&&this.registerSynchronizer(N)}get enabled(){return this._enabled.sort((o,c)=>o[1]-c[1]).map(([o])=>o)}get disabled(){return S.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,c){c?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([I])=>I.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new T.DisposableStore,u=c.add(this.createSynchronizer(o));c.add(u.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(u.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(u.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const v=this.getOrder(o);this._enabled.push([u,v,c])}deRegisterSynchronizer(o){const c=this._enabled.findIndex(([u])=>u.resource===o);if(c!==-1){const u=this._enabled.splice(c,1);for(const[v,,I]of u){if(v.status!=="idle"){const _=v.conflicts.length>0;v.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}I.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(m.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(p.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};i=de([J(3,S.IUserDataSyncEnablementService),J(4,f.IInstantiationService),J(5,C.IExtensionGalleryService),J(6,S.IUserDataSyncLogService)],i);function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[239],ne([0,1,3,2,14,7,24]),function(Y,e,D,n,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,y){try{return await this._call(C,f,y)}catch(h){throw this.logService.error(h),h}}async _call(C,f,y){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(y[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(y[0],A.URI.revive(y[1]),y[2],y[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(y[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0]);case"getAssociatedResources":return this.service.getAssociatedResources(y[0],{created:y[1].created,uri:A.URI.revive(y[1].uri)});case"getMachineId":return this.service.getMachineId(y[0],{created:y[1].created,uri:A.URI.revive(y[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring("manualSync/".length),p=y[0],d=this.getManualSyncTask(p);switch(y=y.slice(1),h){case"preview":return d.preview();case"accept":return d.accept(A.URI.revive(y[0]),y[1]);case"merge":return d.merge(A.URI.revive(y[0]));case"discard":return d.discard(A.URI.revive(y[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new n.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(y=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:y}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=R;class b extends n.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,y,h){return C.call(f,y,h).then(null,p=>{throw T.UserDataSyncError.toUserDataSyncError(p)})},listen(f,y){return C.listen(f,y)}},this.channel.call("_getInitialData").then(([f,y,h])=>{this.updateStatus(f),this.updateConflicts(y),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([y,h])=>[y,T.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:y}=await this.channel.call("createManualSyncTask"),h=this,p=new E(C,f,y,{async call(d,g,w){return h.channel.call(`manualSync/${d}`,[C,...(0,k.isArray)(g)?g:[g]],w)},listen(d,g){return D.Event.map(D.Event.filter(h.channel.listen(`manualSync/${d}`,g),w=>!p.isDiposed()&&w.manualSyncTaskId===C),w=>w.data)}});return p}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,y,h){return this.channel.call("accept",[C,f,y,h])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:y,uri:h})=>({created:y,uri:A.URI.revive(h)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:y,uri:h})=>({created:y,uri:A.URI.revive(h)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:h,comparableResource:p})=>({resource:A.URI.revive(h),comparableResource:A.URI.revive(p)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,y])=>[f,y.map(h=>({...h,localResource:A.URI.revive(h.localResource),remoteResource:A.URI.revive(h.remoteResource),previewResource:A.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=b;class E extends n.Disposable{constructor(C,f,y,h){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=y;const p=this;this.channel={async call(d,g,w){try{const m=await h.call(d,g,w);return p.isDiposed()||(p._status=await h.call("_getStatus")),m}catch(m){throw T.UserDataSyncError.toUserDataSyncError(m)}},listen(d,g){return h.listen(d,g)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const y=await this.channel.call("accept",[C,f]);return this.deserializePreviews(y)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,y])=>[f,{isLastSyncFromCurrentMachine:y.isLastSyncFromCurrentMachine,resourcePreviews:y.resourcePreviews.map(h=>({...h,localResource:A.URI.revive(h.localResource),remoteResource:A.URI.revive(h.remoteResource),previewResource:A.URI.revive(h.previewResource),acceptedResource:A.URI.revive(h.acceptedResource)}))}])}}}),define(te[240],ne([0,1,5,25,9,3,2,102,4,19,14,7,29,20,15,13,27,43,46,23,24]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends T.Disposable{constructor(O,N,$){super();this.productService=O,this.configurationService=N,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter($.onDidChangeValue,L=>L.key===S.SYNC_SERVICE_URL_TYPE&&L.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(S.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(S.SYNC_SERVICE_URL_TYPE,O,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[S.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=b.isWeb&&O?.web?{...O,...O.web}:O;const $={...O||{},...N||{}};if($&&(0,P.isString)($.url)&&(0,P.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(L=>(0,P.isArray)($.authenticationProviders[L].scopes))){const L=$,U=!!L.canSwitch&&!N?.url,j=L.url===L.insidersUrl?"insiders":"stable",M=(U?this.userDataSyncStoreType:void 0)||j,G=N?.url||(M==="insiders"?L.insidersUrl:M==="stable"?L.stableUrl:L.url);return{url:C.URI.parse(G),type:M,defaultType:j,defaultUrl:C.URI.parse(L.url),stableUrl:C.URI.parse(L.stableUrl),insidersUrl:C.URI.parse(L.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(L.authenticationProviders).reduce((K,x)=>(K.push({id:x,scopes:L.authenticationProviders[x].scopes}),K),[])}}}};o=de([J(0,d.IProductService),J(1,y.IConfigurationService),J(2,m.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let c=class extends o{constructor(O,N,$){super(O,N,$);const L=this.storageService.get(l,0);L&&(this.previousConfigurationSyncStore=JSON.parse(L));const U=this.productService[S.CONFIGURATION_SYNC_STORE_KEY];U?this.storageService.store(l,JSON.stringify(U),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=de([J(0,d.IProductService),J(1,y.IConfigurationService),J(2,m.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let u=class extends T.Disposable{constructor(O,N,$,L,U,j,M){super();this.requestService=$,this.logService=L,this.storageService=M,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(U,j,M).then(G=>{const K={"X-Client-Name":`${N.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(K["X-Client-Commit"]=N.commit),K}),this.session=new I(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),$={},L=await this.request(N.toString(),{type:"GET",headers:$},[],n.CancellationToken.None);return(await(0,g.asJson)(L)||[]).map(({url:j,created:M})=>({ref:(0,E.relativePath)(N,N.with({path:j})),created:M*1e3}))}async resolveContent(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,N).toString(),L={};L["Cache-Control"]="no-cache";const U=await this.request($,{type:"GET",headers:L},[],n.CancellationToken.None);return await(0,g.asText)(U)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async read(O,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();$={...$},$["Cache-Control"]="no-cache",N&&($["If-None-Match"]=N.ref);const U=await this.request(L,{type:"GET",headers:$},[304],n.CancellationToken.None);let j=null;if(U.res.statusCode===304&&(j=N),j===null){const M=U.res.headers.etag;if(!M)throw new S.UserDataSyncStoreError("Server did not return the ref",L,"NoRef",U.res.statusCode,U.res.headers[S.HEADER_OPERATION_ID]);const G=await(0,g.asText)(U);if(!G&&U.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",L,"EmptyResponse",U.res.statusCode,U.res.headers[S.HEADER_OPERATION_ID]);j={ref:M,content:G}}return j}async write(O,N,$,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();L={...L},L["Content-Type"]=R.Mimes.text,$&&(L["If-Match"]=$);const j=await this.request(U,{type:"POST",data:N,headers:L},[],n.CancellationToken.None),M=j.res.headers.etag;if(!M)throw new S.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",j.res.statusCode,j.res.headers[S.HEADER_OPERATION_ID]);return M}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const L=await this.request($,{type:"GET",headers:N},[304],n.CancellationToken.None);let U=null;if(L.res.statusCode===304&&(U=O),!U){const M=L.res.headers.etag;if(!M)throw new S.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",L.res.statusCode,L.res.headers[S.HEADER_OPERATION_ID]);const G=await(0,g.asText)(L);if(!G&&L.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",$,"EmptyResponse",L.res.statusCode,L.res.headers[S.HEADER_OPERATION_ID]);G&&(U={...JSON.parse(G),ref:M})}const j=this.storageService.get(a,0);return j&&U&&j!==U.session&&this.clearSession(),U===null&&j&&this.clearSession(),U&&this.storageService.store(a,U.session,0,1),U}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(i,0)}async request(O,N,$,L){if(!this.authToken)throw new S.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const U=await this.commonHeadersPromise;N.headers={...N.headers||{},...U,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let j;try{j=await this.session.request(O,N,L)}catch(x){if(!(x instanceof S.UserDataSyncStoreError)){let q="RequestFailed";const X=(0,k.getErrorMessage)(x).toLowerCase();X.includes("xhr timeout")?q="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?q="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":X.includes("headers must be an object")?q="RequestHeadersNotObject":(0,k.isCancellationError)(x)&&(q="RequestCanceled"),x=new S.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,q,void 0,void 0)}throw this.logService.info("Request failed",O),x}const M=j.res.headers[S.HEADER_OPERATION_ID],G={url:O,status:j.res.statusCode,"execution-id":N.headers[S.HEADER_EXECUTION_ID],"operation-id":M},K=(0,g.isSuccess)(j)||j.res.statusCode&&$.indexOf(j.res.statusCode)!==-1;if(K?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new S.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",j.res.statusCode,M);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",j.res.statusCode,M);if(j.res.statusCode===410)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",j.res.statusCode,M);if(j.res.statusCode===412)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",j.res.statusCode,M);if(j.res.statusCode===413)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",j.res.statusCode,M);if(j.res.statusCode===426)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",j.res.statusCode,M);if(j.res.statusCode===429){const x=j.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",j.res.statusCode,M)):new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",j.res.statusCode,M)}if(!K)throw new S.UserDataSyncStoreError("Server returned "+j.res.statusCode,O,"Unknown",j.res.statusCode,M);return j}addSessionHeaders(O){let N=this.storageService.get(i,0);N===void 0&&(N=(0,f.generateUuid)(),this.storageService.store(i,N,0,1)),O["X-Machine-Session-Id"]=N;const $=this.storageService.get(a,0);$!==void 0&&(O["X-User-Session-Id"]=$)}};u=de([J(1,d.IProductService),J(2,g.IRequestService),J(3,S.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,p.IFileService),J(6,m.IStorageService)],u),e.UserDataSyncStoreClient=u;let v=class extends u{constructor(O,N,$,L,U,j,M){super(O.userDataSyncStore?.url,N,$,L,U,j,M);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};v=de([J(0,S.IUserDataSyncStoreManagementService),J(1,d.IProductService),J(2,g.IRequestService),J(3,S.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,p.IFileService),J(6,m.IStorageService)],v),e.UserDataSyncStoreService=v;class I{constructor(O,N,$,L){this.limit=O,this.interval=N,this.requestService=$,this.logService=L,this.requests=[],this.startTime=void 0}request(O,N,$){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new S.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(te[241],ne([0,1,3,60,27,23,21,237,24,64,65]),function(Y,e,D,n,k,A,T,R,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends R.UserDataAutoSyncService{constructor(y,h,p,d,g,w,m,S,l,r,a){super(y,h,p,d,g,m,S,l,r,a);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};C=de([J(0,k.IProductService),J(1,b.IUserDataSyncStoreManagementService),J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncEnablementService),J(4,b.IUserDataSyncService),J(5,n.INativeHostService),J(6,b.IUserDataSyncLogService),J(7,E.IUserDataSyncAccountService),J(8,T.ITelemetryService),J(9,P.IUserDataSyncMachinesService),J(10,A.IStorageService)],C),e.UserDataAutoSyncService=C}),define(te[242],ne([0,1,5,3,2]),function(Y,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends k.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:E}){super();this.disposables=this._register(new k.DisposableStore),n.Event.latch(n.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(te[66],ne([0,1,50,5,10,14,22,124,255,256]),function(Y,e,D,n,k,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,a){let i=a.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=a}}e.ExtractError=P;function C(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,i)=>a+i,r&61440)}function f(l){if(l instanceof P)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new P(r,l)}function y(l,r,a,i,t,s){const o=k.dirname(r),c=k.join(i,o);if(!c.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const u=k.join(i,r);let v;return s.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(T.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((I,_)=>{if(!s.isCancellationRequested)try{v=(0,D.createWriteStream)(u,{mode:a}),v.once("close",()=>I()),v.once("error",_),l.once("error",_),l.pipe(v)}catch(O){_(O)}}))}function h(l,r,a,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((o,c)=>{const u=new n.Sequencer,v=I=>{I.isCancellationRequested||(s++,l.readEntry())};l.once("error",c),l.once("close",()=>t.then(()=>{i.isCancellationRequested||l.entryCount===s?o():c(new P("Incomplete",new Error(R.localize(1,null,s,l.entryCount))))},c)),l.readEntry(),l.on("entry",I=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){v(i);return}const _=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(_)){const $=k.join(r,_);t=(0,n.createCancelablePromise)(L=>T.Promises.mkdir($,{recursive:!0}).then(()=>v(L)).then(void 0,c));return}const O=d(l,I),N=C(I);t=(0,n.createCancelablePromise)($=>u.queue(()=>O.then(L=>y(L,_,N,r,a,$).then(()=>v($)))).then(null,c))})})}function p(l,r=!1){return new Promise((a,i)=>{(0,b.open)(l,r?{lazyEntries:!0}:void 0,(t,s)=>{t?i(f(t)):a((0,A.assertIsDefined)(s))})})}function d(l,r){return new Promise((a,i)=>{l.openReadStream(r,(t,s)=>{t?i(f(t)):a((0,A.assertIsDefined)(s))})})}function g(l,r){return new Promise((a,i)=>{const t=new E.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,D.createWriteStream)(l);t.outputStream.pipe(s),t.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>a(l))})}e.zip=g;function w(l,r,a={},i){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=p(l,!0);return a.overwrite&&(s=s.then(o=>T.Promises.rm(r).then(()=>o))),s.then(o=>h(o,r,{sourcePathRegex:t},i))}e.extract=w;function m(l,r){return p(l).then(a=>new Promise((i,t)=>{a.on("entry",s=>{s.fileName===r&&d(a,s).then(o=>i(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function S(l,r){return m(l,r).then(a=>new Promise((i,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=S}),define(te[243],ne([0,1,66,133]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(A){return(0,D.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=k}),define(te[244],ne([0,1,16,5,9,2,18,10,4,19,61,7,29,22,66,134,15,30,31,154,13,8,27]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends A.Disposable{constructor(t,s,o,c,u){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=c,this.productService=u,this._devSystemExtensionsPath=null,this.systemExtensionsPath=c.builtinExtensionsPath,this.extensionsPath=c.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(o).message,g.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(o).message,g.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,D.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(c=>!s[new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).key()]),t&&(o=(0,w.groupByExtension)(o,u=>u.identifier).map(u=>u.sort((v,I)=>P.rcompare(v.manifest.version,I.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,c){const u=t.key(),v=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),I=R.join(this.extensionsPath,u);try{await y.Promises.rm(I)}catch{try{await y.Promises.rm(I)}catch{}throw new g.ExtensionManagementError((0,p.localize)(0,null,I,t.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,v,c);let _=await this.scanExtension(C.URI.file(v),1);if(!_)throw new Error((0,p.localize)(1,null,v));await this.storeMetadata(_,{...o,installedTimestamp:Date.now()});try{await this.rename(t,v,I,Date.now()+2*60*1e3),this.logService.info("Renamed to",I)}catch(O){try{await y.Promises.rm(v)}catch{}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(O)}. Deleted from extracted location`,v),O}try{_=await this.scanExtension(C.URI.file(I),1)}catch{}if(_)return _;throw new Error((0,p.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),c=await y.Promises.readFile(o,"utf8"),{manifest:u}=await this.parseManifest(c);return u.__metadata=s,await y.Promises.writeFile(o,JSON.stringify(u,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(c=>o[c.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(c=>delete c[t.key()]);const o=(await this.scanExtensions(1)).find(c=>new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(c){if(c.code!=="ENOENT")throw c}let o={};if(s)try{o=JSON.parse(s)}catch{}return t&&(t(o),Object.keys(o).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await y.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await y.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,c){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await y.Promises.rm(o)}catch(u){throw new g.ExtensionManagementError(this.joinErrors(u).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,o,{sourcePath:"extension",overwrite:!0},c),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(u){try{await y.Promises.rm(o)}catch{}let v=g.ExtensionManagementErrorCode.Extract;throw u instanceof h.ExtractError&&(u.type==="CorruptZip"?v=g.ExtensionManagementErrorCode.CorruptZip:u.type==="Incomplete"&&(v=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(u.message,v)}}async rename(t,s,o,c){try{await y.Promises.rename(s,o)}catch(u){if(b.isWindows&&u&&u.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,c);throw new g.ExtensionManagementError(u.message||(0,p.localize)(3,null,s,o),u.code||g.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,c]=await Promise.all([t,s]);return[...o,...c]}async scanExtensionsInDir(t,s){const o=new n.Limiter(10),c=await this.fileService.resolve(C.URI.file(t));return c.children?(await Promise.all(c.children.filter(v=>v.isDirectory).map(v=>o.queue(async()=>s===1&&(0,E.basename)(v.resource).indexOf(".")===0?null:this.scanExtension(v.resource,s))))).filter(v=>v&&v.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:c,metadata:u}=await this.readManifest(t.fsPath),v=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,I=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,_={id:(0,w.getGalleryExtensionId)(c.publisher,c.name)},O={type:s,identifier:_,manifest:c,location:t,readmeUrl:v,changelogUrl:I,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(O,u),O}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(c=>(0,w.areSameExtensions)(o.identifier,{id:c})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const v of s)t[new w.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]||o.add(v.identifier.id.toLowerCase());const c=(0,w.groupByExtension)(s,v=>v.identifier);await n.Promises.settled(c.map(async v=>{const I=v.sort((_,O)=>P.rcompare(_.manifest.version,O.manifest.version))[0];o.has(I.identifier.id.toLowerCase())||await this.beforeRemovingExtension(I)}));const u=s.filter(v=>t[new w.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]);await n.Promises.settled(u.map(v=>this.removeUninstalledExtension(v)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,w.groupByExtension)(t,c=>c.identifier);s.push(...(0,D.flatten)(o.map(c=>c.sort((u,v)=>P.rcompare(u.manifest.version,v.manifest.version)).slice(1)))),await n.Promises.settled(s.map(c=>this.removeExtension(c,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(T.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[y.Promises.readFile(R.join(t,"package.json"),"utf8").then(v=>this.parseManifest(v)),y.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,v=>v.code!=="ENOENT"?Promise.reject(v):"{}").then(v=>JSON.parse(v))],[{manifest:o,metadata:c},u]=await Promise.all(s);return{manifest:(0,m.localizeManifest)(o,u),metadata:c}}parseManifest(t){return new Promise((s,o)=>{try{const c=JSON.parse(t),u=c.__metadata||null;s({manifest:c,metadata:u})}catch{o(new Error((0,p.localize)(4,null)))}})}};a=de([J(1,S.IFileService),J(2,l.ILogService),J(3,d.INativeEnvironmentService),J(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(te[245],ne([0,1,37,9,18,10,4,32,19,61,7,29,22,66,132,81,15,206,30,31,188,174,243,189,244,220,78,13,6,8,27,21,34]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l,r,a,i,t,s,o,c,u,v,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends g.AbstractExtensionManagementService{constructor(M,G,K,x,q,X,H,Z,ee){super(M,G,K,Z);this.environmentService=x,this.downloadService=q,this.fileService=H;const W=this._register(X.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(i.ExtensionsScanner,V=>W.postUninstall(V))),this.manifestCache=this._register(new a.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(X.createInstance(S.ExtensionsDownloader));const F=this._register(new t.ExtensionsWatcher(this,H,x,K,ee));this._register(F.onDidChangeExtensionsByAnotherSource(({added:V,removed:z})=>{V.length&&this._onDidInstallExtensions.fire(V.map(B=>({identifier:B.identifier,operation:1,local:B}))),z.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),G=(0,w.getTargetPlatform)(M?"alpine":T.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let M;try{M=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{M=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(K){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(K))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const G=await this.collectFiles(M),K=await(0,y.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,G);return P.URI.file(K)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const G=await this.downloadVsix(M),K=A.resolve(G.fsPath);return(0,r.getManifest)(K)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,G={}){this.logService.trace("ExtensionManagementService#install",M.toString());const K=await this.downloadVsix(M),x=await(0,r.getManifest)(A.resolve(K.fsPath));if(x.engines&&x.engines.vscode&&!(0,s.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,m.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,K,G)}async updateMetadata(M,G){this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id);const K={...M.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(K.preRelease=!0),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,K),this.manifestCache.invalidate(),M}async updateExtensionScope(M,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===k.Schemas.file)return M;const G=(0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(M,G),G}createInstallExtensionTask(M,G,K){return P.URI.isUri(G)?new L(M,G,K,this.galleryService,this.extensionsScanner,this.logService):new $(G,K,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,G){return new U(M,G,this.extensionsScanner)}async collectFiles(M){const G=async x=>{let q=await f.Promises.readdir(x);q=q.map(Z=>A.join(x,Z));const X=await Promise.all(q.map(Z=>f.Promises.stat(Z)));let H=Promise.resolve([]);return X.forEach((Z,ee)=>{const W=q[ee];Z.isFile()&&(H=H.then(F=>[...F,W])),Z.isDirectory()&&(H=H.then(F=>G(W).then(V=>[...F,...V])))}),H};return(await G(M.location.fsPath)).map(x=>({path:`extension/${A.relative(M.location.fsPath,x)}`,localPath:x}))}};O=de([J(0,w.IExtensionGalleryService),J(1,I.ITelemetryService),J(2,u.ILogService),J(3,d.INativeEnvironmentService),J(4,p.IDownloadService),J(5,c.IInstantiationService),J(6,o.IFileService),J(7,v.IProductService),J(8,_.IUriIdentityService)],O),e.ExtensionManagementService=O;class N extends g.AbstractExtensionTask{constructor(M,G,K,x){super();this.identifier=M,this.source=G,this.extensionsScanner=K,this.logService=x,this._operation=2}get operation(){return this._operation}async installExtension(M,G){try{const K=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(K)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(K,{...K.manifest.__metadata||{},...M.metadata}):K}catch{throw T.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(M,G)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const K=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),K}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:G,metadata:K},x){let q=await this.extensionsScanner.extractUserExtension(G,M,K,x);return this.logService.info("Extracting completed.",G.id),q}}class $ extends N{constructor(M,G,K,x,q){super(M.identifier,M,x,q);this.gallery=M,this.options=G,this.extensionsDownloader=K}async doRun(M){const K=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,m.areSameExtensions)(q.identifier,this.gallery.identifier));K&&(this._operation=3);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||K?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||K?.isBuiltin,x.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,x.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:K?.preRelease||this.options.installPreReleaseVersion;try{const q=await this.installExtension(x,M);return K&&E.neq(K.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(K),q}catch(q){throw await this.deleteDownloadedVSIX(x.zipPath),q}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(P.URI.file(M))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,n.getErrorMessage)(G))}}async downloadInstallableExtension(M,G){const K={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let x;try{this.logService.trace("Started downloading extension:",M.identifier.id),x=(await this.extensionsDownloader.downloadExtension(M,G)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,x)}catch(q){throw new w.ExtensionManagementError((0,g.joinErrors)(q).message,w.ExtensionManagementErrorCode.Download)}try{const q=await(0,r.getManifest)(x);return{zipPath:x,identifierWithVersion:new m.ExtensionIdentifierWithVersion(M.identifier,q.version),metadata:K}}catch(q){throw await this.deleteDownloadedVSIX(x),new w.ExtensionManagementError((0,g.joinErrors)(q).message,w.ExtensionManagementErrorCode.Invalid)}}}class L extends N{constructor(M,G,K,x,q,X){super({id:(0,m.getGalleryExtensionId)(M.publisher,M.name)},G,q,X);this.manifest=M,this.location=G,this.options=K,this.galleryService=x}async doRun(M){const G=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(X=>(0,m.areSameExtensions)(this.identifier,X.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,M);if(q.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=3,G.equals(new m.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const X=await this.unsetUninstalledAndGetLocal(G);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:A.resolve(this.location.fsPath),identifierWithVersion:G,metadata:q},M)}async getMetadata(M,G,K){try{let[x]=await this.galleryService.getExtensions([{id:M,version:G}],K);if(x||([x]=await this.galleryService.getExtensions([{id:M}],K)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class U extends g.AbstractExtensionTask{constructor(M,G,K){super();this.extension=M,this.options=G,this.extensionsScanner=K}async doRun(M){const G=[],K=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...K.filter(q=>x.equals(new m.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else G.push(...K.filter(x=>(0,m.areSameExtensions)(x.identifier,this.extension.identifier)));if(!G.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const x of G)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(q){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(q)))}}}}),define(te[246],ne([0,1,83,56,33,17,9,3,2,10,4,29,36,73,257]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(I,_=""){this.debugLabel=_,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,T.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,_){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const _=O=>{this.traceSocketEvent("read",O),I(A.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(I){const _=O=>{this.traceSocketEvent("close",{hadError:O}),I({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(I){const _=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=p;var d;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var g;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(g||(g={}));class w extends b.Disposable{constructor(I,_,O,N){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new m(this,_,O,N,this._onData,($,L)=>this._write($,L))),this._register(this._flowManager.onError($=>{console.error($),(0,T.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,_){this.socket.traceSocketEvent(I,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let O=2;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const N=A.VSBuffer.alloc(O);if(_?N.writeUInt8(194,0):N.writeUInt8(130,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let $=1;N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}else{N.writeUInt8(127,1);let $=1;N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(I.byteLength>>>24&255,++$),N.writeUInt8(I.byteLength>>>16&255,++$),N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}this.socket.write(A.VSBuffer.concat([N,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),N=(O&128)>>>7,$=(O&64)>>>6,L=_.readUInt8(1),U=(L&128)>>>7,j=L&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),N=(O&128)>>>7;let $=O&127,L=1;$===126?$=_.readUInt8(++L)*2**8+_.readUInt8(++L):$===127&&($=_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*2**24+_.readUInt8(++L)*2**16+_.readUInt8(++L)*2**8+_.readUInt8(++L));let U=0;N&&(U=_.readUInt8(++L)*2**24+_.readUInt8(++L)*2**16+_.readUInt8(++L)*2**8+_.readUInt8(++L)),this._state.state=3,this._state.readLen=$,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class m extends b.Disposable{constructor(I,_,O,N,$,L){super();this._tracer=I,this._onData=$,this._writeFn=L,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new S(this._tracer,N,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(_,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,_){return new Promise((O,N)=>{I.write(_),I.flush($=>O($))})}acceptFrame(I,_,O){this._readQueue.push({data:I,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,_,O){return new Promise((N,$)=>{I.write(_),O&&I.write(A.VSBuffer.fromByteArray([0,0,255,255])),I.flush(L=>N(L))})}}class S extends b.Disposable{constructor(I,_,O,N){super();this._tracer=I,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(A.VSBuffer.wrap($))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(_)})}}class l extends b.Disposable{constructor(I,_){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(A.VSBuffer.wrap(O))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),I(_)})}}function r(v,I){if(I===0)return;let _=v.byteLength>>>2;for(let j=0;j<_;j++){const M=v.readUInt32BE(j*4);v.writeUInt32BE(M^I,j*4)}let O=_*4,N=v.byteLength-O;const $=I>>>24&255,L=I>>>16&255,U=I>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(O)^$,O),N>=2&&v.writeUInt8(v.readUInt8(O+1)^L,O+1),N>=3&&v.writeUInt8(v.readUInt8(O+2)^U,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const v=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):I=(0,E.join)((0,k.tmpdir)(),`vscode-ipc-${v}.sock`),s(I),I}e.createRandomIPCHandle=i;function t(v,I,_){const O=(0,D.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${I}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${I}.sock`):N=(0,E.join)(v,`${_}-${I}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(v){const I=a[P.platform];typeof I=="number"&&v.length>=I&&console.warn(`WARNING: IPC handle "${v}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const _=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(_,O=>({protocol:new y.Protocol(new p(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(v){return new Promise((I,_)=>{const O=(0,n.createServer)();O.on("error",_),O.listen(v,()=>{O.removeListener("error",_),I(new o(O))})})}e.serve=c;function u(v,I){return new Promise((_,O)=>{const N=(0,n.createConnection)(v,()=>{N.removeListener("error",O),_(y.Client.fromSocket(new p(N,`ipc-client${I}`),I))});N.once("error",O)})}e.connect=u}),define(te[247],ne([0,1,56,246]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,A,T,R,b){const E=C=>b(C,void 0),P=D.createConnection({host:k,port:A},()=>{P.removeListener("error",E);const C=Buffer.alloc(16);for(let p=0;p<16;p++)C[p]=Math.round(Math.random()*256);const f=C.toString("base64"),y=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${A}/?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(y.join(`\r
`)+`\r
\r
`);const h=p=>{p.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",h),b(void 0,new n.NodeSocket(P,R)))};P.on("data",h)});P.setNoDelay(!0),P.once("error",E)}}}),define(te[248],ne([0,1,56,115,247,5,2,20,8,27,185,62,92]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(w,m,S,l,r){let a;for(let i=3;i&&(a&&a.dispose(),a=await new h(w,m,S,l,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));i--);return a}class h extends T.Disposable{constructor(m,S,l,r,a){super();this.defaultTunnelHost=S,this.suggestedLocalPort=a,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=m,this._server=D.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(S=>{S()})}async waitForReady(){let m=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),S=null;return this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address(),S||(m=0,this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address()),this.tunnelLocalPort=S.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${S.port}`,this}async _onConnection(m){m.pause();const S=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,S,this.tunnelRemotePort),r=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&m.write(a.buffer),m.on("end",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),r.end()}),m.on("close",()=>r.end()),m.on("error",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),r.destroy()}),r.on("end",()=>m.end()),r.on("close",()=>m.end()),r.on("error",()=>{m.destroy()}),m.pipe(r),r.pipe(m),m.localAddress&&this._socketsDispose.set(m.localAddress,()=>{m.end(),r.end()})}}let p=class extends C.AbstractTunnelService{constructor(m,S,l,r,a){super(S);this.socketFactory=m,this.signService=l,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(m,S,l,r,a,i,t){const s=this.getTunnelFromMap(S,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,S,l,r,a,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${S}:${l} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:m,signService:this.signService,logService:this.logService,ipcLogger:null},c=y(o,this.defaultTunnelHost,S,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(S,l,c),c}}};p=de([J(1,b.ILogService),J(2,f.ISignService),J(3,E.IProductService),J(4,R.IConfigurationService)],p),e.BaseTunnelService=p;let d=class extends p{constructor(m,S,l,r){super(k.nodeSocketFactory,m,S,l,r)}};d=de([J(0,b.ILogService),J(1,f.ISignService),J(2,E.IProductService),J(3,R.IConfigurationService)],d),e.TunnelService=d;let g=class extends T.Disposable{constructor(m,S,l,r){super();this.logService=m,this.productService=S,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(m,S,l,r,a,i,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${a}.`),!this._tunnelServices.has(m)){const o=new d(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(m,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(m))})}return this._tunnelServices.get(m).openTunnel(S,l,r,a,i,t,s)}};g=de([J(0,b.ILogService),J(1,E.IProductService),J(2,f.ISignService),J(3,R.IConfigurationService)],g),e.SharedTunnelsService=g}),define(te[258],ne([0,1,74,33,37,9,2,18,19,7,36,118,179,201,180,171,172,173,157,160,20,183,80,205,81,194,15,198,200,209,30,159,207,245,82,155,13,176,178,51,6,168,85,169,170,59,190,8,86,60,87,27,193,43,23,203,204,21,93,94,95,44,210,211,96,213,219,63,98,24,64,233,235,236,65,234,238,239,240,241,242,92,199,62,248,191,192,91,197,208,34,221,4,222,163,182,181]),function(Y,e,D,n,k,A,T,R,b,E,P,C,f,y,h,p,d,g,w,m,S,l,r,a,i,t,s,o,c,u,v,I,_,O,N,$,L,U,j,M,G,K,x,q,X,H,Z,ee,W,F,V,z,B,ie,se,ce,he,ge,me,ye,Se,Ie,Ee,De,Fe,Ue,Ne,ze,re,ae,ue,be,Ce,$e,Te,Oe,_e,Q,oe,le,fe,ve,Le,we,Re,ke,Pe,Ae,We,xe,Be,Pt,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends T.Disposable{constructor(pe){super();this.configuration=pe,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const pe=()=>this.dispose();process.once("exit",pe),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",pe);const Me="vscode:electron-main->shared-process=disposeWorker",qe=(Ye,je)=>this.onDisposeWorker(je);D.ipcRenderer.on(Me,qe),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Me,qe)))}onDisposeWorker(pe){this.sharedProcessWorkerService?.disposeWorker(pe)}async open(){const pe=await this.initServices();(0,ae.registerConfiguration)(),pe.invokeFunction(Me=>{const qe=Me.get(ee.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(qe)}),this._register((0,T.combinedDisposable)(pe.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),pe.createInstance(h.LanguagePackCachedDataCleaner),pe.createInstance(g.StorageDataCleaner,this.configuration.backupWorkspacesPath),pe.createInstance(d.LogsDataCleaner),pe.createInstance(p.LocalizationsUpdater),pe.createInstance(y.ExtensionsCleaner)))}async initServices(){const pe=new x.ServiceCollection,Me={_serviceBrand:void 0,...V.default};pe.set(z.IProductService,Me);const qe=new P.StaticRouter(Ge=>Ge==="main"),Ye=new q.MessagePortMainProcessService(this.server,qe);pe.set(X.IMainProcessService,Ye);const je=new o.SharedProcessEnvironmentService(this.configuration.args,Me);pe.set(s.INativeEnvironmentService,je);const it=new W.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Xe=new W.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Ye.getChannel("logger"));pe.set(ee.ILoggerService,Xe);const ot=this._register(new ee.MultiplexLogService([this._register(new ee.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(E.URI.file(je.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new W.FollowerLogService(it,ot));pe.set(ee.ILogService,Je),this.sharedProcessWorkerService=new We.SharedProcessWorkerService(Je),pe.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new U.FileService(Je));pe.set(L.IFileService,Ve);const at=this._register(new j.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ye.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,ct);const He=this._register(new l.ConfigurationService(je.settingsResource,Ve));pe.set(S.IConfigurationService,He);const et=new ce.NativeStorageService(void 0,Ye,je);pe.set(se.IStorageService,et),this._register((0,T.toDisposable)(()=>et.flush())),await Promise.all([He.initialize(),et.initialize()]),pe.set(Be.IUriIdentityService,new Pt.UriIdentityService(Ve)),pe.set(ie.IRequestService,new M.SyncDescriptor(B.RequestService)),pe.set(w.IChecksumService,new M.SyncDescriptor(m.ChecksumService)),pe.set(St.IV8InspectProfilingService,new M.SyncDescriptor(kt.InspectProfilingService));const rt=P.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});pe.set(F.INativeHostService,rt),pe.set(i.IDownloadService,new M.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(rt)),ut=new P.StaticRouter(Ge=>lt.getActiveClientId().then(dt=>Ge===dt));pe.set(N.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new xe.AssignmentService(this.configuration.machineId,He,Me);let tt;const Qe=[];if((0,Ie.supportsTelemetry)(Me,je)){const Ge=new ye.TelemetryLogAppender(Xe,je);Qe.push(Ge);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=je;if(Me.aiConfig&&Me.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Me.quality!=="stable";if(ft&&st){const bt=new Ee.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,st,!0);this._register((0,T.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new Ee.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,T.toDisposable)(()=>Et.flush())),Qe.push(Et)}tt=new Se.TelemetryService({appenders:Qe,commonProperties:(0,he.resolveCommonProperties)(Ve,(0,n.release)(),(0,n.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},He)}else{tt=Ie.NullTelemetryService;const Ge=Ie.NullAppender;Qe.push(Ge)}this.server.registerChannel("telemetryAppender",new me.TelemetryAppenderChannel(Qe)),pe.set(ge.ITelemetryService,tt);const At=new De.CustomEndpointTelemetryService(He,tt,Xe,je);pe.set(ge.ICustomEndpointTelemetryService,At),pe.set(v.IExtensionManagementService,new M.SyncDescriptor(O.ExtensionManagementService)),pe.set(v.IExtensionGalleryService,new M.SyncDescriptor(u.ExtensionGalleryService)),pe.set(v.IExtensionTipsService,new M.SyncDescriptor(_.ExtensionTipsService)),pe.set(H.ILocalizationsService,new M.SyncDescriptor(Z.LocalizationsService)),pe.set(r.IDiagnosticsService,new M.SyncDescriptor(a.DiagnosticsService)),pe.set(ue.IUserDataSyncAccountService,new M.SyncDescriptor(ue.UserDataSyncAccountService)),pe.set(ae.IUserDataSyncLogService,new M.SyncDescriptor($e.UserDataSyncLogService)),pe.set(ae.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),pe.set(v.IGlobalExtensionEnablementService,new M.SyncDescriptor(c.GlobalExtensionEnablementService)),pe.set(re.IIgnoredExtensionsManagementService,new M.SyncDescriptor(re.IgnoredExtensionsManagementService)),pe.set(ze.IExtensionStorageService,new M.SyncDescriptor(ze.ExtensionStorageService)),pe.set(ae.IUserDataSyncStoreManagementService,new M.SyncDescriptor(oe.UserDataSyncStoreManagementService)),pe.set(ae.IUserDataSyncStoreService,new M.SyncDescriptor(oe.UserDataSyncStoreService)),pe.set(Te.IUserDataSyncMachinesService,new M.SyncDescriptor(Te.UserDataSyncMachinesService)),pe.set(ae.IUserDataSyncBackupStoreService,new M.SyncDescriptor(be.UserDataSyncBackupStoreService)),pe.set(ae.IUserDataSyncEnablementService,new M.SyncDescriptor(Oe.UserDataSyncEnablementService)),pe.set(ae.IUserDataSyncService,new M.SyncDescriptor(_e.UserDataSyncService));const wt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,je,Je,tt);return await wt.initialize(),pe.set(Ue.ILocalPtyService,this._register(wt)),pe.set(ve.ISignService,new M.SyncDescriptor(Le.SignService)),pe.set(we.ISharedTunnelsService,new M.SyncDescriptor(Re.SharedTunnelsService)),pe.set(ke.ISharedProcessTunnelService,new M.SyncDescriptor(Pe.SharedProcessTunnelService)),new K.InstantiationService(pe)}initChannels(pe){const Me=new I.ExtensionManagementChannel(pe.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const qe=P.ProxyChannel.fromService(pe.get(H.ILocalizationsService));this.server.registerChannel("localizations",qe);const Ye=P.ProxyChannel.fromService(pe.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const je=new I.ExtensionTipsChannel(pe.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",je);const it=P.ProxyChannel.fromService(pe.get(w.IChecksumService));this.server.registerChannel("checksum",it);const Xe=P.ProxyChannel.fromService(pe.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Ce.UserDataSyncMachinesServiceChannel(pe.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Je=P.ProxyChannel.fromService(pe.get(ge.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Ce.UserDataSyncAccountServiceChannel(pe.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const at=new Ce.UserDataSyncStoreManagementServiceChannel(pe.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new Q.UserDataSyncChannel(pe.get(ae.IUserDataSyncService),pe.get(ee.ILogService));this.server.registerChannel("userDataSync",ct);const He=this._register(pe.get(G.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new Ce.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",et);const rt=pe.get(Ue.ILocalPtyService),lt=P.ProxyChannel.fromService(rt);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(pe.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(pe.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(pe){window.addEventListener("unhandledrejection",Me=>{(0,A.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Me=>{const qe=(0,k.toErrorMessage)(Me,!0);!qe||pe.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Tt(yt){const pe=new Lt(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await pe.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4f6f7e009ef0ab5906f2435aa82b5206ca40bba/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
